unit BoucleExperimentDialog;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TLoopDialog = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    OKBtn: TButton;
    CancelBtn: TButton;
    TemperatureCheckBox: TCheckBox;
    RFFrequencyCheckBox: TCheckBox;
    PulseTATBCheckBox: TCheckBox;
    PulseTA2TBCheckBox: TCheckBox;
    PulseCheckBox: TCheckBox;
    PulseName: TEdit;
    FirstValueBox: TEdit;
    LastValueBox: TEdit;
    StepBox: TEdit;
    IntegralCheckBox: TCheckBox;
    leftcursor: TEdit;
    rightcursor: TEdit;
    leftbgd: TEdit;
    rightbgd: TEdit;
    TFIntegralCheckBox: TCheckBox;
    TFLeftCursor: TEdit;
    TFRightCursor: TEdit;
    TFLeftBGD: TEdit;
    TFRightBGD: TEdit;
    DoTFCheckBox: TCheckBox;
    SaveTFCheckBox: TCheckBox;
    SaveArrayCheckBox: TCheckBox;
    FileNameBox: TEdit;
    ApendToInterpreteur: TCheckBox;
    TemperatureIntervalle: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    TemperatureDelay: TEdit;
    Label17: TLabel;
    StopPulseAtTheEnd: TCheckBox;
    AmplitudeCheckBox: TCheckBox;
    AmplitudeName: TEdit;
    procedure TemperatureCheckBoxClick(Sender: TObject);
    procedure IntegralCheckBoxClick(Sender: TObject);
    procedure TFIntegralCheckBoxClick(Sender: TObject);
    procedure DoTFCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LoopDialog: TLoopDialog;

implementation

{$R *.DFM}

procedure TLoopDialog.TemperatureCheckBoxClick(Sender: TObject);
begin
if TemperatureCheckBox.state=cbchecked then
             begin
             label15.Visible:=true;
             label16.Visible:=true;
             label17.Visible:=true;
             TemperatureIntervalle.Visible:=true;
             TemperatureDelay.Visible:=true;
             end
             else
             begin
             label15.Visible:=false;
             label16.Visible:=false;
             label17.Visible:=false;
             TemperatureIntervalle.Visible:=false;
             TemperatureDelay.Visible:=false;
             end;
end;

procedure TLoopDialog.IntegralCheckBoxClick(Sender: TObject);
begin
  if IntegralCheckBox.state=cbchecked then
     begin
     label5.visible:=true;
     label6.visible:=true;
     label7.visible:=true;
     label8.visible:=true;
     leftcursor.visible:=true;
     rightcursor.visible:=true;
     leftBGD.visible:=true;
     rightBGD.visible:=true;
     end
     else
     begin
     label5.visible:=false;
     label6.visible:=false;
     label7.visible:=false;
     label8.visible:=false;
     leftcursor.visible:=false;
     rightcursor.visible:=false;
     leftBGD.visible:=false;
     rightBGD.visible:=false;
     end

end;

procedure TLoopDialog.TFIntegralCheckBoxClick(Sender: TObject);
begin
  if TFIntegralCheckBox.state=cbchecked then
     begin
     label9.visible:=true;
     label10.visible:=true;
     label11.visible:=true;
     label12.visible:=true;
     TFLeftCursor.visible:=true;
     TFRightCursor.visible:=true;
     TFLeftBGD.visible:=true;
     TFRightBGD.visible:=true;
     end
     else
     begin
     label9.visible:=false;
     label10.visible:=false;
     label11.visible:=false;
     label12.visible:=false;
     TFLeftCursor.visible:=false;
     TFRightCursor.visible:=false;
     TFLeftBGD.visible:=false;
     TFRightBGD.visible:=false;
     end;

end;

procedure TLoopDialog.DoTFCheckBoxClick(Sender: TObject);
begin
  if DoTFCheckBox.state=cbchecked then
     begin
     saveTFCheckBox.visible:=true;
     TFIntegralCheckBox.visible:=true;
     end
     else
     begin
     saveTFCheckBox.visible:=false;
     TFIntegralCheckBox.visible:=false;
     end;
end;

end.
