unit Graph2D;
{ unit de visualisation des spectres Raw 2D}
{ MODIFICATIONS                                                                     }
{ mise a jour le 31.10.2000                                                         }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, editdata, Spin, Menus, SommeSpectre2D, BoiteNoire,
  controlesDivers, EditReal;

const
  couleur:array[0..15] of integer=(0,
  $800000,$FF0000,
  $800080,$FF00FF,
  $80,$FF,
  $00A0FF,$00FFFF,
  $8000,$FF00,
  $A0A000,$FFFF00,
  $FFFFC0,$FFFFFF,$FFFFFF);
wm_fermeture=$400+wm_user;
wm_redessiner=$401+wm_user;

type
  PintArray = ^TintArray;
  TintArray = array[0..8191] of integer;

type
  Tdeuxdform = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    Button1: TButton;
    Panel3: TPanel;
    Edit1: TEdit;

    Image2: TImage;
    Panel4: TPanel;
    spby: TSpinEdit;
    spbx: TSpinEdit;
    Label1: TLabel;
    Panel5: TPanel;
    Label2: TLabel;
    spay: TSpinEdit;
    spax: TSpinEdit;
    Panel6: TPanel;
    Label3: TLabel;
    spcy: TSpinEdit;
    spCx: TSpinEdit;
    MainMenu1: TMainMenu;
    fermer1: TMenuItem;
    ComboBox2: TComboBox;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    PopupMenu1: TPopupMenu;
    Sauvegarder1: TMenuItem;
    
    N1: TMenuItem;
    sauverlebitmap1: TMenuItem;
    fermer2: TMenuItem;
    N2: TMenuItem;
    operations1: TMenuItem;
    Effacer1: TMenuItem;
    nouveau1: TMenuItem;
    N3: TMenuItem;
    Sommes1: TMenuItem;
    OpenDialog1: TOpenDialog;
    choixspectre: TComboBox;
    openspectre: TMenuItem;
    N4: TMenuItem;
    Label6: TLabel;
    moniteur: TEdit;
    Label7: TLabel;
    somme: TEdit;
    addition: TMenuItem;
    soustraction: TMenuItem;
    SaveDialog1: TSaveDialog;
    suprimer: TMenuItem;
    PAXY: TMenuItem;
    SavetoPAXY1: TMenuItem;
    ReadfromPAXY1: TMenuItem;
    surmoniteur: TMenuItem;
    vieuxprg: TMenuItem;
    readW31: TMenuItem;
    N5: TMenuItem;
    graph: TMenuItem;
    Label8: TLabel;
    caNumEdit: TEditReal;
    cbNumEdit: TEditReal;
    MinEdit: TSpinEdit;
    MaxEdit: TSpinEdit;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ChoixspectreClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure spaxChange(Sender: TObject);
    procedure fermer1Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure choixspectreChange(Sender: TObject);
    procedure maxeditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure nouveau1Click(Sender: TObject);
    procedure Effacer1Click(Sender: TObject);
    procedure maxeditChange(Sender: TObject);
    procedure mineditChange(Sender: TObject);
    procedure Sommes1Click(Sender: TObject);
    procedure spbxchange(Sender: TObject);
    procedure Sauvegarder1Click(Sender: TObject);
    procedure openspectreClick(Sender: TObject);
    procedure SavetoPAXYClick(Sender: TObject);
    procedure calculsomme;
    procedure additionClick(Sender: TObject);
    procedure soustractionClick(Sender: TObject);
    procedure suprimerClick(Sender: TObject);
    procedure surmoniteurClick(Sender: TObject);
    procedure readW31Click(Sender: TObject);
    procedure spCxChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ReadfromPAXY1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);

  private
  taX,tay:integer;
  bknd1:tbitmap;
  bknd2:tbitmap;
  vind:integer;
  procedure fermeture(var msg:tmessage); message wm_fermeture;
    procedure wmredessiner(var msg:tmessage); message wm_redessiner;
  { Dclarations prives}
  public
  coloris:integer;
  somgraphform:tSommeSpectre2DForm;
  procedure curseurs;
  procedure redimensionne;
  procedure redessiner;
  constructor Create(AOwner: TComponent;X:integer;Y:integer);virtual;
  end;

implementation

uses dialogNewSpectrum, PilotageManipMainForm, dialogaddspectrum;

{$R *.DFM}

constructor Tdeuxdform.Create(AOwner: TComponent;X:integer;Y:integer);
begin
inherited create(Aowner);
taX:=X;
taY:=Y;
end;

procedure Tdeuxdform.FormCreate(Sender: TObject);
var
i:integer;
tf:boolean;
min,max:real;
begin
bknd1:=tbitmap.create;
bknd2:=tbitmap.create;
bknd1.pixelformat:= pf32bit;
bknd2.pixelformat:= pf32bit;
tf:=false;vind:=-1;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
begin
choixspectre.items.add(deuxd.spect[i].nom);
if not tf then begin
choixspectre.text:=deuxd.spect[i].nom;
vind:=i;
taX:=deuxd.spect[vind].x;
tay:=deuxd.spect[vind].y;
deuxd.spect[vind].minmax(min,max);
minedit.value:=round(min);
maxedit.value:=round(max);
tf:=true;
end;
end;
redimensionne;
coloris:=7;combobox2.text:='gris';
redessiner;
image1.popupmenu:=nil;
image2.popupmenu:=nil;
end;
{*******************************************
*}
procedure Tdeuxdform.ChoixspectreClick(Sender: TObject);
var i:integer;
begin
{reinitialisation des items de choixspectre a chaque ouverture du combo}
choixspectre.items.clear;

for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
   choixspectre.items.add(deuxd.spect[i].nom);

end;
{*******************************************
*}
procedure Tdeuxdform.redimensionne;
begin
height:=tay*2+109;width:=tax*2+110;
spay.maxvalue:=tay;spby.maxvalue:=tay;
spax.maxvalue:=tax;spbx.maxvalue:=tax;
spax.value:=tax div 10;spbx.value:=(tax*9) div 10;
spay.value:=tay div 10;spby.value:=(tay*9) div 10;
bknd1.width:=taX;
bknd1.height:=taY;
bknd2.width:=taX;
bknd2.height:=taY;
bknd2.transparentcolor:=clwhite;
{x1pos:=10;y1pos:=10;
x2pos:=tax-10;y2pos:=tay-10;}
end;
{*******************************************
*}

procedure Tdeuxdform.Button1Click(Sender: TObject);
begin
redessiner;
end;
{*******************************************
*}
procedure Tdeuxdform.wmredessiner(var msg:tmessage);
begin
redessiner;
end;
{*******************************************
redessiner}
procedure Tdeuxdform.redessiner;
var
  x,y : integer;
  P : PintArray;
  min,u:real;
  u2,u1:integer;


begin
min:=minedit.value;
if maxedit.value<>min then begin
u:=31/(maxedit.value-minedit.value);
if coloris<>7 then begin
    case coloris of
    0:u1:=8;
    1:u1:=$800;
    2:u1:=$80000;
    3:u1:=$80800;
    4:u1:=$80008;
    5:u1:=$808;
    else
    u1:=$80808;
    end;
    for y := 0 to taY-1 do
    begin
      P := Bknd1.ScanLine[y];
    for x := 0 to taX -1 do begin
    u2:=round((deuxd.spect[vind].data[x,y].z-min)*u);
    if u2>31 then u2:=31;
    if u2<0 then u2:=0;
    p[x]:=u2*u1;
    end;
    end;
end else begin
u:=15/(maxedit.value-minedit.value);
    for y := 0 to taY-1 do
    begin
     P := Bknd1.ScanLine[y];
    for x := 0 to taX -1 do begin
    u2:=round((deuxd.spect[vind].data[x,y].z-min)*u);
    if u2>15 then u2:=15;
    if u2<0 then u2:=0;
    p[x]:=u2*couleur[u2];
    end;
 end;
end;
end else begin
    for y := 0 to taY-1 do
    begin
      P := Bknd1.ScanLine[y];
    for x := 0 to taX -1 do P[x] :=30;
    end;
end;
image1.Picture.graphic:=bknd1;
image2.Picture.graphic:=bknd2;
curseurs;

edit1.text:=deuxd.spect[vind].comment;
moniteur.text:=floattostr(deuxd.spect[vind].data[0,0].mon);
calculsomme;

end;
{*******************************************
*calcul du total du carre central}
procedure Tdeuxdform.calculsomme;
var
  total:real;
  i,j,minx,miny,maxx,maxy:integer;
begin

total:=0;
if  spbx.value>spax.value then
    begin
    maxx:=spbx.value;
    minx:=spax.value;
    end
else begin
     minx:=spbx.value;
     maxx:=spax.value;
     end;

if  spby.value>spay.value then
    begin
    maxy:=spby.value;
    miny:=spay.value;
    end
else begin
     miny:=spby.value;
     maxy:=spay.value;
     end;
{calcul}
for i:=minx-1 to maxx-1 do
      for j:=miny-1 to maxy-1 do
          total:=total+deuxd.spect[vind].data[i,j].Z;

somme.text:=floattostr(total);
integrale:=somme.text;
end;
{*******************************************
*}
procedure Tdeuxdform.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (button=mbleft) then begin
if ssshift in shift then begin
spcx.value:=round(x*taX/image2.width);
spcy.value:=round(y*taY/image2.height);
end else begin
spax.value:=round(x*taX/image2.width);
spay.value:=round(y*taY/image2.height);
end;
end;
if button=mbright then begin
spbx.value:=round(x*taX/image2.width);
spby.value:=round(y*taY/image2.height);
end;
end;
{*******************************************
*}
procedure tdeuxdform.curseurs;
begin
image2.canvas.brush.color:=clwhite;
image2.canvas.pen.color:=clwhite;
image2.canvas.rectangle(0,0,taX-1,taY-1);
image2.canvas.pen.color:=clred;
image2.canvas.moveto(0,spay.value);
image2.canvas.lineto(taX-1,spay.value);
image2.canvas.moveto(spax.value,0);
image2.canvas.lineto(spax.value,taY-1);
image2.canvas.pen.color:=clblue;
image2.canvas.moveto(0,spby.value);
image2.canvas.lineto(taX-1,spby.value);
image2.canvas.moveto(spbx.value,0);
image2.canvas.lineto(spbx.value,taY-1);
if somgraphform<>nil then
begin
somgraphform.cax:=spax.value;
somgraphform.cay:=spay.value;
somgraphform.cbx:=spbx.value;
somgraphform.cby:=spby.value;
somgraphform.ccx:=spcx.value;
somgraphform.ccy:=spcy.value;
somgraphform.redessine;
end;
end;
{*******************************************
*}
procedure Tdeuxdform.spaxChange(Sender: TObject);
begin
curseurs;
canumedit.value:=deuxd.spect[vind].data[spax.value-1,spay.value-1].z;
calculsomme;
end;
{*******************************************
*}
procedure Tdeuxdform.spbxchange(Sender: TObject);
begin
curseurs;
cbnumedit.value:=deuxd.spect[vind].data[spbx.value-1,spby.value-1].z;
calculsomme;
end;
{*******************************************
*}
procedure Tdeuxdform.fermeture(var msg:tmessage);
begin
if somgraphform<>nil then somgraphform.release;
release;
end;
{*******************************************
*}
procedure Tdeuxdform.fermer1Click(Sender: TObject);
begin
if somgraphform<>nil then somgraphform.release;
release;
end;
{*******************************************
*}
procedure Tdeuxdform.ComboBox2Change(Sender: TObject);
begin
coloris:=combobox2.itemindex;
redessiner;
end;
{*******************************************
*}
procedure Tdeuxdform.choixspectreChange(Sender: TObject);
var
min,max:real;
begin
vind:=deuxd.indexof(choixspectre.text);
if vind>=1 then
  begin
  taX:=deuxd.spect[vind].x;
  tay:=deuxd.spect[vind].y;
  deuxd.spect[vind].minmax(min,max);
  minedit.value:=round(min);
  maxedit.value:=round(max);
  {redimensionne;}
  redessiner;
  {modification du spectre dans la fenetre somgraph}
  if somgraphform<>nil then
    begin
    somgraphform.spectreindex:=vind;
    somgraphform.redessine;
    end;

  end;
end;
{*******************************************
* }
procedure Tdeuxdform.maxeditMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
redessiner;
end;
{*******************************************
*}
procedure Tdeuxdform.nouveau1Click(Sender: TObject);
var
i:integer;
begin
enterdlg.editeur.text:='';
enterdlg.editeur.maxlength:=15;
if enterdlg.showmodal=mrOK then
if enterdlg.editeur.text<>'' then begin
deuxd.addspectre(enterdlg.editeur.text,tax,tay);
i:=choixspectre.items.add(enterdlg.editeur.text);
choixspectre.itemindex:=i;
choixspectrechange(sender);
end;
end;

{*******************************************
*}
procedure Tdeuxdform.Effacer1Click(Sender: TObject);
begin
vind:=deuxd.indexof(choixspectre.text);
deuxd.spect[vind].clear;
end;
{*******************************************
* }
procedure Tdeuxdform.maxeditChange(Sender: TObject);
begin
if maxedit.value<=minedit.value then
maxedit.value:=minedit.value+1;
end;
{*******************************************
*}
procedure Tdeuxdform.mineditChange(Sender: TObject);
begin
if maxedit.value<=minedit.value then
minedit.value:=maxedit.value-1;
end;
{*******************************************
*}
procedure Tdeuxdform.Sommes1Click(Sender: TObject);
begin
if somgraphform=nil then
   begin
   somgraphform:=tSommeSpectre2DForm.create(principalform);
   somgraphform.spectreindex:=vind;
   somgraphform.panel1.color:=panel2.color;
   curseurs;
   end
else
    somgraphform.windowstate:=wsnormal;
end;
{*******************************************
sauvegarde, attention: on ne doit pas saisir l'extension
du fichier dans la boite de dialogue}
procedure Tdeuxdform.Sauvegarder1Click(Sender: TObject);

begin
savedialog1.initialDir:=boitnoir.RepertoireManip.text;

if savedialog1.execute then
begin
deuxd.spect[vind].savetofile(savedialog1.filename);
end;
end;

{*******************************************
lit un spectre a partir d'un fichier}
procedure Tdeuxdform.openspectreClick(Sender: TObject);

begin
opendialog1.initialDir:=boitnoir.RepertoireManip.text;

if opendialog1.execute then begin
deuxd.spect[vind].readfromfile(opendialog1.filename);
redessiner
end;
end;

{*********************************************
sauvegarde le spectre en cours au format PAXY }

procedure Tdeuxdform.SavetoPAXYClick(Sender: TObject);

begin
{tres provisoir}
deuxd.spect[vind].savetoPAXY(boitnoir.RepertoireManip.text+'\','titre','nom','date','heure','temps',1);
end;
{*********************************************
lit un spectre au format PAXY }
procedure Tdeuxdform.ReadfromPAXY1Click(Sender: TObject);
var titre,nom,date,heure,temps:string;
begin
opendialog1.initialDir:=boitnoir.RepertoireManip.text;

if opendialog1.execute then begin
deuxd.spect[vind].readfromPAXY(opendialog1.filename,titre,nom,date,heure,temps);
redessiner;
end;
end;
{**************************************
cree une fenetre dialogaddform pour l'addition   }
procedure Tdeuxdform.additionClick(Sender: TObject);
begin
Application.CreateForm(Tdialogaddform, dialogaddform);
end;
{**************************************
cree une fenetre dialogaddform pour la soustraction  }
procedure Tdeuxdform.soustractionClick(Sender: TObject);
begin
Application.CreateForm(Tdialogaddform, dialogaddform);
dialogaddform.operation.text:='-';
end;
{************************************
suprime le spectre en cours}
procedure Tdeuxdform.suprimerClick(Sender: TObject);
begin
deuxd.deletespectre(vind);
choixspectre.text:=deuxd.spect[1].nom;
choixspectreChange(Sender);
end;
{**************************************
divise le spectre en cours par moniteur.text
et mise du moniteur a 1}
procedure Tdeuxdform.surmoniteurClick(Sender: TObject);

var i,j:integer;

begin
for i:=0 to 127 do
    for j:=0 to 127 do
    deuxd.spect[vind].data[i,j].Z:=deuxd.spect[vind].data[i,j].Z/strtofloat(moniteur.text);

deuxd.spect[vind].data[0,0].mon:=1;
end;
{********************************************
procedure de lecture des anciens fichiers format texte}
procedure Tdeuxdform.readW31Click(Sender: TObject);

var i,j,len,k:integer;
    f: textfile;
    temp,data:string;

begin
opendialog1.initialdir:='a:\';
if opendialog1.execute then
   begin
   assignfile(f,opendialog1.filename);
   reset(f);
   for i:=0 to 127 do
       for j:=0 to 127 do
           begin
           if (i<>127) or (j<>127) then
           begin
           readln(f,temp);
           len:=length(temp);
           k:=0;
           repeat
           k:=k+1;
           until temp[k]=#9;
           repeat
           k:=k+1;
           until temp[k]<>' ';
           data:='';
           repeat
           data:=data+temp[k];
           k:=k+1;
           until temp[k]=#9;
           deuxd.spect[1].data[j,i].Z:=strtofloat(data);
           repeat
           k:=k+1;
           until temp[k]<>' ';
           data:='';
           repeat
           data:=data+temp[k];
           k:=k+1;
           until k=len+1;
           deuxd.spect[2].data[j,i].Z:=strtofloat(data);
           end
           else
           begin
           deuxd.spect[1].data[i,j].Z:=0;
           deuxd.spect[2].data[i,j].Z:=0;
           end;
           end;

   closefile(f);
   end;
end;

{******************************}
procedure Tdeuxdform.spCxChange(Sender: TObject);
begin
if (spcx.text<>'') and (spcy.text<>'') then
if somgraphform<>nil then
    begin
    somgraphform.ccx:=spcx.value;
    somgraphform.ccy:=spcy.value;
    somgraphform.redessine;
    end;
end;
{******************************
permet de modifier le commentaire}
procedure Tdeuxdform.Edit1Change(Sender: TObject);
begin
deuxd.spect[vind].comment:=edit1.text;
end;




procedure Tdeuxdform.Button3Click(Sender: TObject);
var
i,j:integer;
begin
und.spect[und.indexof('VE')].clear;
for i:=0 to 255 do
for j:=spay.value to spby.value do
und.spect[und.indexof('VE')].data[i,0].z:=deuxd.spect[vind].data[i,j].z+und.spect[und.indexof('VE')].data[i,0].z;
end;

end.
