unit ITC4drv;
{ ITC4 DRive on COM2 RS232
la communication avec l'ITC4 n'est pas sans faille }
{ si on envoie une serie de commandes, certaines finissent pas ne plus repondre }
{ SOLUTION: utiliser flushbuffer avant toute operation                          }
{ Probleme: on ne locke pas Remote/Local      }
{           cependant si l'utilisateur passe en local,  et oublie d'y revenir on est dans la merde }
{           car on envoie pas sytmatiquement de C3                                                }
{ prevoir une fonction Remote }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Comrs232, StdCtrls, Spin, EditReal,boitenoire,DrapeauAlloulUnit;

type
  TITC4 = class(TForm)
    StringToSend: TEdit;
    SendButton: TButton;
    memo1: TMemo;
    Display: TButton;
    Regulation: TButton;
    GetStatusButton: TButton;
    SetTempBox: TEditReal;
    GainPbox: TEditReal;
    Label1: TLabel;

    Label2: TLabel;
    Label3: TLabel;
    GazFlowLevelBox: TEdit;
    GainIntBox: TEditReal;
    TestMarconiButton: TButton;
    ChannelBox: TSpinEdit;
    CommPortITC4Driver: TCommPortDriver;
    ChangeHeaterStatus: TButton;
    ChangeGazFlowStatus: TButton;
    HeaterStatus: TLabel;
    GazFlowStatus: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    TempBox: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PropValue: TLabel;
    IntValue: TLabel;
    Label9: TLabel;
    GainDerivBox: TEditReal;
    DerivValue: TLabel;
    Label10: TLabel;
    maxheater: TEditReal;
    ChangeToLocal: TButton;
    ChangeToRemote: TButton;
    Label11: TLabel;
    heatervalue: TLabel;
    gazflowvalue: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    SetTemperature: TLabel;
    HeaterLevelBox: TEdit;
    Label14: TLabel;
    procedure CommPortITC4driverReceiveData(Sender: TObject;s:string;
      DataSize: Integer);
    procedure DisplayClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure StringToSendKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RegulationClick(Sender: TObject);
    procedure GetStatusButtonClick(Sender: TObject);
    procedure ouverture;
    procedure GazFlowLevelBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OpenSerialPort; {ajout Alloul}
    procedure CloseSerialPort; {ajout Alloul}
    procedure RafraichirITC4;
    procedure TestMarconiButtonClick(Sender: TObject);
    procedure ChangeHeaterStatusClick(Sender: TObject);
    procedure ChangeGazFlowStatusClick(Sender: TObject);
    procedure SetTempBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainPboxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainIntBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GainDerivBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure maxheaterKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ChangeToLocalClick(Sender: TObject);
    procedure ChangeToRemoteClick(Sender: TObject);
    function  readSetTemperature_ITC4():real;
    procedure HeaterLevelBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState); { ok }
      private

      FTempInBuffer              : pointer;
    { envoi d'une chaine et lecture sur l'ITC4 }
    function sendread(su:string):string;
    { Dclarations prives }
  public
    { Dclarations publiques }
    { lecture du status de l'ITC4 }
    function GetStatusA:byte;
    function GetStatusC:byte;
    function GetStatusS:byte;
    { passage en rgulation automatique (pour le heater) }
    procedure SetHeaterAuto_ITC4;
    { passage en rgulation automatique (pour la NV) }
    procedure SetGazFlowAuto_ITC4;
    { passage en rgulation automatique (pour le heater) }
    procedure SetHeaterManual_ITC4;
    { passage en rgulation automatique (pour la NV) }
    procedure SetGazFlowManual_ITC4;
    { definition du gain P en pourcents }
    procedure SetProportionnal_ITC4(p:real);
    { definition du gain I en pourcents }
    procedure SetIntegral_ITC4(i:real);
    { definition du gain P en pourcents }
    procedure SetDerivative_ITC4(d:real);
    procedure SetMaxHeater_ITC4(d:real);

    { lecture de la temprature sur le channel "channel", OUTPUT en kelvin }
    function readTemperature_ITC4(channel:byte):real; { ok }
    { change le display de l'affichage sur un des toris canaux de lecture }
    procedure DisplayTemperature_ITC4(channel:byte); { ok }
    { choix du channel pour la regulation }
    procedure SetRegulationChannel_ITC4(channel:byte);
    { definition d'un SetPoint }
    procedure setTemperature_ITC4(Tempera:real);
    { ouverture de la needle valve }
    procedure setGazFlow_ITC4(opening:integer);
    {changement du heater}
    procedure setHeater_ITC4(value:real);

  end;

var
  ITC4: TITC4;
  xtc:boolean; { quoi qu'est-ce? }

implementation

{$R *.DFM}

{ initialisation de la connection et verification si l'ITC4 est allum }
procedure TITC4.FormCreate(Sender: TObject);
var s:string;
begin
     {initialisation de la connexion RS232 necessaire ensuite}
      CommPortITC4driver.ComPort:=pnCOM2; // Choose pnCOM1 or pnCOM2
      CommPortITC4driver.ComPortSpeed:= br9600; //9600 Bauds
      CommPortITC4driver.ComPortDataBits           := db8BITS; // 8 data bits
      CommPortITC4driver.ComPortStopBits           := sb1BITS; // 1 stop bit
      CommPortITC4driver.ComPortParity             := ptNONE;  // no parity
      CommPortITC4driver.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
      CommPortITC4driver.ComPortSwHandshaking      := shNONE;


  xtc:=true;
  GetMem( FTempInBuffer,10);
  CommPortITC4driver.connect;
  CommPortITC4driver.FlushBuffers(true,true);
  s:=sendread('C3'+#13);
  if s[1]<> 'C' then
     begin
            messagebox(handle,'ITC4 not answering','Attention!',mb_ok)
     end;
{  Itc4.Closeserialport;}
end;

procedure TITC4.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
ITC4.WindowState:=WsMinimized;
ITC4.WindowState:=WsNormal;
end;

procedure TITC4.FormDestroy(Sender: TObject);
begin
  ITC4.closeSerialPort;
end;

{ pourquoi faut-il redefinir cette procedure ici ??? }
procedure TITC4.CommPortITC4driverReceiveData(Sender: TObject;
  s:string; DataSize: Integer);
var
s1:string[2];
begin
s1:=copy(s,length(s),1);
s:=copy(s,1,length(s)-1);
if s1=#6 then s:=s+' :ack';
if s1=#21 then s:=s+' :nack';
memo1.lines.add(s);
end;

{ procdure criture/lecture sur l'ITC4 }
{ INPUT: su, chaine a envoyer           }
{ OUTPUT: la chane de rponse          }
{ N.B. aprs les chaines utiles, il y a des caractres supplmentaires qui arrivent !!! }
{ il ne faut pas en tenir compte }
function TITC4.sendread(su:string):string;
var
u:integer;
p:pchar;
s1:string[1];
s:string;
u1,u2:double;
fin:boolean;
begin
{  s:=su+#13;            { WHY?, c'est deja rajout dans les chaines envoyes au bidule }
  s:=su;
  CommPortITC4driver.SendData( pchar(s),length(s));
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0001 est le timeout }
 while (u1+0.0001>time) and (s1[1]<>#13) and (s1[1]<>#10) do
  begin
    u:=_hread(CommPortITC4driver.comhandle,@Ftempinbuffer^,1);
     if u>0 then
        begin
          p:=Ftempinbuffer;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then result:=s else result:='timeout';
end;

{ =========================================================== }
{ procdures gnrales de pilotage de l'ITC4                  }
{ =========================================================== }

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: An, defining the AUTO/MAN status }
function TITC4.GetStatusA:byte;
var
   ca:string;
   s:string;
begin
{   ITC4.openSerialPort;}
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusA:=round(strtofloat(copy(s,4,1)));
{   ITC4.CloseSerialPort; }
end;

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: Cn, defining the Lock/Rem status }
function TITC4.GetStatusC:byte;
var
   ca:string;
   s:string;
begin
{   ITC4.openSerialPort;}
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusC:=round(strtofloat(copy(s,6,1)));
{   ITC4.CloseSerialPort; }
end;

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: Sn, defining the Sweep status }
function TITC4.GetStatusS:byte;
var
   ca:string;
   s:string;
begin
{   ITC4.openSerialPort;}
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusS:=round(strtofloat(copy(s,8,2)));
{   ITC4.CloseSerialPort; }
end;

{ passage en rgulation automatique (pour le heater) }
{ on laisse la regul NV dans l'tat ou elle tait }
procedure TITC4.SetHeaterAuto_ITC4;
var s:string;
    An:byte;
begin
{   ITC4.openSerialPort;}
   An:=GetStatusA;
   s:='aa';
   case An of
      0:s:=sendread('A1'+#13);
      1:s:=sendread('A1'+#13);
      2:s:=sendread('A3'+#13);
      3:s:=sendread('A3'+#13);
   end;
   memo1.lines.add(s);
   RafraichirITC4;
{   ITC4.CloseSerialPort; }
end;

{ passage en rgulation automatique (pour la NV) }
procedure TITC4.SetGazFlowAuto_ITC4;
var s:string;
    An:byte;
begin
{   ITC4.openSerialPort;}
   An:=GetStatusA;
   s:='aa';
   case An of
      0:s:=sendread('A2'+#13) ;
      1:s:=sendread('A3'+#13)  ;
      2:s:=sendread('A2'+#13) ;
      3:s:=sendread('A3'+#13) ;
   end;
   memo1.lines.add(s);
   RafraichirITC4;
{   ITC4.CloseSerialPort;}
end;

{ passage en rgulation manuelle (pour le heater) }
procedure TITC4.SetHeaterManual_ITC4;
var s:string;
    An:byte;
begin

   An:=GetStatusA;
{   ITC4.openSerialPort;}
   s:='aa';
   case An of
{      0:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      1:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      2:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;
      3:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;}
      0:s:=sendread('A0'+#13);
      1:s:=sendread('A0'+#13);
      2:s:=sendread('A2'+#13);
      3:s:=sendread('A2'+#13);
   end;
   memo1.lines.add(s);
   RafraichirITC4;
   {   ITC4.CloseSerialPort;  }
end;

{ passage en rgulation manuelle (pour la NV) }
procedure TITC4.SetGazFlowManual_ITC4;
var s:string;
    An:byte;
begin
   An:=GetStatusA;
 {  ITC4.openSerialPort;}
   s:='aa';
   case An of
      0:s:=sendread('A0'+#13);
      1:s:=sendread('A1'+#13);
      2:s:=sendread('A0'+#13);
      3:s:=sendread('A1'+#13);
   end;
   memo1.lines.add(s);
   RafraichirITC4;
   {  ITC4.CloseSerialPort; }
end;

{ definition du gain P en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetProportionnal_ITC4(p:real); { ok }
var
   ca:string;
   p1:real;
   s:string;
begin
 { ITC4.openSerialPort;}
   p1:=round(p*10);
   str(p1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   s:=sendread('P'+ca+#13);
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;

{ definition du gain I en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetIntegral_ITC4(i:real); { ok }
var
   ca:string;
   i1:real;
   s:string;
begin
{  ITC4.openSerialPort;}
   i1:=round(i*10);
   str(i1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   s:=sendread('I'+ca+#13);
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;

{ definition du gain D en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetDerivative_ITC4(d:real); { ok }
var
   ca:string;
   d1:real;
   s:string;
begin
{  ITC4.openSerialPort;}
   d1:=round(d*10);
   str(d1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   s:=sendread('D'+ca+#13);
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;

procedure TITC4.SetMaxHeater_ITC4(d:real); { ok }
var
   ca:string;
   d1:real;
   s:string;
begin
   d1:=round(d*10);
   str(d1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   s:=sendread('M'+ca+#13);
   memo1.lines.add(s);
end;


    { lecture de la temperature }
{ INPUT: channel, channel de lecture }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
function TITC4.readTemperature_ITC4(channel:byte):real; { ok }
var
   ca:string;
   temp1:real;
   s:string;
begin
   if (channel>=1) and (channel<=3) then
   begin
{  ITC4.openSerialPort;}
   str(channel,ca);
   s:='aa';
   while s[1]<>'R' do begin s:=sendread('R'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   temp1:=strtofloat(copy(s,3,length(s)-3));
   result:=temp1/10; { facteur 10 depend des settings internes de l'ITC4)  }
{  ITC4.CloseSerialPort;}
   end
   else begin result:=9999;messagebox(handle,'Channel non disponible sur ITC4','Attention!',mb_ok) end;
   TempBox.caption:=floattostr(result);
   ITC4LastReadTemperature:=result;


{ajout Alloul : securite : si il lit entre 0 et 5 K, il demande 300K en automatique}
{   if (result>0) and (result<4.5) then
      begin
      SetGazFlowAuto_ITC4;
      SetHeaterAuto_ITC4;
      setTemperature_ITC4(20);
      end;
   if (result>450) and (result<1000) then
      begin
      SetGazFlowAuto_ITC4;
      SetHeaterAuto_ITC4;
      setTemperature_ITC4(300);
      end;
 }

end;

function TITC4.readSetTemperature_ITC4():real; { ok }
var
   ca,chaine:string;
   temp1:real;
   s:string;
begin
   s:='aa';
   while s[1]<>'R' do begin s:=sendread('R0'+#13) end;
   memo1.lines.add(s);
   temp1:=strtofloat(copy(s,3,length(s)-3));
   result:=temp1/10; { facteur 10 depend des settings internes de l'ITC4)  }
   str(result:8:2,chaine);
   settemperature.caption:=chaine;
   settemperature.refresh;

end;

procedure TITC4.setHeater_ITC4(value:real);
{en volts sans virgules}
var temp1:integer;
    ca,s:string;
begin
    temp1:=round(value);
    str(temp1:3,ca);
    memo1.lines.add(ca);
    s:='aa';
    while s[1]<>'O' do begin s:=sendread('O'+ca+#13)  end;
    memo1.lines.add(s);
end;

procedure TITC4.DisplayTemperature_ITC4(channel:byte); { ok }
var
   ca:string;
   temp1:real;
   s:string;
begin
{  ITC4.openSerialPort;}
   str(channel,ca);
   s:='aa';
   while s[1]<>'F' do begin s:=sendread('F'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;

{ choix du channel pour la regulation }
{ INPUT: channel, channel a partir duquel on va faire la regulation }
{ OUTPUT: none                       }
procedure TITC4.SetRegulationChannel_ITC4(channel:byte);
var
   ca:string;
   status:byte;
   s:string;
begin

{ il faut d'abord passe en manuel passage duheater et du gas flow en manuel }
{  ITC4.openSerialPort;}
   s:='aa';
   while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
   memo1.lines.add(s);
{ changement du channel de regulation }
   CommPortITC4driver.FlushBuffers(true,true);
   str(channel,ca);
   s:='aa';
   while s[1]<>'H' do begin s:=sendread('H'+ca+#13)  end;
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;


{ ouverture de la needle valve }
{ INPUT: channel, channel a partir duquel on va faire la regulation }
{ OUTPUT: none                       }
procedure TITC4.setGazFlow_ITC4(opening:integer);
var
   ca:string;
   temp1:real;
   s:string;
begin
{  ITC4.openSerialPort;}
   temp1:=round(opening);
   str(temp1:3:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'G' do begin s:=sendread('G'+ca+#13)  end;
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}
end;

{ definition d'un SetPoint }
{ INPUT: temp, temperature en Kelvin }
{ OUTPUT: on envoie la consigne  l'ITC4 }
procedure TITC4.setTemperature_ITC4(Tempera:real);
var
   ca:string; indice:integer;
   tempera1,tempera2:real;
   s:string;
begin
{ajout Alloul : limite en temperature  5K-400K}
   if (tempera>0) and (tempera<400) then
   begin
{   ITC4.openSerialPort;}
    tempera1:=round(tempera*10);
    str(tempera1:4:0,ca);
    memo1.lines.add(ca);
    s:='aa';
    while s[1]<>'T' do begin s:=sendread('T'+ca+#13)  end;
    memo1.lines.add(s);
    {on relit sur l'itc4le parametre TSet qu'on vient d'envoyer}
    tempera2:=readSetTemperature_ITC4;
    {si on ne retrouve pas pareil, on ferme : on reessaye plusieurs fois et
    on ferme tout si ca ne marche toujours pas}
    if (tempera<>tempera2) then
        begin
        {on reessaye dix fois d'abord}
        indice:=0;
        repeat
              tempera2:=0;
              indice:=indice+1;
              s:='aa';
              while s[1]<>'T' do begin s:=sendread('T'+ca+#13)  end;
              memo1.lines.add(s);
              {on relit sur l'itc4le parametre TSet qu'on vient d'envoyer}
              tempera2:=readSetTemperature_ITC4;
              {si a echoue encore, on stoppe tout}
        until (indice>10) or (tempera=tempera2);
        {si ca ne marche toujours pas on bloque tout}
        if (tempera<>tempera2) then
            begin
            {passage en manuel de gaz flow et consigne  0}
            SetGazFlowManual_ITC4;
            setGazFlow_ITC4(0);
            {passage en manuel du heater et consigne  0}
            SetHeaterManual_ITC4;
            SetHeater_ITC4(0);
            messagebox(handle,'ITC4 does not get the proper order when temperature is asked so ITC4 is reset to 0','Attention!',mb_ok);
            end;
        end;




   end
                       else
    boitnoir.receivetext('ATTENTION, LIMITE EN TEMPERATURE DEPASSEE, CONSIGNE NON EXECUTEE');

end;

{ ========================================================== }
{ procdures de test                                         }
{ ========================================================== }

procedure TITC4.DisplayClick(Sender: TObject);
var channel,i:integer;
    s,ca:string;
begin
     DisplayTemperature_ITC4(ChannelBox.value);
end;

procedure TITC4.SendButtonClick(Sender: TObject);
var
s:string;
s1:string[2];
begin
{  ITC4.openSerialPort;}
   {  CommPortITC4driver.connect; }
   s:=stringToSend.text;
   s:=sendread(s+#13);
{   memo1.lines.add(s+'X'); } { to vizualiaze the extra characters }
   s1:=copy(s,length(s),1);
   s:=copy(s,1,length(s)-1);
   if s1=#6 then s:=s+' :ack';
   if s1=#21 then s:=s+' :nack';
   memo1.lines.add(s);
{  ITC4.CloseSerialPort;}

end;


procedure TITC4.StringToSendKeyPress(Sender: TObject; var Key: Char);
var
s:string;
s1:string[2];
begin
if key=#13 then begin
s:=sendread(StringToSend.text+#13);
s1:=copy(s,length(s),1);
s:=copy(s,1,length(s)-1);
if s1=#6 then s:=s+' :ack';
if s1=#21 then s:=s+' :nack';
memo1.lines.add(s);
end;
end;

procedure TITC4.RegulationClick(Sender: TObject);
begin
    SetRegulationChannel_ITC4(ChannelBox.value);
end;

procedure TITC4.GetStatusButtonClick(Sender: TObject);
var A,C,S:byte;
begin
     GetStatusA
end;

procedure TITC4.GazFlowLevelBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x:real;err:integer;y:integer;
begin
  if  Key=13 then
  begin
     val(GazFlowLevelBox.text,x,err);
     if err=0 then
       begin
       {passage en manuel}
       SetGazFlowManual_ITC4;
       {demande de la valeur}
       y:=round(10*x);
       if (y>=0) and (y<=1000) then begin
                                   setGazFlow_ITC4(y);
                                   end;
       end;
     gazflowlevelbox.text:='';
   end;

end;


procedure TITC4.OpenSerialPort; {ajout Alloul}
begin
  GetMem( FTempInBuffer,10);
  CommPortITC4driver.connect;
  CommPortITC4driver.FlushBuffers(true,true);
end;


procedure TITC4.CloseSerialPort;
begin
  CommPortITC4driver.Disconnect;
  FreeMem( FTempInBuffer,10);
end;


procedure TITC4.RAfraichirITC4;
var s:string;
    An:byte;
    nombre:extended;err:integer;
begin
   HeaterStatus.caption:='NOT KNOWN';
   GazFlowStatus.caption:='NOT KNOWN';
   ChangeHeaterStatus.caption:='Change not possible';
   ChangeGazFlowStatus.caption:='Change not possible';
   An:=GetStatusA;
   case An of
      0:begin
        HeaterStatus.caption:='MANUAL';
        GazFlowStatus.caption:='MANUAL';
        ChangeHeaterStatus.caption:='Change to AUTO';
        ChangeGazFlowStatus.caption:='Change to AUTO';
        end;
      1:begin
        HeaterStatus.caption:='AUTO';
        GazFlowStatus.caption:='MANUAL';
        ChangeHeaterStatus.caption:='Change to MANUAL';
        ChangeGazFlowStatus.caption:='Change to AUTO';
        end;
      2:begin
        HeaterStatus.caption:='MANUAL';
        GazFlowStatus.caption:='AUTO';
        ChangeHeaterStatus.caption:='Change to AUTO';
        ChangeGazFlowStatus.caption:='Change to MANUAL';
        end;
      3:begin
        HeaterStatus.caption:='AUTO';
        GazFlowStatus.caption:='AUTO';
        ChangeHeaterStatus.caption:='Change to MANUAL';
        ChangeGazFlowStatus.caption:='Change to MANUAL';
        end;
   end;
   heaterstatus.refresh;
   gazflowstatus.refresh;
   TempBox.caption:=floattostr(ReadTemperature_ITC4(ChannelBox.value));
   {LECTURE DU Gaz Flow}
   s:=sendread('R7'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 gazflowvalue.Caption:=floattostr(nombre)+'%';
                 gazflowvalue.refresh;
                 end;
   {LECTURE DU heater en Volts}
   s:=sendread('R6'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 heaterValue.Caption:=floattostr(nombre)+' Volts';
                 heaterValue.refresh;
                 end;
   {LECTURE DU Prop}
   s:=sendread('R8'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 propvalue.Caption:=floattostr(nombre);
                 propvalue.refresh;
                 end;
   {LECTURE DU Int}
   s:=sendread('R9'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 intvalue.Caption:=floattostr(nombre);
                 intvalue.refresh;
                 end;
  {LECTURE DU Deriv}
   s:=sendread('R10'+#13);
   s:=copy(s,3,length(s)-1);
   val(s,nombre,err);
   if err=0 then begin
                 nombre:=nombre/10;
                 derivvalue.Caption:=floattostr(nombre);
                 derivvalue.refresh;
                 end;
end;



procedure TITC4.TestMarconiButtonClick(Sender: TObject);
begin
RafraichirITC4;
end;

procedure TITC4.ChangeHeaterStatusClick(Sender: TObject);
begin
RafraichirITC4;
if (heaterstatus.caption='AUTO') then SetHeaterManual_ITC4
                                 else SetHeaterAuto_ITC4;
end;

procedure TITC4.ChangeGazFlowStatusClick(Sender: TObject);
begin
RafraichirITC4;
if (gazflowstatus.caption='AUTO') then SetGazFlowManual_ITC4
                                 else SetGazFlowAuto_ITC4;

end;

procedure TITC4.SetTempBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then
          begin
        SetTemperature_ITC4(SetTempBox.value);
        settempbox.Text:='';
        end;

end;

procedure TITC4.GainPboxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then  begin
          SetProportionnal_ITC4(gainPbox.Value);
          gainPbox.Text:='';
        end;
end;

procedure TITC4.GainIntBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then   begin
          SetIntegral_ITC4(gainIntbox.Value);
          gainintbox.text:='';end;
end;

procedure TITC4.GainDerivBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then  begin
           SetDerivative_ITC4(gainDerivbox.Value);
           gainderivbox.text:='';
           end;
end;

procedure TITC4.maxheaterKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then begin
          SetMaxHeater_ITC4(MaxHeater.Value);
          maxheater.text:='';
          end;
end;

procedure TITC4.ChangeToLocalClick(Sender: TObject);
var s:string;
begin
   {passe en mode remote}
   s:=sendread('C2'+#13);
end;

procedure TITC4.ChangeToRemoteClick(Sender: TObject);
var s:string;
begin
   {passe en mode local}
   s:=sendread('C3'+#13);
end;

procedure TITC4.HeaterLevelBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x:real;err:integer;y:integer;
begin
  if  Key=13 then
  begin
     val(HeaterLevelBox.text,x,err);
     if err=0 then
       begin
       {passage en manuel}
       SetHeaterManual_ITC4;
       {demande de la valeur}
       y:=round(10*x);
       if (y>=0) and (y<=1000) then begin
                                   setHeater_ITC4(y);
                                   end;
       end;
     gazflowlevelbox.text:='';
   end;

end;

end.
