unit reception;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,editdata,DrapeauAlloulUnit;

const
pafreq=$300;
pbfreq=pafreq+1;
pcfreq=pbfreq+1;
pcofreq=pcfreq+1;
padeph=$304;
pbdeph=padeph+1;
pcdeph=pbdeph+1;
pcodeph=pcdeph+1;


type
  TFenetre_reception = class(TForm)
    GainHF1: TEdit;
    GainLo0: TEdit;
    GainBF0: TEdit;
    PhaseFLo1: TEdit;
    GainHF2: TEdit;
    GainLo90: TEdit;
    GainBF90: TEdit;
    PhaseFLo2: TEdit;
    L_GainHF1: TLabel;
    L_GainHF2: TLabel;
    L_GainLo0: TLabel;
    L_GainLo90: TLabel;
    L_GainBF0: TLabel;
    L_GainBF90: TLabel;
    L_PhaseFLo1: TLabel;
    L_PhaseFLo2: TLabel;
    Freq: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    HELPbutton: TButton;
    MemoHelp: TMemo;
    CloseHelpButton: TButton;
  procedure ouverture;

    procedure Change_gainHF1(Sender: TObject;var key:char);
    procedure Change_gainHF2(Sender: TObject; var Key: Char);
    procedure Change_gainLo01(Sender: TObject; var Key: Char);
    procedure Change_gainLo90(Sender: TObject; var Key: Char);
    procedure Change_gainBF0(Sender: TObject; var Key: Char);
    procedure Change_gainBF90(Sender: TObject; var Key: Char);
    procedure Change_phase1(Sender: TObject; var Key: Char);
    procedure Change_phase2(Sender: TObject; var Key: Char);
    procedure Change_Freq(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure SauveParametresRMN;
    procedure HELPbuttonClick(Sender: TObject);
    procedure CloseHelpButtonClick(Sender: TObject);  {resauve tous les parametres RMN de la reception
         dans le fichier Parametres RMN.txt}

  private
    { Dclarations prives}


  public
    { Dclarations publiques}
  end;

procedure initfreqem;
procedure initfreq;
procedure initfreqrec;
procedure change_gainrec(i:smallint;value:smallint);


var
  fenetre_reception: TFenetre_reception;

implementation

{$R *.DFM}

procedure TFenetre_reception.ouverture;
var sender:Tobject;
begin
  Fenetre_reception.WindowState:=WsMinimized;
  Fenetre_reception.WindowState:=wsNormal;
end;

procedure TFenetre_reception.Change_Freq(Sender: TObject; var Key: Char);
var value,err:integer;
{Apres un return, on va rinitialiser le parametre chang}
begin
 if key=#13 then
    begin
      Initfreqem;
      SauveParametresRMN;
    end;
end;


procedure TFenetre_reception.Change_gainHF1(Sender: TObject; var key:char);
var value,err:integer;
{Apres un return, on va rinitialiser le parametre chang}
begin
 if key=#13 then
    begin
       val(gainHF1.text,value,err);
       if value>0 then
            begin
            change_gainrec(0,value);
            SauveParametresRMN;
            end

          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              end;
    end;
end;

procedure TFenetre_reception.Change_gainHF2(Sender: TObject;
  var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(gainHF2.text,value,err);
       if value>0 then
            begin
            change_gainrec(1,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              gainHF2.text:='255';
              end;
    end;

end;

procedure TFenetre_reception.Change_gainLo01(Sender: TObject;
  var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(gainLo0.text,value,err);
       if value>0 then
            begin
            change_gainrec(2,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              gainLo0.text:='255';
              end;
    end;

end;
procedure TFenetre_reception.Change_gainLo90(Sender: TObject;
  var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(gainLo90.text,value,err);
       if value>0 then
            begin
            change_gainrec(3,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              gainLo90.text:='255';
              end;
    end;

end;

procedure TFenetre_reception.Change_gainBF0(Sender: TObject;
  var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(gainBF0.text,value,err);
       if value>0 then
            begin
            change_gainrec(4,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              gainBF0.text:='255';
              end;
    end;

end;

procedure TFenetre_reception.Change_gainBF90(Sender: TObject;
  var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(gainBF90.text,value,err);
       if value>0 then
            begin
            change_gainrec(5,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              gainBF90.text:='255';
              end;
    end;

end;

procedure TFenetre_reception.Change_phase1(Sender: TObject; var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(phaseFLo1.text,value,err);
       if value>0 then
            begin
            change_gainrec(6,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              phaseFLo1.text:='255';
              end;
    end;

end;

procedure TFenetre_reception.Change_phase2(Sender: TObject; var Key: Char);
var value,err:integer;
begin
 if key=#13 then
    begin
       val(phaseFLo2.text,value,err);
       if value>0 then
            begin
            change_gainrec(7,value);
            SauveParametresRMN;
            end
          else
              begin
              MessageDlg('Valeur erronne', mtWarning, [mbOk], 0);
              phaseFLo2.text:='255';
              end;
    end;

end;

{---------------------------------------------------------------------------------}
{** Anciennes procedures de compil.pas pour initialiser la reception**}

{initialisation des frquences}
    procedure initfreq;
    begin
    asm
    mov dx,pcofreq
    mov ax,$80
    out dx,al
    mov dx,pcodeph
    mov ax,$80
    out dx,al
    end;
    initfreqrec;{Initialise curpa^.fr : pas utilise chez nous tant qu'on utilise la mme voie pour emission et reception ?}
    initfreqem;
    {initfreqem2;}  {Initialise curpa^.fx : pas utilise chez nous tant qu'on a un seul canal emission ?}
    asm
    mov ax,$00
    mov dx,padeph
    out dx,al
    mov dx,pcdeph
    out dx,al
    end;
    end;

{initialisation frquence rception}
    procedure initfreqrec;
    var
    a1,a2,a3,a4:byte;
    ahi,alo:integer;
    fr:longint;
    begin
    {fr:=round(curpa^.fr.val/60000000*256*256*256*256);}
    fr:=round(8000000/60000000*256*256*256*256);
    ahi:=fr div (256*256);
    alo:=fr-ahi*256*256;
    a1:=lo(alo);a2:=hi(alo);a3:=lo(ahi);a4:=hi(ahi);
    asm
    mov dx,pbfreq
    mov ax,$EA
    out dx,al
    mov dx,pafreq
    mov al,a1
    out dx,al
    mov dx,pcfreq
    mov ax,$F0
    out dx,al
    mov ax,$70
    out dx,al
    mov ax,$F0
    out dx,al
    mov dx,pafreq
    mov al,a2
    out dx,al
    mov dx,pcfreq
    mov ax,$F1
    out dx,al
    mov ax,$71
    out dx,al
    mov ax,$F1
    out dx,al
    mov dx,pafreq
    mov al,a3
    out dx,al
    mov dx,pcfreq
    mov ax,$F2
    out dx,al
    mov ax,$72
    out dx,al
    mov ax,$F2
    out dx,al
    mov dx,pafreq
    mov al,a4
    out dx,al
    mov dx,pcfreq
    mov ax,$F3
    out dx,al
    mov ax,$73
    out dx,al
    mov ax,$F3
    out dx,al
    mov ax,$D3
    out dx,al
    mov ax,$F3
    out dx,al
    mov ax,$0F
    mov ax,$F8
    mov dx,pbfreq
    out dx,al
    mov ax,$0F
    mov dx,pbdeph
    out dx,al
    end;
    end;

{initialisation frquence mission}
    procedure initfreqem;
    var
    a1,a2,a3,a4:byte;
    ahi,alo:integer;
    fr:longint;
    err:integer;
    begin
    Val(fenetre_reception.Freq.text, fr,err );
    if err=0 then fr:=round(fr/60000000*256*256*256*256) else MessageDlg('Mauvaise lecture frquence', mtWarning, [mbOk], 0);
    ahi:=fr div (256*256);
    alo:=fr-ahi*256*256;
    a1:=lo(alo);a2:=hi(alo);a3:=lo(ahi);a4:=hi(ahi);
    {messagebox(getfocus,'toto','toto',mb_ok);}
    asm
    mov dx,pbfreq
    mov ax,$F1
    out dx,al
    mov dx,pafreq
    mov al,a1
    out dx,al
    mov dx,pcfreq
    mov ax,$F0
    out dx,al
    mov ax,$70
    out dx,al
    mov ax,$F0
    out dx,al
    mov dx,pafreq
    mov al,a2
    out dx,al
    mov dx,pcfreq
    mov ax,$F1
    out dx,al
    mov ax,$71
    out dx,al
    mov ax,$F1
    out dx,al
    mov dx,pafreq
    mov al,a3
    out dx,al
    mov dx,pcfreq
    mov ax,$F2
    out dx,al
    mov ax,$72
    out dx,al
    mov ax,$F2
    out dx,al
    mov dx,pafreq
    mov al,a4
    out dx,al
    mov dx,pcfreq
    mov ax,$F3
    out dx,al
    mov ax,$73
    out dx,al
    mov ax,$F3
    out dx,al
    mov ax,$D3
    out dx,al
    mov ax,$F3
    out dx,al
    mov ax,$F8
         mov dx,pbfreq
    out dx,al
    end;
    end;

procedure change_gainrec(i:smallint;value:smallint);
    {procedure appelle prgrec dans compil.pas}
    {i dsigne le gain  changer
    0 gainHF1
    1 gainHF2
    2 gainLo0
    3 gainLo90
    4 gainBF0
    5 gainBF90
    6 phase1
    7 phase2}

    const
    add=$340; {306  on suppose les bits 0 pour data,1 pour clock et 2 pour load barre}
    add1=$343;
    label
    prgrec1,prgrec2;
    begin
    asm
        mov ax,80h            {initialisation PIA ecriture DAC}
        mov dx,add1
        out dx,al
        mov ax,04h            {LD barre=1}
        mov dx,add
        out dx,al
        mov ecx,3

    {il se boucle dans la boucle  venir pdt 6 minutes, pourquoi ?????}

prgrec1:mov ax,i               {N de CNA a programmer}
        dec cx
        shr ax,cl
        and ax,01h
        or ax,04h              {LD Barre=1 CLK=0}
        out dx,al
        or ax,06h              {LD Barre=1 CLK=1}
        out dx,al
        and ax,0FDh            {LD Barre=1 CLK=0 fb?}
        out dx,al
        inc cx
        loop prgrec1
        mov ecx,8               {On s'occuppe des datas}
prgrec2:mov ax,value
        dec cx
        shr ax,cl
        and ax,01h
        or ax,04h              {LD Barre=1 CLK=0}
        out dx,al
        or ax,06h              {LD Barre=1 CLK=1}
        out dx,al
        and ax,0FDh            {LD Barre=1 CLK=0 fb?}
        out dx,al
        inc cx
        loop prgrec2
        mov ax,0               {LD Barre=0}
        out dx,al
        mov ax,04h             {LD Barre=1}
        out dx,al
        end;

    end;


procedure TFenetre_reception.FormCreate(Sender: TObject);
var chaine,valeur,nomFichier:string;
    fich:textfile;err,i:integer;key:char;Xvaleur:extended;

begin
  {relie les valeurs de parametres entres la fois derniere dans le fichier
  Parametres RMN.txt dans c:\NewSpectro\}
  {

  Parametres RMN :

  Reception Amplifiers
  GainHF1
  140
  GainHF2
  160
  GainLo0
  150
  GainLo90
  150
  GainBF0
  130
  GainBF90
  160
  Phase F+Lo1
  200
  Phase F+Lo2
  200
  Frequence Lo = 15*F
  14000000
  ***************************
  Acquisition GAGE Parameters
  Chanel A (Volts)
  1
  Chanel B (Volts)
  1
  Chanel A (Mode)
  DC  (ou AC)
  Chanel B (Mode)
  DC  (ou AC)
  Nb Points
  4096 (16 32 64 128 256 512 1024 2048 4096 8192)
  Digit Freq
  10 MHz (10 MHz 5 MHz 4 MHz 2 MHz 1 MHz 500 KHz 200 KHz 100 KHz
          50 KHz  20 KHz  10 KHz 5 KHz 2 KHz  1 KHz EXTERNE)
  Trigger : sign, chanel, voltage (en Volts), mode
  POSITIF (NEGATIF)
  VOIE A  (VOIE B    VOIES A et B    EXTERNE   SOFT)
  1.00
  DC (AC)
  ******************************
  Last Pulse Sequence
  Echo 2 pulses mode vary.seq}

  chaine:=LitDansParametresRMN('Gain HF1 old hetero');
  if chaine<>'' then GainHF1.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain HF2 old hetero');
  if chaine<>'' then GainHF2.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain Lo0 old hetero');
    if chaine<>'' then GainLo0.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain Lo90 old hetero');
    if chaine<>'' then GainLo90.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain BF0 old hetero');
    if chaine<>'' then GainBF0.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain BF90 old hetero');
    if chaine<>'' then GainBF90.Text:=chaine;
  chaine:=LitDansParametresRMN('Phase F+Lo1 old hetero');
    if chaine<>'' then PhaseFLo1.Text:=chaine;
  chaine:=LitDansParametresRMN('Phase F+Lo2 old hetero');
    if chaine<>'' then PhaseFLo2.Text:=chaine;
  chaine:=LitDansParametresRMN('Frequence Lo = 15*F old hetero');
    if chaine<>'' then freq.Text:=chaine;
{validation des parametres de la fenetre reception}
  initfreq; {initialise les frequences}
  key:=#13;
  {revalidation de tous les gains de la fenetre}
  Change_gainHF1(Sender,key);Change_gainHF2(Sender,key);
  Change_gainLo01(Sender,key);Change_gainLo90(Sender,key);
  Change_gainBF0(Sender,key);Change_gainBF90(Sender,key);
  Change_Phase1(Sender,key);Change_Phase2(Sender,key);

  {ruse pour eviter un bug classique : je revalide la case Freq en ajoutant 1 puis
  en enlevant 1}
  val(Freq.Text,Xvaleur,err);
  if (err=0) and (Xvaleur<>0) then
     begin
     Freq.text:=inttostr(round(Xvaleur)+1);Freq.refresh;
     Change_Freq(Sender,key);
     Freq.text:=inttostr(round(Xvaleur));Freq.refresh;
     Change_Freq(Sender,key);
     end;

end;

procedure TFenetre_reception.SauveParametresRMN;  {resauve tous les parametres RMN de la reception
        dans le fichier Parametres RMN.txt}
var chaine,valeur,nomFichier:string;
    fich:textfile;i,err:integer;
    chaineTableau:array[0..100] of string;
begin
  EcritDansParametresRMN('Gain HF1 old hetero',GainHF1.text);
  EcritDansParametresRMN('Gain HF2 old hetero',GainHF2.text);
  EcritDansParametresRMN('Gain Lo0 old hetero',GainLo0.text);
  EcritDansParametresRMN('Gain Lo90 old hetero',GainLo90.text);
  EcritDansParametresRMN('Gain BF0 old hetero',GainBF0.text);
  EcritDansParametresRMN('Gain BF90 old hetero',GainBF90.text);
  EcritDansParametresRMN('Phase F+Lo1 old hetero',phaseFLo1.text);
  EcritDansParametresRMN('Phase F+Lo2 old hetero',phaseFLo2.text);
  EcritDansParametresRMN('Frequence Lo = 15*F old hetero',freq.text);
end;


procedure TFenetre_reception.HELPbuttonClick(Sender: TObject);
begin
memoHelp.visible:=true;
CloseHelpButton.visible:=true;
end;

procedure TFenetre_reception.CloseHelpButtonClick(Sender: TObject);
begin
   closehelpButton.visible:=false;
   memoHelp.visible:=false;
end;

end.
