unit T1RunDialog;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Grids, Dialogs;

type
  TT1orT2dialogForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    DelayNameBox: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    leftcursor: TEdit;
    Label3: TLabel;
    rightcursor: TEdit;
    Label4: TLabel;
    leftbgd: TEdit;
    rightbgd: TEdit;
    Label5: TLabel;
    delayfile: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    resultfile: TEdit;
    DATAGrille: TStringGrid;
    LoadArrayButton: TButton;
    SaveArrayButton: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label8: TLabel;
    DoTFCheckBox: TCheckBox;
    Label9: TLabel;
    TFLeftCursor: TEdit;
    TFRightCursor: TEdit;
    Label11: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    TFRightBGD: TEdit;
    TFLeftBGD: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure LoadArrayButtonClick(Sender: TObject);
    procedure SaveArrayButtonClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DoTFCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  T1orT2dialogForm: TT1orT2dialogForm;

implementation

{$R *.DFM}

procedure TT1orT2dialogForm.FormCreate(Sender: TObject);
var i:integer;
begin
  {initialisation de la fenetre DataGrille}
  DataGrille.cells[1,0]:='Delay_(in_msec)';
  DataGrille.cells[2,0]:='Nb_of_points_for_Acquisition';
  for i:=1 to 50 do DataGrille.cells[0,i]:='point n'+inttostr(i);

end;

procedure TT1orT2dialogForm.LoadArrayButtonClick(Sender: TObject);
var filepara:string;
    fich:textfile;
    i,j:integer;nomFichier,chaine:string;
    nombre1,nombre2,nombre3,nombre4:extended;

begin
for i:=1 to DataGrille.colcount do
    for j:=1 to DataGrille.rowcount do datagrille.cells[j,i]:='';

     openDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if openDialog1.Execute then
         begin
         if FileExists(OpenDialog1.Filename) then
            begin
            {lit le fichier}
            nomFichier:=OpenDialog1.Filename;

            assignfile(fich,nomfichier);
            reset(fich);
            {lit la premiere ligne pour rien}
            readln(fich,chaine);
            i:=0;
            while not eof(fich) do
                  begin
                  i:=i+1;
                  readln(fich,nombre1,nombre2);
                  DataGrille.cells[1,i]:=floattostr(nombre1);
                  if Pos(',',DataGrille.cells[1,i])>0 then
                   begin
                   chaine:=copy(DataGrille.cells[1,i],1,Pos(',',DataGrille.cells[1,i])-1)+'.'+
                            copy(DataGrille.cells[1,i],Pos(',',DataGrille.cells[1,i])+1,length(DataGrille.cells[1,i])-Pos(',',DataGrille.cells[1,i]));
                   DataGrille.cells[1,i]:=chaine;
                   end;
                  DataGrille.cells[2,i]:=floattostr(nombre2);
                  if Pos(',',DataGrille.cells[2,i])>0 then
                   begin
                   chaine:=copy(DataGrille.cells[2,i],1,Pos(',',DataGrille.cells[2,i])-1)+'.'+
                            copy(DataGrille.cells[2,i],Pos(',',DataGrille.cells[2,i])+1,length(DataGrille.cells[2,i])-Pos(',',DataGrille.cells[2,i]));
                   DataGrille.cells[2,i]:=chaine;
                   end;
                  end;
            closefile(fich);
            delayfile.text:=NomFichier;
            end;
         end;


end;

procedure TT1orT2dialogForm.SaveArrayButtonClick(Sender: TObject);
var fich:textfile;
    err,i,j:integer;nomFichier,chaine:string;
    nombre1,nombre2:extended;

begin
     saveDialog1.Filter:='fichier donnees|*.dat|fichier ascii|*.asc|tous fichiers|*.*';
     if saveDialog1.Execute then
         begin
            {sauve le fichier}
            nomFichier:=saveDialog1.Filename;
            if copy(nomFichier,length(nomfichier)-3,1)<>'.' then nomFichier:=nomFichier+'.dat';
            assignfile(fich,nomfichier);
            rewrite(fich);
            {ecrit le nom des colonnes en premiere ligne}
            writeln(fich,DataGrille.cells[1,0],' ',DataGrille.cells[2,0]);
            for i:=1 to 50 do
                begin
                if (DataGrille.cells[1,i]<>'') then
                        begin
                        val(DataGrille.cells[1,i],nombre1,err);
                        val(DataGrille.cells[2,i],nombre2,err);
                        writeln(fich,nombre1,nombre2);
                        end;
                end;
            closefile(fich);
            delayfile.text:=nomFichier;
            end;


end;

procedure TT1orT2dialogForm.OKBtnClick(Sender: TObject);
begin
if delayfile.Text='' then
   begin
   MessageDlg('ATTENTION : you did not enter a name of delay file - the program will not work !', mtWarning, [mbOk], 0);
   end;   


end;

procedure TT1orT2dialogForm.DoTFCheckBoxClick(Sender: TObject);
begin
  if dotfcheckbox.state=cbchecked then
     begin
     label9.visible:=true;
     label10.visible:=true;
     label11.visible:=true;
     label12.visible:=true;
     label13.visible:=true;
     TFLeftCursor.visible:=true;
     TFRightCursor.visible:=true;
     TFLeftBGD.visible:=true;
     TFRightBGD.visible:=true;
     end
     else
     begin
     label9.visible:=false;
     label10.visible:=false;
     label11.visible:=false;
     label12.visible:=false;
     label13.visible:=false;
     TFLeftCursor.visible:=false;
     TFRightCursor.visible:=false;
     TFLeftBGD.visible:=false;
     TFRightBGD.visible:=false;
     end;

end;

end.
