unit gestgage;
{GESTION DE LA CARTE GAGE 1012}

{les parametres de la carte GAGE sont specifies dans AcquisitionRMN.FormCreate
et sont appeles de la}


  {ATTENTION : SI GestGage utilise une unit, quand une instruction du genre
  gage_read_config ou initialisation est lance, toute unit utilise perd
  son pointeur et donc tout son contenu...}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,gage_drv,editdata,
  StdCtrls,ExtCtrls, {Vcl_Ott,}sta1012 {,graph2 {doit on mettre ou non
  graph1D ?}, Spin, EditReal,DrapeauAlloulUnit;

const
     INTERPOLATE_TRIGGER_DISABLE = 32;
     boards_in_system=1;
     BLF            = 260;
     TRIG_TIMEOUT   = 10;
     BUSY_TIMEOUT   = 10;
     seg=$FFFF;
     ind=$FFFF;
     interpolate_trigger_channel= INTERPOLATE_TRIGGER_DISABLE;
     power2:array[1..15] of integer=(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384);

type
     pacqui=^tacqui;
     tacqui=array[0..32767] of byte;
type
     ptable1012=^ttableGAGE1012Long;
     ttableGAGE1012Long=array[0..16384] of longint;
     ptable1012smallint1012=^ttableGAGE1012;
     ttableGAGE1012=array[0..16384] of smallint{longint};



type
  Tacquisparam = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StartButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure STOPButtonClick(Sender: TObject);
    procedure InitButtonClick(Sender: TObject);
    procedure EDnivKeyPress(Sender: TObject; var Key: Char);
    procedure ChangeParametreEtInit(Sender:TObject);


  private
    { Dclarations prives}
  public
    { Dclarations publiques}
   procedure readconfig(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN,
   NMRFormCOVVAC,NMRFormCOVBC,NMRFormCOSLOPE,NMRFormCOSOURCE,
   NMRFormCOTRIGAC:integer;NMRFormEdNiv:string);
   procedure initialisation(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN,
   NMRFormCOVVAC,NMRFormCOVBC,NMRFormCOSLOPE,NMRFormCOSOURCE,
   NMRFormCOTRIGAC:integer;NMRFormEdNiv:string);
   procedure AcquisitionSansTimer(NbCoupsAFaire:integer;var NbCoupsFait:integer);
   procedure Gage1012GetDataBobAvecTableauSignes(NbCoupsAFaire:integer;var NbCoupsFait:integer);

  end;

var
{  graph2d: Tgraph1d;}
  acquisparam1012: Tacquisparam;
  acqon:boolean;
  tab1,tab2:ptable1012smallint1012;
  tab3,tab4:ptable1012;
  buffer:                 array[0..BLF] of char;
  typfft:integer;
  acqact:integer;
      procedure init_chan_memory_pointers (board, chan, operation_mode: int16; tbs: single; var trig: int32;
                var start: int32; var endaddr: int32);
      procedure init_memory_pointers (board, operation_mode: int16; tbs: single; var trig: address;
                 var start: address; var endaddr: address);
      procedure   Timing (point1msec: word);
      function InitBoard(hwindow:hwnd): integer;
      procedure InitMemPtrs;
      procedure SetBoard{(hwindow:hwnd)};
      procedure AcquireStart;
      procedure transfertdat;

implementation

{uses ParSeq,Seq16Channels,seqnewhetero;}

{$R *.DFM}

procedure Tacquisparam.FormCreate(Sender: TObject);
var
cfgfn:pchar;
uu:word;
begin
DrapeauAcquisitionNMRencours:=false;
DrapeauGAGEdejaInitialise:=false;
DrapeauAcquisitionVientDeFinir:=false;
cfgfn:='c:\windows\gagescop.inc';
tab1:=new(ptable1012smallint1012);tab2:=new(ptable1012smallint1012);
tab3:=new(ptable1012);tab4:=new(ptable1012);
curpa^.range_e	:= GAGE_PM_1_V;
typfft:=0;
end;

procedure Tacquisparam.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        dispose(curpa);
        dispose(savecurpa);
        dispose(gage);
        dispose(tab1);
        dispose(tab2);
        dispose(tab3);
        dispose(tab4);
end;

procedure Tacquisparam.StartButtonClick(Sender: TObject);
{Bouton ACQUISITION Simple}

begin
{InitButtonClick(Sender);
NbCoupsAFaireNMR:=NbCoupsAFaireBox.value;
NbCoupsDejaFaitNMR:=0;
DrapeauAcquisitionNMREnCours:=true;}
end;



procedure Tacquisparam.readconfig(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN,
   NMRFormCOVVAC,NMRFormCOVBC,NMRFormCOSLOPE,NMRFormCOSOURCE,
   NMRFormCOTRIGAC:integer;NMRFormEdNiv:string);
{INITIALISE LES PARAMETRES GAGE}
var err,i,indice:integer;
var chaine,chainevaleur,nom:string;
    fich:textfile;
var ednivValue:real;

begin


curpa^.range_e	:= GAGE_PM_1_V;
case NMRFormedfreq  of
   0: curpa^.srindex 	:= 22;
   1: curpa^.srindex 	:= 21;
   2: curpa^.srindex 	:= 20;
   3: curpa^.srindex 	:= 19;
   4: curpa^.srindex 	:= 18;
   5: curpa^.srindex 	:= 17;
   6: curpa^.srindex 	:= 16;
   7: curpa^.srindex 	:= 15;
   8: curpa^.srindex 	:= 14;
   9: curpa^.srindex 	:= 13;
   10: curpa^.srindex 	:= 12;
   11: curpa^.srindex 	:= 11;
   12: curpa^.srindex 	:= 10;
   13: curpa^.srindex 	:= 9;
   14: curpa^.srindex 	:= 42; {ext clock}
end;

curpa^.range_a 	:= NMRFormcovaran;
curpa^.couple_a := NMRFormcovvac+1;
curpa^.range_b 	:= NMRFormcovbran;
curpa^.couple_b := NMRFormcovbc+1;
curpa^.source 	:= NMRFormcosource+1;
curpa^.slope	:= NMRFormcoslope+1;
curpa^.depth	:= NMRFormEDPOINTS+5;
NbPointsParChannel:=power2[curpa^.depth];
val(NMRFormedniv,ednivValue,err);
curpa^.level	:= round(ednivValue*4096/10);
curpa^.range_e	:= GAGE_PM_1_V;
curpa^.couple_e	:= NMRFormcotrigac+1;
curpa^.multiple:=false;

{redimensionnement de ECHO et OSCILLO, puis reecriture de l'axe X de ECHO et OSCILLO}
indice:=und.indexof('ECHO');
und.spect[indice].X:=NbPointsParChannel;
{base de temps en microsecondes}
for i:=0 to NbPointsParChannel-1 do
             begin
              und.spect[indice].data[i,0].X:=i*gage^.srtable[curpa^.srindex].sr_calc/1000;
              und.spect[indice].data[i,0].Z:=0;
              und.spect[indice].data[i,0].mon:=0;
             end;

indice:=und.indexof('OSCILLO');
und.spect[indice].X:=NbPointsParChannel;
{base de temps en microsecondes}
for i:=0 to NbPointsParChannel-1 do
             begin
              und.spect[indice].data[i,0].X:=i*gage^.srtable[curpa^.srindex].sr_calc/1000;
              und.spect[indice].data[i,0].Z:=0;
              und.spect[indice].data[i,0].mon:=0;
             end;
TimePerChannel:=gage^.srtable[curpa^.srindex].sr_calc/1000;
end;

procedure Tacquisparam.Timer1Timer(Sender: TObject);
{**********************}
{NON UTILISE MAINTENANT}
{**********************}
{appel par un timer}
var
vr,vs:int16;
chaine:string;
i,indice:integer;
label tt1;
begin
{  vr:=gage_triggered;vs:=gage_busy;
  if (vr>2) and (DrapeauAcquisitionNMRencours) and (DrapeauGAGEdejaInitialise) and (vs=0) then
  begin
    transfertdat;
    for i:=1 to NbPointsParChannel do
        begin
        tab3^[i]:=tab3^[i]+tab1^[i];tab4^[i]:=tab4^[i]+tab2^[i];
        end;
    {transfert du data GAGE moyenn}
 {   indice:=und.indexof('ECHO');
    for i:=1 to NbPointsParChannel do
    begin
    und.spect[indice].data[i-1,0].z:=tab3^[i];
    und.spect[indice].data[i-1,0].mon:=tab4^[i];
    end;
    {transfert du data GAGE un coup}
  {  indice:=und.indexof('OSCILLO');
    for i:=1 to NbPointsParChannel do
    begin
    und.spect[indice].data[i-1,0].z:=tab1^[i];
    und.spect[indice].data[i-1,0].mon:=tab2^[i];
    end;


    NbCoupsDejaFaitNMR:=NbCoupsDejaFaitNMR+1;

    if NbCoupsDejaFaitNMR>=NbCoupsAFaireNMR then {fin de l'acquisition}
   {    begin
       DrapeauAcquisitionNMRencours:=false;
       DrapeauAcquisitionVientDeFinir:=true;
       end
                               else
       acquirestart;
  end;}

end;



procedure Tacquisparam.STOPButtonClick(Sender: TObject);
begin
DrapeauAcquisitionNMRencours:=false;
DrapeauAcquisitionVientDeFinir:=true;
end;
{----------------------------------------------------------}
function InitBoard(hwindow:hwnd): integer;
var
rec:int16;
segment:uint16;
index:uint16;
typename:uint16;
status:uint16;
begin
rec:=0;
segment:=0;
index:=0;
     if gage_driver_initialize(gage_board_location, GAGE_MEMORY_SIZE_TEST) = 0 then
     begin
          MessageBox(HWindow, 'No Compuscope boards found', 'Error', mb_ok);
     end;
     {Timing (100);} { Let the relays settle. }
     gage_select_board(1);  {Select master}
end;





procedure init_interpolate_trigger (board, trigger_source, operation_mode, trigger_level, trigger_slope: int16);
begin
      gage_reset_interpolate_trigger (0, GAGE_CHAN_A, 0, 0, 0); {Disable interpolated trigger.}
end;


procedure init_chan_memory_pointers (board, chan, operation_mode: int16; tbs: single; var trig: int32;
                              var start: int32; var endaddr: int32);
begin
    gage_select_board (board);
    gage_calculate_addresses (chan AND 1, operation_mode, tbs, trig, start, endaddr);
{    gage_get_interpolate_trigger(0,chan and 1,trig,start,endaddr);}
end;


procedure init_memory_pointers (board, operation_mode: int16; tbs: single; var trig: address;
                               var start: address; var endaddr: address);
var
    i:int16;
    trigr,startr,endaddrr:int32;
begin
     if interpolate_trigger_channel<interpolate_trigger_disable then begin
    gage_select_board (board);
    gage_calculate_addresses (interpolate_trigger_channel AND 1, operation_mode, tbs, trigr, startr, endaddrr);
{    gage_get_interpolate_trigger(0,interpolate_trigger_channel and 1,trigr,startr,endaddrr);}
     end;
     FOR i:=0 to 1 do  begin
         init_chan_memory_pointers (1, i, operation_mode, tbs, trig[i], start[i], endaddr[i]);
      end;
end;

procedure Timing (point1msec: word);
begin
     { CX: Loop Counter }
     { Pascal takes care of the stack for your. }
     asm
        xor ecx,ecx
        mov  cx,point1msec
        jcxz @t2_fast_return   { Routine required no timeout. }

     @t2_init_timer_2:

        mov  al,10110110B      { Init T/C 2, 2 bytes, Mode 3, Binary count.}
        out  43h,al

        mov  ax,1193           { Timing constant = approximately 1,000 Hz.}
        mov  ax,119            { Timing constant = approximately 10,000 Hz.}
        out  42h,al            { Loat Timer #2. }
        mov  al,ah
        out  42h,al

        in   al,61h            { Get Current 8255 port 1 value. }
        and  al,0fch           { Clear last two bits of port. }
        or   al,1              { Turn Timer #2 GATE on. }
        out  61h,al

     @t2_wait_expire_time:

     @t2_low_to_high:

        in   al,61h            { Get timer 2 status. Use 61h because it's not an PC/XT. }
        test al,20h            { Test the Timer channel 2 bit. }
        jnz  @t2_low_to_high   { Loop until it is low. }

     @t2_wait_high:

        in   al,61h            { Get timer 2 status. }
        test al,20h            { Test the bit again. }
        jz   @t2_wait_high     { Loop until it goes high. }
        loop @t2_wait_expire_time    { Loop CX times. }

     @t2_return:
        in   al,61h            { Get current port values. }
        and  al,0fch           { Clear speaker bit. }

     @t2_fast_return:
   end;
end;

procedure InitMemPtrs;
begin
init_memory_pointers (1, curpa^.opmode, gage^.srtable[curpa^.srindex].sr_calc, gage^.trigger_address,
                          gage^.starting_address,gage^.ending_address);
end;

procedure SetBoard{(hwindow:hwnd)};
var
     i: int16;
     error_code: int16;
     tempstr: string[8];
     error_str: array[0..7] of char;
     j:integer;
begin
     if curpa^.multiple then gage_multiple_record(1) else gage_multiple_record(0);
     gage_capture_mode(curpa^.opmode,gage^.srtable[curpa^.srindex].rate,gage^.srtable[curpa^.srindex].mult);
     {gage_init_clock;}
     gage_input_control(GAGE_CHAN_A, GAGE_INPUT_ENABLE, curpa^.couple_a, curpa^.range_a);
     if curpa^.opmode = GAGE_SINGLE_CHAN then
          gage_input_control(GAGE_CHAN_B, GAGE_INPUT_ENABLE, curpa^.couple_a, curpa^.range_a)
     else
          gage_input_control(GAGE_CHAN_B, GAGE_INPUT_ENABLE, curpa^.couple_b, curpa^.range_b);
     gage_get_driver_info(board_info);
     j:=NbPointsParChannel;
     if curpa^.multiple then
     gage_trigger_control(curpa^.source, curpa^.couple_e, curpa^.range_e,curpa^.slope, curpa^.level,256)
     else
     gage_trigger_control(curpa^.source, curpa^.couple_e, curpa^.range_e,curpa^.slope, curpa^.level,j);
      {gage_multiple_record(1);}
       gage^.buffer_size := board_info.max_available_memory;
       gage^.buffer_mask := gage^.buffer_size - 1;
end;

procedure AcquireStart;
var
    auto_trigger: int16;
    vr,vs:int16;
    chaine1,chaine2:string;
    i:integer;
begin
{if curpa^.source = GAGE_SOFTWARE then
         auto_trigger := 1 else auto_trigger := 0;}
     {asm gestion interuptions}
    {mov dx,0200h}
     {mov al,04
     out dx,al
     mov al,10100100b
     inc dx
     out dx,al
     mov al,00100100b
     out dx,al
     mov al,10100100b
     out dx,al}
   {  mov al,03
     mov dx,0200h
     out dx,al
     inc dx
     mov al,$1F
     out dx,al
     mov al,$0F
     out dx,al
     dec dx
     mov al,01
     out dx,al
     inc dx
     mov al,$83
     out dx,al
     end;}

    { autre methode que gage_start_capture :
    gage_init_clock;
    gage_get_data;
    mais ne faitpasgagner de temps}

   gage_start_capture(0);


{ gage_start_capture(0); {si on met (1) ca autotrigge sans regarder
    le trigger externe, si on met (0) c'est l'inverse}
end;


procedure transfertdat;
    var
      blck,i,j:integer;
          startbloc:word;
       pdep:longint;
       mask:byte;
       ind:integer;
       transfer:array[0..32767] of uInt8{word{byte};
       offset:word;
       blocktransferred:{smallint}int16;
       aa,yy,final:smallint;{16 bits sign}
       gain,conversionFactor:extended;
     begin
     pdep:=NbPointsParChannel;
     if pdep>4096 then pdep:=4096;
     mask:=gage^.srtable[curpa^.srindex].mask;
     InitMemPtrs;
     gage_need_ram(1);
     loc := gage^.trigger_address[0];
     startbloc:=loc div 4096;
     offset:=loc mod 4096;
     {transfert d'un coup du data : modif Fermon / Alloul sept 2001
     en utilisant gage_32k_to_buffer

     POUR GAGNER ENCORE PLUS EN TEMPS (1/3), il faudrait construire tab1 comme
     un tableau  la fois d'entier long et court, comme ca, ca permettrait
     de faire directement gage32ktobuf(tab1,0,startblock,blocktransferred)
     Voir avec Fermon}

    {debut transfert nouvelle methode par buffer 32k
    quelque soit le nb de points
    Rep mini = 42 msec
    DONC methode toujours aussi ou plus rapide que l'autre mothode
    pt par pt sauf pour 512 points}

{    gage_32k_to_buffer(transfer[0],0,startbloc,blocktransferred);    }
    {il delivre le nombre cod en 16 bits signs sous forme de deux blocs chacun
    de 8 bits. Il faut juste les recoller, et les mettre dans une variable
    16 bits signs, tab1}

     if offset<32768-8192  then
     for i:=1 to pdep do
            tab1^[i]:=(transfer[2*i+1+2*offset] shl 8) or transfer[2*i+2*offset];

     {gage_32k_to_buffer(transfer[0],1,startbloc,blocktransferred);}
     if offset<32768-8192  then
     for i:=1 to pdep do
         tab2^[i]:=(transfer[2*i+1+2*offset] shl 8) or transfer[2*i+2*offset];

  {debut transfert ancienne methode point par point
    4096 points Rep mini = 140 msec
    2048 points Rep = 70 msec
    1024 points Rep = 47 msec
    512 points Rep = 33 msec}
    { for i:=1 to pdep do
         begin
         tab1^[i]:=gage_mem_read_chan_a((i+loc) mod gage^.buffer_mask);
         end;
     loc := gage^.trigger_address[1];
     for i:=1 to pdep do
         begin
         tab2^[i]:=gage_mem_read_chan_b((i+loc)mod gage^.buffer_mask);
         end;    }
         {fin ancienne methode point par point}
     gage_need_ram(0);
end;


procedure Tacquisparam.AcquisitionSansTimer(NbCoupsAFaire:integer;var NbCoupsFait:integer);
{la bonne procedure pour acquerir en boucle}
var vr,vs:int16;
chaine:string;
start,compteur,err,i,j,indice,nbAcquisitions:integer;
timeout,DrapeauFirstShot,DrapeauAlternance:boolean;
DelayOneCanal:extended;
canalmarker1,canalmarker2,canalmarker3,canalmarker4:integer;
iteration,AmplitudeMarker,canalnomarker1,canalnomarker2,canalnomarker3,canalnomarker4:integer;
StartDelayPreviousSequence,StartDelayThisSequence,StartDelay,EndDelay:longword;
Caractere:char;
label tt1;



begin
{trois possibilits : soustraction aveugle, soustraction avec un time check,
soustraction avec reconnaissance RS232}

  {si ancien spectro hetero, slt soustraction avec timecheck possible}
{  if DrapeauSpectroOldHetero=true then
    begin
    if DrapeauSequenceurTimeCheck=true then
            val(SeqPar.TempsRepetitionBox.text,REpetitionTime,err);
    DrapeauSequenceur16VoiesRecognitionStep:=false;
    end;
  {si sequenceur 16 voies Cromieres, soustraction avec RS232 check possible}
 { if (DrapeauSpectroHomodyne=true) and
     (DrapeauSequenceur16VoiesRecognitionStep=true) then
    begin
      Seq16ChannelsForm.openSerialPort;
      DrapeauSequenceurTimeCheck:=false;
    end;
  }
acquirestart;
{besoin juste au debut de l'acquisition pour preparer le trigger,
mais plus ensuite, au moins en mode 32k to buffer}
NbCoupsDejaFaitNMR:=0;
{if tab3=nil then
  begin
     dispose(tab1);dispose(tab2);dispose(tab3);dispose(tab4);
     new(tab3);new(tab4);new(tab2);new(tab1); {RECREE LES POINTEURS qui ont t
   dtruits on ne sait pas trop pourquoi en interferant avec l'appel  GAGE
   c'est Setboard qui detruit les pointeurs}
{  end;}
  tab1:=new(ptable1012smallint1012);tab2:=new(ptable1012smallint1012);
  tab3:=new(ptable1012);tab4:=new(ptable1012);

  for i:=1 to NbPointsParChannel do
    begin
    tab3^[i]:=0;tab4^[i]:=0;
    end;
{boucle d'acquisition}
NbCoupsDejaFaitNMR:=0;
DrapeauAlternance:=false;
compteur:=1;

{Ici, on relance la sequence de pulses chargee dans ParSeq/SeqPar
pour toujours demarrer du meme trigger :
tres important dans les modes ou il y a soustraction entre deux coups pour toujours
 la fin avoir l'echo dans le meme sens}

{a faire ici : eviter d'appeler ces procedures qui vont tout faire echouer

verifier dans la suite ou on utilise seqpar. et seqnewhetero...

verifier dans procedure SeqNEwhetero qd il rappelle un fichier pourquoi
il rappelle mal les parametres qu'il dcale tous dee une case
 }

drapeauStartAgainSequence:=true;
{attendre qu'il lance la sequence jq 100 msec}
start:= GetTickCount;
REPEAT
    timeout:= ((GetTickCount - start) > 100);
    Application.processMessages;
UNTIL (DrapeauStartAgainSequence=false) or (timeout);


StartDelayPreviousSequence:=gettickcount;
DrapeauFirstShot:=true;

repeat
NbCoupsDejaFaitNMR:=NbCoupsDejaFaitNMR+1;

application.processMessages;{reflechir si on veut un jour mettre Application.ProcessMessages;}{routine qui va scruter les valeurs de la fenetre avant
meme pendant une boucle}
{   application.processMessages;   }
   acquirestart; {on aimerait economiser du temps ici en enlevant acquirestart
   et en mettant la procedure assembleur qui regarde si il y a eu evennement trigger sans
   en chercher un nouveau}

{   asm
            mov dx,$200       {test fin}
{            xor ax,ax
            out dx,al
            inc dx
            in al,dx
            and al,$05 {test de l'arrive d'un trigger}
 {           cmp al,$04
            jnz tt1  {si pas d'arrive de trigger, il recommence la boucle : le label tt1
            est  la fin du repeat}
  { end;
      {cas ou il y a arrive d'un trigger : il transfert le data dans ce cas}

   repeat
   vr:=gage_triggered;vs:=gage_busy
   until (vr>2) and (vs=0);

   StartDelayThisSequence:=gettickcount; {on repere le temps initial avant transfert}

   if (vr>2) and (vs=0) then
    begin
    transfertdat;
    {MODE sans alternance : jamais besoin de verification}
    if (DrapeauModeAcquisition4pulses=false) and (drapeauModeAcquisition2pulses=false) then
        begin
           for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab1^[i];
                         tab4^[i]:=tab4^[i]+tab2^[i];
                         end;
        end;
    {******************************************************************}
    {MODE SANS VERIFICATION NI DE TEMPS NI VIA RS232}
    if (DrapeauSequenceurTimeCheck=false) and (DrapeauSequenceur16VoiesRecognitionStep=false) then
      begin
      {MODE SANS VERIFICATION 4 steps}
      if (DrapeauModeAcquisition4pulses=true) then
        begin
        {acquisition en mode  4 temps}
        if (compteur=1) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab1^[i];
                         tab4^[i]:=tab4^[i]+tab2^[i];
                         end;
              end;
        if (compteur=2) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab2^[i];
                         tab4^[i]:=tab4^[i]-tab1^[i];
                         end;
              end;
        if (compteur=3) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab1^[i];
                         tab4^[i]:=tab4^[i]-tab2^[i];
                         end;
              end;
        if (compteur=4) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab2^[i];
                         tab4^[i]:=tab4^[i]+tab1^[i];
                         end;
              end;
        compteur:=compteur+1;
        if compteur=5 then compteur:=1;
        end; {fin du mode 4 steps}
     {MODE SANS VERIFICATION 2 steps}
      if (DrapeauModeAcquisition2pulses=true) then
        begin
        {acquisition en mode  2 temps}

        {recherche eventuelle de la phase de la sequence,
        c'est  dire du compteur, via des marqueurs TTL}
        if (compteur=1) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab1^[i];
                         tab4^[i]:=tab4^[i]+tab2^[i];
                         end;
              end;
        if (compteur=2) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab1^[i];
                         tab4^[i]:=tab4^[i]-tab2^[i];
                         end;
              end;
        if compteur=1 then compteur:=2
                      else compteur:=1;
        end; {fin du mode 2 steps}

      end;
    {******************************************************************}
     {MODE AVEC VERIFICATION VIA TEMPS ECOULE}
     if (DrapeauSequenceurTimeCheck=true) and (DrapeauSequenceur16VoiesRecognitionStep=false) then
     begin
       {on repere le temps de repetition qui s'est coul}
       if ((StartDelayThisSequence-StartDelayPreviousSequence)>1.5*(TempsRepetition)) and (DrapeauFirstShot=false) then
         begin
            DrapeauFirstShot:=true;
            {on relance le sequenceur}
            drapeauStartAgainSequence:=true;
            {attendre qu'il se lance jq 100 msec}
            start:= GetTickCount;
            REPEAT
                timeout:= ((GetTickCount - start) > 100);
                Application.processMessages;
            UNTIL (DrapeauStartAgainSequence=false) or (timeout);
            StartDelayPreviousSequence:=StartDelayThisSequence;
            NbCoupsDejaFaitNMR:=NbCoupsDejaFaitNMR-1;
            compteur:=0;
         end
         else
         begin
          DrapeauFirstShot:=false;
          {4 steps avec verif temps ecoul}
          if (DrapeauModeAcquisition4pulses=true) then
          begin
          {acquisition en mode  4 temps}
          if (compteur=1) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab1^[i];
                         tab4^[i]:=tab4^[i]+tab2^[i];
                         end;
              end;
          if (compteur=2) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab2^[i];
                         tab4^[i]:=tab4^[i]-tab1^[i];
                         end;
              end;
          if (compteur=3) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab1^[i];
                         tab4^[i]:=tab4^[i]-tab2^[i];
                         end;
              end;
          if (compteur=4) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab2^[i];
                         tab4^[i]:=tab4^[i]+tab1^[i];
                         end;
              end;
          compteur:=compteur+1;
          if compteur=5 then compteur:=1;
          end; {fin du mode 4 steps}
          {MODE AVEC VERIFICATION 2 steps}
          if (DrapeauModeAcquisition2pulses=true) then
          begin
          {acquisition en mode  2 temps}
          {recherche eventuelle de la phase de la sequence,
          c'est  dire du compteur, via des marqueurs TTL}
          if (compteur=1) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]+tab1^[i];
                         tab4^[i]:=tab4^[i]+tab2^[i];
                         end;
              end;
          if (compteur=2) then
              begin
              for i:=1 to NbPointsParChannel do
                         begin
                         tab3^[i]:=tab3^[i]-tab1^[i];
                         tab4^[i]:=tab4^[i]-tab2^[i];
                         end;
              end;
          if compteur=1 then compteur:=2
                      else compteur:=1;
          end; {fin du mode 2 steps}
         end;
     end;{fin de la verif avec temps ecoul}
    {******************************************************************}
    end;{fin transfert data}
until (NbCoupsDejaFaitNMR>=NbcoupsAFaire) or (DrapeauAcquisitionNMRencours=false);

NbCoupsFait:=NbCoupsDejaFaitNMR;
  {transfert du data GAGE moyenn}
  indice:=und.indexof('ECHO');
  for i:=1 to NbPointsParChannel do
  begin
    und.spect[indice].data[i-1,0].z:=tab3^[i];
    und.spect[indice].data[i-1,0].mon:=tab4^[i];
  end;
  {transfert du data GAGE un coup}
  indice:=und.indexof('OSCILLO');
  for i:=1 to NbPointsParChannel do
  begin
    und.spect[indice].data[i-1,0].z:=tab1^[i];
    und.spect[indice].data[i-1,0].mon:=tab2^[i];
  end;
 {on referme le port RS232  la fin}
{  if (DrapeauSpectroHomodyne=true) and
   (DrapeauSequenceur16VoiesRecognitionStep=true) then Seq16ChannelsForm.closeSerialPort;
 }
  DrapeauAcquisitionVientDeFinir:=true;
end;


procedure Tacquisparam.InitButtonClick(Sender: TObject);
{initialise la carte GAGE : a faire avant la toute premiere acquisition et
qd on change de parametre de carte. Ca a pour effet de tout detruire
les pointeurs...}
var i,err:integer;
chaine:string;

begin
  DrapeauGAGEdejaInitialise:=true;
{  readconfig(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN);}
  setboard{(handle)}; {detruit le pointeur acquisparam et toutes les variables}
  acquirestart;
  NbCoupsDejaFaitNMR:=0;
  if tab3=nil then
  begin
     dispose(tab1);dispose(tab2);dispose(tab3);dispose(tab4);
     new(tab3);new(tab4);new(tab2);new(tab1);
     {RECREE LES POINTEURS qui ont t  dtruits on ne sait pas trop pourquoi
      en interferant avec l'appel  GAGE c'est Setboard qui detruit les pointeurs}
  end;
  for i:=1 to NbPointsParChannel do
    begin
    tab3^[i]:=0;tab4^[i]:=0;
    end;
  DrapeauGAGEdejaInitialise:=true;
end;



procedure Tacquisparam.EDnivKeyPress(Sender: TObject; var Key: Char);
{test qd on change le niveau si on a fini de taper le nombre avec RETURN}
begin
 if key=#13 then
    begin
    ChangeParametreEtInit(Sender);
    end;
end;

procedure Tacquisparam.ChangeParametreEtInit(Sender:TObject);
begin
    InitButtonClick(Sender);
end;

procedure Tacquisparam.initialisation(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN,
   NMRFormCOVVAC,NMRFormCOVBC,NMRFormCOSLOPE,NMRFormCOSOURCE,
   NMRFormCOTRIGAC:integer;NMRFormEdNiv:string);
{initialise la carte GAGE : a faire avant la toute premiere acquisition et
qd on change de parametre de carte. Ca a pour effet de tout detruire
les pointeurs...}
var i,err:integer;
chaine:string;

begin
  DrapeauGAGEdejaInitialise:=true;
  readconfig(NMRFormEDFREQ,NMRFormEDPoints,NMRFormCOVARAN,NMRFormCOVBRAN,
   NMRFormCOVVAC,NMRFormCOVBC,NMRFormCOSLOPE,NMRFormCOSOURCE,
   NMRFormCOTRIGAC,NMRFormEdNiv);
  setboard{(handle)}; {detruit le pointeur acquisparam et toutes les variables}
  acquirestart;
  NbCoupsDejaFaitNMR:=0;
{  if tab3=nil then
  begin
     if tab1<>nil then
        begin
        dispose(tab1);
        end;
     if tab2<>nil then dispose(tab2);
     if tab3<>nil then dispose(tab3);
     if tab4<>nil then dispose(tab4);
     new(tab3);new(tab4);new(tab2);new(tab1);
     {RECREE LES POINTEURS qui ont t  dtruits on ne sait pas trop pourquoi
      en interferant avec l'appel  GAGE c'est Setboard qui detruit les pointeurs}
 { end;}
  tab1:=new(ptable1012smallint1012);tab2:=new(ptable1012smallint1012);
  tab3:=new(ptable1012);tab4:=new(ptable1012);

  for i:=1 to NbPointsParChannel do
    begin
    tab3^[i]:=0;tab4^[i]:=0;
    end;
  DrapeauGAGEdejaInitialise:=true;
end;


procedure Tacquisparam.Gage1012GetDataBobAvecTableauSignes(NbCoupsAFaire:integer;var NbCoupsFait:integer);
{la bonne procedure pour acquerir en boucle}
var vr,vs:int16;
chaine:string;
start,compteur,err,i,j,indice,nbAcquisitions:integer;
timeout,DrapeauFirstShot,DrapeauAlternance:boolean;
DelayOneCanal:extended;
canalmarker1,canalmarker2,canalmarker3,canalmarker4:integer;
iteration,AmplitudeMarker,canalnomarker1,canalnomarker2,canalnomarker3,canalnomarker4:integer;
valeur,StartSequenceTime,StartPreviousSequence:longword;
Caractere:char;
couprate:boolean;
label tt1;


begin


{on dispose des parametres :
NombreStepsPourReception = nb de steps
et tableauSignesReceptionNMR[1][i] et [2][i] : vaut 1,2,3,4
selon qu'on veut X, Y, -X, -Y dans voie 1 et voie 2}

{on exclue ici le cas du spectro avec reconnaissance RS232 Sequenceur 16 channels Cromieres
car dans ce cas, pas de lattitude, c'est necessairemenet +X, +Y puis -X,-Y}

{deux possibilits : soustraction aveugle ou soustraction avec un time check
selon valeur de DrapeauSequenceurTimeCheck}

{on choisit que si seq  plusieurs temps, on veut un time check,
sinon pas la peine}
if (NombreStepsPourReception>1) then DrapeauSequenceurTimeCheck:=true
                                else DrapeauSequenceurTimeCheck:=false;

acquirestart;
{besoin juste au debut de l'acquisition pour preparer le trigger,
mais plus ensuite, au moins en mode 32k to buffer}
NbCoupsDejaFaitNMR:=0;
tab1:=new(ptable1012smallint1012);tab2:=new(ptable1012smallint1012);
tab3:=new(ptable1012);tab4:=new(ptable1012);

for i:=1 to NbPointsParChannel do
    begin
    tab3^[i]:=0;tab4^[i]:=0;
    end;

{boucle d'acquisition}
NbCoupsDejaFaitNMR:=0;
DrapeauAlternance:=false;
compteur:=1;

{Ici, on relance la sequence de pulses chargee dans ParSeq/SeqPar
pour toujours demarrer du meme trigger :
tres important dans les modes ou il y a soustraction entre deux coups pour toujours
 la fin avoir l'echo dans le meme sens}

{a faire ici : eviter d'appeler ces procedures qui vont tout faire echouer

verifier dans la suite ou on utilise seqpar. et seqnewhetero...

verifier dans procedure SeqNEwhetero qd il rappelle un fichier pourquoi
il rappelle mal les parametres qu'il dcale tous dee une case
 }



{MODIF : Jenleve l'utilisation du timer ici}

{drapeauStartAgainSequence:=true;
REPEAT
    Application.processMessages;
UNTIL (DrapeauStartAgainSequence=false);
 }

DrapeauFirstShot:=true;
compteur:=-1;

repeat
application.processMessages;{reflechir si on veut un jour mettre Application.ProcessMessages;}{routine qui va scruter les valeurs de la fenetre avant
meme pendant une boucle}
{   application.processMessages;   }
   StartSequenceTime:=gettickcount; {on repere le temps initial avant transfert}
   acquirestart; {on aimerait economiser du temps ici en enlevant acquirestart
   et en mettant la procedure assembleur qui regarde si il y a eu evennement trigger sans
   en chercher un nouveau}

{   asm
            mov dx,$200       {test fin}
{            xor ax,ax
            out dx,al
            inc dx
            in al,dx
            and al,$05 {test de l'arrive d'un trigger}
 {           cmp al,$04
            jnz tt1  {si pas d'arrive de trigger, il recommence la boucle : le label tt1
            est  la fin du repeat}
  { end;
      {cas ou il y a arrive d'un trigger : il transfert le data dans ce cas}

   repeat
   vr:=gage_triggered;
   Application.processMessages;
   until (vr>2);

   repeat
   vs:=gage_busy
   until (vs=0);

   transfertdat;
   if (DrapeauSequenceurTimeCheck=true) then
        begin
        {on repere le temps de repetition qui s'est coul}
        if ((StartSequenceTime-StartPreviousSequence)>TempsRepetition*1.5) and (DrapeauFirstShot=false)
                         then CoupRate:=true
                         else CoupRAte:=false;
        end
        else CoupRAte:=false;
   StartPreviousSequence:=StartSequenceTime;
   if (CoupRate=true) then {ce sera  false si il n'y a pas de time check}
      begin
         {si on rate le coup, on relance le spectro}
            compteur:=-1;
            DrapeauFirstShot:=true;
            {on relance le sequenceur}
           {           start:= GetTickCount; }
            drapeauStartAgainSequence:=true;
          REPEAT
                Application.processMessages;
          UNTIL (DrapeauStartAgainSequence=false);
      end
      else
      begin
        DrapeauFirstShot:=false;

        compteur:=(compteur+1) mod NombreStepsPourReception;
        {selon le step parmi le nb de steps NombreStepsPourReception, on additionne de faon diffrente}
        if (tableauSignesReceptionNMR[1][compteur+1]=1) then
               for i:=1 to NbPointsParChannel do tab3^[i]:=tab3^[i]-tab1[i];
        if (tableauSignesReceptionNMR[1][compteur+1]=2) then
                for i:=1 to NbPointsParChannel do tab3^[i]:=tab3^[i]-tab2[i];
        if (tableauSignesReceptionNMR[1][compteur+1]=3) then
               for i:=1 to NbPointsParChannel do tab3^[i]:=tab3^[i]+tab1[i];
        if (tableauSignesReceptionNMR[1][compteur+1]=4) then
               for i:=1 to NbPointsParChannel do tab3^[i]:=tab3^[i]+tab2[i];

        if (tableauSignesReceptionNMR[2][compteur+1]=1) then
              for i:=1 to NbPointsParChannel do tab4^[i]:=tab4^[i]-tab1[i];
        if (tableauSignesReceptionNMR[2][compteur+1]=2) then
              for i:=1 to NbPointsParChannel do tab4^[i]:=tab4^[i]-tab2[i];
        if (tableauSignesReceptionNMR[2][compteur+1]=3) then
              for i:=1 to NbPointsParChannel do tab4^[i]:=tab4^[i]+tab1[i];
        if (tableauSignesReceptionNMR[2][compteur+1]=4) then
              for i:=1 to NbPointsParChannel do tab4^[i]:=tab4^[i]+tab2[i];

        NbCoupsDejaFaitNMR:=NbCoupsDejaFaitNMR+1;

      end;{fin transfert data}

until (NbCoupsDejaFaitNMR>=NbcoupsAFaire) or (DrapeauAcquisitionNMRencours=false);
{FIN BOUCLE ACQUISITION}

NbCoupsFait:=NbCoupsDejaFaitNMR;
  {transfert du data GAGE moyenn}
  indice:=und.indexof('ECHO');
  for i:=1 to NbPointsParChannel do
  begin
    und.spect[indice].data[i-1,0].z:=tab3^[i];
    und.spect[indice].data[i-1,0].mon:=tab4^[i];
  end;
  {transfert du data GAGE un coup}
  indice:=und.indexof('OSCILLO');
  for i:=1 to NbPointsParChannel do
  begin
    und.spect[indice].data[i-1,0].z:=tab1^[i];
    und.spect[indice].data[i-1,0].mon:=tab2^[i];
  end;
 {on referme le port RS232  la fin}
{  if (DrapeauSpectroHomodyne=true) and
   (DrapeauSequenceur16VoiesRecognitionStep=true) then Seq16ChannelsForm.closeSerialPort;
 }
  DrapeauAcquisitionVientDeFinir:=true;
end;


end.
