unit multimemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,stdctrls,Spin,extctrls,menus,comctrls;

type
  tmultimemo = class(TcustomControl)
  private
  fmaxvalue:integer;
    { Dclarations prives }
  fnom:array[1..19] of string[25];
  ffilename:array[1..19] of string;
  fbevel:tbevel;
  flabel:tlabel;
  factivepage:integer;
  fdir:string;
  FAlignment: TAlignment;
  FScrollBars: TScrollStyle;
  FMaxLength: Integer;
  FHideSelection: Boolean;
  Fplaintext: Boolean;
  FLines: TStrings;
  FReadOnly: Boolean;
  FWordWrap: Boolean;
  FWantReturns: Boolean;
  FWantTabs: Boolean;
  FOnChange: TNotifyEvent;
  ffont:tfont;
  fdefaultext:string;
  ffilter:string;
  opendlg:Topendialog;
  savedlg:Tsavedialog;
  finddlg:Tfinddialog;
  PrintDialog1: TPrintDialog;
  PrinterSetupDialog1: TPrinterSetupDialog;
  PopupMenu1: TPopupMenu;
  Fichier1: TMenuItem;
  Configurationdelimpression1: TMenuItem;
  Imprimer1: TMenuItem;
  N2,N3,N4: TMenuItem;
  Enregistrersous1: TMenuItem;
  Enregistrer2: TMenuItem;
  ajouter1:TMenuitem;
  Ouvrir2: TMenuItem;
  Nouveau1: TMenuItem;
  Edition1: TMenuItem;
  Remplacer1: TMenuItem;
  Chercher1: TMenuItem;
  Coller1: TMenuItem;
  Copier1: TMenuItem;
  Couper1: TMenuItem;
  Dfaire1: TMenuItem;
  Effacertout1: TMenuItem;
  rechercheglobale1: TMenuItem;
  sauvertout1: TMenuItem;
  global1:tmenuitem;
  recher:integer;
  recherstring:string;
  procedure setactivepage(i:integer);
  procedure setmaxvalue(val:integer);
  procedure setalignment(v:talignment);
  function getalignment:talignment;
  procedure setscrollbars(v:TScrollStyle);
  function getscrollbars:TScrollStyle;
  function  getHideSelection:boolean;
  procedure SetHideSelection(v:boolean);
  function  getMaxLength:integer;
  procedure SetMaxLength(v:integer);
  function  getplaintext:boolean;
  procedure Setplaintext(v:boolean);
  procedure SetLines(Value: TStrings);
  function  getlines:Tstrings;
  function  getWordWrap:boolean;
  procedure SetWordWrap(v:boolean);
  function  getWantReturns:boolean;
  procedure SetWantReturns(v:boolean);
  function  getWantTabs:boolean;
  procedure SetWantTabs(v:boolean);
  function  getreadonly:boolean;
  procedure Setreadonly(v:boolean);
  function  getfont:tfont;
  procedure Setfont(v:tfont);
  function  getdefaultext:string;
  procedure Setdefaultext(s:string);
  function  getfilter:string;
  procedure Setfilter(s:string);
  protected
    { Dclarations protges }
    procedure Nouveau1Click(Sender: TObject);
    procedure Ouvrir2Click(Sender: TObject);
    procedure Ajouter1click(Sender: TObject);
    procedure Enregistrer2Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Configurationdelimpression1Click(Sender: TObject);
    procedure Dfaire1Click(Sender: TObject);
    procedure Couper1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure Chercher1Click(Sender: TObject);
    procedure Remplacer1Click(Sender: TObject);
    procedure Copiertoutclick(Sender: TObject);
    procedure Effacertoutclick(Sender: TObject);
    procedure rechercheglobaleclick(Sender: TObject);
    procedure sauvertoutclick(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
  public
  memo:trichedit;
  sp:tspinedit;
  allstrings:array[1..19] of tstringlist;
  procedure Loaded; override;
  procedure paint;override;
  procedure changement(sender:tobject);
  procedure addcurrent;
  procedure savecurrent;
  procedure saveascurrent;
  procedure opencurrent;
  procedure newfile;
  procedure closecurrent;
  procedure Clearall;
  procedure CopyallToClipboard;
  constructor Create(AOwner: TComponent); override;
    { Dclarations publiques }
  published
  property maxvalue:integer read fmaxvalue write setmaxvalue;
  property activepage:integer read factivepage write setactivepage default 0;
  property directory:string read fdir write fdir;
  property Alignment: TAlignment read getAlignment write setalignment default taLeftJustify;
  property ScrollBars: TScrollStyle read getscrollbars write SetScrollBars default ssNone;
  property Align;
  property Color;
  property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property Lines: TStrings read getLines write SetLines;
    property HideSelection: Boolean read getHideSelection write SetHideSelection default True;
    property MaxLength: Integer read getMaxLength write SetMaxLength default 0;
    property plaintext: Boolean read getplaintext write Setplaintext default False;
    property defaultext: string read getdefaultext write Setdefaultext;
    property filter : string read getfilter write Setfilter;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly: Boolean read getReadOnly write SetReadOnly default False;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property WantReturns: Boolean read getWantReturns write setWantReturns default True;
    property WantTabs: Boolean read getWantTabs write setWantTabs default False;
    property WordWrap: Boolean read getWordWrap write SetWordWrap default True;
    property memofont:tfont read getfont write setfont;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    { Dclarations publies }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Claude', [tmultimemo]);
end;

constructor tmultimemo.Create(AOwner: TComponent);
var
items:array[0..2] of tmenuitem;
items1:array[0..7] of tmenuitem;
items2:array[0..7] of tmenuitem;
items3:array[0..2] of tmenuitem;
begin
inherited;
memo:=trichedit.create(self);memo.parent:=self;
sp:=tspinedit.create(self);sp.parent:=self;
fbevel:=tbevel.create(self);fbevel.parent:=self;
flabel:=tlabel.create(self);flabel.parent:=self;
{fmaxvalue:=9;}
ctl3D:=true;
Nouveau1:=NewItem('&Nouveau',0,false,true,nouveau1click,0,'');
Ouvrir2:=NewItem('&ouvrir...',0,false,true,Ouvrir2click,0,'');
Ajouter1:=NewItem('&Insrer...',0,false,true,Ajouter1click,0,'');
Enregistrer2:=NewItem('&Enregistrer',0,false,true,Enregistrer2click,0,'');
Enregistrersous1:=NewItem('&Enregistrer sous...',0,
false,true,Enregistrersous1click,0,'');
N2:=newline;
Imprimer1:=NewItem('&Imprimer',0,false,true,Imprimer1click,0,'');
Configurationdelimpression1:=NewItem('&Configuration de l'#39'impression...',0,
false,true,Configurationdelimpression1click,0,'');
items1[0]:=nouveau1;
items1[1]:=ouvrir2;
items1[2]:=Ajouter1;
items1[3]:=Enregistrer2;
items1[4]:=Enregistrersous1;
items1[5]:=N2;
items1[6]:=Imprimer1;
items1[7]:=Configurationdelimpression1;
Fichier1:=NewSubMenu('&Fichier',0,'essai',items1);
items[0]:=Fichier1;
Dfaire1:=NewItem('&Dfaire',0,false,true,Dfaire1click,0,'');
N3:=newline;
Couper1:=NewItem('&Couper',0,false,true,Couper1click,0,'');
Copier1:=NewItem('Co&pier',0,false,true,Copier1click,0,'');
Coller1:=NewItem('C&oller',0,false,true,Coller1click,0,'');
N4:=newline;
Chercher1:=NewItem('C&hercher...',0,false,true,Chercher1click,0,'');
Remplacer1:=NewItem('Re&mplacer...',0,false,true,Remplacer1click,0,'');
items2[0]:=Dfaire1;
items2[1]:=N3;
items2[2]:=Copier1;
items2[3]:=Coller1;
items2[4]:=Couper1;
items2[5]:=N4;
items2[6]:=chercher1;
items2[7]:=remplacer1;
Edition1:=NewSubMenu('&Edition',0,'essai1',items2);
items[1]:=edition1;
Effacertout1:=NewItem('&Effacer tout',0,false,true,effacertoutclick,0,'');
rechercheglobale1:=NewItem('&Chercher..',0,false,true,rechercheglobaleclick,0,'');
sauvertout1:=NewItem('&Sauver tout',0,false,true,sauvertoutclick,0,'');
items3[0]:=Effacertout1;
items3[1]:=rechercheglobale1;
items3[2]:=sauvertout1;
Global1:=NewSubMenu('&Global',0,'essai2',items3);
items[2]:=global1;
popupmenu1:=NewPopupMenu(self,'toto',paleft,true,
Items);
flabel.caption:='inconnu';
opendlg:=topendialog.create(self);
savedlg:=tsavedialog.create(self);
finddlg:=tfinddialog.create(self);
finddlg.onfind:=finddialog1find;
PrintDialog1:=TPrintDialog.create(self);
PrinterSetupDialog1:=TPrinterSetupDialog.create(self);
end;

procedure tmultimemo.loaded;
var
i:integer;
begin
inherited;
if popupmenu=nil then popupmenu:=popupmenu1;
for i:=1 to 19 do begin
allstrings[i]:=tstringlist.create;
fnom[i]:='inconnu';
end;
fbevel.align:=alclient;
sp.height:=20;sp.width:=35;
sp.top:=0;sp.left:=width-35;
sp.text:=inttostr(factivepage);
sp.minvalue:=1;sp.maxvalue:=maxvalue;
flabel.top:=1;flabel.left:=1;
flabel.width:=width-35;flabel.height:=20;
flabel.autosize:=true;
sp.Onchange:=changement;
end;

procedure tmultimemo.setmaxvalue(val:integer);
begin
if val<1 then val:=1;
if val>19 then val:=19;
fmaxvalue:=val;
sp.maxvalue:=fmaxvalue;
if val>=10 then sp.maxlength:=2 else sp.maxlength:=1;
end;

procedure tmultimemo.changement(sender:tobject);
var
err,i:integer;
begin
allstrings[activepage].text:=memo.text;
val(sp.text,i,err);
factivepage:=i;
memo.text:=allstrings[activepage].text;
flabel.caption:=fnom[activepage];
end;

procedure tmultimemo.paint;
begin
memo.top:=20;memo.height:=height-20;
memo.width:=width;
sp.top:=0;sp.left:=width-35;
inherited;
end;

procedure tmultimemo.setactivepage(i:integer);
begin
if (i>=1) and (i<=maxvalue) then sp.text:=inttostr(i);
if factivepage=0 then factivepage:=i;
end;

procedure tmultimemo.setalignment(v:talignment);
begin
memo.alignment:=v;
end;

function tmultimemo.getalignment:talignment;
begin
result:=memo.alignment;
end;

procedure tmultimemo.setscrollbars(v:TScrollStyle);
begin
memo.scrollbars:=v;
end;


function tmultimemo.getscrollbars:TScrollStyle;
begin
result:=memo.scrollbars;
end;

function  tmultimemo.getHideSelection:boolean;
begin
result:=memo.hideselection;
end;
procedure tmultimemo.SetHideSelection(v:boolean);
begin
memo.hideselection:=v;
end;

function  tmultimemo.getMaxLength:integer;
begin
result:=memo.MaxLength;
end;

procedure tmultimemo.SetMaxLength(v:integer);
begin
memo.MaxLength:=v;
end;

function  tmultimemo.getplaintext:boolean;
begin
result:=memo.plaintext;
end;

procedure tmultimemo.Setplaintext(v:boolean);
begin
memo.plaintext:=v;
end;

procedure tmultimemo.SetLines(Value: TStrings);
begin
memo.lines.addstrings(value);
end;


function  tmultimemo.getlines:Tstrings;
begin
result:=memo.lines;
end;

function  tmultimemo.getreadonly:boolean;
begin
result:=memo.readonly;
end;

procedure tmultimemo.Setreadonly(v:boolean);
begin
memo.readonly:=v;
end;

function  tmultimemo.getWordWrap:boolean;
begin
result:=memo.WordWrap;
end;

procedure tmultimemo.SetWordWrap(v:boolean);
begin
memo.WordWrap:=v;
end;

function  tmultimemo.getWantReturns:boolean;
begin
result:=memo.WantReturns;
end;

procedure tmultimemo.SetWantReturns(v:boolean);
begin
memo.WantReturns:=v;
end;

function  tmultimemo.getWantTabs:boolean;
begin
result:=memo.WantTabs;
end;


procedure tmultimemo.SetWantTabs(v:boolean);
begin
memo.WantTabs:=v;
end;

function  tmultimemo.getfont:tfont;
begin
result:=memo.font;
end;


procedure tmultimemo.Setfont(v:tfont);
begin
memo.font:=v;
end;

function  tmultimemo.getfilter:string;
begin
result:=ffilter;
end;


procedure tmultimemo.Setfilter(s:string);
begin
opendlg.filter:=s;
savedlg.filter:=s;
ffilter:=s;
end;

function  tmultimemo.getdefaultext:string;
begin
result:=fdefaultext;
end;


procedure tmultimemo.Setdefaultext(s:string);
begin
opendlg.defaultext:=copy(s,1,3);
savedlg.defaultext:=copy(s,1,3);
fdefaultext:=copy(s,1,3);
end;


procedure tmultimemo.savecurrent;
begin
if fnom[activepage]='inconnu' then saveascurrent
else begin
Memo.Lines.savetoFile(ffilename[factivepage]);
end;

end;

procedure tmultimemo.saveascurrent;
var
s:string;
begin
  savedlg.initialdir:=directory;
  if saveDlg.Execute then
  begin
    Memo.Lines.savetoFile(saveDlg.FileName);
    s:=extractfilename(saveDlg.FileName);
    if pos('.',s)>0 then fnom[factivepage]:=copy(s,1,pos('.',s)-1)
    else fnom[factivepage]:=s;
    ffilename[factivepage]:=saveDlg.FileName;
    flabel.Caption :=fnom[factivepage];
  end;
end;


procedure tmultimemo.opencurrent;
var
s:string;
begin
  opendlg.initialdir:=directory;
  if OpenDlg.Execute then
  begin
    Memo.Lines.LoadfromFile(OpenDlg.FileName);
    s:=extractfilename(OpenDlg.FileName);
    ffilename[factivepage]:=OpenDlg.FileName;
    if pos('.',s)>0 then fnom[factivepage]:=copy(s,1,pos('.',s)-1)
    else fnom[factivepage]:=s;
    flabel.Caption :=fnom[factivepage];
  end;
end;

procedure tmultimemo.addcurrent;
var
st:tstringlist;
begin
  st:=tstringlist.create;
  opendlg.initialdir:=directory;
  if OpenDlg.Execute then
  begin
    st.LoadfromFile(OpenDlg.FileName);
    memo.seltext:=st.text;
  end;
  st.destroy;
end;

procedure tmultimemo.closecurrent;
var
i:integer;
begin
for i:=factivepage to fmaxvalue do
allstrings[i].assign(allstrings[i+1]);
fmaxvalue:=fmaxvalue-1;
end;

procedure tmultimemo.newfile;
begin
if fmaxvalue<19 then maxvalue:=fmaxvalue+1;
activepage:=fmaxvalue;
end;

procedure tmultimemo.Clearall;
var
i:integer;
begin
for i:=1 to fmaxvalue do
allstrings[i].clear;
memo.clear;
end;

 procedure tmultimemo.copyalltoclipboard;
 var
 st:tmemo;
 i:integer;
 begin
 st:=tmemo.create(self);st.parent:=self;
 for i:=1 to fmaxvalue do begin
 st.lines.add(' ');
 st.lines.add('Fichier 1 : '+ffilename[i]);
 st.lines.add(' ');
 st.lines.addstrings(allstrings[i]);
 end;
 st.copytoclipboard;
 st.destroy;
 end;


procedure Tmultimemo.Nouveau1Click(Sender: TObject);
begin
newfile;
end;

procedure Tmultimemo.Ouvrir2Click(Sender: TObject);
begin
opencurrent;
end;

procedure Tmultimemo.Ajouter1click(Sender: TObject);
begin
addcurrent;
end;


procedure Tmultimemo.Enregistrer2Click(Sender: TObject);
begin
savecurrent;
end;

procedure Tmultimemo.Enregistrersous1Click(Sender: TObject);
begin
saveascurrent;
end;

procedure Tmultimemo.Imprimer1Click(Sender: TObject);
begin
if printdialog1.execute
then memo.print(fnom[factivepage]);
end;

procedure Tmultimemo.Configurationdelimpression1Click(Sender: TObject);
begin
printersetupdialog1.execute;
end;

procedure Tmultimemo.Dfaire1Click(Sender: TObject);
begin
with memo do
  if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);

end;

procedure Tmultimemo.Couper1Click(Sender: TObject);
begin
memo.cuttoclipboard;
end;

procedure Tmultimemo.Copier1Click(Sender: TObject);
begin
memo.copytoclipboard;
end;

procedure Tmultimemo.Coller1Click(Sender: TObject);
begin
memo.pastefromclipboard;
end;

procedure Tmultimemo.Chercher1Click(Sender: TObject);
begin
finddlg.execute;
end;

procedure Tmultimemo.Remplacer1Click(Sender: TObject);
begin
{fmaxvalue:=9;}
end;

procedure Tmultimemo.Effacertoutclick(Sender: TObject);
begin
clearall;
end;

procedure Tmultimemo.Copiertoutclick(Sender: TObject);
begin
copyalltoclipboard;
end;


procedure Tmultimemo.rechercheglobaleclick(Sender: TObject);
begin
{fmaxvalue:=9;}
end;



procedure Tmultimemo.sauvertoutclick(Sender: TObject);
begin
copyalltoclipboard;
end;

procedure Tmultimemo.FindDialog1Find(Sender: TObject);
label
debut;
var
i:integer;
begin
debut:
i:=memo.FindText(finddlg.findtext,recher,memo.gettextlen,[]);
if i>=0 then begin
memo.selstart:=i;
memo.sellength:=length(finddlg.findtext);
memo.setfocus;
recherstring:=finddlg.findtext;
recher:=i+length(finddlg.findtext);
end else begin
if recher<>0 then begin
recher:=0;goto debut;
end;
MessageDlg('Chane non trouve',mtWarning,[mbOK],0);
finddlg.closedialog;
end;
end;


end.
