unit controlesDivers;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,DBctrls,DB, DBTables,Mask,DBConsts;

 const
    valgain:array[1..31] of array[0..4] of char=('1/32','1/16',' 1/8',' 1/4',' 1/2','   1','   2','   4','   8',
    '  16','  32','  64',' 128',' 256',' 512','  1k','  2k','  4k','  8k',
    ' 16k',' 32k',' 64k','128k','256k','512k','  1M','  2M','  4M','  8M',
    ' 16M',' 32M');
    wm_gain=10400;

  type
    Pperbox=^Tperbox;
    Tperbox=class(Tcustomcontrol)
    private
    fcouleur:tcolor;
    fvalue:longint;
    fspectre:integer;
    fvalmax:longint;
    fvalmin:longint;
    FOnChange: TNotifyEvent;
    protected
    procedure Hscrolmsg(var msg:TWMScroll); message WM_HSCROLL;
    procedure CNCommand(var Message: TWMCommand); message WM_COMMAND;
    public
    scrol:Tscrollbar;
    box:Tcheckbox;
    st:Tedit;
    graph:hwnd;
    constructor create(Aowner:Tcomponent);override;
    procedure loaded;override;
    function getval:longint;
    procedure refresh;
    procedure setval(value:longint);
    procedure check;
    procedure uncheck;
    function getcheck:word;
    procedure wmlbuttondown(var msg:tmessage);message wm_lbuttondown;
    procedure wmrbuttondown(var msg:tmessage);message wm_rbuttondown;
    procedure Paint; override;
    published
    property onchange:tnotifyevent read Fonchange write Fonchange;
    property valeur:longint read getval write setval;
    property max:longint read fvalmax write fvalmax ;
    property min:longint read fvalmin write fvalmin ;
    property spectre:integer read fspectre write fspectre ;
    property couleur:tcolor read fcouleur write fcouleur;
    end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PilotageManip', [Tperbox]);
end;

function power2(i:integer):longint;
var
j,k:longint;
begin
j:=i;k:=1;
if j>=31 then j:=31;
while j>0 do begin
k:=k*2;j:=j-1;end;
power2:=k;
end;


{----------perbox---------boite a cocher+editeur+scroll-----}

    constructor Tperbox.create(Aowner:Tcomponent);
    const
    perStyle = [csClickEvents, csSetCaption, csDoubleClicks, csFixedHeight,csFramed];
    begin
    inherited create(Aowner);
    ControlStyle := perStyle;
    scrol:=tscrollbar.create(self);scrol.parent:=self;
    box:=tcheckbox.create(self);box.parent:=self;
    st:=tedit.create(self);st.parent:=self;
    min:=1;
    max:=31;
    valeur:=6; {valeur par defaut: 1 et pas 1/32}
    spectre:=1;
    {controlstyle:=csFramed;}
    color:=clWindow;
    end;

    procedure Tperbox.loaded;
    begin
    inherited;
    width:=90;height:=15;
{    scrol.left:=30;scrol.top:=0;scrol.width:=55;scrol.height:=15;}
    scrol.left:=25;scrol.top:=0;scrol.width:=30;scrol.height:=15;
    box.left:=10;box.top:=0;box.width:=12;box.height:=15;
    st.left:=55;st.top:=0;st.width:=35;st.height:=15;
    st.readonly:=true;
    scrol.setparams(fvalmin,fvalmin,fvalmax);
    box.state:=cbChecked;
    if fvalmax>31 then fvalmax:=31;
    if fvalmin<1 then fvalmin:=1;
    graph:=parent.handle;
    end;

    procedure Tperbox.paint;
    var
    mt:array[0..3] of char;
    begin
    inherited paint;
    strpcopy(mt,chr(64+spectre));
    setbkmode(canvas.handle,transparent);
    settextcolor(canvas.handle,couleur);
    canvas.textout(1,1,chr(64+spectre));
    end;

    procedure tperbox.Hscrolmsg(var msg:TWMScroll);
    begin
    fvalue:=scrol.position;
    if fvalue>fvalmax then fvalue:=fvalmax;
    if fvalue<fvalmin then fvalue:=fvalmin;
    if msg.scrollcode=8 then setval(fvalue) else
    st.settextbuf(valgain[fvalue]);
    inherited;
    end;

    procedure Tperbox.CNCommand(var Message: TWMCommand);
    begin
    if Message.NotifyCode = BN_CLICKED then
    sendmessage(graph,wm_user+wm_gain,spectre,2+getcheck);
    inherited;
    end;

    function Tperbox.getval:longint;
    begin
    getval:=fvalue;
    end;

    procedure Tperbox.setval(value:longint);
    begin
    fvalue:=value;
    if fvalue>fvalmax then fvalue:=fvalmax;
    if fvalue<fvalmin then fvalue:=fvalmin;
    st.settextbuf(valgain[fvalue]);
    scrol.position:=fvalue;
    sendmessage(graph,wm_user+wm_gain,spectre+10,fvalue);
    end;

    procedure Tperbox.check;
    begin
    box.state:=cbchecked;
    sendmessage(graph,wm_user+wm_gain,spectre,3);
    end;

    procedure Tperbox.uncheck;
    begin
    box.state:=cbunchecked;
    sendmessage(graph,wm_user+wm_gain,spectre,2);
    end;

    procedure Tperbox.Refresh;
    begin
    setval(fvalue);
    inherited refresh;
    end;

    function Tperbox.getcheck:word;
    begin
    if box.state=cbchecked then getcheck:=1 else getcheck:=0;
    end;

    procedure Tperbox.wmlbuttondown(var msg:tmessage);
    begin
    if (msg.lparamlo<10) then begin
    sendmessage(graph,wm_user+wm_gain,spectre,1);
    refresh;
    end;
    end;

    procedure Tperbox.wmrbuttondown(var msg:tmessage);
    begin
    if (msg.lparamlo<10) then begin
    sendmessage(graph,wm_user+wm_gain,spectre,-1);
    end;
    end;

end.
