unit FieldSweepPS;
{a faire:
voir comment activer les drapeaux au cas o qq demande  nouveau une consigne de
champ quand il en a deja une
sauver valeur precedente de champ qq part
afficher champ actuel qq part

sur le sequenceur 16 channels:  faire la sauvegarde et ouverture des fichiers proprement

sur interpreteur : une commande qui libere la memoire et vire tous les fichiers
de und.spec
 }



{For using a GPIB IEEE interface : install first the gpib
programs from the disk. Then, go to the program cbconf.exe
choose Edit GPIB1 Board Options,
then chang Board is installed to Board is not installed
Then specify an adress at Primary GPIB adress,
the same that you will specify in the device which will be interfaced.
Finally, fo to DEV1 or DEV2 or... menu, and
specify in one of them the name of the device (for example : FieldSweepForm)
Then go back to main menu, and Save Current Configuration. Then quit CBCONF32.

Then, in this delphi unit, put in the definition of the constants
at the begining a lien which specifies the name again : like
const
    DEV_NAME = 'FieldSweepForm';

Finally, make sure that the unit you use for your interface has in 'uses' the
unit 'gpib' specified

*******************************************************************
*******************************************************************
IMPORTANT : BE SURE WHEN YOU CHANGE OF COMPUTER TO CHECK AGAIN THE OPTIONS
OF THE CBCONF.EXE AND THAT ALL THE NAMES OF THE DEVICE TO BE USED ARE
WELL SPECIFIED !!!
*************************************************************************
*************************************************************}

{In this FieldSweepPS unit, GPIB commands are always done after a delay of DelayAttenteGPIB msec :
see in commande}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gpib, StdCtrls, ExtCtrls,DrapeauAlloulUnit,FieldSweepKeithley,editdata;


type
  TFieldSweepForm = class(TForm)
    ErrBox: TMemo;
    Label4: TLabel;
    Label7: TLabel;
    GPIBStatusBox: TLabel;
    SwitchONButton: TButton;
    SwitchOffButton: TButton;
    RampeRateBox: TEdit;
    RampRateLabel: TLabel;
    LimitVoltageBox: TEdit;
    Label2: TLabel;
    UnitBox: TEdit;
    Label3: TLabel;
    Label6: TLabel;
    MIDbox: TEdit;
    Label5: TLabel;
    RampRateValueLabel: TLabel;
    VoltageLimitValueLabel: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    HeaterOutputBox: TEdit;
    ConversionTperAmpLabel: TLabel;
    Label8: TLabel;
    ConversionTperAmpBox: TEdit;
    heaterOutputLabel: TLabel;
    Label13: TLabel;
    outputTeslaValueLabel: TLabel;
    Label14: TLabel;
    outputVoltsValueLabel: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    RampStatusLabel: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    TimeLeftForRampLabel: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    MidvalueLabel: TLabel;
    Label22: TLabel;
    FieldStabilisationDelayBox: TEdit;
    FieldValueCaption: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Label1: TLabel;
    Label25: TLabel;
    DateUpdate: TLabel;
    HMIDBox: TEdit;
    SwitchStateBox: TEdit;
    MessageUpdate: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    statusOfTheFieldComment: TLabel;
    SwitchStateComment: TLabel;
    Label10: TLabel;
    ActualFieldValueBox: TLabel;
    Label29: TLabel;
    PreviousFieldValueBox: TLabel;
    TimePreviousFieldValueBox: TLabel;
    TimeACtualFieldValueBox: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    MIDvalueBis: TLabel;
    Memo1: TMemo;
    Label32: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpenDevice;
    procedure ouverture;
    procedure writecommand (CommandStr:string);
    procedure ReadValue (var ReadStr:string);
    procedure PrntErrs (ErrMsg:string);
    procedure Connect;
    procedure StopConnection;
    procedure Commande(Commande:string);
    procedure SwitchONButtonClick(Sender: TObject);
    procedure SwitchOffButtonClick(Sender: TObject);
    procedure CheckRampStatus(var Status:string;var MIDvalue:extended);
    procedure CheckHeaterStatus(var reponseStatus:boolean);

    procedure RampeRateBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LimitVoltageBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckSwitch;
    procedure UnitBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MIDboxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpdateParametres;
    procedure GetOutput;
    procedure ConversionTperAmpBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HeaterOutputBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ChangeField(Field:extended);
    procedure ReadFieldValue(drapeauCommentBoiteNoire:boolean;var Fieldvalue:extended);
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HMIDBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SwitchStateBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SauveFieldParametersInAscii(fieldValueChaine:string;switchstate:string;actualfieldvalue:string);
    procedure ReadFieldParametersInAscii;
    procedure PutSwitchOn;
    procedure PutSwitchOff;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FieldSweepForm: TFieldSweepForm;

const
   convtperamp=0.138;
   MaxLen = 80;                 { Size of IBRD/IBWRT strings  }
   DEV_NAME = 'SWEEPPS';        { Name for device as specified in CBCONF }
   {specificity of the SMS power supply}
   DefaultRampRate =0.05; {initial rampe rate A/sec}
   HeaterVoltageSwitch = 4.5 ;{value in Volt of the current for heating the switch before plugging}
   ConversionKeithleyVoltageToTesla=1000*0.13772/1.99073; {volt to Tesla from Keithley reading}
   DelayAttenteGPIB=300; {attente avant d'envoyer un ordre, en msec : mettre 200}
   NomFichierSweep ='c:\newspectro\Field Sweep Status.dat'; {nom du fichier o est sauv l'tat}
  var
  DevHandle:Integer;
  GPIBCallInProgress:Boolean;
  ChaineCommande:string;
  TimeWhenSwitchHasBeenPutOn,LimitMaxVoltageAtMagnet:extended;
  DrapeauChangeFieldLoop:boolean;



implementation

uses BoiteNoire, interpreteur;

{$R *.DFM}
{*******************************************************************}
procedure TFieldSweepForm.FormCreate(Sender: TObject);
var valeur:extended;err:integer;chainecommande,reponse,chaine:string;
    nombre,midvalue:extended;reponseStatus:boolean;
    fich:textfile;dateForTheInfo,valeurchamp,statutswitch:string;
begin
DrapeauChangeFieldLoop:=false;
DrapeauChampSMSDejaInitialise:=false;
TimeWhenSwitchHasBeenPutOn:=0;
{lecture du champ prcdent et switch prcdent}
if fexis(nomfichierSweep) then
   begin
   ReadFieldParametersInAscii;
   end
   else
   begin
   chaine:='Did not succeed to read '+NomFichierSweep+' - please update the field and switch value yourself';
   messagedlg(chaine, mtInformation, [mbOk], 0)
   end;

MessageUpdate.Caption:='These values are updated in '+NomFichierSweep;

{ne pas initialiser le champ ici, mais seulement quand on lui enverra une commande
la premiere fois (genre quand on ouvre cette fenetre la premiere fois...) en
jouant sur le drapeau ci dessus)}


{verification du GPIB}
   TimeSwitch:=0;
   DrapeauGPIBconnection:=false; {dit si GPIB marche ou pas}
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   if (DrapeauGPIBconnection=false) then
            MessageDlg('SMS Power Suply not connected to GPIB', mtInformation, [mbOk], 0)
     else
     begin
    {envoi d'une chaine quelconque pour voir le statut de dpart}
    ChaineCommande:='U'+#13;
    commande(ChaineCommande);
    ReadValue (reponse);
    ErrBox.lines.Add ('Device Identification = ' +reponse);
    {on passe en unite Ampere d'abord}
    ChaineCommande:='TESLA 0'+#13;commande(ChaineCommande);
    {on set max intensity in Amps}
    ChaineCommande:='SET MAX 53.1'+#13;commande(ChaineCommande);
    {on passe en unite Ampere d'abord}
    ChaineCommande:='TESLA 1'+#13;commande(ChaineCommande);
    {on specifie la rampe  0.05}
    ChaineCommande:='SET RAMP 0.05'+#13;commande(ChaineCommande);
    {on set max heater en V}
    ChaineCommande:='SET HEATER 4.5'+#13;commande(ChaineCommande);
    {on specifie la limite  2.5}
    ChaineCommande:='SET LIMIT 2.5'+#13;commande(ChaineCommande);

    {lecture des valeurs nouvelles des parametres}
    UpdateParametres;
    {SI ON NE MET PAS UPDATE PARAMETERS, IL NE LIT PAS BIEN LA REPONSE
    DE GETOUTPUT qui suit, comme si son buffer de reponse n'tait pas bien
    vid...}

{ces instructions marchent aleatoirement donc je ne les utilise pas ici}
    {lecture du output}
{    GetOutPut;
    {verifie le statut de la rampe}
{    CheckRampStatus(reponse,midvalue);
    {on verifie le switch}
 {   CheckHeaterStatus(reponseStatus);}
    TimeLeftForRampLabel.visible:=false;
   end;

end;
{*******************************************************************}
procedure TFieldSweepForm.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
FieldSweepForm.WindowState:=WsMinimized;
FieldSweepForm.WindowState:=WsNormal;
end;
{************************************************************************}
{                                                                        }
{  Name:         OpenDevice                                            }
{  Returns:      Handle of opened GPIB device                }
{  Description:  Opens the GPIB device (Fluke45) and resets it
{                                                                        }
{************************************************************************}

procedure TFieldSweepForm.OpenDevice;
var
  DevName:PChar;IDString:string;

begin
   If (DevHandle > 0) then Exit;
   DevName := StrAlloc (length (DEV_NAME) + 1);
   StrPCopy (DevName, DEV_NAME);

   DevHandle := ibfind (DevName);        { Open the device }
   if (DevHandle < 0) and (iberr=EDVR) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      ErrBox.lines.add ('IBFIND Couldn''t find device ' +dev_name);
      ErrBox.lines.add ('   Make sure that you have assigned the name '+ dev_name);
      ErrBox.lines.add ('   to the meter with the CBCONF.EXE program.  Make sure that');
      ErrBox.lines.add ('   the meter is configured for the address that you specified');
      ErrBox.lines.add ('   with CBCONF.EXE.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end

   else if (DevHandle < 0) and (iberr=ECFG) then
      begin
      GPIBStatusBox.caption:='NOT WORKING WELL'   ;
      ErrBox.lines.add ('Board type is incorrect');
      ErrBox.lines.add ('   The board type specified in GPIB.CFG does not match the installed');
      ErrBox.lines.add ('   board.  Run CBCONF.EXE and check the board type that is set there.');
      ErrBox.lines.add ('   Make sure that it matches the type of board that is installed in');
      ErrBox.lines.add ('   your system.');
      ErrBox.lines.add ('');
      DrapeauGPIBconnection:=false;
      end
   else
       begin
       GPIBStatusBox.caption:='WORKING OK';
       ibtmo (DevHandle,T3s);         { Set timeout to 3 seconds }
       DrapeauGPIBconnection:=true;
       {       commande (RESET_CMD);      { Reset the device }
       end;

end;

{************************************************************************}
{                                                                        }
{  Name:         writecommand                                            }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                CommandStr - command string to write to device          }
{  Description:  Writes a string to a GPIB device and checks for errors  }
{                                                                        }
{************************************************************************}

procedure TFieldSweepForm.writecommand (CommandStr:string);

var
  StrLen,i:integer;
  CommandP:PChar;
  timeout:boolean;start:integer;

begin

 {attente pour le SMS de DelayAttenteGPIB msec AVANT chaque commande
 (apres, ca ne sert  rien}

   start:= GetTickCount;
   REPEAT
      timeout:= ((GetTickCount - start) > DelayAttenteGPIB);
   UNTIL timeout;

   CommandP := StrAlloc (length (CommandStr) + 1);
   StrPCopy (CommandP, CommandStr);

 StrLen := length (CommandStr);              { Copy from string to buffer }
 ibwrt (DevHandle, CommandP, StrLen);          { Write to GPIB }
   if (ibcnt<>StrLen) or (ibsta and ERR <> 0) then  { Check for errors }
      PrntErrs ('IBWRT failed while writing ' +CommandStr);


end;





{************************************************************************}
{                                                                        }
{  Name:         ReadValue                                               }
{  Arguments:    DevHandle - handle of opened GPIB device                }
{                buffer - buffer to read data into                       }
{                bufsize - size of buffer                                }
{  Description:  Reads from a GPIB device                                }
{                                                                        }
{************************************************************************}


procedure TFieldSweepForm.ReadValue (var ReadStr:string);

const
     READ_BUF_SIZE = 200;
var
  ReadBuf: array[0..READ_BUF_SIZE] of Char;
  start:integer;timeout:boolean;
begin
   if (DevHandle = 0) then
      begin
      ErrBox.lines.add('---');
      GPIBStatusBox.caption:='NOT WORKING WELL'  ;
      end
   else
       begin
{       start:= GetTickCount;
        REPEAT
         timeout:= ((GetTickCount - start) > DelayAttenteGPIB);
        UNTIL timeout;
 }     ibrd(DevHandle, ReadBuf, READ_BUF_SIZE);     { Read from GPIB }
       if (ibcnt = 0) or (ibsta and ERR <> 0) then { Check for errors }
          begin;
          ErrBox.lines.add('---');
          PrntErrs ('IBRD failed');
          GPIBStatusBox.caption:='NOT WORKING WELL'  ;
          {timer1.Enabled := False;}
          end
       else
           ReadBuf[ibcnt] := #0;
       ReadStr := StrPas (ReadBuf);
       ErrBox.lines.add ( 'ANSWER = '+readStr);
       end;

end;



{************************************************************************}
{                                                                        }
{  Name:         PrintErrors                                             }
{  Description:  This procedure prints an error message followed by the  }
{                values of the global staus variables - IBSTA, IBERR,    }
{                and IBCNT.  For IBSTA it prints the name of every bit   }
{                that is set.  For IBERR it prints the mnemonic for the  }
{                error code.                                             }
{                                                                        }
{************************************************************************}

procedure TFieldSweepForm.PrntErrs (ErrMsg:string);

var
   ErrStr: String;
   HexStr: String;

begin
   ErrBox.lines.Add (ErrMsg);

   ErrStr := '   IBSTA=';              { Print IBSTA value }

   if ibsta and ERR  <> 0 then ErrStr := ErrStr + ' ERR';
   if ibsta and TIMO <> 0 then ErrStr := ErrStr + ' TMO';
   if ibsta and EEND <> 0 then ErrStr := ErrStr + ' END';
   if ibsta and SRQI <> 0 then ErrStr := ErrStr + ' SRQI';
   if ibsta and RQS  <> 0 then ErrStr := ErrStr + ' RQS';;
   if ibsta and SPOLL <> 0 then ErrStr := ErrStr + ' SPOLL';
   if ibsta and EVENT <> 0 then ErrStr := ErrStr + ' EVENT';
   if ibsta and CMPL <> 0 then ErrStr := ErrStr + ' CMPL';
   if ibsta and LOK  <> 0 then ErrStr := ErrStr + ' LOK';
   if ibsta and REM  <> 0 then ErrStr := ErrStr + ' REM';
   if ibsta and CIC  <> 0 then ErrStr := ErrStr + ' CIC';
   if ibsta and ATN  <> 0 then ErrStr := ErrStr + ' ATN';
   if ibsta and TACS <> 0 then ErrStr := ErrStr + ' TACS';
   if ibsta and LACS <> 0 then ErrStr := ErrStr + ' LACS';
   if ibsta and DTAS <> 0 then ErrStr := ErrStr + ' DTAS';
   if ibsta and DCAS <> 0 then ErrStr := ErrStr + ' DCAS';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBERR=';
   if iberr = EDVR then ErrStr := ErrStr + ' EDVR <DOS Error>';
   if iberr = ECIC then ErrStr := ErrStr + ' ECIC <Not CIC>';
   if iberr = ENOL then ErrStr := ErrStr + ' ENOL <No Listener>';
   if iberr = EADR then ErrStr := ErrStr + ' EADR <Address Error>';
   if iberr = EARG then ErrStr := ErrStr + ' EARG <Invalid Arguments>';
   if iberr = ESAC then ErrStr := ErrStr + ' ESAC <Not System Controller>';
   if iberr = EABO then ErrStr := ErrStr + ' EABO <Operation aborted>';
   if iberr = ENEB then ErrStr := ErrStr + ' ENEB <No GPIB board>';
   if iberr = EOIP then ErrStr := ErrStr + ' EOIP <Async I/I in progress>';
   if iberr = ECAP then ErrStr := ErrStr + ' ECAP <No Capability>';
   if iberr = EFSO then ErrStr := ErrStr + ' EFSO <File Error>';
   if iberr = EBUS then ErrStr := ErrStr + ' EBUS <Command error>';
   if iberr = ESTB then ErrStr := ErrStr + ' ESTB <Status byte lost>';
   if iberr = ESRQ then ErrStr := ErrStr + ' ESRQ <SRQ Stuck On>';
   if iberr = ETAB then ErrStr := ErrStr + ' ETAB <Table Overflow>';
   if iberr = ECFG then ErrStr := ErrStr + ' ECFG <Incorrect board>';
   ErrBox.lines.add (ErrStr);

   ErrStr := '   IBCNT=';
   ErrBox.lines.add (ErrStr);
end;
{*******************************************************************}
procedure TFieldSweepForm.Connect;
begin
   OpenDevice;                         { Open the GPIB device }
{   timer1.Enabled := True;}
end;
{*******************************************************************}
procedure TFieldSweepForm.Commande(Commande:string);

var
   CmdStr: string;
   i,start: Integer;

begin
   ibptrs (ibsta, iberr, ibcnt, ibcntl);
   GPIBCallInProgress := FALSE;
   DevHandle := 0;
   {on ouvre et on ferme la connexion juste pour la tester}
   OpenDevice;
   CmdStr:=Commande;

   {exple : '*IDN?' 'CFRQ:VALUE 15MHZ' 'RFLV:VALUE 9DBM'}

    if GPIBCallInProgress = FALSE then
       begin;
       GPIBCallInProgress := TRUE;
       writecommand(CmdStr);
       GPIBCallInProgress := FALSE;
       ErrBox.lines.Add(Commande); {on affiche la commande}
       end;
end;
{*******************************************************************}
procedure TFieldSweepForm.StopConnection;
begin
 If GPIBCallInProgress = FALSE Then
    begin;
    GPIBCallInProgress := TRUE;
    ibclr(DevHandle);
    ibloc(DevHandle);
    GPIBCallInProgress := FALSE;
    end;

end;
{*******************************************************************}
procedure TFieldSweepForm.SwitchONButtonClick(Sender: TObject);

begin
     PutSwitchOn;
end;
{*******************************************************************}
procedure TFieldSweepForm.SwitchOffButtonClick(Sender: TObject);
begin
   PutSwitchOff;
end;
{*******************************************************************}
procedure TFieldSweepForm.CheckSwitch;
{answers true if command is allowed, namely if 30 sec
have elapsed since last switch}
var Reponse:boolean;y:extended;
begin
Reponse:=false;
if (TimeSwitch<>0) then
   begin
   y:=time;
   if ((y-TimeSwitch)>30) then begin Reponse:=true;TimeSwitch:=0;end
                             else
                             begin
                             {wait 30 seconds}
                             repeat
                             y:=time;
                             Application.processMessages;
                             until(y-TimeSwitch>30);
                             Reponse:=true;
                             end;
   end
   else Reponse:=true;

end;
{*******************************************************************}
procedure TFieldSweepForm.RampeRateBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var valeur:extended;err:integer;
begin
{CHANGEMENT DE RAMPE RATE}
  if  Key=13 {si return} then
  begin
     val(RampeRateBox.text,valeur,err);
     if err=0 then
       begin
       {demande de la valeur}
       if (valeur<6) and (valeur>0) then
          begin
          ChaineCommande:='SET RAMP '+RampeRateBox.text+#13;
          commande(ChaineCommande);
          end
          else RampeRateBox.text:='NOT RECOGNIZED';
       end
       else
       RampeRateBox.text:='NOT RECOGNIZED';
  end;
end;
{*******************************************************************}
procedure TFieldSweepForm.UnitBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var valeur:extended;err:integer;
begin
  {CHANGEMENT DES UNITES : AMPERE OU TESLA}
  if  Key=13 {si return} then
  begin
     if (UnitBox.text='Tesla') or (UnitBox.text='TESLA')
      or (UnitBox.text='tesla') or (UnitBox.text='T')
      then UnitBox.text:='TESLA';

     if (UnitBox.text='AMPERE') or (UnitBox.text='Ampere')
      or (UnitBox.text='ampere') or (UnitBox.text='A')
      then UnitBox.text:='AMPERE';

     if (UnitBox.text<>'AMPERE') and (UnitBox.text<>'TESLA')
            then UnitBox.text:='TESLA';
     if UnitBox.text='TESLA' then
            begin
            {en Tesla}
            ChaineCommande:='TESLA 1'+#13;
            commande(ChaineCommande);
            end
            else
            begin
            {en Ampere}
            ChaineCommande:='TESLA 0'+#13;
            commande(ChaineCommande);
            end;
  end;
end;
{*******************************************************************}
procedure TFieldSweepForm.MIDboxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var valeur:extended;err:integer;TimeToWait,y:extended;
begin
{CHANGEMENT DU CHAMP via la valeur du MID cad Set Field}
  if  Key=13 {si return} then
  begin
  val(MIDBox.text,valeur,err);
  if err=0 then ChangeField(valeur);
  end;
end;
{*******************************************************************}
procedure TFieldSweepForm.UpdateParametres;
{envoie la commande U et analyse la rponse}
var chaine,reponse:string;
{reponse de la forme :
ANSWER =
20:10:18 UNITS: AMPS
20:10:18 MAX SETTING: 53.100 AMPS
20:10:19 UNITS: TESLA
20:10:19 RAMP RATE: 0.0520 A/SEC
20:10:20 HEATER OUTPUT: 4.5 VOLTS
20:10:20 VOLTAGE LIMIT: 2.5 VOLTS
........ REMOTE CONTROL: ENABLED
........ EXTERNAL TRIP: DISABLED
........ FIELD CONSTANT: 0.138 T/A
........ HEATER OUTPUT: 4.5 VOLTS
........ VOLTAGE LIMIT: 2.5 VOLTS
........ RAMP RATE: 0.0520 A/SEC
........ MID SETTING: 0.1000 TESLA
........ MAX SETTING: 7.3278 TESLA
........ HEATER STATUS: OFF
........ PAUSE STATUS: OFF
........ RAMP TARGET: ZERO
........ RAMP STATUS: HOLDING ON TARGET AT 0.0000 TESLA
........ LEVEL GAUGE: 0 mm
20:10:21 OUTPUT: 0.0000 TESLA AT 0.0 VOLTS
}
begin
    commande ('U'+#13);
    ErrBox.lines.Add ('PARAMETERS FROM UPDATE: ');
    ReadValue (reponse);
    {on identifie ces valeurs}
    if pos('RAMP RATE',reponse)>0 then
    begin
{on ne veut pas update le ramprate pour eviter les bugs si ramprate=6 et qu'on
arrete tout  ce moment l}
{    if pos('RAMP RATE',reponse)>0 then
        RampRateValueLabel.Caption:=
            copy(reponse,pos('RAMP RATE:',reponse)+11,length(reponse)-pos('RAMP RATE:',reponse)-10);}
    if pos('VOLTAGE LIMIT',reponse)>0 then
        begin
        chaine:=copy(reponse,pos('VOLTAGE LIMIT:',reponse)+15,length(reponse)-pos('VOLTAGE LIMIT:',reponse)-14);
        chaine:=copy(chaine,1,pos('VOLTS',chaine)-1);
        VoltageLimitValueLabel.Caption:=chaine;
        end;
    if pos('HEATER OUTPUT:',reponse)>0 then
        begin
        chaine:=copy(reponse,pos('HEATER OUTPUT:',reponse)+15,length(reponse)-pos('HEATER OUTPUT:',reponse)-14);
        chaine:=copy(chaine,1,pos('VOLTS',chaine)-1);
        HeaterOutputLabel.Caption:=chaine;
        end;
    end
    else
    begin
    VoltageLimitValueLabel.Caption:='-----------';
    ConversionTperAmpLabel.Caption:='-----------';
    HeaterOutputLabel.Caption:='-----------';
    RampRateValueLabel.Caption:='-----------';
    end;

    VoltageLimitValueLabel.refresh;
    ConversionTperAmpLabel.refresh;
    HeaterOutputLabel.refresh;
    RampRateValueLabel.refresh;

end;
{*******************************************************************}
procedure TFieldSweepForm.GetOutPut;
{envoie la commande G et analyse la rponse}
{reponse de la forme :ANSWER =
19:52:49 LEVEL GAUGE: 0 mm
19:52:49 OUTPUT: 0.0000 TESLA AT 0.0 VOLTS}
var chaine,reponse:string;
begin
    commande ('G'+#13);
    ReadValue (reponse);
    ErrBox.lines.Add ('PARAMETERS : ' +reponse);
    {on identifie ces valeurs}


    if pos('OUTPUT:',reponse)>0 then
        begin
{        chaine:=copy(reponse,pos('HEATER OUTPUT',reponse),length(reponse)-pos('HEATER OUTPUT',reponse)}
        chaine:=copy(reponse,pos('OUTPUT:',reponse)+8,length(reponse)-pos('OUTPUT:',reponse)-7);
        outputTeslaValueLabel.Caption:=copy(chaine,1,pos('TESLA AT',chaine)-2);
        outputTeslaValueLabel.refresh;
        chaine:=copy(reponse,pos('TESLA AT',reponse)+9,length(reponse)-pos('TESLA AT',reponse)-7);
        outputVoltsValueLabel.Caption:=copy(chaine,1,pos('VOLTS',chaine)-2);
        outputVoltsValueLabel.refresh;
        end
        else
        begin
        outputTeslaValueLabel.Caption:='------------';outputTeslaValueLabel.refresh;
        outputVoltsValueLabel.Caption:='------------';outputVoltsValueLabel.refresh;
        end;

end;
{*******************************************************************}
procedure TFieldSweepForm.CheckRampStatus(var Status:string;var MIDvalue:extended);
{envoie la commande RAMP S et analyse la rponse}
{reponse de la forme :
hors de la rampe :
ANSWER =
........ RAMP STATUS: HOLDING ON TARGET AT 2.000 AMPS
pdt la rampe :
ANSWER =
........ RAMP STATUS: RAMPING FROM 2.000 TO 0.000 AMPS AT 0.0520 A/SECANSWER =}

var chaine,reponse:string;valeur:extended;err:integer;
begin
    commande ('RAMP S'+#13);
    ReadValue (reponse);
    ErrBox.lines.Add ('PARAMETERS : ' +reponse);
    if pos('RAMPING',reponse)>0 then
              begin
              RampStatusLabel.caption:=copy(reponse,pos('RAMPING FROM',chaine),length(chaine)-pos('RAMPING FROM',chaine)+1);
              status:='RAMPING';
              end
              else
              begin
              if pos('HOLDING',reponse)>0 then
               begin
               chaine:=copy(reponse,pos('RAMP STATUS',reponse),length(reponse)-pos('RAMP STATUS',reponse));
               chaine:=copy(chaine,pos('TARGET',chaine),length(chaine)-pos('TARGET',chaine));
               chaine:=copy(chaine,11,pos('TESLA',chaine)-12);
               val(chaine,valeur,err);
               if err=0 then midvalue:=valeur else midvalue:=-999;
               str(midvalue:8:8,chaine);
               MidvalueLabel.caption:=chaine;
               chaine:=copy(reponse,pos('RAMP STATUS',reponse),length(reponse)-pos('RAMP STATUS',reponse));
               chaine:=copy(chaine,13,pos('TESLA',chaine)-12+5);
               RampStatusLabel.caption:=copy(chaine,13,length(chaine)-12);
               status:='HOLDING';
               end
                 else
                 begin
                 RampSTatusLabel.caption:='NOT KNOWN';
                 status:='NOT KNOWN';
                 end;
              end;
    RampStatusLabel.refresh;
end;
{*******************************************************************}
procedure TFieldSweepForm.CheckHeaterStatus(var reponseStatus:boolean);
{answers TRUE if switch ON and FALSE if switch OFF}
{envoie la commande RAMP S et analyse la rponse}
{reponse de la forme :
hors de la rampe : HEATER STATUS: OFF}

var chaine,reponse:string;
begin
{marche aleatoirement}
    commande ('H'+#13);
    ReadValue (reponse);
    ErrBox.lines.Add ('HEATER STATUS : ' +reponse);
    if pos(': ON',reponse)>0 then
              begin
              switchstatebox.text:='ON';
              end
              else
              if pos('OFF',reponse)>0 then
                 switchstatebox.text:='OFF'
                 else  switchstatebox.text:='NOT KNOWN';
    switchstatebox.refresh;
    if switchstatebox.text='ON' then reponseStatus:=true
                                else reponseStatus:=false;
end;
{*******************************************************************}
procedure TFieldSweepForm.ConversionTperAmpBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var valeur:extended;err:integer;
begin
  if  Key=13 {si return} then
  begin
     val(ConversionTPerAmpBox.text,valeur,err);
     if (err=0) then
       begin
       {demande de la valeur}
       if (valeur>=0.13) and (valeur<=0.15) then
          begin
          ChaineCommande:='SET TPA '+ConversionTPerAmpBox.text+#13;
          commande(ChaineCommande);
          end
          else ConversionTPerAmpBox.text:='NOT RECOGNIZED';
       end
       else
       ConversionTPerAmpBox.text:='NOT RECOGNIZED';
  end;
end;
{*******************************************************************}
procedure TFieldSweepForm.HeaterOutputBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var valeur:extended;err:integer;
begin
  if  Key=13 {si return} then
  begin
     val(HeaterOutPutBox.text,valeur,err);
     if (err=0) then
       begin
       {demande de la valeur}
       if (valeur>0) and (valeur<10) then
          begin
          ChaineCommande:='SET HEATER '+HeaterOutPutBox.text+#13;
          commande(ChaineCommande);
          end
          else ConversionTPerAmpBox.text:='NOT RECOGNIZED';
       end
       else
       ConversionTPerAmpBox.text:='NOT RECOGNIZED';
  end;
end;
{*******************************************************************}
procedure TFieldSweepForm.LimitVoltageBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var valeur:extended;err:integer;
begin
{CHANGEMENT DE LIMIT VOLTAGE}
  if  Key=13 {si return} then
  begin
     val(LimitVoltageBox.text,valeur,err);
     if (err=0) then
       begin
       {demande de la valeur}
       if (valeur<=3) and (valeur>0) then
          begin
          ChaineCommande:='SET LIMIT '+LimitVoltageBox.text+#13;
          commande(ChaineCommande);
          end
          else LimitVoltageBox.text:='NOT RECOGNIZED';
       end
       else
       LimitVoltageBox.text:='NOT RECOGNIZED';
  end;

end;
{*******************************************************************}
procedure TFieldSweepForm.ChangeField(Field:extended);
var status:string;MIDvalue,ramprate:extended;
var t0,t,start,temps,Time2,starttime:real;err:integer;
 drapeauInitialSwitchStatus:boolean;valeur,voltage,TotalTimeForRamp,nombre:extended;
 y,FieldValue:extended;reponseStatus:boolean;
 chaine:string;   fich:textfile;
 dateForTheInfo,valeurchamp,statutswitch:string;timeout:boolean;
 TempsDattente:integer;
 oldfield:extended;

begin
val(HMIDbox.text,oldfield,err);
midvaluebis.caption:='(CHANGING FIELD TO HMID= '+floattostr(field)+')';
midbox.visible:=false;
midvaluebis.refresh;


PreviousFieldValueBox.Caption:=ActualFieldValueBox.caption;
TimePreviousFieldValueBox.Caption:=TimeActualFieldValueBox.caption;
previousfieldValueBox.refresh;TimePreviousFieldValueBox.refresh;

if err<>0 then
          begin
       messagedlg('ATTENTION, Put first the good value of the previous field', mtInformation, [mbOk], 0);
       exit;
       end;


TimeLeftForRampLabel.visible:=true;
{si le switch a t mis il y a moins de 30 secondes, on attend jusqu' 30 sec}
if (TimeWhenSwitchHasBeenPutOn<>0) then
  begin
        t0:=(time-int(time))*86400;  {temps en s}
        repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
           start:= GetTickCount;
           REPEAT
             timeout:= ((GetTickCount - start) > 1000);
             Application.processMessages;
           UNTIL timeout;
           TimeLeftForRampLabel.Caption:=inttostr(round(30-t+t0));
        until ((t-t0)>30);
    TimeWhenSwitchHasBeenPutOn:=0;
  end;

{lecture du fichier des status du sweep}
if fexis(nomfichierSweep) then
   begin
   ReadFieldParametersInAscii;
   end
   else
   begin
   chaine:='Did not succeed to read '+NomFichierSweep+' - please update the field and switch value yourself before anything else';
   messagedlg(chaine, mtInformation, [mbOk], 0)
   end;

if (switchstatebox.text='ON') or (switchstatebox.text='OFF') then
begin

if switchstatebox.text='ON' then
   begin
   {cas du switch ON}
    drapeauInitialSwitchStatus:=true;
   end
   else
   begin
    {cas du switch OFF}
    drapeauInitialSwitchStatus:=false;
    ChaineCommande:='SET RAMP 6'+#13; {rampe rate a 6 amp/sec}
    commande(ChaineCommande);
    ChaineCommande:='RAMP MID'+#13; {ramp to mid}
    commande(ChaineCommande);

    switchstatecomment.caption:='THE CURRENT IS RAMPED TO THE OLD FIELD VALUE';
    switchstatecomment.refresh;
    switchstatebox.text:='OFF';
    switchstatebox.refresh;switchstatecomment.refresh;

    val(HMIDBox.text,nombre,err);
    if (err=0) then TempsDattente:=round((nombre-0)/(6*convTperAmp))+1
               else TempsDattente:=round((10-0)/(6*convTperAmp))+1;
    {boucle pendant le temps d'attente}
    t0:=(time-int(time))*86400;  {temps en s}
    repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
           start:= GetTickCount;
           REPEAT
             timeout:= ((GetTickCount - start) > 1000);
             Application.processMessages;
           UNTIL timeout;
           TimeLeftForRampLabel.Caption:=inttostr(round(TempsDattente-t+t0));
    until ((t-t0)>TempsDattente);

{    repeat
         t0:=(time-int(time))*86400;
         repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
 {          Application.processMessages;
         until ((t-t0)>1);
         checkrampstatus(status,midvalue);
         Time2:=(time-int(time))*86400;
         if Time2<StartTime then time2:=time2+86400;
         TimeLeftForRampLabel.caption:= inttostr(round(Time2-StartTime));
         TimeLeftForRampLabel.refresh;
    until (Status='HOLDING');}

    ChaineCommande:='H1'+#13; {switch ON, HEATER  ON}
    commande(ChaineCommande);
    switchstatecomment.caption:='THE CURRENT HAS REACHED THE OLD FIELD VALUE - Switch is now going from supra to normal';
    switchstatecomment.refresh;
    switchstatebox.text:='ON';
    switchstatebox.refresh;

    {attente de 30 secondes pour que le switch passe de supra  normal}
    t0:=(time-int(time))*86400;  {temps en s}
    repeat
         t:=(time-int(time))*86400;
         if t<t0 then t:=t+86400;  {correction bug passage par minuit}
         Application.processMessages;
         TimeLeftForRampLabel.Caption:=inttostr(round(30-t+t0));
    until ((t-t0)>30);
   end; {fin du switch off seulement}

   {la suite a toujours lieu quelque soit l'tat initial su switch}

{   val(ConversionTperAmpLabel.caption,convTPerAmp,err);
   if err<>0 then convTperAmp:=0.138;
 }
   val (RampeRateBox.text,rampRate,err);
   if err<>0 then rampRate:=0.05;
   str(rampRate:8:8,chaine);

   StatusOfTheFieldComment.caption:='THE FIELD IS RAMPING TO ITS NEW VALUE';
   StatusOfTheFieldComment.refresh;
   HMIDBox.text:='-----';
   HMIDBox.refresh;

    switchstatecomment.caption:='switch still in normal state';
    switchstatecomment.refresh;
    switchstatebox.text:='ON';
    switchstatebox.refresh;

   ChaineCommande:='SET RAMP '+chaine+#13; {rampe rate a 0.05 amp/sec}
   commande(ChaineCommande);
   str(Field:8:8,chaine);
   ChaineCommande:='SET MID '+chaine+#13;
   commande(ChaineCommande);
   {ecriture dans le fichier sweep pour updater le nouveau champ}
   str(Field:8:8,chaine);
   HMIDBox.Text:=chaine;
   HMIDBox.refresh;
   SauveFieldParametersInAscii(HMIDBox.text,'ON','?');

   {attente pendant la rampe}
   TempsDattente:=round(abs(field-oldfield)/(rampRate*convTperAmp))+1;

    {boucle pendant le temps d'attente}
    t0:=(time-int(time))*86400;  {temps en s}
    repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
           Application.processMessages;
           TimeLeftForRampLabel.Caption:=inttostr(round(TempsDattente-t+t0));
    until ((t-t0)>TempsDattente);


   {lecture du champ obtenu et affichage sur panneau avant}
   ReadFieldValue(false,Fieldvalue);
   str(fieldvalue:8:8,chaine);
   ActualFieldValueBox.caption:=chaine;
   chaine:=TimeToStr(Time)+','+DateToStr(Date);
   TimeActualFieldValueBox.caption:=chaine;
   ActualFieldValueBox.refresh;
   StatusOfTheFieldcomment.caption:='THE FIELD HAS REACHED ITS NEW VALUE - it is now stabilizing';
   StatusOfTheFieldcomment.refresh;


   {attente d'un delai fixe pour la stabilisation du champ}
   val(FieldStabilisationDelayBox.text,valeur,err);
   if (err<>0) then valeur:=30;
  {boucle attente valeur secondes}
   t0:=(time-int(time))*86400;  {temps en s}
   repeat
         t:=(time-int(time))*86400;
         if t<t0 then t:=t+86400;  {correction bug passage par minuit}
         Application.processMessages;
         TimeLeftForRampLabel.Caption:=inttostr(round(valeur-t+t0));
     until ((t-t0)>valeur);

   {lecture du champ obtenu et affichage sur panneau avant}
   ReadFieldValue(true,Fieldvalue);
   str(fieldvalue:8:8,chaine);
   ActualFieldValueBox.caption:=chaine;
   ActualFieldValueBox.refresh;
   chaine:=TimeToStr(Time)+','+DateToStr(Date);
   TimeActualFieldValueBox.caption:=chaine;
   TimeActualFieldValueBox.refresh;
   StatusOfTheFieldcomment.caption:='THE FIELD IS STABLE';
   StatusOfTheFieldcomment.refresh;

  {CHECK IF THE FIELD WERE IT WENT IS THE SAME AS THE ONE ASKED MORE OR LESS}
  val(ActualFieldValueBox.caption,nombre,err);
  if (err=0) then
   begin
   if (abs(nombre-field)>0.1) then {CONDITION : field reached must be closer to
   field asked than 0.1 Tesla}
     begin
      boitnoir.receivetext('PROBLEM : field asked ='+floattostr(field)+' but field actually reached = '
                           +floattostr(nombre)+' at '+copy(timetostr(time),1,length(timetostr(time))-3)+' , '+DateToStr(Date));
      {there is a problem : actual field is too much different than the one asked}
      {put it back to zero}
      DrapeauChangeFieldLoop:=true;
      changefield(0);
      {attente 15 mn pour eventuellement que les amenees de courant se refroidissent}
      t0:=(time-int(time))*86400;  {temps en s}
      repeat
         t:=(time-int(time))*86400;
         if t<t0 then t:=t+86400;  {correction bug passage par minuit}
         Application.processMessages;
         TimeLeftForRampLabel.Caption:=inttostr(round(valeur-t+t0));
      until ((t-t0)>900);
      {on demande ensuite  nouveau la valeur voulue au depart}
      boitnoir.receivetext('Go back to the field which was asked');
      changefield(field);
      exit; {dans le cas ou on redemande le champ, on ne le fait qu'une fois
      et on ne veut plus executer le bout qui suit}
     end;
   end;
   {END OF THE TEST IF THE FIELD REACHED WAS THE FIELD ASKED}

   {ecriture dans le fichier sweep pour updater le nouveau champ}
   SauveFieldParametersInAscii(HMIDBox.text,'ON',actualfieldvaluebox.caption);


   if (drapeauInitialSwitchStatus=false) then
      begin
      {cas o le switch au dpart tait  OFF : on l'eteint  nouveau}
      ChaineCommande:='H0'+#13; {switch OFF, HEATER  OFF}
      commande(ChaineCommande);
    switchstatecomment.caption:='going from normal to supra';
    switchstatecomment.refresh;
    switchstatebox.text:='OFF';
    switchstatebox.refresh;

     {ecriture dans le fichier sweep pour updater le nouveau switch}
      SauveFieldParametersInAscii(HMIDBox.text,'OFF',actualfieldvaluebox.caption);

      {attente de 30 secondes pour que le switch passe de supra  normal}
      t0:=(time-int(time))*86400;  {temps en s}
      repeat
         t:=(time-int(time))*86400;
         if t<t0 then t:=t+86400;  {correction bug passage par minuit}
         Application.processMessages;
         TimeLeftForRampLabel.Caption:=inttostr(round(valeur-t+t0));
      until ((t-t0)>30);

      switchstatecomment.caption:='THE CURRENT IS RAMPING BACK TO ZERO - switch in supra state';
      switchstatecomment.refresh;
      switchstatebox.text:='OFF';
      switchstatebox.refresh;

      ChaineCommande:='SET RAMP 6'+#13; {rampe rate  6 amps}
      commande(ChaineCommande);
      ChaineCommande:='RAMP ZERO'+#13; {rampe ramen  0 amps}
      commande(ChaineCommande);

      val(HMIDBox.text,nombre,err);
      if (err=0) then TempsDattente:=round(abs(oldfield-nombre)/(6*convTperAmp))+1
               else TempsDattente:=round((10-0)/(6*convTperAmp))+1;
      {boucle pendant le temps d'attente}
      t0:=(time-int(time))*86400;  {temps en s}
      repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
           start:= GetTickCount;
           REPEAT
             timeout:= ((GetTickCount - start) > 1000);
             Application.processMessages;
           UNTIL timeout;
           TimeLeftForRampLabel.Caption:=inttostr(round(TempsDattente-t+t0));
      until ((t-t0)>TempsDattente);
      switchstatecomment.caption:='---------------------';
      switchstatecomment.refresh;
      end;
   TimeLeftForRampLabel.visible:=false;
   midbox.visible:=true;

end
else
MessageDlg('Heater status not known - pb with GPIB', mtInformation, [mbOk], 0);

midbox.text:='';midbox.refresh;
end;
{*******************************************************************}
procedure TFieldSweepForm.ReadFieldValue(DrapeauCommentBoitenoire:boolean;var Fieldvalue:extended);
{reads the keithley and convert it to TEsla
If drapeauCommentBoiteNoire=true then puts the value in the boite noire}
var voltage:extended;
    chaine:string;
{in tesla}
begin
   FieldSweepKeithleyForm.ReadVoltage(voltage);{lecture Keithley}
   if voltage<>-999 then FieldValue:=ConversionKeithleyVoltageToTesla*voltage{conversion en Tesla}
      else fieldvalue:=-999;
   str(fieldvalue:8:8,chaine);
   FieldValuecaption.caption:=chaine;
   FieldValuecaption.refresh;
   boitnoir.receivetext('H='+fieldsweepform.fieldvaluecaption.caption +' T at '
                   +copy(timetostr(time),1,length(timetostr(time))-3)+' , '+DateToStr(Date));
end;

procedure TFieldSweepForm.Button1Click(Sender: TObject);
var fieldvalue:extended;
begin
   ReadFieldValue(true,Fieldvalue);
end;
                                
procedure TFieldSweepForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var reponse:string;
begin
  if  Key=13 {si return} then
  begin
    ChaineCommande:=Edit1.Text+#13;
    commande(ChaineCommande);
    ReadValue (reponse);
    ErrBox.lines.Add (reponse);
  end;

end;

procedure TFieldSweepForm.HMIDBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var valeur:extended;err:integer;fich:textfile;chaine:string;
begin
{CHANGEMENT MANUEL DU UPDATE FIELD}
  if  Key=13 {si return} then
  begin
     val(HMIDBox.text,valeur,err);
     if err=0 then
             begin
             {ecriture dans le fichier sweep pour updater le nouveau champ}
             SauveFieldParametersInAscii(HMIDBox.text,switchstatebox.Text,actualfieldvaluebox.caption)
             end
             else HMIDBOX.text:='NOT KNOWN';
  end;
end;

procedure TFieldSweepForm.SwitchStateBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var valeur:extended;err:integer;fich:textfile;chaine:string;
begin
{CHANGEMENT MANUEL DU UPDATE FIELD}
  if  Key=13 {si return} then
  begin
     if (SwitchStateBox.text='ON') or (SwitchStateBox.text='OFF') then
             begin
             {ecriture dans le fichier sweep pour updater le nouveau champ}
             SauveFieldParametersInAscii(HmidBox.text,switchstatebox.Text,actualfieldvaluebox.caption)
             end
             else SwitchStateBox.text:='NOT KNOWN';
  end;
end;

procedure TFieldSweepForm.SauveFieldParametersInAscii(fieldValueChaine:string;switchstate:string;actualfieldvalue:string);
var fich:textfile;chaine:string;
begin
   {ecriture dans le fichier sweep pour updater le nouveau champ}
   assignfile(fich,nomFichierSweep);
   rewrite(fich);
   chaine:='last update of Field SMS values done at :';
   writeln(fich,chaine);
   chaine:=TimeToStr(Time)+','+DateToStr(Date);
   writeln(fich,chaine);
   DateUpdate.caption:=chaine;DateUpdate.refresh;
   chaine:='Field value (Tesla):';
   writeln(fich,chaine);
   writeln(fich,fieldvaluechaine);
   chaine:='Switch status (ON or OFF):';
   writeln(fich,chaine);
   writeln(fich,switchstate);
   chaine:='Last real Field Value from keithley:';
   writeln(fich,chaine);
   writeln(fich,actualfieldvalue);

   closefile(fich);
end;

procedure TFieldSweepForm.ReadFieldParametersInAscii;
var fich:textfile;chaine:string;actualfieldvalue,datefortheinfo,valeurchamp,statutswitch:string;
    nombre:extended;err:integer;
begin
   assignfile(fich,nomFichierSweep);
   reset(fich);
   readln(fich,chaine);
   readln(fich,dateForTheInfo);
   readln(fich,chaine);
   readln(fich,ValeurChamp);
   readln(fich,chaine);
   readln(fich,statutSwitch);
   readln(fich,chaine);
   readln(fich,actualfieldvalue);
   closefile(fich);
   actualfieldvaluebox.caption:=actualfieldvalue;
   actualfieldvaluebox.refresh;
   DateUpdate.caption:=dateForTheInfo;DateUpdate.refresh;
   val(ValeurChamp,Nombre,err);
   if err=0 then HMIDBox.text:=valeurChamp
            else HMIDBox.text:='NOT KNOWN';
   if (statutSwitch='ON') or (statutSwitch='OFF') then switchstatebox.text:=statutSwitch
                                                  else switchstatebox.text:='NOT KNOWN';


end;

procedure TFieldSweepForm.PutSwitchOn;
var t0,t:extended;nombre:extended;err,start,tempsdattente:integer;
    timeout:boolean;
begin
   {qd on passe le switch ON, il bloque toute commande possible de mid pdt
   30 secondes}
   TimeWhenSwitchHasBeenPutOn:=time;
   ChaineCommande:='SET RAMP 6'+#13; {rampe rate a 6 amp/sec}
   commande(ChaineCommande);
   ChaineCommande:='RAMP MID'+#13; {ramp to mid}
   commande(ChaineCommande);
   val(HMIDBox.text,nombre,err);
   if (err=0) then TempsDattente:=round((nombre-0)/(6*convTperAmp))+1
               else TempsDattente:=round((10-0)/(6*convTperAmp))+1;
    {boucle pendant le temps d'attente}
   t0:=(time-int(time))*86400;  {temps en s}
   repeat
           t:=(time-int(time))*86400;
           if t<t0 then t:=t+86400;  {correction bug passage par minuit}
           start:= GetTickCount;
           REPEAT
             timeout:= ((GetTickCount - start) > 1000);
           UNTIL timeout;
           TimeLeftForRampLabel.Caption:=inttostr(round(TempsDattente-t+t0));
    until ((t-t0)>TempsDattente);

   ChaineCommande:='HEATER1'+#13;
   commande(ChaineCommande);
   switchstatebox.text:='ON';switchstatecomment.caption:='---------------';
   SauveFieldParametersInAscii(HMIDBox.text,switchstatebox.text,actualfieldvaluebox.caption);
   TimeSwitch:=time;


end;

procedure TFieldSweepForm.PutSwitchOff;
var t0,t:extended;
begin
   {qd on passe le switch ON, il bloque toute commande possible de mid pdt
   30 secondes}
   TimeWhenSwitchHasBeenPutOn:=time;

   ChaineCommande:='HEATER0'+#13;
   commande(ChaineCommande);
   switchstatecomment.caption:='going from supra to normal';
   switchstatecomment.refresh;
   switchstatebox.text:='OFF';
   switchstatebox.refresh;

  {ecriture dans le fichier sweep pour updater le nouveau switch}
  SauveFieldParametersInAscii(HMIDBox.text,'OFF',actualfieldvaluebox.caption);

  {attente de 30 secondes pour que le switch passe de supra  normal}
  t0:=(time-int(time))*86400;  {temps en s}
      repeat
         t:=(time-int(time))*86400;
         if t<t0 then t:=t+86400;  {correction bug passage par minuit}
         TimeLeftForRampLabel.Caption:=inttostr(round(30-t+t0));
      until ((t-t0)>30);

   ChaineCommande:='SET RAMP 6'+#13; {rampe rate a 6 amp/sec}
   commande(ChaineCommande);
   ChaineCommande:='RAMP ZERO'+#13; {ramp to mid}
   commande(ChaineCommande);
   switchstatebox.text:='OFF';switchstatecomment.caption:='---------------';
   TimeSwitch:=time;

end;


end.
