{ATTENTION MODIF OCTOBRE 2005 QUAND J'AI INSTALLE LA GAGE 14100 :
j'ai mis en commentaire les procedures gage_get_interpolate
et gage_32k_to_buffer qui devaient servir au fonctionnement de la 1012

 remettre si besoin...}


{ATTENTION : modif de mars 2004 pas forcement judicieuse :
j'ai remplace 'gage_drv' par 'gage_drv.dll' dans cette unite,
ce qui dirige peut etre vers la mauvaise dll. J'ai fait a pour
l'installation sous W2000, mais ca marchait sans avec la 1012 avant.
Cela marchera-t-il avec aprs ???




{********************************************************}
{                                                        }
{   Gage_drv.Pas                    Version 2.85         }
{   For CompuScope boards and Microsoft Windows 3.x.     }
{   Copyright (c) 1993 Gage Applied Sciences Inc.        }
{   Last Update:                    12/02/94             }
{                                                        }
{********************************************************}

unit Gage_drv;

interface

uses   Windows, Messages;

const
{----------------------------------------------------------}

{       All global definitions of constants, variables and functions
	that are user usable and callable.			      }

{	Compuscope driver error codes.  These values are returned in
	the low byte of the error variable (gage_error_code).  The high
	byte contains the number of the board that caused the error.  }

	GAGE_NO_ERROR		      = $00;
	GAGE_NO_SUCH_BOARD	      = $01;
	GAGE_NO_SUCH_MODE	      = $02;
	GAGE_NO_SUCH_INPUT	      = $03;
	GAGE_INVALID_SAMPLE_RATE  = $04;
	GAGE_NO_SUCH_COUPLING	  = $05;
	GAGE_NO_SUCH_CHANNEL	  = $06;
	GAGE_NO_SUCH_GAIN	      = $07;
	GAGE_NO_SUCH_TRIG_DEPTH	  = $08;
	GAGE_NO_SUCH_TRIG_POINT   = $09;
	GAGE_NO_SUCH_TRIG_SLOPE   = $0a;
	GAGE_NO_SUCH_TRIG_SOURCE  = $0b;

	GAGE_MISC_ERROR		      = $ff;

{	CompuScope buffer size.  }

	GAGE_MAX_RAM_WINDOW	        = 4096;    { CompuScope area for RAM exchanges }
	GAGE_DOUBLE_MAX_RAM_WINDOW  = 8192;
	GAGE_DUAL_SHIFT_VALUE	    = 12;
	GAGE_DUAL_AND_VALUE	        = 4095;
	GAGE_SINGLE_SHIFT_VALUE	    = 13;
	GAGE_SINGLE_AND_VALUE	    = 8191;

{	CompuScope channel and trigger source values.  }

	GAGE_SINGLE_CHAN    = 1;
	GAGE_DUAL_CHAN	    = 2;

	GAGE_CHAN_A	        = 1;
	GAGE_CHAN_B	        = 2;
        GAGE_CH_A_CH_B      = 3;
	GAGE_EXTERNAL	    = 4;
	GAGE_SOFTWARE	    = 5;
	GAGE_EXTERNAL_DIV_5 = 6;	{ Only available on the CS1012. }


{	CompuScope channel input source values.  }

	GAGE_INPUT_ENABLE   = 1;		    { Use with CS6012, CS1012, CS250, CS225  and CS220 }
	GAGE_INPUT_DISABLE  = 2;                    { Use with CS6012, CS1012, CS250, CS225 and CS220 }
	GAGE_INPUT_DATA	    = GAGE_INPUT_ENABLE;    { Use with CSLITE }
	GAGE_INPUT_TEST	    = GAGE_INPUT_DISABLE;   { Use with CSLITE }

{	CompuScope trigger type values.  }

	GAGE_DC	= 1;
	GAGE_AC	= 2;

{	CompuScope trigger slope values.  }

	GAGE_POSITIVE = 1;
	GAGE_NEGATIVE = 2;

{	CompuScope sample rate multiplier values.  }

	GAGE_HZ	     = 1;
	GAGE_KHZ     = 2;
	GAGE_MHZ     = 3;
	GAGE_GHZ     = 4;
	GAGE_EXT_CLK = 5;
	GAGE_SW_CLK  = 6;

{	CompuScope sample rate rate values.  }

	GAGE_RATE_1   = 1;
	GAGE_RATE_2   = 2;
	GAGE_RATE_4   = 4;
	GAGE_RATE_5   = 5;
	GAGE_RATE_10  = 10;
	GAGE_RATE_20  = 20;
	GAGE_RATE_25  = 25;	{ Used only with GAGE_MHZ and CS250. }
	GAGE_RATE_30  = 30;	{ Used only with GAGE_MHZ and CS6012.}
	GAGE_RATE_40  = 40;	{ Used only with GAGE_MHZ and CSLITE or CS220 }
	GAGE_RATE_50  = 50;
	GAGE_RATE_60  = 60;	{ Used only with GAGE_MHZ and CS6012.}
	GAGE_RATE_100 = 100;
	GAGE_RATE_120 = 120;	{ Used only with GAGE_MHZ for future use. }
	GAGE_RATE_125 = 125;	{ Used only with GAGE_MHZ and CS2125.}
	GAGE_RATE_150 = 150;	{ Used only with GAGE_MHZ for future use. }
	GAGE_RATE_200 = 200;
	GAGE_RATE_250 = 250;	{ Used only with GAGE_MHZ and CS2125.}
	GAGE_RATE_300 = 300;	{ Used only with GAGE_MHZ for future use. }
	GAGE_RATE_500 = 500;
    GAGE_RATE_12500 = 12500;{ Used only with GAGE_KHZ and CS225 for 12.5 MHz. }

{	CompuScope gain values.  }
        	  { Supported by Board:          1012    250   220   LITE  }
	GAGE_PM_10_V	= 0;  {+\- 10 volts        No     No    No     No  }
	GAGE_PM_5_V     = 1;  {+\- 5 volts         Yes    Yes   Yes    No  }
	GAGE_PM_2_V     = 2;  {+\- 2 volts         Yes    No    Yes    No  }
	GAGE_PM_1_V     = 3;  {+\- 1 volts         Yes    Yes   Yes    Yes }
	GAGE_PM_500_MV	= 4;  {+\- 500 millivolts  Yes    Yes   Yes    No  }
	GAGE_PM_200_MV	= 5;  {+\- 200 millivolts  Yes    Yes   Yes    Yes }
	GAGE_PM_100_MV	= 6;  {+\- 100 millivolts  Yes    Yes   Yes    No  }
	GAGE_MAX_RANGES	= 7;  { Used by CS2125, CS6012 and CS1012 code to access gain/offset }
			              { values in the local "dac_12_bit_values array}

{   Old gain constants, kept for compatibility. }
    GAGE_DIVIDE_10  = 0;
    GAGE_DIVIDE_5   = 1;
    GAGE_DIVIDE_2   = 2;
    GAGE_TIMES_1    = 3;
    GAGE_TIMES_2    = 4;
    GAGE_TIMES_5    = 5;
    GAGE_TIMES_10   = 6;


{	CompuScope trigger point values.  }

	GAGE_POST_0K   = 0;
	GAGE_POST_128  = 128;
	GAGE_POST_256  = 256;
	GAGE_POST_512  = 512;
	GAGE_POST_1K   = 1024;
	GAGE_POST_2K   = 2048;
	GAGE_POST_4K   = 4096;
	GAGE_POST_8K   = 8192;
	GAGE_POST_16K  = 16384;
	GAGE_POST_32K  = 32768;
	GAGE_POST_64K  = 65536;
	GAGE_POST_128K = 131072;
	GAGE_POST_256K = 262144;
	GAGE_POST_512K = 524288;
	GAGE_POST_1M   = 1048576;
	GAGE_POST_2M   = 2097152;
	GAGE_POST_4M   = 4194304;
	GAGE_POST_8M   = 8388608;


{***************************************************************************\
*																			*
*	CompuScope gage_board_location structure.								*
*	=========================================								*
*																			*
*			GAGE_B_L_ELEMENT_SIZE	    	GAGE_B_L_STATUS_SIZE			*
*				  _|_					     _|_						    *
*				 /   \					    /   \						    *
*																			*
* array index:	0	1	2	3	...	30	31	32	33	34	35	...	62	63	    *
*																			*
* meaning:     S1   I1	S2	I2	...	S16	I16	B1	E1	B2	E2	...	B16	E16	    *
*										    ^							    *
*										    |							    *
*								            GAGE_B_L_STATUS_START		    *
*																			*
*	where:		Sx = segment for board x,								    *
*				Ix = index for board x,									    *
*				Bx = returned board type for board x,					    *
*				Ex = returned status error for board x.					    *
*																			*
\***************************************************************************}


{	CompuScope definitions for gage_board_location sizing.  }

	GAGE_B_L_MAX_CARDS	    = 1;
	GAGE_B_L_SIZEOF_ELEMENT = 2;
	GAGE_B_L_ELEMENT_SIZE	= 2;
	GAGE_B_L_STATUS_SIZE	= 2;
	GAGE_B_L_STATUS_START	= (GAGE_B_L_MAX_CARDS * GAGE_B_L_ELEMENT_SIZE);
	GAGE_B_L_BUFFER_SIZE	= (GAGE_B_L_MAX_CARDS * (GAGE_B_L_ELEMENT_SIZE + GAGE_B_L_STATUS_SIZE));


{	CompuScope definitions for gage_board_location status errors.  }

	GAGE_BAD_LSB_SEGMENT	= $0001;
	GAGE_BAD_MSB_SEGMENT	= $0002;
	GAGE_BAD_LSB_INDEX		= $0004;
	GAGE_BAD_MSB_INDEX		= $0008;
	GAGE_DETECT_FAILED		= $0010;
	GAGE_MEMORY_FAILED		= $0020;
	GAGE_BAD_MEMORY_SIZE	= $0040;

	GAGE_ALL_NON_GAGE_STATUS_ERRORS	= $0000;
	GAGE_ALL_GAGE_STATUS_ERRORS	    = (GAGE_BAD_LSB_SEGMENT OR GAGE_BAD_MSB_SEGMENT OR GAGE_BAD_LSB_INDEX
                                           OR GAGE_BAD_MSB_INDEX OR GAGE_DETECT_FAILED OR GAGE_MEMORY_FAILED
                                           OR GAGE_BAD_MEMORY_SIZE);
	GAGE_ALL_STATUS_ERRORS		    = (GAGE_ALL_NON_GAGE_STATUS_ERRORS OR GAGE_ALL_GAGE_STATUS_ERRORS);


{   CompuScope definitions for "board_type" test override values and for
	"gage_board_location" status checks.  The CS2125 is included here for
	future use.  The CS25016 will also be released in the near future.	}

	GAGE_ASSUME_NOTHING	     = $0000;
        GAGE_ASSUME_CS225        = $0040;
	GAGE_ASSUME_CS25016	     = $0080;	{  CS250:  Version 1.6+.	}
	GAGE_ASSUME_CSLITE	     = $0100;
	GAGE_ASSUME_CS220	     = $0200;
	GAGE_ASSUME_CS250	     = $0400;
	GAGE_ASSUME_CSLITE15	 = $0800;	{  CSLITE: Version 1.5+.	}
	GAGE_ASSUME_CS1012	     = $1000;
	GAGE_ASSUME_CS6012	     = $2000;
	GAGE_ASSUME_CS2125	     = $4000;
	GAGE_ASSUME_RESERVED	 = $8000;
	GAGE_ASSUME_ALL_BOARDS	 = (GAGE_ASSUME_CS25016 OR
				               GAGE_ASSUME_CSLITE   OR
				               GAGE_ASSUME_CS220    OR
                               GAGE_ASSUME_CS225    OR
				               GAGE_ASSUME_CS250    OR
				               GAGE_ASSUME_CSLITE15 OR
				               GAGE_ASSUME_CS1012   OR
				               GAGE_ASSUME_CS6012   OR
				               GAGE_ASSUME_CS2125);

{	CompuScope definitions for memory test override values.  }

	GAGE_MEMORY_SIZE_TEST	= 0;
	GAGE_MEMORY_SIZE_16K	= 16;
	GAGE_MEMORY_SIZE_32K	= 32;
	GAGE_MEMORY_SIZE_64K	= 64;
	GAGE_MEMORY_SIZE_128K	= 128;
	GAGE_MEMORY_SIZE_256K	= 256;
	GAGE_MEMORY_SIZE_512K	= 512;
	GAGE_MEMORY_SIZE_001M	= 1024;
	GAGE_MEMORY_SIZE_002M	= 2048;
	GAGE_MEMORY_SIZE_004M	= 4096;
	GAGE_MEMORY_SIZE_008M	= 8192;

{----------------------------------------------------------}


type
        int16 = smallint;
        int32 = integer;
        uInt8 = byte;
        uInt16 = word;
        pint16 = ^int16;
        pint32 = ^int32;
        puInt8 = ^uInt8;
        puInt16 = ^uInt16;
        gdiPtr = ^gage_driver_info_type;
        gdiPtrPtr =  ^gdiPtr;
        address = array[0..GAGE_B_L_MAX_CARDS * 2 - 1] of int32;

gage_driver_info_type = record
		index:   uInt16;
		segment: uInt16;
		board_type: uInt16;
		max_memory: int32;
		max_available_memory: int32;
		bank_offset_value: uInt16;
		mode: int16;
		enable_a: int16;
		enable_b: int16;
		rate: int16;
		multiplier: int16;
		coupling_a: int16;
		coupling_b: int16;
		coupling_ext: int16;
		gain_a: int16;
		gain_b: int16;
		gain_ext: int16;
		trigger_depth: int32;
		trigger_level: int16;
		trigger_slope: int16;
		trigger_source: int16;
		trigger_res: int16;
		multiple_recording: int16;
		sample_offset: int16;
		sample_resolution: int16;
		sample_bits: int16;
		external_clock_delay: uInt16;
		external_clock_rate: single;
        sample_rate: single;
        memptr: Pointer;
end;



	{ Type definition for gage_board_location  }

gage_b_l_array = array[0..GAGE_B_L_BUFFER_SIZE] of uInt16;



	{	Routines to initialize the driver and CompuScope and select which
		CompuScope to control.  }

procedure	gage_make_error_code(board, error: uInt16);stdcall;
function	gage_get_config_filename(cfgfn: pchar): word;stdcall;
function	gage_read_config_file(filename: pchar; var records: gage_b_l_array): int16;stdcall;
function	gage_set_records(var records: gage_b_l_array; rec: int16; segment, index, typename, status: uInt16): int16;stdcall;
function        gage_get_records(var records: gage_b_l_array; rec: int16; var segment: uInt16; var index: uInt16;
                                 var typename: uInt16; var status: uInt16): int16;stdcall;
function	gage_driver_initialize(var records: gage_b_l_array; memory: uInt16): int16;stdcall;
procedure       gage_driver_remove;stdcall;
function	gage_select_board(board: int16): int16;stdcall;
function	gage_get_boards_found: int16;stdcall;
function	gage_get_error_code: int16;stdcall;

function	gage_trigger_address: int32;stdcall;
procedure	gage_start_capture(auto_trigger: int16);stdcall;
procedure	gage_initialize_start_capture(hardware_to_use: int16);stdcall;
procedure	gage_abort_capture(reset_trigger_source: int16);stdcall;
procedure	gage_forced_trigger_capture(reset_trigger_source: int16);stdcall;
function	gage_normalize_address(start, address, ram_size: int32): int32;stdcall;
procedure	gage_calculate_addresses(chan, op_mode: int16; tbs: single; var trig: int32;
                                      var start: int32; var endaddr: int32);stdcall;
function	gage_calculate_mr_addresses(group: int32; board_type: int16; depth, memory: int32;
                                                     chan, op_mode: int16; tbs: single; var trig: int32;
                                                     var start: int32; var endaddr: int32): int32;stdcall;



	{ ALL the following routines work with the current selected board }
	{ as determined by "gage_select_board"			    }


	{ Routines that configure a CompuScope board for the desired mode of operation }
	{ and with the desired parameters.						 }

function	gage_input_control(channel, enable, coupling, gain: int16): int16;stdcall;
function	gage_capture_mode(mode, rate, multiplier: int16): int16;stdcall;
function	gage_trigger_control(source, ext_coupling, ext_gain, slope, level: int16; depth: int32): int16;stdcall;


	{ Routines that allow control over the CompuScope disabling and enabling data capturing,   }
	{ reading internal memory buffers and also getting the trigger addresses in the CompuScope }
	{ to allow for repetious capture of signals.						     }


procedure	gage_abort;stdcall;
procedure	gage_get_data;stdcall;
procedure	gage_get_data_low;stdcall;
procedure	gage_get_data_high;stdcall;
procedure	gage_need_ram(need: int16);stdcall;
function	gage_mem_read_dual(channel: int16; location: int32): int16;stdcall;
function	gage_mem_read_chan_a(location: int32): int16;stdcall;
function	gage_mem_read_chan_b(location: int32): int16;stdcall;
function	gage_mem_read_single(location: int32): int16;stdcall;


	{ Routines that, under software control, activate normally automatic functions within   }
	{ the CompuScope for starting and performing data capture.	  }

procedure	gage_software_clock;stdcall;
procedure	gage_software_trigger;stdcall;


	{ Routines to read back various control signals generated by the CompuScope to provide	}
	{	the application writer feedback from the current board's operational state.	  }

function	gage_busy: int16;stdcall;
function	gage_ram_full: int16;stdcall;
function	gage_triggered: int16;stdcall;
function	gage_triggered_aux: int16;stdcall;
function    gage_read_master_status: int16;stdcall;
procedure	gage_get_driver_info(var driver_info: gage_driver_info_type);stdcall;


	{ Routines that control how the memory buffers are accessed and located.  }

procedure	gage_set_block_number(block: uInt16);stdcall;
procedure	gage_fast_set_block_number(block: uInt16);stdcall;
{procedure	gage_32k_to_buffer(var buffer: uInt8; high_half, start_block: int16; var blocks_transfered: int16);stdcall;}
procedure	gage_get_trigger_view_offset (offset: pint32);stdcall;
procedure	gage_set_trigger_view_offset (offset: int32);stdcall;
procedure	gage_trigger_view_transfer(channel: int16; var buffer: uInt8; nsamples: int16);stdcall;


	{ Routines that control miscellaneous functions.	   }

procedure	gage_init_clock;stdcall;
procedure	gage_multiple_record(mode: uInt16);stdcall;
function	gage_detect_multiple_record: int16;stdcall;


	{ Routines that handle interpolated trigger functionality.  }

procedure	gage_reset_interpolate_trigger (board, channel, auto_mode, level, slope: int16);stdcall;
{procedure	gage_get_interpolate_trigger (action, chan: int16; var trig: int32; start, endaddr: int32);stdcall;
 }

procedure   gage_update_driver_info;stdcall;
procedure   gage_get_driver_info_structure (major_version: puInt16; minor_version: puInt16; board_support: puInt16;
                                           gdi: gdiPtrPtr; gdi_size: pint32);stdcall;
procedure   gage_set_ext_clock_variables (external_clock_delay: uInt16; external_clock_rate: single);stdcall;


	{ CS1012 specific routines.	}

procedure	cs1012_enable_test_memory(test: int16);stdcall;
procedure	cs1012_test_memory_chan(channel: int16);stdcall;
procedure	cs1012_offset_adjust(channel, offset_adjust: int16);stdcall;
function	cs1012_trigger_control_2 (source_1, source_2, ext_coupling,ext_gain,slope_1,slope_2,level_1,level_2:int16;
								   depth: int32; trigger_from_bus,trigger_to_bus: int16): int16;stdcall;

    { CS250 specific routines for equivalent time sampling. }

procedure   cs250_enable_ets (ets: int16);stdcall;
procedure   cs250_ets_average_capture (auto_trigger: int16; timeout: int32; avgs: int16);stdcall;
procedure   cs250_ets_average_capture_2 (auto_trigger: int16; timeout: int32; avgs: int16;
                                                       var a_buffer: uInt8; var b_buffer: uInt8);stdcall;
procedure   cs250_ets_capture (auto_trigger: int16; timeout: int32);stdcall;
procedure   cs250_ets_capture_2 (auto_trigger: int16; timeout: int32; var a_buffer: uInt8; var b_buffer: uInt8);stdcall;
function    cs250_ets_detect: int16;stdcall;
procedure   cs250_mem_read_ets_data (location: int32; var abuf: uInt8; var bbuf: uInt8);stdcall;
procedure   cs250_set_ets_delay (ets_delay: int16);stdcall;
procedure   cs250_set_ets_rate (ets_rate: int16);stdcall;


implementation

{procedure	gage_32k_to_buffer;			                external 'gage_drv.dll';}
procedure	gage_abort;				                    external 'gage_drv.dll';
procedure	gage_abort_capture;			                external 'gage_drv.dll';
function	gage_busy;				                    external 'gage_drv.dll';
procedure	gage_calculate_addresses;		            external 'gage_drv.dll';
function	gage_calculate_mr_addresses;                external 'gage_drv.dll';
function	gage_capture_mode;			                external 'gage_drv.dll';
function	gage_detect_multiple_record;		        external 'gage_drv.dll';
function	gage_driver_initialize;			            external 'gage_drv.dll';
procedure   gage_driver_remove;                         external 'gage_drv.dll';
procedure	gage_fast_set_block_number;		            external 'gage_drv.dll';
procedure	gage_forced_trigger_capture;		        external 'gage_drv.dll';
function	gage_get_boards_found;			            external 'gage_drv.dll';
function	gage_get_config_filename;		            external 'gage_drv.dll';
procedure	gage_get_data;				                external 'gage_drv.dll';
procedure	gage_get_data_high;			                external 'gage_drv.dll';
procedure	gage_get_data_low;			                external 'gage_drv.dll';
procedure	gage_get_driver_info;			            external 'gage_drv.dll';
procedure   gage_get_driver_info_structure;             external 'gage_drv.dll';
function	gage_get_error_code;			            external 'gage_drv.dll';
{procedure	gage_get_interpolate_trigger;		        external 'gage_drv.dll';
}function    gage_get_records;                           external 'gage_drv.dll';
procedure	gage_get_trigger_view_offset;		        external 'gage_drv.dll';
procedure	gage_init_clock;			                external 'gage_drv.dll';
procedure	gage_initialize_start_capture;		        external 'gage_drv.dll';
function	gage_input_control;			                external 'gage_drv.dll';
procedure	gage_make_error_code;			            external 'gage_drv.dll';
function	gage_mem_read_chan_a;			            external 'gage_drv.dll';
function	gage_mem_read_chan_b;			            external 'gage_drv.dll';
function	gage_mem_read_dual;			                external 'gage_drv.dll';
function	gage_mem_read_single;			            external 'gage_drv.dll';
procedure	gage_multiple_record;			            external 'gage_drv.dll';
procedure	gage_need_ram;				                external 'gage_drv.dll';
function	gage_normalize_address;			            external 'gage_drv.dll';
function	gage_ram_full;				                external 'gage_drv.dll';
function	gage_read_config_file;			            external 'gage_drv.dll';
function    gage_read_master_status;                    external 'gage_drv.dll';
procedure	gage_reset_interpolate_trigger;	            external 'gage_drv.dll';
function	gage_select_board;			                external 'gage_drv.dll';
procedure	gage_set_block_number;			            external 'gage_drv.dll';
procedure   gage_set_ext_clock_variables;               external 'gage_drv.dll';
function	gage_set_records;			                external 'gage_drv.dll';
procedure	gage_set_trigger_view_offset;		        external 'gage_drv.dll';
procedure	gage_software_clock;			            external 'gage_drv.dll';
procedure	gage_software_trigger;			            external 'gage_drv.dll';
procedure	gage_start_capture;			                external 'gage_drv.dll';
function	gage_trigger_address;			            external 'gage_drv.dll';
function	gage_trigger_control;			            external 'gage_drv.dll';
procedure	gage_trigger_view_transfer;		            external 'gage_drv.dll';
function	gage_triggered;				                external 'gage_drv.dll';
function	gage_triggered_aux;			                external 'gage_drv.dll';
procedure   gage_update_driver_info;                    external 'gage_drv.dll';
procedure	cs1012_enable_test_memory;		            external 'gage_drv.dll';
procedure	cs1012_test_memory_chan;		            external 'gage_drv.dll';
procedure	cs1012_offset_adjust;			            external 'gage_drv.dll';
function	cs1012_trigger_control_2;		            external 'gage_drv.dll';
procedure   cs250_enable_ets;                           external 'gage_drv.dll';
procedure   cs250_ets_average_capture;                  external 'gage_drv.dll';
procedure   cs250_ets_average_capture_2;                external 'gage_drv.dll';
procedure   cs250_ets_capture;                          external 'gage_drv.dll';
procedure   cs250_ets_capture_2;                        external 'gage_drv.dll';
function    cs250_ets_detect;                           external 'gage_drv.dll';
procedure   cs250_mem_read_ets_data;                    external 'gage_drv.dll';
procedure   cs250_set_ets_delay;                        external 'gage_drv.dll';
procedure   cs250_set_ets_rate;                         external 'gage_drv.dll';
end.
