unit AcquisitionRMN;
{modif: 30/10/00 Edouard :+ procedure cocourbedropdown initialise les items des cocourbe}
{ MODIFICATIONS                                                                     }
{ mise a jour le 31.10.2000                                                         }
{ 8/11/00 : Claire : + procedure xyGraph1MoveMouse donne les coordonnes quand la  }
{                    souris se dplace dans le plan                                }
{ 01.02.01 : FO : modification de l'initialisation du graph1D                      }
{ Probleme lors du passage en Log
ESSAYER
AutoZero: Boolean
Setting Autozero will cause the zerovalue to be ignored and the internal offset will be set at the lowest value in the series
InternalZero: Double
InternalZero is subtracted from the Y value before anything else is done }
interface
{******************************************}
{PUT UNDEF OR DEFINE IN THE FOLLOWING LINES IF YOU DON'T WANT OR IF YOU WANT
TO USE THE FOLLOWING DEVICES, AND DO THE SAME IN PilotageManip4, PilotageManipMainForm and
Interpreteur Units}
{GPIB and GAGECARD flags : false if GPIB or GAGECARD is not used}


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, xyGraph, StdCtrls, ComCtrls, Spin, Buttons, ToolWin,
  math,xydesign,xyDatWiz, Menus,editdata, Parser10, controlesDivers,
  EditReal,reception,
{$IFDEF GAGECARD}
  GAGE_gainter,GAGE_sta1012,configGAGE,
  gestgage,sta1012,gage1450,generf_gpib,
{$ENDIF}
{$IFDEF GPIB}
FieldSweepPS,
{$ENDIF}
  FileCtrl,DrapeauAlloulUnit,ParSeq;
  {ruse : pour eviter une ref circulaire qd interpreteur utilise cette unite
  deja, mettre le "uses interpreteur " apres implementation}
const
wm_fermeture=$400+wm_user;
wm_redessiner=$401+wm_user;
type
  TNMRform = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    courbes1: TMenuItem;
    Nouvelle1: TMenuItem;
    Nouvelle2: TMenuItem;
    Oprations1: TMenuItem;
    Panel10: TPanel;
    Edit1: TEdit;
    Edit3: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    Panel11: TPanel;
    cocourbe1: TComboBox;
    perbox1: Tperbox;
    Panel12: TPanel;
    cocourbe2: TComboBox;
    perbox2: Tperbox;
    Panel13: TPanel;
    cocourbe3: TComboBox;
    perbox3: Tperbox;
    Panel14: TPanel;
    cocourbe4: TComboBox;
    perbox4: Tperbox;
    Panel2: TPanel;
    BoiteCommande: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Parser1: TParser;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    sauver1: TMenuItem;
    charger1: TMenuItem;
    SpeedButton7: TSpeedButton;
    ToggleLinLog: TButton;
    Xpos: TEditReal;
    Label2: TLabel;
    Ypos: TEditReal;
    Label3: TLabel;
    NBBox: TEdit;
    StartButton: TButton;
    TimerImporteData: TTimer;
    PileBox: TEdit;
    Label5: TLabel;
    StopButton: TButton;
    RunEnCoursCaption: TLabel;
    COVARAN: TComboBox;
    COVBRAN: TComboBox;
    EDPOINTS: TComboBox;
    EDFREQ: TComboBox;
    GAGEParamButton: TButton;
    COVVAC: TComboBox;
    COVBAC: TComboBox;
    COSOURCE: TComboBox;
    COSLOPE: TComboBox;
    EDniv: TEditReal;
    COTRIGAC: TComboBox;
    GAGEEdit1: TLabel;
    GAGEEdit2: TLabel;
    GAGEEdit3: TLabel;
    GAGEEdit4: TLabel;
    GAGEEdit5: TLabel;
    GAGEEdit6: TLabel;
    PBnumberBox: TLabel;
    Label6: TLabel;
    Label4: TLabel;
    Label11: TLabel;
    phaseValueBox: TEdit;
    xyGraph1: TxyGraph;
    distanceText: TLabel;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    moyenneAtext: TLabel;
    MoyenneBText: TLabel;
    MoyenneCtext: TLabel;
    moyenneDtext: TLabel;
    MoyenneABtext: TLabel;
    moyenneCDtext: TLabel;
    Label1: TLabel;
    DataManipulationCaption: TLabel;
    commentspectretextA: TMemo;
    commentspectretextC: TMemo;
    UpDownPhaseAB: TSpinButton;
    Label7: TLabel;
    RefreshButton: TButton;

    procedure cocourbedropdown(sender:tobject);
    procedure StartFastRepetModeButtonClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure xyGraph1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cocourbe1Change(Sender: TObject);
    procedure perbox1change(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure BoiteCommandeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure ToggleLinLogClick(Sender: TObject);
    procedure xyGraph1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Rafraichir(Sender: TObject);

    procedure FormActivate(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure ParamGAGEChange(Sender: TObject);
    procedure GAGEParamButtonClick(Sender: TObject);
    procedure ouverture;
    procedure PileBoxExit(Sender: TObject);
    procedure phaseValueBoxExit(Sender: TObject);
    procedure phaseValueBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SauveParametresRMN;  {resauve tous les parametres RMN de la reception
         dans le fichier Parametres RMN.txt}
    procedure CalculMoyenneEntreCurseurs;
    procedure CalculDistanceEntreCurseurs;
    procedure bidonClick(Sender: TObject);
    procedure UpDownPhaseABDownClick(Sender: TObject);
    procedure UpDownPhaseABUpClick(Sender: TObject);
    procedure RefreshButtonClick(Sender: TObject);

  private
    index1,index2:integer;
    arrayzoom:array[0..15,1..4] of double;
    indexzoom:integer;
    procedure fermeture(var msg:tmessage); message wm_fermeture;
    procedure wmredessiner(var msg:tmessage); message wm_redessiner;
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure redessiner;
    procedure changegain(var msg:tmessage);message wm_user+wm_gain;
    procedure tfrspectre(i:integer;courbe:integer);
    procedure traitchaine(s:string);
    procedure  RafraichissementPileEtDirectoryNMR;
    procedure ChangePhase;


end;

var
{Variables gnerales du traitement RMN qui doivent tre accessibles  tous les fichiers GAGE}
    PAval,PBval:integer;

var
  NMRForm: TNMRform;
  coul:array[1..16] of tcolor;
  ga:array[1..16] of integer;
  PositionUpDownPhase:integer;
  PositionUpDownTimeZero:integer;
  AngleTF,OldAngleTF:extended;
implementation

uses TFRMN,interpreteur, dialogdebut, PilotageManipMainForm, Seq16Channels,
  SeqNewHetero;    {ruse : pour eviter une ref circulaire qd interpreteur
utilise cette unite deja, mettre le "uses interpreteur " apres implementation}

{$R *.DFM}

procedure TNMRform.cocourbedropdown(sender:tobject);
var i:integer;
begin
cocourbe1.items.clear;
cocourbe2.items.clear;
cocourbe3.items.clear;
cocourbe4.items.clear;

for i:=1 to totalspectre do
if und.spect[i]<>nil then
   begin
   cocourbe1.items.add(und.spect[i].nom);
   cocourbe2.items.add(und.spect[i].nom);
   cocourbe3.items.add(und.spect[i].nom);
   cocourbe4.items.add(und.spect[i].nom);
   end;
end;

procedure TNMRform.redessiner;
begin
cocourbe1change(cocourbe1);
cocourbe1change(cocourbe2);
cocourbe1change(cocourbe3);
cocourbe1change(cocourbe4);
{ajoute le commentaire lu dans und spect sur fenetre avant, ajout Alloul}
if und.indexof(cocourbe1.text)<>-1 then
   begin
   commentspectretextA.Lines.Clear;
   commentSpectreTextA.text:=Und.spect[und.indexof(cocourbe1.text)].comment;
   end;
if und.indexof(cocourbe3.text)<>-1 then
   begin
   commentspectretextC.Lines.Clear;
   commentSpectreTextC.text:=Und.spect[und.indexof(cocourbe3.text)].comment;
   end;

CalculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end;

procedure TNMRform.wmredessiner(var msg:tmessage);
begin
redessiner;
end;

procedure TNMRform.fermeture(var msg:tmessage);
begin
release;
end;

procedure TNMRform.StartFastRepetModeButtonClick(Sender: TObject);
{LANCE L'ACQUISITION}
var nbCoups,err,i:integer;frequenceRMN,nombre:extended;
begin
if (DrapeauSequenceurSpectroHetero=true) then seqpar.stop.visible:=false;
val(NMRForm.NBBox.text,nbCoups,err);
if err<>0 then begin nbCoups:=1;NMRForm.NBBox.text:='1';end;
NbCoupsAFaireNMR:=nbCoups;
NbCoupsDejaFaitNMR:=0;
NMRForm.PBNumberBox.caption:=inttostr(NbCoupsDejaFaitNMR);
DrapeauSoftSubstraction:=false;
DrapeauSeqParHasBeenChanged:=true;
{si plusieurs steps, on veut un nb de point multiple de ce nb de step}
if (NombreStepsPourReception>1) then
    begin
    if ((NbCoupsAFaireNMR/NombreStepsPourReception)<>round(NBCoupsAFaireNMR/NombreStepsPourReception)) then
       begin
       NbCoupsAFaireNMR:=round(NBCoupsAFaireNMR/NombreStepsPourReception)*NombreStepsPourReception;
       if NbCoupsAFaireNMR=0 then NBCoupsAFAireNMR:=NombreStepsPourReception;
       NMRForm.NBBox.text:=inttostr(NbCoupsAFaireNMR);
       end;
   end;

NMRForm.cocourbe1.text:='ECHO';
NMRForm.cocourbe2.text:='ECHO';
{si gene rf connecte, on va lire la valeur de la rf}
   {$IFDEF GPIB}
   if (DrapeauRFGenerateurMarconi2023=true) or (DrapeauRFGenerateurMarconi2022D=true) then generf.affichefrequence(FrequenceRMN);
   {$ENDIF}

if und.spect[2].nom='ECHO' then
   begin
    und.spect[2].comment:='echo NB='+inttostr(NbCoupsDejaFaitNMR);
    if drapeaunormalizedata=true then und.spect[2].comment:=und.spect[2].comment+' normalized';
   {$IFDEF GPIB}
   {si field sweep, on met la valeur du dernier champ lu dans le commentaire}
   if debutdlg.tableexpf8.value=1 then
                     und.spect[2].comment:=und.spect[2].comment+' H='+fieldsweepform.actualfieldvalueBox.caption;
   {si gene rf connecte, on met la valeur de la frequence lue dans le commentaire}
   if (DrapeauRFGenerateurMarconi2023=true) or (DrapeauRFGenerateurMarconi2022D=true) then
                    begin
                    val(generf.nmrRFfreqBox.text,nombre,err);
                    if (nombre>0) and (err=0) then und.spect[2].comment:=und.spect[2].comment+' RF='+generf.nmrRFfreqBox.text;
                    end;
   {$ENDIF}
   end;
NMRForm.cocourbe3.text:='OSCILLO';
NMRForm.cocourbe4.text:='OSCILLO';

NMRForm.StopButton.visible:=true;
NMRForm.RefreshButton.visible:=true;
NMRForm.RunEnCoursCaption.visible:=true;
NMRForm.StartButton.visible:=false;
NMRForm.GageParamButton.visible:=false;
{active le timer de rafraichissement}
NMRForm.timerimportedata.enabled:=true;

{AIGUILLAGE DIFFERENT SELON LA CARTE GAGE UTILISEE}
{$IFDEF GAGECARD}

{initialisation de la carte GAGE}
if DrapeauGAGEdejaInitialise=false then
         begin
         if DrapeauCarteGAGE1012=true then acquisparam1012.Initialisation(EDFreq.ItemIndex,EDPoints.ItemIndex,COVARAN.ItemIndex,COVBRAN.ItemIndex,
          COVVAC.ItemIndex,COVBaC.ItemIndex,COSLOPE.ItemIndex,COSOURCE.ItemIndex,COTRIGAC.ItemIndex,EdNiv.text)
          else if DrapeauCarteGAGE1450=true then  gage1450.gageinit(EDFreq.ItemIndex,EDPoints.ItemIndex,COVARAN.ItemIndex,COVBRAN.ItemIndex,
          COVVAC.ItemIndex,COVBaC.ItemIndex,COSLOPE.ItemIndex,COSOURCE.ItemIndex,COTRIGAC.ItemIndex,EdNiv.text) ;
         end;

{si carte 1012, on doit activer le timer du sequenceur si recombinaison soft}
{if drapeauCarteGAGE1012=true then
    begin
    seqnewheteroform.RestartSequenceur;
    drapeauStartAgainSequence:=false;
    end;
}
{LANCEMENT DE l'ACQUISITION SELON CARTE GAGE}
DrapeauAcquisitionNMRencours:=true;

{GAGE1012}


if DrapeauCarteGAGE1012=true then
   begin
    {sequenceur 16 channels}
      {RS232 mode recognition & soft substraction}
      if (DrapeauSequenceur16VoiesIndependant=true) and (DrapeauSequenceur16VoiesRecognitionStep=true)
               then acquisparam1012.AcquisitionSansTimer(NbCoupsAFaireNMR,NbCoupsDejaFaitNMR);
      {no substraction}
      if (DrapeauSequenceur16VoiesIndependant=true) and (DrapeauSequenceur16VoiesRecognitionStep=false)
               then acquisparam1012.AcquisitionSansTimer(NbCoupsAFaireNMR,NbCoupsDejaFaitNMR);
    {sequenceurs heterodyne : dans tous les cas meme procedure}
      if (DrapeauSequenceurSpectroHetero=true) or (DrapeauSequenceurNewHetero=true) then
                 begin
                 SeqNewHeteroForm.StartSequenceur;
                 if (TempsRepetition<100) and (NombreStepsPourReception>1) then
                      MessageDlg('You should use repetition time >100 in this software recombination mode', mtWarning, [mbOk], 0);
                 acquisparam1012.Gage1012GetDataBobAvecTableauSignes(NbCoupsAFaireNMR,NbCoupsDejaFaitNMR);
                 end;

   end;

if DrapeauCarteGAGE1450=true then
    begin
    {sequenceur 16 channels}
      {RS232 mode recognition & soft substraction}
      if (DrapeauSequenceur16VoiesIndependant=true) and (DrapeauSequenceur16VoiesRecognitionStep=true)
               then   gage1450.GetDataBobRS232Recognition2Steps;
      {no substraction}
      if (DrapeauSequenceur16VoiesIndependant=true) and (DrapeauSequenceur16VoiesRecognitionStep=false)
               then gage1450.getDataBobNoSoftSubstraction;
    {sequenceurs heterodyne : dans tous les cas meme procedure}
      if (DrapeauSequenceurSpectroHetero=true) or (DrapeauSequenceurNewHetero=true) then
                 gage1450.getDataBobAvecTableauSignes;
    end;
{$ENDIF}

NMRForm.PBNumberBox.caption:=inttostr(NbCoupsDejaFaitNMR);
DrapeauAcquisitionNMRencours:=false;
NMRForm.StopButton.visible:=false;
NMRForm.RefreshButton.visible:=false;
NMRForm.RunEnCoursCaption.visible:=false;
NMRForm.StartButton.visible:=true;
NMRForm.GageParamButton.visible:=true;
NMRForm.TimerImporteData.Enabled:=true;
NMRForm.Rafraichir(sender);

{rafraichit finalement le data en visu avant}
{met en commentaire dans le und.spect le nb de coups fait}
if und.spect[2].nom='ECHO' then
   begin
    und.spect[2].comment:='echo NB='+inttostr(NbCoupsDejaFaitNMR);
        if drapeaunormalizedata=true then und.spect[2].comment:=und.spect[2].comment+' normalized';
   {$IFDEF GPIB}
   {si field sweep, on met la valeur du dernier champ lu dans le commentaire}
   if debutdlg.tableexpf8.value=1 then
                     und.spect[2].comment:=und.spect[2].comment+' H='+FieldSweepForm.actualfieldvaluebox.caption;
   {si gene rf connecte, on met la valeur de la frequence lue dans le commentaire}
   if (DrapeauRFGenerateurMarconi2023=true) or (DrapeauRFGenerateurMarconi2022D=true) then
                    begin
                    val(generf.nmrRFfreqBox.text,nombre,err);
                    if (nombre>0) and (err=0) then und.spect[2].comment:=und.spect[2].comment+' RF='+generf.nmrRFfreqBox.text;
                    end;
   {$ENDIF}
   end;

end;

procedure TNMRform.SpeedButton2Click(Sender: TObject);
begin
xygraph1.print;
end;

procedure TNMRform.SpeedButton3Click(Sender: TObject);
begin
editxyGraph(self, xyGraph1);
end;

procedure TNMRform.SpeedButton5Click(Sender: TObject);
begin
if indexzoom>=1 then begin
indexzoom:=indexzoom-1;
xygraph1.xaxis.min:=arrayzoom[indexzoom,1];
xygraph1.xaxis.max:=arrayzoom[indexzoom,2];
(xygraph1.annotations[1] as tmark).x1:=arrayzoom[indexzoom,3];
(xygraph1.annotations[2] as tmark).x1:=arrayzoom[indexzoom,4];
end;
end;

procedure TNMRform.SpeedButton6Click(Sender: TObject);
var
i:integer;
v1,v2:double;
begin
if indexzoom=0 then begin
arrayzoom[indexzoom,1]:=xygraph1.xaxis.min;
arrayzoom[indexzoom,2]:=xygraph1.xaxis.max;
arrayzoom[indexzoom,3]:=(xygraph1.annotations[1] as tmark).x1;
arrayzoom[indexzoom,4]:=(xygraph1.annotations[2] as tmark).x1;
end;
v1:=(xygraph1.annotations[1] as tmark).x1;
v2:=(xygraph1.annotations[2] as tmark).x1;
if v2>v1 then begin
indexzoom:=indexzoom+1;
if indexzoom>15 then begin
indexzoom:=15;
for i:=1 to 14 do begin
arrayzoom[i,1]:=arrayzoom[i+1,1];
arrayzoom[i,2]:=arrayzoom[i+1,2];
arrayzoom[i,3]:=arrayzoom[i+1,3];
arrayzoom[i,4]:=arrayzoom[i+1,4];
end;
end;
arrayzoom[indexzoom,1]:=v1;arrayzoom[indexzoom,2]:=v2;
arrayzoom[indexzoom,3]:=v1;arrayzoom[indexzoom,4]:=v2;
xygraph1.xaxis.min:=v1;
xygraph1.xaxis.max:=v2;
end;
end;

procedure TNMRform.FormCreate(Sender: TObject);
var
i,indice:integer;
tf:boolean;
nomFichier,directory_NMR:string;
fich:textfile;
chaine,valeur:string;
err:integer;
chaineTableau:array[0..100] of string;

begin
{desactive le timer de rafraichissement}
timerimportedata.enabled:=false;
for i:=1 to 4 do ga[i]:=1;
tf:=false;
xygraph1.Addmark(1,xygraph1.xAxis.Min,xygraph1.YAxis.Min,xygraph1.xAxis.Min,xygraph1.YAxis.Max,clred,'1',mtxmark ,mpUpLeft, dtAfter);
xygraph1.Addmark(2,xygraph1.xAxis.Max,xygraph1.YAxis.Min,xygraph1.xAxis.Max,xygraph1.YAxis.Max,clblue,'2',mtxmark ,mpUpLeft, dtAfter);
coul[1]:=$000000;coul[2]:=$0000FF;coul[3]:=$FF0000;
coul[4]:=$007F00;coul[5]:=$FFFF00;coul[6]:=$FF00FF;
coul[7]:=$00FFFF;coul[8]:=$7F0000;

for i:=1 to totalspectre do
    if und.spect[i]<>nil
    then case i of
         1:begin cocourbe1.items.add(und.spect[i].nom);cocourbe1.text:=und.spect[i].nom;tfrspectre(i,1) end;
         2:begin cocourbe2.items.add(und.spect[i].nom);cocourbe2.text:=und.spect[i].nom;tfrspectre(i,2) end;
         3:begin cocourbe3.items.add(und.spect[i].nom);cocourbe3.text:=und.spect[i].nom;tfrspectre(i,3) end;
         4:begin cocourbe4.items.add(und.spect[i].nom);cocourbe4.text:=und.spect[i].nom;tfrspectre(i,4) end;
         end;

{Creation des spectres ECHO et OSCILLO : voir pilotagemanipmainform}
indice:=2;
NMRForm.cocourbe1.text:='ECHO';
NMRForm.cocourbe2.text:='ECHO';
NMRForm.tfrspectre(indice,1);{Place le spectre RMN en voie 1}
NMRForm.tfrspectre(indice,2);

indice:=3;
NMRForm.cocourbe3.text:='OSCILLO';
NMRForm.cocourbe4.text:='OSCILLO';
NMRForm.tfrspectre(indice,3);{Place le spectre RMN en voie 1}
NMRForm.tfrspectre(indice,4);

{lit le fichier c:\newspectro\data\current.doc qui contient le nom du dernier directory utilis}
nomFichier:='c:\newspectro\data\current.txt';
if fexis(nomFichier) then
 begin
 assignfile(fich,nomFichier);
 reset(fich);
 read(fich,directory_NMR);
 closefile(fich);
 if not(DirectoryExists(directory_NMR)) then ForceDirectories(directory_NMR);
 ChDir(directory_NMR); {specifie le directory de travail}
 RafraichissementPileEtDirectoryNMR;
 end
 else
 begin
 {cas ou il n'existe pas: on le cree : c:\newspectro\data\defaut}
 if not(DirectoryExists('c:\newspectro\data')) then ForceDirectories('c:\newspectro\data');
 assignfile(fich,nomFichier);
 rewrite(fich);
 if not(fexis('c:\newspectro\data\defaut')) then ForceDirectories('c:\newspectro\data\defaut');
 writeln(fich,'c:\newspectro\data\defaut');
 directory_NMR:='c:\newspectro\data\defaut';
 closefile(fich);
 ChDir(directory_NMR); {specifie le directory de travail}
 RafraichissementPileEtDirectoryNMR;
 end;


StopButton.visible:=false;
RefreshButton.visible:=false;
RunEnCoursCaption.visible:=false;
GageParamButton.visible:=true;
GAGEEdit1.visible:=false;GAGEEdit2.visible:=false;GAGEEdit3.visible:=false;
GAGEEdit4.visible:=false;GAGEEdit5.visible:=false;GAGEEdit6.visible:=false;
covaran.visible:=false;covbran.visible:=false;
covvac.visible:=false;covbac.visible:=false;
edpoints.visible:=false;edfreq.visible:=false;
coslope.visible:=false;cosource.visible:=false;
edniv.visible:=false;cotrigac.visible:=false;

StartButton.visible:=true;
DrapeauSoustraitBackground:=true;

chaine:=LitDansParametresRMN('Automatic Background Substraction (YES/NO)');
if chaine='NO' then DrapeauSoustraitBackground:=false
               else DrapeauSoustraitBackground:=true;
chaine:=LitDansParametresRMN('Normalization of data when acquisition (YES/NO)');
if chaine='YES' then DrapeauNormalizeData:=true
               else DrapeauNormalizeData:=false;

if DrapeauNormalizeData=true then nmrform.DataManipulationCaption.caption:='during acquisition: normalization '
                          else nmrform.DataManipulationCaption.caption:='during acquisition:no normalization ';
if DrapeausoustraitBAckground=true then nmrform.DataManipulationCaption.caption:=nmrform.DataManipulationCaption.caption+' and bgd substraction'
                             else nmrform.DataManipulationCaption.caption:=nmrform.DataManipulationCaption.caption+' and no bgd substraction';
nmrform.Datamanipulationcaption.refresh;
{parametres par defaut de Carte GAGE diriges par cette fenetre: les lit
sur Parametres RMN.txt}

if fexis(nomFichierParametresRMN) then
 begin
  {amplitude channel A et B}
  chaine:=LitDansParametresRMN('Chanel A (+/-10V');
  if chaine='+/-10V' then begin covaran.itemindex:=0;gainCarteGageA:=10;end;
  if chaine='+/-5V' then begin covaran.itemindex:=1;gainCarteGageA:=5;end;
  if chaine='+/-2V' then begin covaran.itemindex:=2;gainCarteGageA:=2;end;
  if chaine='+/-1V' then begin covaran.itemindex:=3;gainCarteGageA:=1;end;
  if chaine='+/-0.5V' then begin covaran.itemindex:=4;gainCarteGageA:=0.5;end;
  if chaine='+/-0.2V' then begin covaran.itemindex:=5;gainCarteGageA:=0.2;end;
  if chaine='+/-0.1V' then begin covaran.itemindex:=6;gainCarteGageA:=0.1;end;
  chaine:=LitDansParametresRMN('Chanel B (Volts)');
  if chaine='+/-10V' then begin covbran.itemindex:=0;gainCarteGageB:=10;end;
  if chaine='+/-5V' then begin covbran.itemindex:=1;gainCarteGageB:=5;end;
  if chaine='+/-2V' then begin covbran.itemindex:=2;gainCarteGageB:=2;end;
  if chaine='+/-1V' then begin covbran.itemindex:=3;gainCarteGageB:=1;end;
  if chaine='+/-0.5V' then begin covbran.itemindex:=4;gainCarteGageB:=0.5;end;
  if chaine='+/-0.2V' then begin covbran.itemindex:=5;gainCarteGageB:=0.2;end;
  if chaine='+/-0.1V' then begin covbran.itemindex:=6;gainCarteGageB:=0.1;end;
  {mode channel A et B}
  chaine:=LitDansParametresRMN('Chanel A (Mode AC ou DC)');
  if chaine='DC' then begin covvac.itemindex:=0;end;
  if chaine='AC' then begin covvac.itemindex:=1;end;
  chaine:=LitDansParametresRMN('Chanel B (Mode AC ou DC)');
  if chaine='DC' then begin covbac.itemindex:=0;end;
  if chaine='AC' then begin covbac.itemindex:=1;    end;
  {nb de points}
  chaine:=LitDansParametresRMN('Nb Points (16');
  if chaine='16' then begin   NbPointsParChannel:=16;EDPOINTS.itemindex:=0;      end;
  if chaine='32' then begin   NbPointsParChannel:=32;EDPOINTS.itemindex:=1;          end;
  if chaine='64' then begin   NbPointsParChannel:=64;EDPOINTS.itemindex:=2;end;
  if chaine='128' then begin   NbPointsParChannel:=128;eDPOINTS.itemindex:=3;   end;
  if chaine='256' then begin   NbPointsParChannel:=256;EDPOINTS.itemindex:=4;       end;
  if chaine='512' then begin   NbPointsParChannel:=512;EDPOINTS.itemindex:=5;           end;
  if chaine='1024' then begin   NbPointsParChannel:=1024;EDPOINTS.itemindex:=6;              end;
  if chaine='2048' then begin   NbPointsParChannel:=2048;EDPOINTS.itemindex:=7;end;
  if chaine='4096' then begin   NbPointsParChannel:=4096;EDPOINTS.itemindex:=8;    end;
  if chaine='8192' then begin   NbPointsParChannel:=8192;EDPOINTS.itemindex:=9;        end;
  if chaine='16384' then begin   NbPointsParChannel:=16384;EDPOINTS.itemindex:=10;        end;
             {digitalization}
  chaine:=LitDansParametresRMN('Digit Freq (10 MHz');
  if chaine='10 MHz' then begin edfreq.itemindex:=0;            end;
  if chaine='5 MHz' then begin edfreq.itemindex:=1;                 end;
  if chaine='4 MHz' then begin edfreq.itemindex:=2;                     end;
  if chaine='2 MHz' then begin edfreq.itemindex:=3;end;
  if chaine='1 MHz' then begin edfreq.itemindex:=4;    end;
  if chaine='500 KHz' then
     begin edfreq.itemindex:=5;      end;
  if chaine='200 KHz' then
     begin edfreq.itemindex:=6;          end;
  if chaine='100 KHz' then
     begin edfreq.itemindex:=7;              end;
  if chaine='50 KHz' then
     begin edfreq.itemindex:=8;                   end;
  if chaine='20 KHz' then
     begin edfreq.itemindex:=9;                       end;
  if chaine='10 KHz' then
     begin edfreq.itemindex:=10;                          end;
  if chaine='5 KHz' then
     begin edfreq.itemindex:=11;end;
  if chaine='2 KHz' then
     begin edfreq.itemindex:=12;    end;
   if chaine='1 KHz' then
     begin edfreq.itemindex:=13;        end;
  if chaine='EXTERNE' then begin edfreq.itemindex:=14;          end;
  {trigger}
  chaine:=LitDansParametresRMN('Trigger (POSITIF/NEGATIF)');
  if chaine='POSITIF' then begin coslope.itemindex:=0;              end;
  if chaine='NEGATIF' then begin coslope.itemindex:=1;                  end;
  chaine:=LitDansParametresRMN('Trigger (VOIE A');
  if chaine='VOIE A' then begin cosource.itemindex:=0;end;
  if chaine='VOIE B' then  begin cosource.itemindex:=1;    end;
  if chaine='VOIE A et B' then begin cosource.itemindex:=2;   end;
  if chaine='EXTERNE' then begin cosource.itemindex:=3;           end;
  if chaine='SOFT' then begin cosource.itemindex:=4;                  end;
  chaine:=LitDansParametresRMN('Trigger (niveau)');
  edniv.text:=chaine;
  chaine:=LitDansParametresRMN('Trigger (DC/AC)');
  if chaine='DC' then begin cotrigac.itemindex:=0;end;
  if chaine='AC' then begin cotrigac.itemindex:=1;end;
  end
   else
  begin
  {cas ou le fichier de Parametre RMN.txt n'existe pas : valeurs par defaut}
  EDPOINTS.itemindex:=8; {nb points :0 = 16; 1=32; 2=64; 3=128; 4=256;
  5=512; 6=1024; 7 = 2048; 8 =4096; 9 =8192}
  edfreq.itemindex:=3;  {freq de digitalisation:
  0 = 10 MHz: 1 = 5 MHz; 2 = 4 MHz; 3 = 2 MHz; 4 = 1 MHz
  5 = 500 KHz; 6 =200 KHz; 7 = 100 KHz; 8 =50 KHz
  9 = 20 KHz; 10 = 10 KHz; 11 = 5 KHz; 12 = 2 KHz;
  13 = 1 KHz; 14 = EXTERNE}
  covaran.itemindex:=3; {Chanel A 0 = +/-10V; 1 = +/-5V
  2 = +/-2V; 3 = +/-1V; 4 = +/-0.5V; 5 = +/-0.2V; 6 = +/-0.1V}
  covbran.itemindex:=3; {Chanel B idem}
  covvac.itemindex:=0; { Chanel A : 0 = DC, 1 = AC}
  covbac.itemindex:=0; { Chanel B : 0 = DC, 1 = AC}
  {trigger}
  cosource.itemindex:=3;{source trigger : 0 = VOIE A; 1 =VOIE B;
  2 = VOIES A et B; 3=EXTERNE; 4 = SOFT}
  coslope.itemindex:=0; {pente trigger : 0 = POSITIF, 1 = NEGATIF}
  edniv.text:='1.00'; {niveau trigger en Volts}
  cotrigac.itemindex:=1;  {trigger DC = 0 ;AC = 1}
  end;
{fin des valeurs carte GAGE}
perbox1.graph:=handle;perbox2.graph:=handle;perbox3.graph:=handle;perbox4.graph:=handle;
perbox1.setval(6);perbox2.setval(6);perbox3.setval(6);perbox4.setval(6);
indexzoom:=0;
top:=0;
left:=0;
width:=580;
height:=350;
end;


{ transfert d'un spectre du tableau des spectres dans une courbe }
{ INPUT : numero du spectre 1D a transferer                      }
{         courbe, n de la courbe dans laquelle le spectre doit arriver }
{ REM : faire le transfert avec un passage du spectre dans la procdure }
{       et pas uniquement son numro                                    }
procedure TNMRform.tfrspectre(i:integer;courbe:integer);
var j:integer;
tf:boolean;
begin

if (courbe=1) or (courbe=3) then
begin
     tf:=false;
     xygraph1.series[courbe].holdupdates:=true;
     xygraph1.Series[courbe].clear;
     xygraph1.Series[courbe].seriesname:=und.spect[i].nom;
     xygraph1[courbe].drawpoints:=false;
     xygraph1[courbe].linecolor:=coul[courbe];
     xygraph1[courbe].LineStyle:=pssolid;

     {AffichageRMN : partie relle=z en courbe et partie im=mon en courbe+1}
     if und.spect[i].typex='rmn' then
        begin
           for j:=1 to und.spect[i].x-1 do
               begin
                  xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].z*intpower(2,ga[courbe]-6));
               end;
            tf:=true;
        end;

     if not tf then for j:=0 to und.spect[i].x-1 do xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].z*intpower(2,ga[courbe]-6));
        xygraph1.series[courbe].holdupdates:=false;

     if (courbe=1) then cocourbe2.text:=cocourbe1.text;
     if (courbe=3) then cocourbe4.text:=cocourbe3.text;
     tf:=false;
     xygraph1.series[courbe+1].holdupdates:=true;
     xygraph1.Series[courbe+1].clear;
     xygraph1.Series[courbe+1].seriesname:=und.spect[i].nom;
     xygraph1[courbe+1].drawpoints:=false;
     xygraph1[courbe+1].linecolor:=coul[courbe+1];
     xygraph1[courbe+1].LineStyle:=pssolid;

     {AffichageRMN : partie relle=z en courbe et partie im=mon en courbe+1}
     if und.spect[i].typex='rmn' then
        begin
           for j:=1 to und.spect[i].x-1 do
               begin
                  xygraph1.Series[courbe+1].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].mon*intpower(2,ga[courbe+1]-6));
               end;
            tf:=true;
        end;

     if not tf then for j:=0 to und.spect[i].x-1 do xygraph1.Series[courbe+1].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].mon*intpower(2,ga[courbe+1]-6));
        xygraph1.series[courbe+1].holdupdates:=false;
{ajoute le commentaire lu dans und spect sur fenetre avant, ajout Alloul}
if und.indexof(cocourbe1.text)<>-1 then
   begin
   commentspectretextA.Lines.Clear;
   commentSpectreTextA.lines[0]:=Und.spect[und.indexof(cocourbe1.text)].comment;
   end;
if und.indexof(cocourbe3.text)<>-1 then
   begin
   commentspectretextC.Lines.Clear;
   commentSpectreTextC.lines[0]:=Und.spect[und.indexof(cocourbe3.text)].comment;
   end;
   CalculMoyenneEntreCurseurs;
   CalculDistanceEntreCurseurs;

end;

if (courbe=2) or (courbe=4) then
begin
     tf:=false;
     xygraph1.series[courbe].holdupdates:=true;
     xygraph1.Series[courbe].clear;
     xygraph1.Series[courbe].seriesname:=und.spect[i].nom;
     xygraph1[courbe].drawpoints:=false;
     xygraph1[courbe].linecolor:=coul[courbe];
     xygraph1[courbe].LineStyle:=pssolid;

     {AffichageRMN : partie relle=z en courbe et partie im=mon en courbe+1}
     if und.spect[i].typex='rmn' then
        begin
           for j:=1 to und.spect[i].x-1 do
               begin
                  xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].mon*intpower(2,ga[courbe]-6));
               end;
            tf:=true;
        end;

        if not tf then for j:=0 to und.spect[i].x-1 do xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].mon*intpower(2,ga[courbe]-6));
        xygraph1.series[courbe].holdupdates:=false;
end;
CalculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;


end;

procedure TNMRform.changegain(var msg:tmessage);
begin
  if (msg.wparam<=4)and (msg.wparam>=1) then
  begin
    if msg.lparam=3 then xygraph1.series[msg.wparam].active:=false;
    if msg.lparam=2 then xygraph1.series[msg.wparam].active:=true;
    if msg.lparam=1 then begin{left button}end;
    if msg.lparam=-1 then begin {right button}end;
  end
     else
  begin
    ga[msg.wparam-10]:=msg.lparamlo;
    case msg.wparam-10 of
    1:cocourbe1change(cocourbe1);
    2:cocourbe1change(cocourbe2);
    3:cocourbe1change(cocourbe3);
    4:cocourbe1change(cocourbe4);
    end;
  end;
end;

procedure TNMRform.xyGraph1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var

  x2,y2:double;
  x3,y3:double;
  index:integer;
  begin
  inherited;
xygraph1.GetMouseXY(1, x, y, index, x2, y2, x3, y3);
if button=mbleft then begin
edit1.text:=floattostrf(x3,fffixed,8,7); {Ajout Alloul : on change le nb de digits}
edit2.text:=floattostrf(y3,fffixed,4,8);
(xygraph1.Annotations[1] as TMark).x1 := x3;
(xygraph1.Annotations[1] as TMark).x2 := x3;
index1:=index;
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end;
if button=mbright then begin
edit3.text:=floattostrf(x3,fffixed,8,7);
edit4.text:=floattostrf(y3,fffixed,4,8);
(xygraph1.Annotations[2] as TMark).x1 := x3;
(xygraph1.Annotations[2] as TMark).x2 := x3;
index2:=index;
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end;
end;

procedure TNMRform.cocourbe1Change(Sender: TObject);
begin
if sender=cocourbe1 then
tfrspectre(und.indexof(cocourbe1.text),1);
if sender=cocourbe2 then
tfrspectre(und.indexof(cocourbe2.text),2);
if sender=cocourbe3 then
tfrspectre(und.indexof(cocourbe3.text),3);
if sender=cocourbe4 then
tfrspectre(und.indexof(cocourbe4.text),4);
calculmoyenneentrecurseurs; {ajout Alloul}
CalculDistanceEntreCurseurs;
end;

procedure TNMRform.perbox1change(Sender: TObject);
begin
if perbox1.getcheck=1 then xygraph1.series[1].active:=true
else xygraph1.series[1].active:=false;
end;

procedure TNMRform.SpeedButton4Click(Sender: TObject);
begin
ShowxyDataWizard(self, xyGraph1);
end;



procedure TNMRform.SpinButton1UpClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index1:=index1+1;
index4:=index1;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[1] as TMark).x1 := x;
(xygraph1.Annotations[1] as TMark).x2 := x;
edit1.text:=floattostrf(x,fffixed,8,7); {Ajout Alloul : on change le nb de digits}
edit2.text:=floattostrf(y,fffixed,4,8);
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end else begin
index1:=index1-1;
end;
end;

procedure TNMRform.SpinButton1DownClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index1:=index1-1;
index4:=index1;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[1] as TMark).x1 := x;
(xygraph1.Annotations[1] as TMark).x2 := x;
edit1.text:=floattostrf(x,fffixed,8,7); {Ajout Alloul : on change le nb de digits}
edit2.text:=floattostrf(y,fffixed,4,8);
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end else begin
index1:=index1+1;
end;
end;

procedure TNMRform.SpinButton2DownClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index2:=index2-1;
index4:=index2;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[2] as TMark).x1 := x;
(xygraph1.Annotations[2] as TMark).x2 := x;
edit3.text:=floattostrf(x,fffixed,8,7);
edit4.text:=floattostrf(y,fffixed,4,8);
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end else begin
index2:=index2+1;
end;
end;

procedure TNMRform.SpinButton2UpClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index2:=index2+1;
index4:=index2;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[2] as TMark).x1 := x;
(xygraph1.Annotations[2] as TMark).x2 := x;
edit3.text:=floattostrf(x,fffixed,8,7);
edit4.text:=floattostrf(y,fffixed,4,8);
{ajout Alloul : on fait calculer l'integrale entre curseurs}
calculMoyenneEntreCurseurs;
CalculDistanceEntreCurseurs;
end else begin
index2:=index2-1;
end;
end;

procedure TNMRform.SpeedButton7Click(Sender: TObject);
begin
if xygraph1.yaxis.autosizing then begin
xygraph1.yaxis.autosizing:=false;
speedbutton7.caption:='Man';
end else begin
xygraph1.yaxis.autosizing:=true;
speedbutton7.caption:='Auto';
end;
end;

procedure TNMRform.ToggleLinLogClick(Sender: TObject);
begin
     If ToggleLinLog.caption='Lin'
     then begin
          xygraph1.Yaxis.Logscale:=True;
          ToggleLinLog.caption:='Log'
          end
     else begin
          xyGraph1.Yaxis.Logscale:=False;
          ToggleLinLog.caption:='Lin'
          end;
     redessiner
end;

{Donne les coordonnes quand la souris se dplace dans le plan}
procedure TNMRform.xyGraph1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
     Xpos.value:=xyGraph1.GetMouseX(X);
     Ypos.value:=xyGraph1.GetMouseY(Y);
end;

{--------------------------------------------------------------------------------}
{------------------------Procedures specifiques Acquisition RMN------------------}
{--------------------------------------------------------------------------------}
procedure TNMRform.Rafraichir(Sender: TObject);
var indice,i,j,err:integer;conversionFactorA,conversionFactorB,nombre:extended;
begin
{Rafraichit A et B en cours de run,
et en fin de run (DrapeauAcquisitionVientDeFinir=true)
  dirig par un timer regulier}

{$IFDEF GAGECARD}
if (DrapeauAcquisitionNMRencours=true) or (drapeauAcquisitionVientDeFinir=true) then
 begin
 if (DrapeauSansRafraichissement=false) or (drapeauAcquisitionVientDeFinir=true) then
   begin {on rafraichit l'affichage du data}
   {transfert du data GAGE moyenn}

   if DrapeauCarteGAGE1012=true then
     begin
      { POUR GAGE 1012 : convertit en volts le nombre compris entre 0 et 4095
       en utilisant le gain choisi par la carte gage}
        conversionFactorA:=gainCarteGageA/2048;
        conversionFactorB:=gainCarteGageB/2048;
      indice:=und.indexof('ECHO');
      for i:=1 to NbPointsParChannel do
         begin
          und.spect[indice].data[i-1,0].z:=-tab3^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorA;
          und.spect[indice].data[i-1,0].mon:=-tab4^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorB;
         end;
      indice:=und.indexof('OSCILLO');
      for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=-tab1^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorA;
        und.spect[indice].data[i-1,0].mon:=-tab2^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorB;
       end;
     end;

   if DrapeauCarteGAGE1450=true then
     begin
     indice:=und.indexof('OSCILLO');
     for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=RangeVoltA/8192*transferA[i];
        und.spect[indice].data[i-1,0].mon:=RangeVoltB/8192*transferB[i];
       end;
     indice:=und.indexof('ECHO');
     for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=RangeVoltA/8192*tab1450_3^[i];
        und.spect[indice].data[i-1,0].mon:=RangeVoltB/8192*tab1450_4^[i];
       end;
     end;

   indice:=und.indexof('ECHO');
   {on soustrait eventuellement le bgd}
   if DrapeauSoustraitBAckground=true then interpreteurform.soustraitBackground('ECHO');
   {on normalise eventuellement par le nb de points}
   if (DrapeauNormalizeData=true) and (NbCoupsDejaFaitNMR>0) then
                                begin
                                for i:=1 to NbPointsParChannel do
                                         begin
                                         und.spect[indice].data[i-1,0].z:=und.spect[indice].data[i-1,0].z/NbCoupsDejaFaitNMR;
                                         und.spect[indice].data[i-1,0].mon:=und.spect[indice].data[i-1,0].mon/NbCoupsDejaFaitNMR;
                                         end;
                                end;

   NMRForm.redessiner;     {ca prend  peu prs 300 msec pour redessiner}
   PBNumberBox.caption:=inttostr(NbCoupsDejaFaitNMR);
   end
                                                     else
   begin {dans le cas d'un mode rapide ou il ne faut pas perdre de temps, on
   affiche juste le nb de coups deja fait}
      PBNumberBox.caption:=inttostr(NbCoupsDejaFaitNMR);
   end;

 end;

if (drapeauAcquisitionVientDeFinir=true) then
   begin
   {desactive le timer de rafraichissement}
   timerimportedata.enabled:=false;

   if (DrapeauSequenceurSpectroHetero=true) then seqpar.stop.visible:=true;
   {si carte 1012,on arrete eventuellment les timers des sequenceurs}
   if drapeauCarteGAGE1012=true then
     begin
     drapeauStartAgainSequence:=false;
     if DrapeauSequenceurSpectroHetero=true then SeqPar.timer1.enabled:=false;
     if DrapeauSequenceur16VoiesIndependant=true then Seq16ChannelsForm.timer1.enabled:=false;
     if DrapeauSequenceurNewHetero=true then SeqNewHeteroForm.timer1.enabled:=false;
     end;

   {transformation en Volts}
   RunEnCoursCaption.visible:=false;
   RunEnCoursCaption.caption:='running';
   StartButton.visible:=true;
   StopButton.visible:=false;
   RefreshButton.visible:=false;
   DrapeauAcquisitionVientDeFinir:=false;{apres le rafraichissement,
   on n'a plus besoin si run fini de recommencer plus tard}
   if und.spect[2].nom='ECHO' then
      begin
      und.spect[2].comment:='echo NB='+inttostr(NbCoupsDejaFaitNMR);
      if drapeaunormalizedata=true then und.spect[2].comment:=und.spect[2].comment+' normalized';
     {$IFDEF GPIB}
     {si field sweep, on met la valeur du dernier champ lu dans le commentaire}
     if debutdlg.tableexpf8.value=1 then
                     und.spect[2].comment:=und.spect[2].comment+' H='+FieldSweepForm.actualfieldvaluebox.caption;
     {si gene rf connecte, on met la valeur de la frequence lue dans le commentaire}
     if (DrapeauRFGenerateurMarconi2023=true) or (DrapeauRFGenerateurMarconi2022D=true) then
                    begin
                    val(generf.nmrRFfreqBox.text,nombre,err);
                    if (nombre>0) and (err=0) then und.spect[2].comment:=und.spect[2].comment+' RF='+generf.nmrRFfreqBox.text;
                    end;
     {$ENDIF}
     end;


      { POUR GAGE 1012 : convertit en volts le nombre compris entre 0 et 4095
       en utilisant le gain choisi par la carte gage}
   conversionFactorA:=gainCarteGageA/2048;
   conversionFactorB:=gainCarteGageB/2048;
   indice:=und.indexof('ECHO');

   if DrapeauCarteGAGE1012=true then
     begin
     for i:=1 to NbPointsParChannel do
         begin
          und.spect[indice].data[i-1,0].z:=-tab3^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorA;
          und.spect[indice].data[i-1,0].mon:=-tab4^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorB;
         end;
     indice:=und.indexof('OSCILLO');
     for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=-tab1^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorA;
        und.spect[indice].data[i-1,0].mon:=-tab2^[i]{-2047*NbCoupsDejaFaitNMR)}*conversionFactorB;
       end;
     end;
   if DrapeauCarteGAGE1450=true then
    begin
    indice:=und.indexof('OSCILLO');
     for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=RangeVoltA/8192*transferA[i];
        und.spect[indice].data[i-1,0].mon:=RangeVoltB/8192*transferB[i];
       end;
     indice:=und.indexof('ECHO');
     for i:=1 to NbPointsParChannel do
       begin
        und.spect[indice].data[i-1,0].z:=RangeVoltA/8192*tab1450_3^[i];
        und.spect[indice].data[i-1,0].mon:=RangeVoltB/8192*tab1450_4^[i];
       end;
     end;

   indice:=und.indexof('ECHO');
   {on soustrait eventuellement le bgd}
   if DrapeauSoustraitBAckground=true then interpreteurform.soustraitBackground('ECHO');
   {on normalise eventuellement par le nb de points}
   if (DrapeauNormalizeData=true) and (NbCoupsDejaFaitNMR>0) then
                                begin
                                for i:=1 to NbPointsParChannel do
                                         begin
                                         und.spect[indice].data[i-1,0].z:=und.spect[indice].data[i-1,0].z/NbCoupsDejaFaitNMR;
                                         und.spect[indice].data[i-1,0].mon:=und.spect[indice].data[i-1,0].mon/NbCoupsDejaFaitNMR;
                                         end;
                                end;

     NMRForm.redessiner;     {ca prend  peu prs 300 msec pour redessiner}
     PBNumberBox.caption:=inttostr(NbCoupsDejaFaitNMR);
   end;

{$ENDIF}
end;




{-------------------------------------------------------------------------------------}


procedure TNMRForm.RafraichissementPileEtDirectoryNMR;
{rafraichit la pile dans AcquisitionRMN}
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine:string;
    pile_NMR:integer;

begin
   {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
   if not(DirectoryExists('c:\NewSpectro\data')) then ForceDirectories('c:\NewSpectro\data');
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);

   {on relit le fichier info.txt}
   if fexis(directory_NMR+'\info.txt') then
   begin
   assignfile(fich,directory_NMR+'\info.txt');
   reset(fich);
   readln(fich,directory_NMR);
   readln(fich,pile_NMR);
   closefile(fich);
   end
   else
   begin
   if not(DirectoryExists(directory_NMR)) then ForceDirectories(directory_NMR);
   assignfile(fich,directory_NMR+'\info.txt');
   rewrite(fich);
   writeln(fich,directory_NMR);
   writeln(fich,'0');
   closefile(fich);
   end;
   str(pile_NMR,chaine);
   NMRForm.PileBox.text:=chaine;

   PrincipalForm.Directory1.caption:='dir : '+Directory_NMR;
  if (TFNMRForm<>nil) then
     begin
     TFNMRForm.PileBox.caption:=chaine;
    TFNMRForm.PileBox.refresh;
    end;

end;

procedure TNMRform.BoiteCommandeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

begin
{ajout : si flche vers le haut (bas), on rappelle la derniere instruction}
if key=38 then
   begin
      NumeroInstructionPrecedente:=NumeroInstructionPrecedente+1;
      if NumeroInstructionPrecedente>20 then NumeroInstructionPrecedente:=0;
      BoiteCommande.Text:=InstructionInterpreteur[NumeroInstructionPrecedente];

   end;
if key=40 then
   begin
      NumeroInstructionPrecedente:=NumeroInstructionPrecedente-1;
      if NumeroInstructionPrecedente<=0 then
                                        begin
                                        NumeroInstructionPrecedente:=0;
                                        BoiteCommande.Text:='';
                                        end
                                        else
                                        BoiteCommande.Text:=InstructionInterpreteur[NumeroInstructionPrecedente];
   end;
if (key<>38) and (key<>40) then NumeroInstructionPrecedente:=0;

if key=13 then traitchaine(BoiteCommande.text);
end;

procedure TNMRform.traitchaine(s:string);
{interprete les commandes dans la boite EDIT : ajout Groupe Alloul
va dans editdata pour faire le boulot}
{On enlve la partie Fermon qui utilise un parseur
et on met nos propres commandes interpretes ici}
var chaine,chaine2,nom:string;i,err,err2,err3,err4,err5,channel:integer;
    nombre,resultat,start,finish,startBGD,finishBGD,valeur:real;
    voieSigne:real;
begin
{va aller traiter la commande via l'interpreteur, SAUF si echos car
alors il faut forcer la sauvegarde quoiqu'il arrive.
c'est  dire comme si on tapait la commande depuis la fenetre interpreteur}
if s<>'echos' then interpreteurform.traitstring(s,1);

if s='echos' then  interpreteurform.ForceSauvegardeECHO(NMRForm.cocourbe1.text);
{une fois l'ordre trait, on l'efface}
BoiteCommande.text:='';

end;


procedure TNMRform.FormActivate(Sender: TObject);
begin
   RafraichissementPileEtDirectoryNMR;

end;


procedure TNMRform.StopButtonClick(Sender: TObject);
begin
  DrapeauAcquisitionNMRencours:=false;
  DrapeauAcquisitionVientDeFinir:=true;
  RunEnCoursCaption.caption:='will stop';
end;


procedure TNMRform.ParamGAGEChange(Sender: TObject);
begin
DrapeauGAGEDejaInitialise:=false; {on demande qd on demarrera la prochaine
acquisition qu'il reinitialise GAGE}
SauveParametresRMN;
end;


procedure TNMRform.GAGEParamButtonClick(Sender: TObject);
{affiche les parametres de la carte GAGE}
begin
    if GAGEParamButton.caption='GAGE Parameters' then
       begin
       GAGEParamButton.caption:='Click to Mask GAGE';
       GAGEEdit1.visible:=true;GAGEEdit2.visible:=true;GAGEEdit3.visible:=true;
       GAGEEdit4.visible:=true;GAGEEdit5.visible:=true;GAGEEdit6.visible:=true;
       covaran.visible:=true;covbran.visible:=true;
       covvac.visible:=true;covbac.visible:=true;
       edpoints.visible:=true;edfreq.visible:=true;
       coslope.visible:=true;cosource.visible:=true;
       edniv.visible:=true;cotrigac.visible:=true;
       end
                                                    else
       begin
       GAGEParamButton.caption:='GAGE Parameters';
       GAGEEdit1.visible:=false;GAGEEdit2.visible:=false;GAGEEdit3.visible:=false;
       GAGEEdit4.visible:=false;GAGEEdit5.visible:=false;GAGEEdit6.visible:=false;
       covaran.visible:=false;covbran.visible:=false;
       covvac.visible:=false;covbac.visible:=false;
       edpoints.visible:=false;edfreq.visible:=false;
       coslope.visible:=false;cosource.visible:=false;
       edniv.visible:=false;cotrigac.visible:=false;
       end



end;

procedure TNMRForm.ouverture;

begin
{on affiche la fenetre qui est juste reduite en la maximisant}
{$R-}
NMRForm.WindowState:=WsMinimized;
NMRForm.WindowState:=WsNormal;
  {$R+}  {modif : on empeche tout bug de debordement pendant les lignes
  qui suivent}

end;

procedure TNMRform.PileBoxExit(Sender: TObject);
{se produit quand on quitte la boite pile : impose
 la nouvelle valeur ecrite par l'utilisateur comme nouvelle pile}

var fich:textfile;
    directory_NMR,chaine,chaine2:string;
    nombre,err:integer;

begin
  {on retrouve d'abord le directory de travail, dont le nom se trouve
    dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on reecrit la pile}
   chaine:=pileBox.text;
   val(chaine,nombre,err);
   if err=0 then
      begin
     {on reecrit le info.txt pour reactualiser la pile}
      assignfile(fich,directory_NMR+'\info.txt');
      rewrite(fich);
      writeln(fich,directory_NMR);
      writeln(fich,chaine);
      closefile(fich);
      end;
   RafraichissementPileEtDirectoryNMR;
end;


procedure TNMRform.phaseValueBoxExit(Sender: TObject);
{When manual phase is changed by hand}
var err:integer;Angle:extended;
    COSINUSAngle,SINUSAngle,poubelle1,poubelle2,nouvelangle:extended;
    indice,i,Nbpoints:integer;
    chaine:string;
begin
   val(phaseValueBox.text,AngleTF,err);

   {conversion degree to radian}
   Angle:=(AngleTF-OldAngleTF)*3.14159265358979/180;
   SINUSANGLE:=sin(Angle);COSINUSANGLE:=cos(Angle);

   indice:=und.indexof(Cocourbe1.text);
   NbPoints:=und.spect[indice].X;

   for i:=0 to NbPoints-1 do
      begin
      poubelle1:=COSINUSAngle*und.spect[indice].data[i,0].z
                 -SINUSAngle*und.spect[indice].data[i,0].mon;
      poubelle2:=COSINUSAngle*und.spect[indice].data[i,0].mon
                 +SINUSAngle*und.spect[indice].data[i,0].z;
      und.spect[indice].data[i,0].z:=poubelle1;
      und.spect[indice].data[i,0].mon:=poubelle2;
      end;

   OldAngleTF:=AngleTF;
   NMRForm.redessiner;
end;

procedure TNMRform.phaseValueBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var err:integer;
begin
if (Key=VK_RETURN) then
   begin
   val(phaseValueBox.text,AngleTF,err);
   changePhase;
   end;

end;

procedure TNMRForm.changephase;
var err:integer;Angle:extended;
    COSINUSAngle,SINUSAngle,poubelle1,poubelle2,nouvelangle:extended;
    indice,i,Nbpoints:integer;
    chaine:string;
begin
   val(phaseValueBox.text,AngleTF,err);
   {conversion degree to radian}
   Angle:=(AngleTF-OldAngleTF)*3.14159265358979/180;
   SINUSANGLE:=sin(Angle);COSINUSANGLE:=cos(Angle);

   indice:=und.indexof(Cocourbe1.text);
   NbPoints:=und.spect[indice].X;

   for i:=0 to NbPoints-1 do
      begin
      poubelle1:=COSINUSAngle*und.spect[indice].data[i,0].z
                 -SINUSAngle*und.spect[indice].data[i,0].mon;
      poubelle2:=COSINUSAngle*und.spect[indice].data[i,0].mon
                 +SINUSAngle*und.spect[indice].data[i,0].z;
      und.spect[indice].data[i,0].z:=poubelle1;
      und.spect[indice].data[i,0].mon:=poubelle2;
      end;

   OldAngleTF:=AngleTF;
   redessiner;
end;

procedure TNMRForm.SauveParametresRMN;  {resauve tous les parametres RMN de la reception
        dans le fichier Parametres RMN.txt}
begin
  EcritDansParametresRMN('Chanel A (+/-10V',covaran.text);
  EcritDansParametresRMN('Chanel B (Volts)',covbran.text);
  EcritDansParametresRMN('Chanel A (Mode AC ou DC)',covvac.text);
  EcritDansParametresRMN('Chanel B (Mode AC ou DC)',covbac.text);
  EcritDansParametresRMN('Nb Points (16',edpoints.text);
  EcritDansParametresRMN('Digit Freq (10 MHz',edfreq.text);
  EcritDansParametresRMN('Trigger (POSITIF/NEGATIF)',coslope.text);
  EcritDansParametresRMN('Trigger (VOIE A',cosource.text);
  EcritDansParametresRMN('Trigger (niveau',edniv.text);
  EcritDansParametresRMN('Trigger (DC/AC)',cotrigac.text);
end;

procedure TNMRForm.CalculMoyenneEntreCurseurs;
{calcul sur differents channels  la Moyenne entre les curseurs donns par le
panneau avant et le met dans MoyenneABox}
var start,finish,Moyenne,moyenneA,CursInf,CursSup:extended;
    err1,err2,indice,i,j,indiceStart,indiceFinish:integer;drapeau,drapeauErreur:boolean;
    chaine:string;
begin

MoyenneAText.caption:='avge=----';
MoyenneBText.caption:='avge=----';
MoyenneCText.caption:='avge=----';
MoyenneDText.caption:='avge=----';

{traitement si une virgule : on remplace par un point}
if pos(',',edit1.text)>0 then
    chaine:=copy(edit1.text,1,pos(',',edit1.text)-1)+'.'
           +copy(edit1.text,pos(',',edit1.text)+1,length(edit1.text)-pos(',',edit1.text))
           else
    chaine:=edit1.text;
val(chaine,CursInf,err1);
if pos(',',edit3.text)>0 then
    chaine:=copy(edit3.text,1,pos(',',edit3.text)-1)+'.'
           +copy(edit3.text,pos(',',edit3.text)+1,length(edit3.text)-pos(',',edit3.text))
           else
    chaine:=edit3.text;
val(chaine,CursSup,err2);
if (err1=0) and (err2=0) then
   begin
   if CursInf<=CursSup then begin start:=cursInf;finish:=curssup;end
                      else begin start:=curssup;finish:=cursinf;end;
   drapeauErreur:=false;
   {VOIES A et B}
   indice:=und.indexof(cocourbe1.text);
   Moyenne:=0;
   {recherche position borne inf Moyenne}
   i:=0;drapeau:=false;
   repeat
     if (Start>=und.spect[indice].Data[i,0].x) and (Start<und.spect[indice].Data[i+1,0].x)
            then drapeau:=true;
     i:=i+1;
   until (i=und.spect[indice].X-2) or (drapeau=true);
   if drapeau=false then drapeauErreur:=true {on n'a pas trouv la borne}
                   else
                   begin                      {on a trouv la borne}
                   IndiceStart:=i-1;
                   {recherche position borne sup Moyenne}
                   i:=IndiceStart+1; drapeau:=false;
                   repeat
                         if (Finish>=und.spect[indice].Data[i,0].x) and (Finish<und.spect[indice].Data[i+1,0].x)
                              then drapeau:=true;
                         i:=i+1;
                   until (i=und.spect[indice].X-2) or (drapeau=true);
                   if drapeau=false then drapeauErreur:=true
                                    else IndiceFinish:=i-1;
                   end;
   if DrapeauErreur=false then
                   begin
                   Moyenne:=0;
                   for i:=IndiceStart to IndiceFinish do
                           Moyenne:=Moyenne+und.spect[indice].data[i,0].z;
                   Moyenne:=Moyenne/abs(IndiceFinish-IndiceStart+1);
                   moyenneA:=moyenne;
                   MoyenneAText.caption:='A='+floattostr(Moyenne) ;
                   Moyenne:=0;
                   for i:=IndiceStart to IndiceFinish do
                           Moyenne:=Moyenne+und.spect[indice].data[i,0].mon;
                   Moyenne:=Moyenne/abs(IndiceFinish-IndiceStart+1);
                   MoyenneBText.caption:='B='+floattostr(Moyenne) ;
                   Moyenne:=sqrt(MoyenneA*MoyenneA+Moyenne*Moyenne);
                   MoyenneABtext.caption:='AB='+floattostr(Moyenne)
                   end;
   {VOIES C et D}
   indice:=und.indexof(cocourbe3.text);
   Moyenne:=0;
   {recherche position borne inf Moyenne}
   i:=0;drapeau:=false;
   repeat
     if (Start>=und.spect[indice].Data[i,0].x) and (Start<und.spect[indice].Data[i+1,0].x)
            then drapeau:=true;
     i:=i+1;
   until (i=und.spect[indice].X-2) or (drapeau=true);
   if drapeau=false then drapeauErreur:=true {on n'a pas trouv la borne}
                   else
                   begin                      {on a trouv la borne}
                   IndiceStart:=i-1;
                   {recherche position borne sup Moyenne}
                   i:=IndiceStart+1; drapeau:=false;
                   repeat
                         if (Finish>=und.spect[indice].Data[i,0].x) and (Finish<und.spect[indice].Data[i+1,0].x)
                              then drapeau:=true;
                         i:=i+1;
                   until (i=und.spect[indice].X-2) or (drapeau=true);
                   if drapeau=false then drapeauErreur:=true
                                    else IndiceFinish:=i-1;
                   end;
   if DrapeauErreur=false then
                   begin
                   Moyenne:=0;
                   for i:=IndiceStart to IndiceFinish do
                           Moyenne:=Moyenne+und.spect[indice].data[i,0].z;
                   Moyenne:=Moyenne/abs(IndiceFinish-IndiceStart+1);
                   MoyenneCText.caption:='C='+floattostr(Moyenne) ;
                   MoyenneA:=Moyenne;
                   Moyenne:=0;

                   for i:=IndiceStart to IndiceFinish do
                           Moyenne:=Moyenne+und.spect[indice].data[i,0].mon;
                   Moyenne:=Moyenne/abs(IndiceFinish-IndiceStart+1);
                   MoyenneDText.caption:='D='+floattostr(Moyenne) ;
                   Moyenne:=sqrt(MoyenneA*MoyenneA+Moyenne*Moyenne);
                   MoyenneCDtext.caption:='CD='+floattostr(Moyenne)
                   end;
   end;
end;

procedure TNMRForm.CalculDistanceEntreCurseurs;
{calcul la distance en valeur absolue entre les deux curseurs}
var distance,start,finish,Moyenne,CursInf,CursSup:extended;
    err1,err2,indice,i,j,indiceStart,indiceFinish:integer;drapeau,drapeauErreur:boolean;
    chaine:string;
begin

DistanceText.caption:='dist=----';

{traitement si une virgule : on remplace par un point}
if pos(',',edit1.text)>0 then
    chaine:=copy(edit1.text,1,pos(',',edit1.text)-1)+'.'
           +copy(edit1.text,pos(',',edit1.text)+1,length(edit1.text)-pos(',',edit1.text))
           else
    chaine:=edit1.text;
val(chaine,CursInf,err1);
if pos(',',edit3.text)>0 then
    chaine:=copy(edit3.text,1,pos(',',edit3.text)-1)+'.'
           +copy(edit3.text,pos(',',edit3.text)+1,length(edit3.text)-pos(',',edit3.text))
           else
    chaine:=edit3.text;
val(chaine,CursSup,err2);
if (err2=0) and (err1=0) then
            begin
            distance:=abs(CursSup-CursInf);
            DistanceText.Caption:='dist='+floattostr(distance)
            end
            else
            DistanceText.Caption:='dist=----';
end;


procedure TNMRform.bidonClick(Sender: TObject);
var nbCoups,err,i:integer;
begin
val(NBBox.text,nbCoups,err);
if err<>0 then begin nbCoups:=1;NBBox.text:='1';end;
NbCoupsAFaireNMR:=nbCoups;
NbCoupsDejaFaitNMR:=0;
PBNumberBox.caption:=inttostr(NbCoupsAFaireNMR);
DrapeauSoftSubstraction:=false;
DrapeauSeqParHasBeenChanged:=true;

cocourbe1.text:='ECHO';
cocourbe2.text:='ECHO';

if und.spect[2].nom='ECHO' then
   begin
    und.spect[2].comment:='echo NB='+inttostr(NbCoupsAFaireNMR);
    if drapeaunormalizedata=true then und.spect[2].comment:=und.spect[2].comment+' normalized';
  end;
cocourbe3.text:='OSCILLO';
cocourbe4.text:='OSCILLO';
PBNumberBox.caption:=inttostr(NbCoupsAFAireNMR);
end;

procedure TNMRform.UpDownPhaseABDownClick(Sender: TObject);
{change of the zero time of TF : It automatically recomputes the TF}
var chaine:string;

begin

  AngleTF:=AngleTF-5;
  str(AngleTF:8:1,chaine);
  phaseValueBox.text:=chaine;
  ChangePhase;

end;

procedure TNMRform.UpDownPhaseABUpClick(Sender: TObject);
var chaine:string;
begin
  AngleTF:=AngleTF+5;
  str(AngleTF:8:1,chaine);
  phaseValueBox.text:=chaine;
  ChangePhase;

end;
procedure TNMRform.RefreshButtonClick(Sender: TObject);
{refreshes the data especially when there is no automatic
refreshing chosen : active only during acquisition}
begin

  if (DrapeauSansRafraichissement=false) then
     begin
     NmrForm.Rafraichir(sender);
     end;
  if (DrapeauSansRafraichissement=true) then
     begin
     DrapeauSansRafraichissement:=false;
     NmrForm.Rafraichir(sender);
     DrapeauSansRafraichissement:=true;
     end;

end;

end.


