unit PulsesViaPortSerie;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Comrs232,
  StdCtrls;

type
  TPulsesViaSerialPort = class(TForm)
    Button1: TButton;
    CommPortDriverPulse1: TCommPortDriver;
    Button4: TButton;
    Label1: TLabel;
    Button5: TButton;
    ChaineLue: TLabel;
    Button2: TButton;
    Button3: TButton;
    delayBox: TEdit;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ouverture;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure LitCaractere(var caractere:string);
  private
      FTempInBuffer2              : pointer;
    { Dclarations prives }

    function sendread(su:string):string;


  public
    { Dclarations publiques }
  end;

var
  PulsesViaSerialPort: TPulsesViaSerialPort;
   drapeauCom1:boolean;

implementation

{$R *.DFM}

procedure TPulsesViaSerialPort.FormCreate(Sender: TObject);
var s:string;

begin

 drapeauCom1:=true;

 CommPortDriverPulse1.ComPort:=pnCOM1; // Choose pnCOM1 or pnCOM2
 CommPortDriverPulse1.ComPortSpeed:= br57600; //9600 Bauds
 CommPortDriverPulse1.ComPortDataBits           := db8BITS; // 8 data bits
 CommPortDriverPulse1.ComPortStopBits           := sb1BITS; // 1 stop bit
 CommPortDriverPulse1.ComPortParity             := ptNONE;  // no parity
 CommPortDriverPulse1.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
 CommPortDriverPulse1.ComPortSwHandshaking      := shNONE;

end;

procedure TPulsesViaSerialPort.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
PulsesViaSerialPort.WindowState:=WsMinimized;
PulsesViaSerialPort.WindowState:=WsNormal;
end;

procedure TPulsesViaSerialPort.Button1Click(Sender: TObject);
var start:integer;timeout:boolean;s,delayChaine:string;
begin
  {syntaxe :
  A6E3R0B1 + return(#13):
  A6E3 : 6*1e3 ns = 6 microsec
  R0 : ne boucle pas  la fin (mettre R1  la dernire instruction)
  B1 : sortie voie 1B (B0 : ne sort rien)
  exple :
  C  (arrte)
  A6E3R0B1 : pulse de 6 microsec
  A1E4R1B0 : le R1 permet de boucler  la fin de la sequence, la commande ici
  de A1e4 n'est pas prise en compte
  B ( demarre)


  GetMem( FTempInBuffer2,10);
{  if drapeauCom1=true then CommPortDriverPulse1.ComPort:=pnCOM1
                      else  CommPortDriverPulse1.ComPort:=pnCOM2;
 }

{cette version marche :
  GetMem( FTempInBuffer2,10);
  CommPortDriverPulse1.connect;
  CommPortDriverPulse1.FlushBuffers(true,true);
  s:='C'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A6E3R0B1'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A6E3R0B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='B'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
}

  delayChaine:=delayBox.Text;
  s:='C'+#13; {stop}
  CommPortDriverPulse1.SendData( pchar(s),length(s));
{avant de lancer l'ordre, il doit avoir finit la derniere etape de la
sequence precedente donc on attend 1 sec}
  start:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - start) > 1000);
       UNTIL timeout;


  {sequence}
  s:='A6E3R0B1'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));

  s:='A6E3R0B32768'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A'+delayChaine+'R0B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A6E3R0B32768'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A'+delayChaine+'R0B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A6E3R0B32768'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A'+delayChaine+'R0B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A6E3R0B32768'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A'+delayChaine+'R0B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='A1e3R1B0'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  {demarre}
  s:='B'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));

end;

function TPulsesViaSerialPort.sendread(su:string):string;
var
u:integer;
p:pchar;
s1:string[1];
s:string;
u1,u2:double;
fin:boolean;
begin
{  s:=su+#13;            { WHY?, c'est deja rajout dans les chaines envoyes au bidule }
  s:=su;
  CommPortDriverPulse1.SendData( pchar(s),length(s));
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0001 est le timeout }

 while (u1+0.0001>time) and (s1[1]<>#13) and (s1[1]<>#10) do
  begin
    u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then
        begin
          p:=Ftempinbuffer2;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then result:=s else result:='timeout';
end;


procedure TPulsesViaSerialPort.Button2Click(Sender: TObject);
var start:integer;timeout:boolean;s:string;
begin
  GetMem( FTempInBuffer2,10);
  CommPortDriverPulse1.connect;
  CommPortDriverPulse1.FlushBuffers(true,true);
end;

procedure TPulsesViaSerialPort.Button3Click(Sender: TObject);
begin
  commportdriverPulse1.Disconnect;
  FreeMem( FTempInBuffer2,10);

end;

procedure TPulsesViaSerialPort.Button4Click(Sender: TObject);
var start:integer;timeout:boolean;s:string;
begin
  s:='C'+#13;
  CommPortDriverPulse1.SendData( pchar(s),length(s));


end;

procedure TPulsesViaSerialPort.Button5Click(Sender: TObject);
var
u:integer;
p:pchar;
s1:string[1];
chaine,s:string;
u1,u2:double;
fin:boolean;
begin
  s:='';u:=1;fin:=false;s1:='1';

  ChaineLue.Caption:='LECTURE EN COURS';ChaineLue.refresh;
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0004 = 4 sec est le timeout }
 while (u1+0.00001>time) and (s1[1]<>#13) and (s1[1]<>#10) do
  begin
    u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then
        begin
          p:=Ftempinbuffer2;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then chaine:=s else chaine:='timeout';
  ChaineLue.Caption:=chaine;ChaineLue.refresh;
end;

procedure TPulsesViaSerialPort.LitCaractere(var caractere:string);
var
u:integer;
p:pchar;
s1:string[1];
chaine,s:string;
u1,u2:double;
fin:boolean;
begin
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0004 = 4 sec est le timeout }
 while (u1+0.00001>time) and (s1[1]<>#13) and (s1[1]<>#10) do
  begin
    u:=_hread(CommPortDriverPulse1.comhandle,@Ftempinbuffer2^,1);
     if u>0 then
        begin
          p:=Ftempinbuffer2;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then chaine:=s else chaine:='timeout';
  ChaineLue.Caption:=chaine;ChaineLue.refresh;
end;


end.
