unit configGAGE;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,GAGE_sta1012,GAGE_drv, ExtCtrls;

type
  TGAGEconfig = class(TForm)
    GroupBox1: TGroupBox;
    Canaux: TComboBox;
    Label1: TLabel;
    GainA: TComboBox;
    CouplageA: TComboBox;
    GainB: TComboBox;
    CouplageB: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    source: TComboBox;
    trigger_slope: TComboBox;
    Edit1: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox3: TGroupBox;
    horloge: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    Freq: TComboBox;
    Label11: TLabel;
    profondeur: TComboBox;
    Label12: TLabel;
    Ok: TButton;
    Cancel: TButton;
    Visualisation: TGroupBox;
    VoirCD: TRadioGroup;
    Label13: TLabel;
    procedure OkClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
    procedure ouverture;
    procedure lecture;

  end;

var
  GAGEconfig: TGAGEconfig;

implementation

{$R *.DFM}

procedure TGAGEconfig.lecture;
{Lecture des parametres actifs (les valeurs par defaut sont dans sta1012)}
var p:integer;
    s:string;

begin
if optionGAGE^.opmode= GAGE_DUAL_CHAN then canaux.text:='A&B' else canaux.text:='A';
GainA.text:=gage^.range[optionGAGE^.range_a].gf_text;
GainB.text:=gage^.range[optionGAGE^.range_b].gf_text;
if optionGAGE^.couple_a = GAGE_DC then couplageA.text:='DC' else couplageA.text:='AC';
if optionGAGE^.couple_b = GAGE_DC then couplageB.text:='DC' else couplageB.text:='AC';
if optionGAGE^.slope= GAGE_POSITIVE then trigger_slope.text:='pos' else trigger_slope.text:='neg';
source.text:=source.items[optionGAGE^.source-1];

if optionGAGE^.acint=0 then horloge.text:='int' else horloge.text:='ext';
Freq.text:=gage^.srtable[optionGAGE^.srindex].text;

p:=round(exp(optionGAGE^.depth*ln(2)));
str(p,s);
profondeur.text:=s;

        {pas trouve syntaxe pour trigger level}
        {Pas utiliss ?}
	optionGAGE^.range_e	:= GAGE_PM_5_V;
	optionGAGE^.couple_e	:= GAGE_AC;
        {Relatif  visualisation ?}
        optionGAGE^.acqrepdir:=1;
        optionGAGE^.acqrepft:=1;

end;


procedure TGAGEconfig.ouverture;

begin
{GAGEconfig:=TGAGEconfig.Create(Application);}
GAGEconfig.visible:=true;
end;

procedure TGAGEconfig.OkClick(Sender: TObject);
var i,err:integer;

begin
{Lecture parametres carte acquisition}

        if canaux.text='A&B' then optionGAGE^.opmode:= GAGE_DUAL_CHAN else optionGAGE^.opmode := GAGE_SINGLE_CHAN;
        for i:=0 to 6 do
           begin
             if GainA.text=gage^.range[i].gf_text then
             optionGAGE^.range_a:= gage^.range[i].constant;
             if GainB.text=gage^.range[i].gf_text then optionGAGE^.range_b:= gage^.range[i].constant;
           end;
         if couplageA.text='DC' then optionGAGE^.couple_a := GAGE_DC else optionGAGE^.couple_a := GAGE_AC;
         if couplageB.text='DC' then optionGAGE^.couple_b := GAGE_DC else optionGAGE^.couple_b := GAGE_AC;

        if trigger_slope.text='pos' then optionGAGE^.slope:= GAGE_POSITIVE else optionGAGE^.slope := GAGE_NEGATIVE;
         for i:=0 to 5 do
            if source.text=source.items[i] then
                 case i of
                          0: optionGAGE^.source:=GAGE_CHAN_A;
                          1: optionGAGE^.source:=GAGE_CHAN_B;
                          2: optionGAGE^.source:=GAGE_CH_A_CH_B;
                          3: optionGAGE^.source:=GAGE_EXTERNAL;
                          4: optionGAGE^.source:=GAGE_SOFTWARE;
                          5: optionGAGE^.source:=GAGE_EXTERNAL_DIV_5;
                     end;
      	optionGAGE^.level	:= 180;{pas trouve syntaxe pour level}

        if horloge.text='int' then optionGAGE^.acint:=0 else optionGAGE^.acint:=1;
        for i:=0 to 22 do
            if  Freq.text=gage^.srtable[i].text then optionGAGE^.srindex:=i;
        if  Freq.text=gage^.srtable[42].text then optionGAGE^.srindex:=42;
        val(profondeur.text,i,err);
        optionGAGE^.depth:= round(ln(i) /ln(2));


        {Pas utiliss ?}
	optionGAGE^.range_e	:= GAGE_PM_5_V;
	optionGAGE^.couple_e	:= GAGE_AC;
        {Relatif  visualisation ?}
        optionGAGE^.acqrepdir:=1;
        optionGAGE^.acqrepft:=1;
        {GAGEconfig.visible:=false;}
        {GAGEconfig.Close;}
end;

procedure TGAGEconfig.CancelClick(Sender: TObject);
begin
        GAGEconfig.Close;
end;

end.
