unit editdata;

{changer totalspectre  pour changer
nombre de fichiers maxi dans la spectliste RMN }

{dernieres modifs
8/08/00: Edouard :modification de Tdataeditform.ComboBox1DropDown
18/10/00: Edouard : ajout des procedures spectre.savetoPAXY et spectre.readfromPAXY }
{ MODIFICATIONS                                                                     }
{ mise a jour le 31.10.2000                                                         }
{ 13.12.00, FO : ajout d'une procdure "litSpectre1D" et "litSpectre2D" pour lire un spectre a partir du disque dur }
{ 13.12.00, FO : ajout d'une variable "integrale" pour l'integrale du spectre entre les deux curseurs                 }
{ 12.01.01: FO : dclaration const sreg='\PilotageManip';                                                             }
{                dclaration indexFichierKey='indexFichier';                                                          }
{                deux nouvelles procdures function GetIndexFichierCrt:integer;
{                                          procedure IncIndexFichierCrt;                                     }
{17.01.01: EL : petite modif sur spectre.readfromfile}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  filectrl,StdCtrls, ExtCtrls, AxCtrls, OleCtrls, vcf1, Parser10, Buttons, registry,
  Spin,DrapeauAlloulUnit;

const
  sreg='\PilotageManip';
  indexFichierKey='indexFichier';

type  {utilis pour l'enregistrement au format PAXY}
    Paxy=record
    entete:array[0..255] of char;
    data:array [0..127,0..127] of word;
end;
type
    points=record
    mon:real;
    x:real;
    y:real;
    z:real;
end;
type
    pspectsav=^spectsav;
    spectsav=record
    X:integer;
    Y:integer;
    nom:string[20];
    com:string[100];
    typX:string[6];
    typY:string[6];
    indexX:integer;
    indexY:integer;
    {data:array of array of points;}
end;

type
    spectre=class(tobject)
    private
    fX:integer;
    fY:integer;
    fnom:string;
    fcom:string;
    ftypX:string;
    ftypY:string;
    { Dclarations prives }
    protected
    public
    data:array of array of points;
    indexX,indexY:integer;
    property X:integer read fx write fx;
    property Y:integer read fy write fy;
    property Nom:string read fnom write fnom;
    property Comment:string read fcom write fcom;
    property typeX:string read ftypX write ftypX;
    property typeY:string read ftypY write ftypY;
    procedure clear;
    function total:real;
    procedure minmax(var min:real;var max:real);
    procedure savetofile(filename:string);
    procedure readfromfile(filename:string);
    procedure savetoPAXY(path,titre,nom,date,heure,temps:string;index:integer);
    procedure readfromPAXY(filename :string;var titre,nom,date,heure,temps:string);

end;
const defaultdir='c:\spe';
      totalspectre=40;

type
    spectlist=class(tobject)
    protected
    procedure free;
    public
    spect:array[1..totalspectre] of spectre;
    procedure createframe;
    function addspectre(nom:string;X:integer;Y:integer):integer;
    procedure deletespectre(ind:integer);
    function indexof(nom:string):integer;
    function addition(nom1,nom2,nom3:string):boolean;{nom3=nom2+nom1}
    function soustraction(nom1,nom2,nom3:string):boolean;{nom3=nom2-nom1}
    function parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
    procedure saveall;
    procedure add(spec:spectre);
    procedure clear(nom:string);
    procedure addpt(nom:string;x,y,z,mon:extended);
end;

type
  Tdataeditform = class(TForm)
    F1Book1: TF1Book;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Parser1: TParser;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    X: TLabel;
    EditX: TEdit;
    Label1: TLabel;
    EditY: TEdit;
    Label2: TLabel;
    EdittypX: TEdit;
    Label3: TLabel;
    EdittypY: TEdit;
    Label4: TLabel;
    Editnom: TEdit;
    Label5: TLabel;
    Editcom: TEdit;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure F1Book1EndEdit(Sender: TObject; var EditString: WideString;
      var Cancel: Smallint);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroup1Click(Sender: TObject);
    procedure F1Book1DblClick(Sender: TObject; nRow, nCol: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure EdittypXChange(Sender: TObject);
    procedure EdittypYChange(Sender: TObject);
    procedure EditnomChange(Sender: TObject);
    procedure EditcomChange(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);


  private
    { Dclarations prives}
    unddeud:boolean;
  public
  procedure traitchaine(s:string);
  procedure sauve(i:integer;nom:string);
  procedure litSpectre1D(s:string);
  procedure litSpectre2D(s:string);
  {ajout Groupe Alloul}
  procedure TraitementCommande(chaine:string;var Intervalle:boolean;var NbreNombres,NbreChaines:integer;var TableauNombres:array of extended;var TableauChaines:array of string);
  procedure sauveFormatNMR(nom:string);
  procedure sauveFormatStandard(nom,nom2:string;decalement:boolean);
  procedure Somme(chaine:string);
  procedure ForceSauvegardeECHO(nom:string);
  procedure recallNMR(NumeroFichier:string);
  procedure recallASCII(NomFichier:string);
  procedure DecaleSpectres;
  procedure TransfertSpectre(NumSource,NumDestine:integer);
  procedure AddAndReplace(nomAAjouter,nomOuSauver:string;DrapeauInitialisation:boolean);
  procedure sauveASCII(chaine:string);
  function Integ(nom:string;Voie,Start,Finish:real):real;
  function IntegNorm(nom:string;Voie,Start,Finish:real):real;
  function IntegEcho(nom:string;Start,Finish,bgdStart,bgdFinish,voieSigne:real):real;
  procedure Normalise(nom:string;valeur:extended);
  procedure SoustraitBackground(nom:string);
  procedure DoSmoothingCurve(nom:string;NbPointsDansEchantillon,DegreeSmoothing:integer);
  function SmoothingPart(xxx,yyy:array of extended;FiltreN:integer;TailleXXX:integer):extended;
    { Dclarations publiques}
  end;

function fexis(nomf:string):boolean;
function GetIndexFichierCrt:integer;
procedure IncIndexFichierCrt;

var
  dataeditform: Tdataeditform;
  deuxd:spectlist;
  und:spectlist;
  indexframe: array[1..16] of integer; {fait la correspondance entre le numero de frame et l'index du spectre}
  integrale:string; { integale du spectre en cours entre les curseurs }
  regis:tregistry;  { pointeur sur la base de registre }
  
implementation

uses BoiteNoire;

function fexis(nomf:string):boolean;
        var
        fich:file;
        begin
        {$I-}
        assignfile(fich,nomf);
        reset(fich);
        closefile(fich);
        {$I+}
        fexis:=(IOresult=0) and (nomf<>'');
        end;

{ lecture de l'index courant du spectre  sauvegarder }
{ INPUT : none                                        }
{ OUTPUT : l'index du dernier spectre sauvegard      }
{ REM    : pas de modif de la base de registre        }
function GetIndexFichierCrt:integer;
var tf:boolean;
    id:integer;
begin
   regis:=tregistry.create;
   tf:=regis.openkey(sreg,true);
   if tf then
   begin
      id:=regis.readinteger(indexFichierKey);
   end;
   regis.free;
   result:=id
end;

{ incrmentation de l'index courant du spectre  sauvegarder }
{ le comptage boucle de 1000  9999                          }
{ on laisse tomber 1  999 pour ne pas  avoir  formater    }
{ INPUT : none                                        }
{ OUTPUT : l'index du fichier est incrment          }
{ REM    : si l'index arrive  10000 on revient  1000}
{          on garde toujours un nombre  4 chiffres pour des problmes de formatage }
procedure IncIndexFichierCrt;
var tf:boolean;
    id:integer;
begin
   regis:=tregistry.create;
   tf:=regis.openkey(sreg,true);
   if tf then
   begin
      id:=regis.readinteger(indexFichierKey);
      inc(id);if id=10000 then id:=1000;
      regis.writeinteger(indexFichierKey,id);
   end;
   regis.free;
end;


{$R *.DFM}



{---------------spectre---------------------------}
procedure spectre.clear;
var
i,j:integer;
begin
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
data[i,j].x:=0;
data[i,j].y:=0;
data[i,j].z:=0;
data[i,j].mon:=0;       {modification Alloul : on met .mon  zero}
end;
indexX:=0;indexY:=0;
end;
{***************************************
}
function spectre.total:real;
var
i,j:integer;
tota:real;
begin
tota:=0;
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
tota:=data[i,j].z+tota;
end;
result:=tota;
end;
{***************************************
}
procedure spectre.minmax(var min:real;var max:real);
var
i,j:integer;
begin
min:=data[1,1].z;max:=data[1,1].z;
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
if min>data[i,j].z then min:=data[i,j].z;
if max<data[i,j].z then max:=data[i,j].z;
end;
end;
{***************************************
modifi le 8/06
filename = chemin+nom sans extension}
procedure spectre.SaveToFile(FileName: string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
filetot:string;
u:real;
begin
fa:=new(pspectsav);
fa.X:=X;fa.Y:=Y;
fa.indexX:=indexX;fa.indexY:=indexY;
fa.com:=comment;fa.nom:=nom;
fa.typX:=typeX;fa.typY:=typeY;
p.mon:=1;p.x:=0;p.y:=0;p.z:=0;u:=0;
if typex<>'raw' then
   begin
   filetot:=filename+'.spe';
   if fexis(filetot) then
      begin
  {ajout Alloul : on ne veut pas de cette option qui renomme le fichier
    si il existe deja en lui ajoutant un nombre, 1,2,3...
    On prefere qu'il ecrase l'ancien donc on desamorce ca dans les lignes qui suivent}
{      i:=1;
      filetot:=filename+inttostr(i)+'.spe';
      while fexis(filetot)do
            begin
            i:=i+1;
            filetot:=filename+inttostr(i)+'.spe';
            end;}
      end;
   assignfile(fich,filetot);
   assignfile(fich1,filetot);
   rewrite(fich1);
   for i:=1 to 200 do write(fich1,p);{blanc}
   for i:=0 to X-1 do
   for j:=0 to Y-1 do write(fich1,data[i,j]);
   {boitnoir.receivetext('sauvegarde sous '+filetot);}
   closefile(fich1);
   reset(fich);
   write(fich,fa^);
   closefile(fich);
   end
else
    begin
    filetot:=filename+'.raw';
    if fexis(filetot) then
       begin
  {ajout Alloul : on ne veut pas de cette option qui renomme le fichier
    si il existe deja en lui ajoutant un nombre, 1,2,3...
    On prefere qu'il ecrase l'ancien donc on desamorce ca dans les lignes qui suivent}
{       i:=1;
       filetot:=filename+inttostr(i)+'.spe';
       while fexis(filetot)do
          begin
          i:=i+1;
          filetot:=filename+inttostr(i)+'.spe';
          end;}
       end;
    assignfile(fich,filetot);
    assignfile(fich2,filetot);
    rewrite(fich2);
    for i:=1  to 200 do write(fich2,u);{blanc}
    for i:=0 to X-1 do
    for j:=0 to Y-1 do write(fich2,data[i,j].z);
    closefile(fich2);
    reset(fich);
    write(fich,fa^);
    closefile(fich);
    end;
dispose(fa);
end;
{***************************************
}
procedure spectre.readfromfile(filename:string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
u:real;
begin
fa:=new(pspectsav);
assignfile(fich,filename);
assignfile(fich1,filename);
assignfile(fich2,filename);
reset(fich);
read(fich,fa^);
X:=fa.X;Y:=fa.Y;
comment:=fa.com;{nom:=fa.nom;}
typeX:=fa.typX;typeY:=fa.typY;
indexX:=fa.indexX;indexY:=fa.indexY;
setlength(data,X,Y);
closefile(fich);
if typeX<>'raw' then begin
reset(fich1);
for i:=1 to 200 do read(fich1,p);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich1,data[i,j]);
closefile(fich1);
end else begin
reset(fich2);
for i:=1 to 200 do read(fich2,u);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich2,data[i,j].z);
closefile(fich2);
{ATTENTION : format raw : indexX sert abusivement pour sauvegarder le moniteur!!}
data[0,0].mon:=indexX;
end;
dispose(fa);
end;
{***********************************************
enregistre une spectre 2D Raw 128*128 (format PAPOL) au format paxy
path: chemin complet termin par \
titre : titre de la manip 6 caractres,
nom : nom de l'echantillon 6 caractres,
date : 10 caractres
heure : 8 caractres
temps : temps de comptage 6 caractres
mon : moniteur 8 caractres
index : numero du fichier PAXY 4 caractres}
procedure spectre.savetoPAXY(path,titre,nom,date,heure,temps:string;index:integer);
var i,j,dataint:integer;
    temp,filename:string;
    f:file of paxy;
    dbyte:word;
    fort,faible:byte;
    paxytemp:paxy;

begin
{******  creation de la tete du fichier PAXY}

{initialisation}
for i:=0 to 255 do
        paxytemp.entete[i]:='1';
{n fichier}
paxytemp.entete[0]:='X';
paxytemp.entete[1]:='Y';
temp:=inttostr(index);
for j:=2 to 5 do
    if j<= 5-length(temp) then
       paxytemp.entete[j]:='0'
    else  paxytemp.entete[j]:=temp[j+length(temp)-5];
{titre manip}
for j:=1 to 6 do
    if j>length(titre) then
       paxytemp.entete[j+5]:=' '
    else
        paxytemp.entete[j+5]:=titre[j];
{nom echantillon}
for j:=1 to 12 do
    if j>length(nom) then
       paxytemp.entete[j+11]:=' '
    else
        paxytemp.entete[j+11]:=nom[j];
{temps de comptage}
for j:=1 to 6 do
    if j>length(temps) then
       paxytemp.entete[j+23]:=' '
    else
        paxytemp.entete[j+23]:=temps[j];
{moniteur}
temp:=inttostr(trunc(data[0,0].mon));
for j:=1 to 8 do
    if j<=8-length(temp) then
       paxytemp.entete[29+j]:='0'
    else
        paxytemp.entete[29+j]:=temp[length(temp)-8+j];
{date}
for j:=1 to 10 do
    if j>length(date) then
       paxytemp.entete[j+37]:=' '
    else
        paxytemp.entete[j+37]:=date[j];
{heure}
for j:=1 to 8 do
    if j>length(heure) then
       paxytemp.entete[j+47]:=' '
    else
        paxytemp.entete[j+47]:=heure[j];
{commentaires}
for j:=67 to 255 do
    if (j-66)>length(comment) then
       paxytemp.entete[j]:=' '
    else
        paxytemp.entete[j]:=comment[j-66];

{******  sauvegarde des datas avec inversion poids fort poids faible}
for i:=0 to 127 do
	for j:=0 to 127 do
	begin
	dataint:=trunc(data[j,127-i].Z);
        fort:=dataint div 256;
        faible:=dataint mod 256;
        dbyte:=faible*256+fort;
	paxytemp.data[i,j]:=dbyte;
	end ;
{****** enregistrement}
filename:=path+copy(paxytemp.entete,0,6)+'.dat';
assignfile(f,filename);
rewrite(f);
write(f,paxytemp);
closefile(f);
end;
{***********************************************
lit un spectre au format PAXY}
procedure spectre.readfromPAXY(filename :string;var titre,nom,date,heure,temps:string);
var i,j,dataint:integer;
    temp:string;
    f:file of paxy;
    dbyte:word;
    fort,faible:byte;
    paxytemp:paxy;

begin
{***** lecture}
assignfile(f,filename);
reset(f);
read(f,paxytemp);
closefile(f);

{**** extraction tete}
titre:=copy(paxytemp.entete,7,6);
nom:=copy(paxytemp.entete,13,12);
temps:=copy(paxytemp.entete,25,6);
temp:=copy(paxytemp.entete,31,8);
data[0,0].mon:=strtofloat(temp);
date:=copy(paxytemp.entete,39,10);
heure:=copy(paxytemp.entete,49,8);
comment:=copy(paxytemp.entete,68,189);

{**** extraction data}
for i:=0 to 127 do
	for j:=0 to 127 do
	begin
        dataint:=paxytemp.data[i,j];
        fort:=dataint div 256;
        faible:=dataint mod 256;
        dbyte:=faible*256+fort;
        data[j,127-i].Z:=dbyte;
	end ;

end;
{----------------spectrelist------------------------}
{***********************************************
cre les 16 spectres frame}
procedure spectlist.createframe;

var i:integer;

begin
{creation de 16 spectres }
for i:=1 to 16 do
    begin
    indexframe[i]:=deuxd.addspectre('ACF'+inttostr(i),128,128);
    deuxd.spect[indexframe[i]].comment:='spectre frame';
    deuxd.spect[indexframe[i]].typex:='raw';
    deuxd.spect[indexframe[i]].typey:='raw';
    end;

end;
{***************************************
                    cree un nouveau spectre dans la liste }
function spectlist.addspectre(nom:string;X:integer;Y:integer):integer;
var
i:integer;
i1:integer;
tf:boolean;
begin
i:=1;i1:=-1;tf:=false;
deletespectre(indexof(nom));
while (i<=totalspectre) and (not tf) do begin
if spect[i]=nil then begin
spect[i]:=spectre.create;
spect[i].nom:=nom;
spect[i].X:=X;
spect[i].Y:=Y;
setlength(spect[i].data,X,Y);
i1:=i;tf:=true;
spect[i].clear;
end;
i:=i+1;
end;
result:=i1;
end;
{***************************************
       cree un nouveau spectre et effectue le chargement}
procedure spectlist.add(spec:spectre);
var
i,k,l:integer;
begin
i:=addspectre(spec.nom,spec.X,spec.Y);
if i>=1 then begin
spect[i].comment:=spec.comment;
spect[i].typeX:=spec.typeX;
spect[i].typeY:=spec.typeY;
spect[i].indexX:=spec.indexX;
spect[i].indexY:=spec.indexY;
for k:=0 to spec.X-1 do
for l:=0 to spec.Y-1 do
spect[i].data[k,l]:=spec.data[k,l];
end;
end;
{***************************************
}
procedure spectlist.deletespectre(ind:integer);
begin
if (ind>=1) and (ind<=totalspectre) then
if spect[ind]<>nil then begin
spect[ind].free;
spect[ind]:=nil;
end;
end;
{***************************************
}
procedure spectlist.free;
var
i:integer;
begin
for i:=1 to totalspectre do spect[i].free;
end;
{***************************************
}
procedure spectlist.clear(nom:string);
var
ind:integer;
begin
ind:=indexof(nom);
if ind>=0 then spect[ind].clear;
end;
{***************************************
}
procedure spectlist.addpt(nom:string;x,y,z,mon:extended);
var
i:integer;
tf:boolean;
begin
i:=indexof(nom);tf:=false;
if i>=0 then begin
if spect[i].indexX>=spect[i].X-1 then begin
  spect[i].indexY:=spect[i].indexY+1;
  if spect[i].indexY<spect[i].Y-1 then begin
  spect[i].indexX:=0;tf:=true;end;
end else begin
  tf:=true;
  spect[i].indexX:=spect[i].indexX+1;
end;
if tf then begin
spect[i].data[spect[i].indexX,spect[i].indexY].x:=x;
spect[i].data[spect[i].indexX,spect[i].indexY].y:=y;
spect[i].data[spect[i].indexX,spect[i].indexY].z:=z;
spect[i].data[spect[i].indexX,spect[i].indexY].mon:=mon;
end;
end;
end;

{***************************************
  retourne l'index du spectre ou -1 si le spectre n'existe pas}
function spectlist.indexof(nom:string):integer;
var
i:integer;
i1:integer;
begin
i:=1;i1:=-1;
while (i<=totalspectre) and (i1=-1) do begin
if spect[i]<>nil then
if spect[i].nom=nom then i1:=i;
i:=i+1;
end;

result:=i1;
end;
{***************************************
   additionne deux spectres si ils sont compatible
au besoin le spectre 3 est automatiquement cree}
function spectlist.addition(nom1,nom2,nom3:string):boolean;{nom3=nom2+nom1}
var
i,j,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
   if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) then
     begin
     if i3<1 then
       i3:=addspectre(nom3,spect[i1].x,spect[i1].y);

     spect[i3].x:=spect[i1].x;
     spect[i3].y:=spect[i1].y;
     spect[i3].typex:=spect[i1].typex;
     spect[i3].typey:=spect[i1].typey;
     for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
         begin
         spect[i3].data[i,j].x:=spect[i1].data[i,j].x;
         spect[i3].data[i,j].y:=spect[i1].data[i,j].y;
         spect[i3].data[i,j].z:=spect[i1].data[i,j].z+spect[i2].data[i,j].z;
         spect[i3].data[i,j].mon:=spect[i1].data[i,j].mon+spect[i2].data[i,j].mon;
         end;

     tf:=true;
     end;

result:=tf;
end;
{***************************************
soustrait deux spectres si ils sont compatible
au besoin le spectre 3 est automatiquement cree et mis au bon format}
function spectlist.soustraction(nom1,nom2,nom3:string):boolean;{nom3=nom2-nom1}
var
i,j,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
  if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) then
    begin
    if i3<1 then
      i3:=addspectre(nom3,spect[i1].x,spect[i1].y);

    spect[i3].x:=spect[i1].x;
    spect[i3].y:=spect[i1].y;
    spect[i3].typex:=spect[i1].typex;
    spect[i3].typey:=spect[i1].typey;
    for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
           begin
           spect[i3].data[i,j].x:=spect[i1].data[i,j].x;
           spect[i3].data[i,j].y:=spect[i1].data[i,j].y;
           spect[i3].data[i,j].z:=spect[i1].data[i,j].z-spect[i2].data[i,j].z;
           spect[i3].data[i,j].mon:=spect[i1].data[i,j].mon-spect[i2].data[i,j].mon;
           end;
    tf:=true;
    end;
result:=tf;
end;
{on se sert du parser en remplacant les variables par la
valeur dans la chane
pour chaque chane on rentre le nom (remplac par [i,j])
on peut rentrer le nommon (remplac par le moniteur) ou le
nomtemps remplac par le temps}
function spectlist.parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
var
s2,s1:string;
s3:array[1..10] of string;
uu3:array[1..10] of integer;
m,i,j,x,y,k,l:integer;
i1:integer;
typx,typy:string;
begin
for i:=1 to 10 do s3[i]:='';
j:=1;x:=0;y:=0;
for i:=1 to totalspectre do if spect[i]<>nil then
 if pos(spect[i].nom,s)>0 then begin
 s3[j]:=spect[i].nom;uu3[j]:=i;j:=j+1;
  x:=spect[i].x;y:=spect[i].y;
  typx:=spect[i].typex;typy:=spect[i].typey;
 end;
if (pos('=',s)>0) and (x>0) and (y>0) then begin
s2:=copy(s,pos('=',s)+1,length(s));
s1:=copy(s,1,pos('=',s)-1);
i1:=indexof(s1);
if i1<0 then begin
i1:=addspectre(s1,x,y);
spect[i1].typex:=typx;
spect[i1].typey:=typy;
end;
for k:=0 to x-1 do
for l:=0 to y-1 do begin
dataeditform.parser1.setvariable('i',k);
dataeditform.parser1.setvariable('j',l);
for m:=0 to 9 do begin
i:=m+1;
if s3[i]<>'' then begin
dataeditform.parser1.setvariable(s3[i],spect[uu3[i]].data[k,l].z);
dataeditform.parser1.setvariable(s3[i]+'mon',spect[uu3[i]].data[k,l].mon);
end;
end;
dataeditform.parser1.expression:=s2;
spect[i1].data[k,l].z:=dataeditform.parser1.value;
end;
end;
result:=true;
end;

procedure spectlist.saveall;
var
i:integer;
begin
i:=1;
while (i<=totalspectre)do begin
if spect[i]<>nil then spect[i].savetofile(spect[i].nom);
i:=i+1;
end;
end;

{----------------------tdataeditform--------------------}
procedure Tdataeditform.ComboBox1Change(Sender: TObject);
var
ind,i,j:integer;
begin
if unddeud=false then begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(deuxd.spect[ind].X);
editY.text:=inttostr(deuxd.spect[ind].Y);
edittypx.text:=deuxd.spect[ind].typeX;
edittypy.text:=deuxd.spect[ind].typeY;
editnom.text:=deuxd.spect[ind].nom;
editcom.text:=deuxd.spect[ind].comment;
f1book1.inittable;
f1book1.maxcol:=deuxd.spect[ind].X;
f1book1.maxrow:=deuxd.spect[ind].Y;
for i:=1 to deuxd.spect[ind].x do
for j:=1 to deuxd.spect[ind].y do begin
f1book1.TextRC[j,i]:=floattostr(deuxd.spect[ind].data[i-1,j-1].z);
end;
for i:=1 to deuxd.spect[ind].x do f1book1.ColText[i]:=inttostr(i);
end;
end else begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(und.spect[ind].X);
editY.text:=inttostr(und.spect[ind].Y);
edittypx.text:=und.spect[ind].typeX;
edittypy.text:=und.spect[ind].typeY;
editnom.text:=und.spect[ind].nom;
editcom.text:=und.spect[ind].comment;
f1book1.inittable;
f1book1.maxcol:=12;
f1book1.maxrow:=und.spect[ind].X;
for i:=1 to und.spect[ind].x do begin
f1book1.TextRC[i,1]:=floattostr(und.spect[ind].data[i-1,0].mon);
f1book1.TextRC[i,2]:=floattostr(und.spect[ind].data[i-1,0].x);
f1book1.TextRC[i,3]:=floattostr(und.spect[ind].data[i-1,0].z);
end;
f1book1.ColText[1]:='mon'; 
f1book1.ColText[2]:='x';
f1book1.ColText[3]:='z';
end;
end;
end;

procedure Tdataeditform.FormCreate(Sender: TObject);
var
i:integer;
begin
unddeud:=true;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
begin
combobox1.items.add(und.spect[i].nom);
end;
top:=0;
left:=0;
end;

procedure Tdataeditform.F1Book1EndEdit(Sender: TObject;
  var EditString: WideString; var Cancel: Smallint);
var
ind,i,j:integer;
u:real;
begin
if unddeud=true then begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
f1book1.GetActiveCell(i,j);
u:=strtofloat(editstring);
if j=1 then und.spect[ind].data[i-1,0].mon:=u;
if j=2 then und.spect[ind].data[i-1,0].x:=u;
if j=3 then und.spect[ind].data[i-1,0].z:=u;
end;
end else begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
f1book1.GetActiveCell(j,i);
u:=strtofloat(editstring);
deuxd.spect[ind].data[i-1,j-1].z:=u;
end;
end;
end;

procedure Tdataeditform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

if key=38 then
   begin
      NumeroInstructionPrecedente:=NumeroInstructionPrecedente+1;
      if NumeroInstructionPrecedente>20 then NumeroInstructionPrecedente:=0;
      edit1.Text:=InstructionInterpreteur[NumeroInstructionPrecedente];
   end;
if key=40 then
   begin
      NumeroInstructionPrecedente:=NumeroInstructionPrecedente-1;
      if NumeroInstructionPrecedente<=0 then
                                        begin
                                        NumeroInstructionPrecedente:=0;
                                        edit1.Text:='';
                                        end
                                        else
                                        edit1.Text:=InstructionInterpreteur[NumeroInstructionPrecedente];
   end;
if (key<>38) and (key<>40) then NumeroInstructionPrecedente:=0;

   if key=13 then traitchaine(edit1.text);
end;

procedure Tdataeditform.traitchaine(s:string);
var
i:integer;
begin
if unddeud=true then begin
und.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
deuxd.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
end;

procedure Tdataeditform.RadioGroup1Click(Sender: TObject);
var
i:integer;
begin
if radiogroup1.itemindex=0 then unddeud:=true else unddeud:=false;
if unddeud=true then begin
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
combobox1.itemindex:=0;
end;

procedure Tdataeditform.F1Book1DblClick(Sender: TObject; nRow,
  nCol: Integer);
begin
f1book1.launchdesigner;
end;

procedure Tdataeditform.sauve(i:integer;nom:string);
begin
if (nom<>'tout') then
 begin
  if i=1 then
     if und.indexof(nom)>=0 then und.spect[und.indexof(nom)].savetofile(nom);
  if i=2 then
     if deuxd.indexof(nom)>=0 then deuxd.spect[deuxd.indexof(nom)].savetofile(nom);
 end
                else
 begin
  if i=1 then und.saveall;
  if i=2 then deuxd.saveall;
 end;
end;

{procdure de lecture d'un spectre  partir du disque dur }
{ INPUT : le nom du fichier                               }
procedure TdataEditForm.litSpectre1D(s:string);
begin
und.spect[1].readfromfile(boitnoir.RepertoireManip.text+'\'+s);
end;

procedure TdataEditForm.litSpectre2D(s:string);
begin
deuxd.spect[1].readfromfile(boitnoir.RepertoireManip.text+'\'+s);
end;

procedure Tdataeditform.SpeedButton2Click(Sender: TObject);
begin
if unddeud then sauve(1,combobox1.text)
else sauve(2,combobox1.text);
end;

procedure Tdataeditform.SpeedButton3Click(Sender: TObject);
begin
if unddeud then sauve(1,'tout')
else sauve(2,'tout');
end;

procedure Tdataeditform.SpeedButton5Click(Sender: TObject);
begin
if unddeud then und.deletespectre(und.indexof(combobox1.text))
else deuxd.deletespectre(deuxd.indexof(combobox1.text));
radiogroup1click(Sender);
end;

procedure Tdataeditform.SpeedButton4Click(Sender: TObject);
var
spec:spectre;
begin
spec:=spectre.create;
opendialog1.initialdir:=defaultdir;
if opendialog1.execute then
begin
spec.readfromfile(opendialog1.filename);
if spec.typey='single' then und.add(spec) else deuxd.add(spec);
end;
spec.Destroy;
end;

procedure Tdataeditform.EdittypXChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeX:=edittypX.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeX:=edittypX.text;
end;

procedure Tdataeditform.EdittypYChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeY:=edittypY.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeY:=edittypY.text;
end;



procedure Tdataeditform.EditnomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].nom:=editnom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].nom:=editnom.text;
ComboBox1Change(Sender);
end;



procedure Tdataeditform.EditcomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].comment:=editcom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].comment:=editcom.text;
end;

procedure Tdataeditform.ComboBox1DropDown(Sender: TObject);
var i:integer;
begin
{reinitialisation des items a chaque ouverture du combo}
combobox1.items.clear;

for i:=1 to totalspectre do
begin
if deuxd<>nil then
if deuxd.spect[i]<>nil then
   combobox1.items.add(deuxd.spect[i].nom);

if und<>nil then
if und.spect[i]<>nil then
   combobox1.items.add(und.spect[i].nom);
end;
end;

procedure Tdataeditform.Button1Click(Sender: TObject);
begin
     SpinEdit1.value:=GetIndexFichierCrt;
end;

procedure Tdataeditform.Button2Click(Sender: TObject);
begin
     IncIndexFichierCrt;
end;

{Ajout groupe Alloul instructions RMN}
procedure Tdataeditform.TraitementCommande(chaine:string;var Intervalle:boolean;var NbreNombres,NbreChaines:integer;var TableauNombres:array of extended;var TableauChaines:array of string);
{traite une chaine de commande "chaine" en extrayant des nombres et des chaines :
exple : si chaine='BLABLA53' renvoit false,1,0,false,tableau contenant 53, tableau ne contenant rien
si chaine='BLABLA_ESSAI' renvoit false,0,1,tableau ne contenant rien, tableau contenant ESSAI
si chaine='BLABLA(53,72,ESSAI,75,ESSAIBIS)' renvoit false,3,2,tableau contenant 53,72,75 et tableau contenant ESSAI,ESSAIBIS
si chaine='BLABLA53-62' ou 'BLABLA(53-62) renvoit true,2,0 et tableau contenant 53,72, et tableau contenant rien
idem si parentheses remplaces par crochets, et si au lieu de ESSAI on a "ESSAI" il enlve les guillemets}

var i,position,longueur,err,err2:integer;
    drapeau,drapeau2,drapeau3:boolean;
    ch1:string;
    nombre:extended;

begin
{initialisation}
NbreNombres:=0;NbreChaines:=0;Intervalle:=false;
for i:=0 to 20 do
    begin
    TableauChaines[i]:='';
    TableauNombres[i]:=0;
    end;
longueur:=length(chaine);

drapeau:=false;
for i:=1 to longueur do
         if (copy(chaine,i,1)='(') or (copy(chaine,i,1)='[') then begin drapeau:=true;Position:=i;end;


{si chaine de la forme 'BLABLA(534-538)' ou 'BLABLA[534-538]'}
if drapeau=true then
   begin
     drapeau3:=false;
     for i:=1 to longueur do
            if copy(chaine,i,1)='-' then begin drapeau3:=true;Position:=i;end;
     if drapeau3=true then
     begin
       Intervalle:=true;
       i:=0;
       repeat
         i:=i+1;
         ch1:=copy(chaine,i,1);
         val(ch1,nombre,err);
       until (err=0) or (i=length(chaine));
       Position:=i;
       repeat
         i:=i+1;
         ch1:=copy(chaine,i,1);
       until (ch1='-');
       val(copy(chaine,Position,i-Position),nombre,err);
       if err=0 then
                    begin
                    NbreNombres:=NbreNombres+1;
                    TableauNombres[NbreNombres]:=nombre;
                    end;
        val(copy(chaine,i+1,length(chaine)-i-1),nombre,err);
        if err=0 then
                    begin
                    NbreNombres:=NbreNombres+1;
                    TableauNombres[NbreNombres]:=nombre;
                    end;
     end;
   end;


{si chaine de la forme 'BLABLA(53,72,ESSAI,75,ESSAIBIS)' ou
'BLABLA[53,72,ESSAI,75,ESSAIBIS]' ou 'BLABLA[53,72,"ESSAI",75,"ESSAIBIS"]'}
if (drapeau=true) and (drapeau3=false) then
   begin
   chaine:=copy(chaine,position+1,longueur-position);
   {reperage des differents numeros et chaines de caractere separes par des virgules}
   ch1:='';i:=0;
   repeat
       i:=i+1;
       if (copy(chaine,i,1)=',') or (copy(chaine,i,1)=')') or (copy(chaine,i,1)=']')
                              then begin
                                    val(ch1,nombre,err);
                                    if err=0 then begin
                                                  nbreNombres:=nbreNombres+1;
                                                  TableauNombres[NbreNombres]:=nombre;
                                                  end
                                              else
                                                  begin
                                                  nbreChaines:=nbreChaines+1;
                                                  TableauChaines[NbreChaines]:=ch1;
                                                  end;
                                    ch1:='';
                                    end
                               else
                                   ch1:=ch1+copy(chaine,i,1);

    until (i=(length(chaine)+1));
    end;

{si chaine de la forme 'BLABLA_ESSAI' ou 'BLABLA_53'}
if drapeau=false then
   begin
   drapeau2:=false;
   for i:=1 to longueur do
         if copy(chaine,i,1)='_' then begin drapeau2:=true;Position:=i;end;

   if drapeau2=true then {deuxieme cas:si chaine de la forme 'BLABLA_ESSAI' ou 'BLABLA_53'}
        begin
        ch1:=copy(chaine,Position+1,length(chaine)-Position+1);
        val(ch1,nombre,err);
        if err=0 then begin
                      nbreNombres:=nbreNombres+1;
                      TableauNombres[NbreNombres]:=nombre;
                      end
                      else
                      begin
                      nbreChaines:=nbreChaines+1;
                      TableauChaines[NbreChaines]:=ch1;
                      end;
        end;

   {si chaine de la forme 'BLABLA534' ou 'BLABLA534-576}
   if drapeau2=false then
        begin
          drapeau3:=false;
          for i:=1 to longueur do
            if copy(chaine,i,1)='-' then begin drapeau3:=true;Position:=i;end;

          if drapeau3=false then  {si chaine de la forme 'BLABLA534' }
             begin
             i:=0;
             repeat
               i:=i+1;
               ch1:=copy(chaine,i,1);
               val(ch1,nombre,err);
             until (err=0) or (i=length(chaine));
             if err=0 then
                begin
                ch1:=copy(chaine,i,length(chaine)-i+1);
                val(ch1,nombre,err2);
                if err2=0 then begin
                      nbreNombres:=nbreNombres+1;
                      TableauNombres[NbreNombres]:=nombre;
                      end;
                end;
             end;

          if drapeau3=true then  {si chaine de la forme 'BLABLA534-538' }
             begin
             Intervalle:=true;
             i:=0;
             repeat
               i:=i+1;
               ch1:=copy(chaine,i,1);
               val(ch1,nombre,err);
             until (err=0) or (i=length(chaine));
             Position:=i;
             repeat
               i:=i+1;
               ch1:=copy(chaine,i,1);
             until (ch1='-');
             val(copy(chaine,Position,i-Position),nombre,err);
               if err=0 then
                    begin
                    NbreNombres:=NbreNombres+1;
                    TableauNombres[NbreNombres]:=nombre;
                    end;
             val(copy(chaine,i+1,length(chaine)-i),nombre,err);
               if err=0 then
                    begin
                    NbreNombres:=NbreNombres+1;
                    TableauNombres[NbreNombres]:=nombre;
                    end;
             end;

        end;

   end;
{correction des chaines de caractre : toute chaine de la forme "COMMANDE"
devient COMMANDE}
if nbreChaines>0 then
   begin
   for i:=1 to nbreChaines do
       begin
       if copy(TAbleauChaines[i],1,1)='"' then TAbleauChaines[i]:=copy(TAbleauChaines[i],2,length(TAbleauChaines[i])-1);
       if copy(TAbleauChaines[i],length(TableauChaines[i]),1)='"' then TAbleauChaines[i]:=copy(TAbleauChaines[i],1,length(TAbleauChaines[i])-1);
       end;
   end;
end;


procedure Tdataeditform.somme(chaine:string);
var ch1,ch2:string;i,j:integer;drapeau,drapeauNB:boolean;numDepart,numFin:integer;
    err,positionTirait,nbFichiers,nbPtsSomme:integer;numero:array[0..100] of integer;
    nombre:extended;
begin

  dataeditform.TraitementCommande(chaine,intervalle,NbreNombres,NbreChaines,TableauNombres,TableauChaines);

  {cas d'une somme de plusieurs fichiers compris entre deux fichiers}
  if intervalle=true then
     begin
     numDepart:=round(TableauNombres[1]);
     numFin:=round(TableauNombres[2]);
     for i:=numDepart to numFin do
         begin
              str(i,ch1);
              recallNMR(ch1);
         end;
    {on enleve SOMME si il existe deja}
    if und.indexof('SOMME')<>-1 then und.deletespectre(und.indexof('SOMME'));
    {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
    qui va etre celui sauvegard ici}
    DecaleSpectres;
    und.spect[1].nom:='SOMME';
    for j:=0 to und.spect[1].x-1 do
         begin
         und.spect[1].data[j,0].z:=0;und.spect[1].data[j,0].mon:=0;
         und.spect[1].data[j,0].x:=und.spect[5].data[j,0].x;
         end;
    drapeauNB:=true;
    nbPtsSomme:=0;
    for i:=numDepart to numFin do
        begin
        if pos('NB=',und.spect[i-numDepart+5].comment)>0 then
               begin
               chaine:=copy(und.spect[i-numDepart+5].comment,pos('NB=',und.spect[i-numDepart+5].comment)+3,
                       length(und.spect[i-numDepart+5].comment)-pos('NB=',und.spect[i-numDepart+5].comment)-2);
               val(chaine,nombre,err);
               if err=0 then nbPtsSomme:=nbPtsSomme+round(nombre)
                        else drapeauNB:=false;
               end
               else drapeauNB:=false;
        for j:=0 to und.spect[1].x-1 do
         begin
         und.spect[1].data[j,0].z:=und.spect[1].data[j,0].z+und.spect[i-numDepart+5].data[j,0].z;
         und.spect[1].data[j,0].mon:=und.spect[1].data[j,0].mon+und.spect[i-numDepart+5].data[j,0].mon;
         end;
        end;
      if drapeauNB=true then und.spect[1].comment:='SOMME NB='+inttostr(nbPtsSomme);
     end;

  {cas d'une somme de differents fichiers non adjacents}
  if intervalle=false then
     begin
     nbFichiers:=nbreNombres;
     {rappel des fichiers}
     for i:=1 to nbFichiers do
         begin
              str(round(TableauNombres[i]),ch1);
              recallNMR(ch1);
         end;
    {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
    qui va etre celui sauvegard ici}
    DecaleSpectres;
    und.spect[1].nom:='SOMME';
    for j:=0 to und.spect[1].x-1 do
         begin
         und.spect[1].data[j,0].z:=0;und.spect[1].data[j,0].mon:=0;
         end;
    drapeauNB:=true;
    nbPtsSomme:=0;
    for i:=1 to nbFichiers do
        begin
        if pos('NB=',und.spect[i+4].comment)>0 then
               begin
               chaine:=copy(und.spect[i+4].comment,pos('NB=',und.spect[i+4].comment)+3,
                       length(und.spect[i+4].comment)-pos('NB=',und.spect[i+4].comment)-2);
               val(chaine,nombre,err);
               if err=0 then nbPtsSomme:=nbPtsSomme+round(nombre)
                        else drapeauNB:=false;
               end
               else drapeauNB:=false;

        for j:=0 to und.spect[1].x-1 do
         begin
         und.spect[1].data[j,0].z:=und.spect[1].data[j,0].z+und.spect[i+4].data[j,0].z;
         und.spect[1].data[j,0].mon:=und.spect[1].data[j,0].mon+und.spect[i+4].data[j,0].mon;
         end;
        end;
      if drapeauNB=true then und.spect[1].comment:='SOMME NB='+inttostr(nbPtsSomme);
      end;
end;
{***************************************************}
procedure Tdataeditform.sauveFormatNMR(nom:string);
   {sauve le fichier nom (qui apparait dans la combobox), qu'on sauve sous
   la syntaxe : exple : Echo devient c:\newspectro\data\Echantillon\EchantillonEcho5.spe
    }
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine,chaine2:string;
    i,j,err,pile_NMR:integer;
begin


 if und.indexof(nom)<>-1 then {on ne fait la sauvegarde que si nom existe}
 begin

   {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire
   exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}
   nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19);
   {lecture de la pile, c.a.d du numero du dernier fichier sauv}
   assignfile(fich,directory_NMR+'\info.txt');
   reset(fich);
   readln(fich,directory_NMR);
   readln(fich,pile_NMR);
   closefile(fich);

   {on incremente la pile}
   pile_NMR:=pile_NMR+1;
   str(pile_NMR,chaine);
   {on verifie que le fichier n'a pas dj une forme du genre DirEcho12.spe
   si c'est le cas, au lieu de l'appeler DirDirEcho1213, on l'appelle juste
   DirEcho13. }
    chaine2:=nom;
    if (copy(chaine2,1,length(nomFichier))=nomFichier) then
      begin
      {on enleve dans ce cas le nombre  droite et le nom du dir  gauche}
      repeat
          val(copy(chaine2,length(chaine2),1),j,err);
          if err=0 then chaine2:=copy(chaine2,1,length(chaine2)-1);
      until (err<>0);
      nomFichier:=chaine2+chaine;
      end
                                 else
      begin
      nomFichier:=nomFichier+nom+chaine;
      end;
      ChDir(directory_NMR); {specifie le repertoire de travail}
      und.spect[und.indexof(nom)].savetofile(nomFichier); {c'est dans savetofile
      qu'il ajoute .spe}

      {on reecrit le info.txt pour reactualiser la pile}
      assignfile(fich,directory_NMR+'\info.txt');
      rewrite(fich);
      writeln(fich,directory_NMR);
      writeln(fich,pile_NMR);
      closefile(fich);

      {on transfere le spectre sauv dans 1 qu'on appelle par le nom sauv
      sauf si ce nom sauv est le meme que le nom de dpart (peu probable)}
      if und.spect[1].nom<>nomFichier then
         begin
        {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
         qui va etre celui sauvegard ici}
         DecaleSpectres;
         {on met le spectre qu'on vient de sauver en 1 sauf si il y est deja}
         if und.spect[1].nom<>nom then transfertspectre(und.indexof(nom),1);
         {on l'appelle par le nouveau nom du fichier sauvegard}
         und.spect[1].nom:=nomFichier;
         end;

 end;
end;
{***************************************************}
procedure TDataEditForm.ForceSauvegardeECHO(nom:string);
   {sauve le fichier en n2 de la serie des spectres,  priori l'echo
    sous la syntaxe c:\newspectro\data\Echantillon\EchantillonEcho5.spe}
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine,chaine2:string;
    indice,i,j,err,pile_NMR:integer;
begin

   {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire
   exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}

   {lecture de la pile, c.a.d du numero du dernier fichier sauv}
   assignfile(fich,directory_NMR+'\info.txt');
   reset(fich);
   readln(fich,directory_NMR);
   readln(fich,pile_NMR);
   closefile(fich);

   {on incremente la pile}
   pile_NMR:=pile_NMR+1;
   str(pile_NMR,chaine);

   nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19)+'ECHO'+chaine;

   ChDir(directory_NMR); {specifie le repertoire de travail}
   und.spect[2].savetofile(nomFichier);
   {c'est dans savetofile qu'il ajoute .spe}

   {on reecrit le info.txt pour reactualiser la pile}
   assignfile(fich,directory_NMR+'\info.txt');
   rewrite(fich);
   writeln(fich,directory_NMR);
   writeln(fich,pile_NMR);
   closefile(fich);

   transfertspectre(und.indexof(nom),1);

   {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
   qui va etre celui sauvegard ici}
   DecaleSpectres;

end;
{***************************************************}
procedure Tdataeditform.sauveFormatStandard(nom,nom2:string;decalement:boolean);
   {sauve le fichier nom (qui apparait dans la combobox) en
    c:\newspectro\data\Echantillon\nom2.spe
    si decalement est  true il dcale avant de sauver les spectres donc on n'efface
    rien en sauvant. Si decalement est  false, il ne decale pas donc on remplace
    le premier spectre de la liste}
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine,chaine2:string;
    i,j,err,pile_NMR:integer;
begin
   {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire
   exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}
   nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19);
   {lecture de la pile, c.a.d du numero du dernier fichier sauv}
   assignfile(fich,directory_NMR+'\info.txt');
   reset(fich);
   readln(fich,directory_NMR);
   readln(fich,pile_NMR);
   closefile(fich);
   ChDir(directory_NMR); {specifie le repertoire de travail}
   und.spect[und.indexof(nom)].savetofile(nom2); {c'est dans savetofile
   qu'il ajoute .spe}
   {on n'incremente pas la pile}

   {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
   qui va etre celui sauvegard ici}
   if decalement=true then DecaleSpectres;
   {on ne reecrit pas le info.txt car pile inchange}
   if und.indexof(nom)<>1 then transfertspectre(und.indexof(nom),1);
   und.spect[1].nom:=nom2;
end;
{***************************************************}
procedure Tdataeditform.recallNMR(NumeroFichier:string);
{si NumeroFichier est un nombre (exple:13) il rappelle
le fichier directoryECHO13.spe ou directoryTF13.spe dans c:\newspectro\data\directory\
si NumeroFichier n'est pas un nombre (exple:NAME) il rappelle
le fichier NAME.spe dans c:\newspectro\data\directory\}
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine,nomAComparer:string;
    i,err,pile_NMR:integer;drapeau:boolean;
begin

   {on retrouve d'abord le directory de travail, dont le nom se trouve
        dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire
   exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}
   chDir(directory_NMR);
   val(NumeroFichier,i,err);
   if err<>0 then nomFichier:=numeroFichier+'.spe';
   if err=0 then nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19)+'ECHO'+NumeroFichier+'.spe';
   if not(fexis(nomFichier)) then
         nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19)+'TF'+NumeroFichier+'.spe';
   if not(fexis(nomFichier)) then
         nomFichier:=copy(directory_NMR,20,length(directory_NMR)-19)+'SOMME'+NumeroFichier+'.spe';

   if fexis(nomFichier) then
      begin
      {si le fichier existe deja dans la liste en dehors de la position 1,
      on le renomme en ajoutant * (puis ** puis ***...). Si il est en 1, on le remplace par le nouveau}
      if (und.indexof(copy(nomFichier,1,length(nomFichier)-4))<>-1) then
                begin
                  drapeau:=false;
                  nomAcomparer:=copy(nomFichier,1,length(nomFichier)-4)+'******************************';
                  repeat
                    if (und.indexof(nomAcomparer)<>-1) then
                                                       begin
                                                       und.spect[und.indexof(nomAcomparer)].nom:=
                                                           und.spect[und.indexof(nomAcomparer)].nom+'*';
                                                       end;
                    if copy(nomAcomparer,length(nomAcomparer),1)<>'*' then Drapeau:=true;
                    nomAComparer:=copy(nomAComparer,1,length(nomAComparer)-1);
                  until (drapeau=true);
                end;
     {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
      qui va etre celui sauvegard ici}
       DecaleSpectres;

      und.spect[1].readfromfile(directory_NMR+'\'+nomFichier);
      und.spect[1].nom:=copy(nomFichier,1,length(nomFichier)-4);
      end
                            else
        {cas ou TF et Echo n'existent pas}
      begin
        MessageDlg('The file does not exist', mtWarning, [mbOk], 0);
     end;
end;
{***************************************************}
procedure TDataEditForm.recallASCII(NomFichier:string);
var fich:textfile;xx,yy,zz:extended;
    directory_NMR,chaine,nomAComparer:string;
    i,err,pile_NMR,nbpoints:integer;drapeau:boolean;
begin
   {on retrouve d'abord le directory de travail, dont le nom se trouve dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire
   exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}
   chDir(directory_NMR);
   {lecture du fichier ascii suppos sur trois colonnes separees par espace ou tab:
   temps ou freq    Partie reelle   Partie Imaginaire}

   {si il n'y a pas d'extension, on teste l'extension .txt ou .asc ou .dat ou sans
   extension}
   if fexis(NomFichier+'.dat') then NomFichier:=NomFichier+'.dat';
   if fexis(NomFichier+'.asc') then NomFichier:=NomFichier+'.asc';
   if fexis(NomFichier+'.txt') then NomFichier:=NomFichier+'.txt';
   if fexis(NomFichier+'.') then NomFichier:=NomFichier+'.';

   if fexis(NomFichier) then
     begin
     {on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
      qui va etre celui sauvegard ici depuis le fichier ASCII}
       DecaleSpectres;
       und.spect[1].nom:=copy(nomFichier,1,pos('.',nomFichier)-1);
       und.Spect[1].X:=1;
       und.spect[1].comment:='RMN from ascii';
       und.spect[1].typex:='rmn';
       und.spect[1].typey:='single';
       assignfile(fich,NomFichier);
       reset(fich);
       nbPoints:=0;
       while not eof(Fich) do
         begin
         readln(Fich,xx,yy,zz);
         und.spect[1].data[nbPoints,0].x:=xx;
         und.spect[1].data[nbPoints,0].z:=yy;
         und.spect[1].data[nbPoints,0].mon:=zz;
         nbPoints:=nbPoints+1;
         und.Spect[1].X:=und.Spect[1].X+1;
         end;
         und.Spect[1].X:=und.Spect[1].X-1;
     end
                                 else
        {cas ou le fichier n'existe pas}
      begin
        MessageDlg('The file does not exist in the current directory', mtWarning, [mbOk], 0);
      end;


end;

{***************************************************}
procedure Tdataeditform.DecaleSpectres;
var i,j,k,l:integer;
{on decale tous les spectres sauf 2,3,4 pour laisser la place au premier
   qui va etre celui sauvegard ou rappel}
begin

{nombre de fichiers maxi dans la
   spectliste RMN = totalspectre}
   i:=4;
   while (und.spect[i]<>nil) and (i<=totalspectre) do i:=i+1;
   if i>totalspectre then i:=totalspectre;
   if (und.spect[1].nom<>'DATA')  then
      begin
        if (i-1)=totalspectre then i:=totalspectre;
        for j:=i-1 downto 5 do TransfertSpectre(j,j+1);
        TransfertSpectre(1,5);
      end;
end;
{***************************************************}
procedure Tdataeditform.TransfertSpectre(NumSource,NumDestine:integer);
{procedure  ne pas utiliser d'ailleurs que depuis DecaleSpectres et
RecallNMR}

var NomTemporaire:string;
var indiceDestine,i,k,l:integer;
begin

if und.spect[NumSource]<>nil then {si numsource existe}
 begin{on efface ce qu'il y a en Numdestine pour laisser la place}
 if und.spect[NumDestine]<>nil then und.deletespectre(NumDestine);
 {ensuite on cree un spectre de la meme taille que NumSource, qui va l'accueillir,
 et qui se met en NumDestine}
 if und.spect[NumDestine]=nil then
   begin
   und.addspectre('NOMTEMPORAIRE',und.spect[NumSource].X,und.spect[NumSource].Y);
   indiceDestine:=und.indexof('NOMTEMPORAIRE');
   end
                         else
   IndiceDestine:=NumDestine;

 if und.spect[NumSource]<>nil then
   begin
   {qd numsource existe, il le transfert dans numdestine}
   und.spect[indicedestine].nom:=und.spect[NumSource].nom;
   und.spect[indicedestine].X:=und.spect[NumSource].X;
   und.spect[indicedestine].Y:=und.spect[NumSource].Y;
   und.spect[indicedestine].comment:=und.spect[NumSource].comment;
   und.spect[indicedestine].typeX:=und.spect[NumSource].typeX;
   und.spect[indicedestine].typeY:=und.spect[NumSource].typeY;
   und.spect[indicedestine].indexX:=und.spect[NumSource].indexX;
   und.spect[indicedestine].indexY:=und.spect[NumSource].indexY;
   for k:=0 to und.spect[indicedestine].X-1 do
     for l:=0 to und.spect[indicedestine].Y-1 do
      und.spect[indicedestine].data[k,l]:=und.spect[NumSource].data[k,l];
   end
 end;

if und.spect[NumSource]=nil then {si numsource n'existe pas}
   begin
   {si numsource n'existe pas il remplit le spectre bidon avec des valeurs bidons}
   if und.spect[NumDestine]<>nil then und.deletespectre(NumDestine);
   und.addspectre('NOMTEMPORAIRE',4096,1);
   indiceDestine:=und.indexof('NOMTEMPORAIRE');
   und.spect[indicedestine].nom:='TEMPORAIRE'+inttostr(NumDestine);
   und.spect[indicedestine].X:=4096;
   und.spect[indicedestine].Y:=1;
   und.spect[indicedestine].comment:='';
   und.spect[indicedestine].typeX:='rmn';
   und.spect[indicedestine].typeY:='single';
   for k:=0 to und.spect[indicedestine].X-1 do
     for l:=0 to und.spect[indicedestine].Y-1 do
      begin
      und.spect[indicedestine].data[k,l].x:=k;
      und.spect[indicedestine].data[k,l].z:=0;
      und.spect[indicedestine].data[k,l].mon:=0;
      end;
   end;

end;
{***************************************************}
procedure Tdataeditform.AddAndReplace(nomAAjouter,nomOuSauver:string;DrapeauInitialisation:boolean);
{AddAndReplace(ECHO,NOM) : rappelle NOM.spe, lui ajoute ECHO, et resauve
dans NOM.spe. Si NOM.spe n'existe pas, sauve ECHO dans NOM.spe. Si ECHO n'existe pas, ne fait rien
si DrapeauInitialisation=true on initialise  0  avant d'ajouter ECHO
NE DECALE PAS LA LISTE DE SPECTRES donc remplace le premier des spectres par NOM}
var nomFichier:string;
    fich:textfile;
    directory_NMR,chaine:string;
    i,j,indice1,indice2,err,pile_NMR:integer;
begin
   {on retrouve d'abord le directory de travail, dont le nom se trouve dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   {on extrait ensuite le nom du repertoire exple : depuis c:\newspectro\data\mesdatas, on extrait mesdatas}
   chDir(directory_NMR);
   {on repere si le fichier nomOuSauver existe deja}
   nomfichier:=nomOuSauver;
   if fexis(nomFichier+'.spe') then
                        begin  {si il existe, on le rappelle, on y ajoute celui
                        de nomAAjouter, puis on le resauve}
                        recallNMR(nomFichier); {si il existe, on le rappelle,
                                                    il va se mettre en indice 1}
                        indice1:=und.indexof(nomFichier);
                        indice2:=und.indexof(nomAAjouter);
                        if indice2>0 then {si nomAAjouter n'existe pas: on
                        ne fait rien}
                          begin
                           if (und.spect[indice1].x=und.spect[indice2].x) then
                           begin
                             for j:=0 to und.spect[indice1].x-1 do
                              begin
                               if DrapeauInitialisation=true then
                                  begin
                                  und.spect[indice1].data[j,0].z:=und.spect[indice2].data[j,0].z;
                                  und.spect[indice1].data[j,0].mon:=und.spect[indice2].data[j,0].mon;
                                  end
                                                        else
                                  begin
                                 und.spect[indice1].data[j,0].z:=und.spect[indice1].data[j,0].z
                                        +und.spect[indice2].data[j,0].z;
                                 und.spect[indice1].data[j,0].mon:=und.spect[indice1].data[j,0].mon
                                        +und.spect[indice2].data[j,0].mon;
                                  end;
                              end;
                           end;
                          end;
                        {on resauve nomOuSauver : on le sauve en 1, en ecrasant le precedent,
                        sans redecaler tous les spectres, d'ou le false en argument}
                        sauveformatstandard(nomOuSauver,nomOuSauver,false);
                        end
                        else {si nomOuSauver n'existe pas, on sauve nomAAjouter dedans en le
                        creant, a la condition que nomAAjouter existe}
                        if und.indexof(nomAAjouter)>0 then sauveFormatStandard(nomAAjouter,nomOuSauver,true);

end;
{***************************************************}
procedure Tdataeditform.sauveASCII(chaine:string);
{sauve en ASCII .
chaine a le format ascii[nomSpectreASauver,nomOuSauver,A] : sauve la voie A slt (.z)
ascii[nomSpectreASauver,nomOuSauver,B] idem mais B slt (.mon)
ascii[nomSpectreASauver,nomOuSauver] idem les deux voies
ascii[15,22,36,38,nomOuSauver,A] idem multicolonnes contenant les spectres 15,22,36,38
(ATTENTION, VERIFIER QU'iLS ONT LES MES COORDONNEES X}
var nom,nomousauver,nomFichier:string;
    nomFichier2:array[1..20] of string;
    fich:textfile;
    directory_NMR,chaine2,chaine3:string;
    i,j,pile_NMR,voieASauver:integer;
begin
   dataeditform.TraitementCommande(chaine,intervalle,NbreNombres,NbreChaines,TableauNombres,TableauChaines);

   {on retrouve d'abord le directory de travail, dont le nom se trouve
    dans current.txt}
   assignfile(fich,'c:\NewSpectro\data\current.txt');
   reset(fich);
   readln(fich,directory_NMR);
   closefile(fich);
   ChDir(directory_NMR); {specifie le repertoire de travail}

   VoieASauver:=0;

   {cas de la syntaxe ascii(nomSpectre,nomOuSauver,A) ou ascii(nomSpectre,nomOuSauver) ou ascii(nomSpectre,A)}
   if NbreNombres=0 then
      begin
      nom:=TableauChaines[1];
      if (TableauChaines[2]<>'A') and (TableauChaines[2]<>'B') and  (TableauChaines[2]<>'') then
                                          nomOuSauver:=TableauChaines[2]
                                          else
                                          nomOuSauver:=nom;
      if (TableauChaines[2]='A') or (TableauChaines[3]='A') then VoieASauver:=1;
      if (TableauChaines[2]='B') or (TableauChaines[3]='B') then VoieASauver:=2;
      {rappelle le fichier si il n'est pas deja rappel}
      if und.indexof(nom)=-1 then recallNMR(nom);
      end;

   {cas de la syntaxe ascii(18,nomOuSauver,A) ou ascii(18,A)}
   if (NbreNombres=1)  then
      begin
      recallNMR(inttostr(round(TableauNombres[1])));
      nom:=und.spect[1].nom;
      if (TableauChaines[1]<>'A') and (TableauChaines[1]<>'B') and  (TableauChaines[1]<>'') then
                                          nomOuSauver:=TableauChaines[1]
                                          else
                                          nomOuSauver:=nom;
      if (TableauChaines[1]='A') or (TableauChaines[2]='A') then VoieASauver:=1;
      if (TableauChaines[1]='B') or (TableauChaines[2]='B') then VoieASauver:=2;
      end;

   if (NbreNombres=0) or (NbreNombres=1) then
   begin
   {conversion ascii pour les deux syntaxes precedentes}
      nomFichier:=nomOuSauver+'.dat';
      assignfile(fich,directory_NMR+'\'+nomFichier);
      rewrite(fich);
      {ecriture de la premiere ligne : nom des colonnes}
      chaine3:=nom;
      for j:=1 to length(chaine3) do if copy(chaine3,j,1)=' '
               then chaine3:=copy(chaine3,1,j-1)+'_'+copy(chaine3,j+1,length(chaine3)-j);

      if pos('ECHO',chaine3)>0 then writeln(fich,'time ',chaine3)
         else begin
              if  pos('TF',chaine3)>0 then writeln(fich,'freq ',chaine3)
                                  else writeln(fich,'X ',chaine3);
              end;
      {ecriture des lignes suivantes}
      for i:=0 to und.spect[und.indexof(nom)].X-1 do
        begin
        if voieASauver=1 then writeln(fich,und.spect[und.indexof(nom)].data[i,0].x,' ',
         und.spect[und.indexof(nom)].data[i,0].z);
        if voieASauver=2  then writeln(fich,und.spect[und.indexof(nom)].data[i,0].x,' ',
         und.spect[und.indexof(nom)].data[i,0].mon);
        if (voieASauver<>1) and (voieASauver<>2) then  writeln(fich,und.spect[und.indexof(nom)].data[i,0].x,' ',
        und.spect[und.indexof(nom)].data[i,0].z,' ',und.spect[und.indexof(nom)].data[i,0].mon);
        end;
      closefile(fich);
   end;

   {cas de la syntaxe ascii(18,22,25,nomOuSauver,A)}
   if NbreNombres>1 then
      begin
      nomOuSauver:=TableauChaines[1];
      nomFichier:=nomOuSauver+'.dat';
      assignfile(fich,directory_NMR+'\'+nomFichier);
      rewrite(fich);
      if (TableauChaines[2]='A') then VoieASauver:=1;
      if (TableauChaines[2]='B') then VoieASauver:=2;
     {cas de ascii(18,22,25,nomOuSauver,A)}
     chaine2:='';
      for i:=1 to nbreNombres do
              begin
              recallNMR(inttostr(round(TableauNombres[i])));
              chaine3:=und.spect[1].nom;
              nomFichier2[i]:=chaine3;
              for j:=1 to length(chaine3) do if copy(chaine3,j,1)=' '
                      then chaine3:=copy(chaine3,1,j-1)+'_'+copy(chaine3,j+1,length(chaine3)-j);
              if (voieASauver=2) or (voieASauver=1) then chaine2:=chaine2+chaine3+' '
                   else chaine2:=chaine2+chaine3+'A '+chaine3+'B ';
              end;
      {ecriture de la premiere ligne : nom des colonnes}
      if pos('ECHO',chaine3)>0 then chaine2:='time '+chaine2
                       else begin
                            if  pos('TF',chaine3)>0 then chaine2:='freq '+chaine2
                                                else chaine2:='X '+chaine2;
                            end;
      writeln(fich,chaine2);
      for i:=0 to und.spect[1].X-1 do
            begin
            write(fich,und.spect[1].data[i,0].x,' ');
            for j:=1 to nbreNombres do
                begin
                if voieASauver=1 then write(fich,und.spect[und.indexof(nomFichier2[j])].data[i,0].z,' ');
                if voieASauver=2 then write(fich,und.spect[und.indexof(nomFichier2[j])].data[i,0].mon,' ');
                if voieASauver=0 then write(fich,und.spect[und.indexof(nomFichier2[j])].data[i,0].z,' ',
                                           und.spect[und.indexof(nomFichier2[j])].data[i,0].mon);
                end;
                writeln(fich,' ');
            end;
      end;
end;
{***************************************************}
procedure TDataeditform.Normalise(nom:string;valeur:extended);
var i:integer;
begin
   if valeur<>0 then
   begin
   for i:=0 to und.spect[und.indexof(nom)].X-1 do
       begin
         und.spect[und.indexof(nom)].data[i,0].z:=und.spect[und.indexof(nom)].data[i,0].z/valeur;
         und.spect[und.indexof(nom)].data[i,0].mon:=und.spect[und.indexof(nom)].data[i,0].mon/valeur;
       end;
   end
      else
   MessageDlg('you cannot divide by zero', mtWarning, [mbOk], 0);

end;
{***************************************************}
procedure TDataeditForm.SoustraitBackground(nom:string);
{soustrait un background calcul sur la fin du data au data de nom "nom" ou bien
au data dirECHO3 si nom est le numero ici 3}
var indiceStart,indiceFinish,i,err,err2,indice:integer;
    ch1,nom2:string;
    sommeA,sommeB:extended;
    drapeauErreur,drapeau:boolean;
begin
 {on rappelle le fichier sauf si nom est deja dans la liste}
 indice:=und.indexof(nom);
 if indice=-1 then begin recallNMR(nom);indice:=1;end;
 sommeA:=0;sommeB:=0;
 {bornes de l'integrale : si N points, de 3/4 N  N-1}
 indiceStart:=round(und.spect[indice].X*3/4);
 indiceFinish:=und.spect[indice].X-1;
 for i:=IndiceStart to IndiceFinish do
                       begin
                        sommeA:=sommeA+und.spect[indice].data[i,0].z;
                        sommeB:=sommeB+und.spect[indice].data[i,0].mon;
                       end;
 sommeA:=sommeA/(IndiceFinish-IndiceStart+1);
 sommeB:=sommeB/(IndiceFinish-IndiceStart+1);
 for i:=0 to und.spect[indice].X-1 do
                       begin
                        und.spect[indice].data[i,0].z:=und.spect[indice].data[i,0].z-sommeA;
                        und.spect[indice].data[i,0].mon:=und.spect[indice].data[i,0].mon-sommeB;
                       end;
 {le background est soustrait}
end;
{***************************************************}
function Tdataeditform.Integ(nom:string;Voie,Start,Finish:real):real;
{integre nom entre Start et Finish (nom qui apparait dans la combobox)
Voie = 1 ou 2 indique si on integre .z ou .mon (reel ou imaginaire)
si nom est un numro, c'est la syntaxe habituelle, dirECHO10, dirTF10...
renvoie -999 si il y a une erreur}
var indiceStart,indiceFinish,i,err,err2,indice:integer;
    directory_NMR,nom2:string;
    somme:real;
    drapeauErreur,drapeau:boolean;
begin

 somme:=0;
 val(nom,i,err);
 if err=0 then {cas ou nom est un chiffre : on identifie l'indice correspondant}
            begin
            {on retrouve le nom du fichier correspondant si il existe}
             i:=0;
             repeat
                nom2:=und.spect[i].nom;
                repeat
                  nom2:=copy(nom2,2,length(nom2)-1);
                  val(nom2,i,err2);
                until (err2=0) or (nom2='');
                i:=i+1;
             until (nom2<>'');
             indice:=i-1;
            end;
 if err<>0 then indice:=und.indexof(nom); {cas ou nom n'est pas un chiffre}

 drapeauErreur:=false;
 if indice=-1 then drapeauErreur:=true;
 if indice>0 then
   begin
   {recherche position borne inf integrale}
   i:=0;drapeau:=false;
   repeat
     if (Start>=und.spect[indice].Data[i,0].x) and (Start<und.spect[indice].Data[i+1,0].x)
            then drapeau:=true;
     i:=i+1;
   until (i=und.spect[indice].X-2) or (drapeau=true);
   if drapeau=false then drapeauErreur:=true {on n'a pas trouv la borne}
                   else
                   begin                      {on a trouv la borne}
                   IndiceStart:=i-1;
                   {recherche position borne sup integrale}
                   i:=IndiceStart+1; drapeau:=false;
                   repeat
                         if (Finish>=und.spect[indice].Data[i,0].x) and (Finish<und.spect[indice].Data[i+1,0].x)
                              then drapeau:=true;
                         i:=i+1;
                   until (i=und.spect[indice].X-2) or (drapeau=true);
                   if drapeau=false then drapeauErreur:=true
                                    else IndiceFinish:=i-1;
                   end;
   if DrapeauErreur=false then
                   begin
                   somme:=0;
                   for i:=IndiceStart to IndiceFinish do
                       begin
                       if Voie=1 then somme:=somme+und.spect[indice].data[i,0].z
                                 else somme:=somme+und.spect[indice].data[i,0].mon;
                       end;
                   end;
   end;
   if DrapeauErreur=true then somme:=-999;
   Integ:=somme;
end;
{***************************************************}
function Tdataeditform.IntegNorm(nom:string;Voie,Start,Finish:real):real;
{integre nom entre Start et Finish et divise par la largeur de l'intervalle (nom qui apparait dans la combobox)
Voie = 1 ou 2 indique si on integre .z ou .mon (reel ou imaginaire)
si nom est un numro, c'est la syntaxe habituelle, dirECHO10, dirTF10...
renvoie -999 si il y a une erreur}
var indiceStart,indiceFinish,i,err,err2,indice:integer;
    directory_NMR,nom2:string;
    somme:real;
    drapeauErreur,drapeau:boolean;
begin

 somme:=0;
 val(nom,i,err);
 if err=0 then {cas ou nom est un chiffre : on identifie l'indice correspondant}
            begin
            {on retrouve le nom du fichier correspondant si il existe}
             i:=0;
             repeat
                nom2:=und.spect[i].nom;
                repeat
                  nom2:=copy(nom2,2,length(nom2)-1);
                  val(nom2,i,err2);
                until (err2=0) or (nom2='');
                i:=i+1;
             until (nom2<>'');
             indice:=i-1;
            end;
 if err<>0 then indice:=und.indexof(nom); {cas ou nom n'est pas un chiffre}

 drapeauErreur:=false;
 if indice=-1 then drapeauErreur:=true;
 if indice>0 then
   begin
   {recherche position borne inf integrale}
   i:=0;drapeau:=false;
   repeat
     if (Start>=und.spect[indice].Data[i,0].x) and (Start<und.spect[indice].Data[i+1,0].x)
            then drapeau:=true;
     i:=i+1;
   until (i=und.spect[indice].X-2) or (drapeau=true);
   if drapeau=false then drapeauErreur:=true {on n'a pas trouv la borne}
                   else
                   begin                      {on a trouv la borne}
                   IndiceStart:=i-1;
                   {recherche position borne sup integrale}
                   i:=IndiceStart+1; drapeau:=false;
                   repeat
                         if (Finish>=und.spect[indice].Data[i,0].x) and (Finish<und.spect[indice].Data[i+1,0].x)
                              then drapeau:=true;
                         i:=i+1;
                   until (i=und.spect[indice].X-2) or (drapeau=true);
                   if drapeau=false then drapeauErreur:=true
                                    else IndiceFinish:=i-1;
                   end;
   if DrapeauErreur=false then
                   begin
                   somme:=0;
                   for i:=IndiceStart to IndiceFinish do
                       begin
                       if Voie=1 then somme:=somme+und.spect[indice].data[i,0].z
                                 else somme:=somme+und.spect[indice].data[i,0].mon;
                       end;
                   somme:=somme/abs(indiceFinish-indiceStart+1);
                   end;
   end;

   if DrapeauErreur=true then somme:=-999;
   IntegNorm:=somme;
end;
{***************************************************}
function TDataEditForm.IntegEcho(nom:string;Start,Finish,bgdStart,bgdFinish:real;voieSigne:real):real;
{integre l'echo contenu dans nom (partie reelle en .z et im en .mon)
selon la formule IntegEcho=sqrt( (integrale entre Start et Finish de voie 1 apres
soustraction de bgd pris entre bgdStart et bgdFinish)^2+(idem voie 2)^2 ))
en multipliant par un signe choisi par dfaut comme le signe de l'integrale de la partie reelle
(voieSigne=1) ou imaginaire (voieSigne=2). Si voieSigne=0, garde l'integrale telle quelle.
si nom est un numro, c'est la syntaxe habituelle, dirECHO10, dirTF10...
renvoie -999 si il y a une erreur}
var total,somme1,somme2,sommebgd1,sommebgd2:real;
    drapeauErreur:boolean;   nbcanaux:real;signe:real;
begin

 DrapeauErreur:=false;
 somme1:=Integ(nom,1,Start,Finish);
 if somme1=-999 then DrapeauErreur:=true;
 somme2:=Integ(nom,2,Start,Finish);
 if somme2=-999 then DrapeauErreur:=true;
 if bgdStart=bgdFinish then sommebgd1:=0
                       else sommebgd1:=IntegNorm(nom,1,bgdStart,bgdFinish);
 if sommebgd1=-999 then DrapeauErreur:=true;
 if bgdStart=bgdFinish then sommebgd2:=0
                       else sommebgd2:=IntegNorm(nom,2,bgdStart,bgdFinish);
 if sommebgd2=-999 then DrapeauErreur:=true;

 if DrapeauErreur=false then
    begin
     nbcanaux:=somme1/IntegNorm(nom,1,Start,Finish);
     {soustraction du bgd}
     somme1:=somme1-sommebgd1*nbcanaux;
     somme2:=somme2-sommebgd2*nbcanaux;
     {calcul final}
     total:=sqrt(somme1*somme1+somme2*somme2);
     {signe + ou - selon signe de l'aire de la voie voieSigne ou bien n'y touche pas
     si VoieSigne<>1 ou 2}
     if (VoieSigne=1) or (VoieSigne=2) then
                    begin
                    signe:=+1;
                    if (voieSigne=1) and (somme1<>0) then signe:=abs(somme1)/somme1;
                    if (voieSigne=2) and (somme2<>0) then signe:=abs(somme2)/somme2;
                    total:=total*signe;
                    end;
    end;

 if DrapeauErreur=true then total:=-999;
 IntegEcho:=total;

end;
{***************************************************}
procedure TDataEditForm.DoSmoothingCurve(nom:string;NbPointsDansEchantillon,DegreeSmoothing:integer);
{fait un smoothing du data dans nom}

type Tableau=array [1..32768] of extended;

var i,j,NbPointsTotal,DegreFiltre:integer;
var xxx,yyy,zzz:array[1..100] of extended;
    moyenAbscisse:extended;
    Xtemp,Ytemp,Ztemp:^Tableau;

begin

if und.indexof(nom)<>-1 then {on fait la TF seulement si nom existe}
 begin
 DegreFiltre:=DegreeSmoothing;
 new(Xtemp);new(Ytemp);new(Ztemp);
 NBPointsTotal:=und.spect[und.indexof(nom)].x;
 for i:=NbPointsDansEchantillon to (NbPointsTotal-NbPointsDansEchantillon) do
    begin
    moyenAbscisse:=0;
    for j:=1 to NbPointsDansEchantillon do
        begin
        xxx[j]:=und.spect[und.indexof(nom)].data[i+j-round(NbPointsDansEchantillon/2)-1-1,0].x;
        yyy[j]:=und.spect[und.indexof(nom)].data[i+j-round(NbPointsDansEchantillon/2)-1-1,0].z;
        zzz[j]:=und.spect[und.indexof(nom)].data[i+j-round(NbPointsDansEchantillon/2)-1-1,0].mon;
        moyenAbscisse:=moyenAbscisse+und.spect[und.indexof(nom)].data[i+j-round(NbPointsDansEchantillon/2)-1-1,0].x;
        end;
{    Xtemp^[i]:=moyenAbscisse/NbPointsDansEchantillon;}
    Xtemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].x;
    Ytemp^[i]:=SmoothingPart(xxx,yyy,DegreFiltre,NbPointsDansEchantillon);
    Ztemp^[i]:=SmoothingPart(xxx,zzz,DegreFiltre,NbPointsDansEchantillon);
    end;
 for i:=1 to (NbPointsDansEchantillon-1) do
    begin
    Xtemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].x;
    Ytemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].z;
    Ztemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].mon;
    end;
 for i:=NbPointsTotal-NbPointsDansEchantillon+1 to NbPointsTotal do
    begin
    Xtemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].x;
    Ytemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].z;
    Ztemp^[i]:=und.spect[und.indexof(nom)].data[i-1,0].mon;
    end;
 for i:=1 to NbPointsTotal do
     begin
     und.spect[und.indexof(nom)].data[i-1,0].x:=Xtemp^[i];
     und.spect[und.indexof(nom)].data[i-1,0].z:=Ytemp^[i];
     und.spect[und.indexof(nom)].data[i-1,0].mon:=Ztemp^[i];
     end;
 dispose(Xtemp);dispose(Ytemp);dispose(Ztemp);

 end;
end;

{*******************************************************}
function TDataEditForm.SmoothingPart(xxx,yyy:array of extended;FiltreN:integer;TailleXXX:integer):extended;
{donne l'integrale moyenne sur le data xxx,yyy constitu de tailleXXX pts,
avec filtre au degr FiltreN}
const nnn=100;
var n,Idegree,h:integer;
    integr,s,sa,sb,ac,cn,sh,sx,sy,x,y,inter:extended;nData,m,i,j:integer;
    DD:array[1..nnn+1,1..nnn+1] of extended; {1..n+1}
    CC:array[0..nnn] of extended;  {0..n}
    PP:array[0..nnn+1,1..nnn] of extended; {0..n+1,1..NData}
    IPP:array[0..nnn] of extended; {0..n}

begin
Idegree:=0;
n:=FiltreN;
Ndata:=TailleXXX;
m:=round(Ndata/2);
inter:=0;
sx:=0;sy:=0;
for i:=1 to NData do
    begin
    PP[0,i]:=1;
    sx:=sx+xxx[i-1]; {xxx numerot ici depuis 0}
    sy:=sy+yyy[i-1];
    end;
DD[1,1]:=sx/NData;    CC[0]:=sy/NData;
for j:=1 to n do
    begin
    ac:=0;cn:=0;
    for i:=1 to NData do
        begin
        sh:=0;
        for h:=1 to j do
            begin
            sh:=sh+DD[h,j]*PP[h-1,i];
            end;

        if xxx[i-1]<0 then PP[j,i]:=-sh-exp(j*ln(-xxx[i-1])); {attention, pb si X<0,  vrifier}
        if xxx[i-1]=0 then PP[j,i]:=-sh+1;
        if xxx[i-1]>0 then PP[j,i]:=-sh+exp(j*ln(xxx[i-1]));
        ac:=ac+sqr(PP[j,i]);
        cn:=cn+yyy[i-1]*PP[j,i];
        end;
    CC[j]:=cn/ac;
    for h:=1 to j+1 do
        begin
        sa:=0;sb:=0;
        for i:=1 to NData do
            begin
            if xxx[i-1]>0 then sa:=sa+exp((j+1)*ln(xxx[i-1]))*PP[h-1,i];
            if xxx[i-1]<0 then sa:=sa-exp((j+1)*ln(-xxx[i-1]))*PP[h-1,i];
            if xxx[i-1]=0 then sa:=sa+1*PP[h-1,i];
            sb:=sb+sqr(PP[h-1,i]);
            end;
        DD[h,j+1]:=sa/sb;
        end;
    end;
If IDegree=0 then
    begin
    S:=0;
    for j:=0 to n do s:=s+CC[j]*PP[j,m+1];
    Integr:=s;
    end;

SmoothingPart:=Integr;
end;

{*******************************************************}


end.
