unit SeqNewHetero;
{sequenceur pour new spectro hetero 2003}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, Buttons,ExtCtrls, xyGraph,  ComCtrls, Spin,  ToolWin,
  math, EditReal,editdata,DrapeauAlloulUnit, Comrs232;


const
  ntemps=20;
  nampli=10;
  nphase=10;

type
  TSeqNewHeteroForm = class(TForm)
    listseqpar: TStringGrid;
    EditSeq: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Stop: TBitBtn;
    Start: TButton;
    Status: TLabel;
    SansRafraichissement: TCheckBox;
    ModeAcquisitionStandard: TCheckBox;
    NomSequenceRMN: TLabel;
    openbutton: TButton;
    saveButton: TButton;
    CommPortNewHetero: TCommPortDriver;
    Label1: TLabel;
    Button4: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    Button5: TButton;
    TableauSignesReception: TStringGrid;
    Label7: TLabel;
    Label8: TLabel;
    Sequences: TComboBox;
    editseqnoncompiled: TMemo;
    Label9: TLabel;
    procedure ouverture;
    procedure initialisation;
    procedure Sauver1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure StartSequenceur;
    procedure RestartSequenceur;
    procedure Close(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SansRafraichissementClick(Sender: TObject);
    procedure ModeAcquisitionStandardClick(Sender: TObject);
    procedure OpenSerialPort;
    procedure CloseSerialPort;
    procedure StartClick(Sender: TObject);
    procedure LitBuffer0123(var Caractere:char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonPulseRecep2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure chargefichier(filename:string);
    procedure Button4Click(Sender: TObject);
    function  conversionBinaryWord(chaine:string):word;
    procedure Timer1Timer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SauveSequence(nomfichier:string);
    procedure TransfertSignesREceptionDansTableau;
    procedure SequencesClick(Sender: TObject);
    procedure EraseTableauSignesReception;
    procedure piSur2Simple;
    procedure piSur2PiSimple;
    procedure InitialiseSequence;
    procedure piSur2Pi2StepsPhaseRecombination;
    procedure piSur2Pi2StepsSmartPhaseRecombination;
    procedure piSur2Pi2StepsSoftRecombination;
    procedure piSur2Pi4StepsPhaseRecombination;
    procedure piSur2Pi4StepsSmartPhaseRecombination;
    procedure piSur2Pi4StepsSoftRecombination;
    procedure piSur2Pi4StepsPhaseRecombinationT1;
    procedure piSur2Pi4StepssmartphaseRecombinationT1;
    procedure piSur2Pi4StepssoftRecombinationT1;
    procedure piSur2PiSimpleT1;

    {    procedure piSur2Pi4StepsSoftRecombinationT1;
    procedure piSur2;
    procedure cyclop;
    procedure piSur2PiSimpleT1;
 }   {procedure ecriture(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure autorisation(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);}


  private
      FTempInBuffer2              : pointer;

    { Dclarations prives}
  public
    procedure ChangeParametreSequence(nomParam:string;Valeur:real);


    { Dclarations publiques}
end;

var
  SeqNewHeteroForm: TSeqNewHeteroForm;
  attentepourfinsequence,TempsTotalUneSequence:extended; {temps total en nanosecondes pour une sequence}
implementation

uses receptionNewHetero, pulsedialogue;

{$R *.DFM}

procedure TSeqNewHeteroForm.ouverture;
var result:boolean;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
SeqNewHeteroForm.WindowState:=WsMinimized;
SeqNewHeteroForm.WindowState:=WsNormal;

end;

procedure TSeqNewHeteroForm.initialisation;
var i:integer;
    s:string;
begin
      {initial directory for NMR pulse sequences}
      OpenDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\NewHetero';
      SaveDialog1.InitialDir:='c:\NewSpectro\sequenceRMN\NewHetero';

      DrapeauSequenceur16VoiesRecognitionStep:=false;
      listseqpar.Cells[0,0]:='Variable';
      listseqpar.Cells[1,0]:='Delay (msec)';
      listseqpar.Cells[2,0]:='Amplitude (0-127)';
      listseqpar.ColCount:=3;

      editseq.left:=200;
      for i:=1 to ntemps do SeqNewHeteroForm.listseqpar.cells[0,i]:=chr(64+i);
      {on interdit la ligne de TF car instruction utilise pour la TF}
      SeqNewHeteroForm.listseqpar.cells[0,6]:='--';


      {initialisation de la connexion RS232 necessaire ensuite}
      CommPortNewHetero.ComPort:=pnCOM1; // Choose pnCOM1 or pnCOM2
      CommPortNewHetero.ComPortSpeed:= br57600; //9600 Bauds
      CommPortNewHetero.ComPortDataBits           := db8BITS; // 8 data bits
      CommPortNewHetero.ComPortStopBits           := sb1BITS; // 1 stop bit
      CommPortNewHetero.ComPortParity             := ptNONE;  // no parity
      CommPortNewHetero.ComPortHwHandshaking      := hhNONE;  // no hardware handshaking
      CommPortNewHetero.ComPortSwHandshaking      := shNONE;

end;

procedure TSeqNewHeteroForm.erasetableauSignesREception;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   TableauSignesReception.cells[1,i]:='';
   TableauSignesReception.cells[2,i]:='';
   end;
end;

procedure TSeqNewHeteroForm.TransfertSignesREceptionDansTableau;
var i:integer;
begin
NombreStepsPourReception:=0;
for i:=1 to 16 do
   begin
   TableauSignesReceptionNMR[1][i]:=0;TableauSignesReceptionNMR[2][i]:=0;
   if (TableauSignesReception.cells[1,i]='+X') or (TableauSignesReception.cells[1,i]='X')
                                               then TableauSignesReceptionNMR[1][i]:=1;
   if (TableauSignesReception.cells[1,i]='+Y') or (TableauSignesReception.cells[1,i]='Y')
                                               then TableauSignesReceptionNMR[1][i]:=2;
   if (TableauSignesReception.cells[1,i]='-X') then TableauSignesReceptionNMR[1][i]:=3;
   if (TableauSignesReception.cells[1,i]='-Y') then TableauSignesReceptionNMR[1][i]:=4;

   if (TableauSignesReception.cells[2,i]='+X') or (TableauSignesReception.cells[2,i]='X')
                                               then TableauSignesReceptionNMR[2][i]:=1;
   if (TableauSignesReception.cells[2,i]='+Y') or (TableauSignesReception.cells[2,i]='Y')
                                               then TableauSignesReceptionNMR[2][i]:=2;
   if (TableauSignesReception.cells[2,i]='-X') then TableauSignesReceptionNMR[2][i]:=3;
   if (TableauSignesReception.cells[2,i]='-Y') then TableauSignesReceptionNMR[2][i]:=4;

   if (TableauSignesReceptionNMR[1][i]<>0) and (TableauSignesReceptionNMR[2][i]<>0)
               then  NombreStepsPourReception:=NombreStepsPourReception+1;
   end;
end;


procedure TSeqNewHeteroForm.ChangeParametreSequence(nomParam:string;Valeur:real);
    { mets Valeur dans la case de nomParam : appel
    depuis interpreteur}
var i,numColonne,numLigne:integer;

begin
   numLigne:=0;   numColonne:=0;
   {on repere la colonne}
   {on repere le numero de ligne correspondant a la lettre : A,B,C...}
   for i:=1 to 26 do if chr(64+i)=copy(nomParam,2,1) then numLigne:=i;
   {on change seulement si c'est bien crit}
   if numLigne<>0 then
   begin
     if copy(nomParam,1,1)='T' then listseqpar.Cells[1,numLigne]:=floattostr(valeur);
     if copy(nomParam,1,1)='A' then listseqpar.Cells[2,numLigne]:=floattostr(valeur);
   end;

   if (numLigne=0) then MessageDlg('Erreur in the command of type TA, PA...', mtWarning, [mbOk], 0);
   if (copy(nomParam,1,1)<>'T' ) and (copy(nomParam,1,1)<>'A' ) then MessageDlg('Erreur in the command of type TA', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.Sauver1Click(Sender: TObject);
begin
    If Savedialog1.execute then  SauveSequence(SaveDialog1.Filename);
end;

procedure TSeqNewHeteroForm.SauveSequence(nomfichier:string);
var  filepara:string;
    fich2:textfile;i:integer;
begin
      TransfertSignesREceptionDansTableau;

      if (copy(nomFichier,length(nomFichier)-3,4)<>'.seq') then nomFichier:=nomFichier+'.seq';
      assignfile(fich2,nomfichier);
      rewrite(fich2);
      writeln(fich2,'NewHeteroSpectrometer');
      writeln(fich2,'DELAYS');
      for i:=1 to ntemps do
          begin
          if SeqNewHeteroForm.listseqpar.cells[1,i]='' then
          SeqNewHeteroForm.listseqpar.cells[1,i]:='0';
          writeln(fich2,SeqNewHeteroForm.listseqpar.cells[1,i]);
          end;
      writeln(fich2,'AMPLITUDES');
      for i:=1 to ntemps do
          begin
          if SeqNewHeteroForm.listseqpar.cells[2,i]='' then
          SeqNewHeteroForm.listseqpar.cells[2,i]:='0';
          writeln(fich2,SeqNewHeteroForm.listseqpar.cells[2,i]);
          end;
      writeln(fich2,'SEQUENCE');

      for i:=0 to editseqnoncompiled.Lines.Count-1 do
          writeln(fich2,editseqnoncompiled.lines[i]);

      writeln(fich2,'NUMBER OF STEPS FOR ACQUISITION :');
      writeln(fich2,inttostr(NombreStepsPourReception));
      if (NombreStepsPourReception>0) then
            begin
            for i:=1 to NombreStepsPourReception do
                       begin
                       writeln(fich2,'step '+inttostr(i));
                       writeln(fich2,TableauSignesReception.cells[1,i]);
                       writeln(fich2,TableauSignesReception.cells[2,i]);
                       end;
            end;
      closefile(fich2);
      SeqNewHeteroForm.NomSequenceRMN.caption:=nomFichier;
      {sauve le nom de la sequence dans Parametres RMN.txt}
      EcritDansParametresRMN('Last Pulse Sequence',nomFichier)

end;


procedure TSeqNewHeteroForm.Ouvrir1Click(Sender: TObject);
var filepara:string;
    fich2:textfile;
    i:integer;nomFichier:string;
       chaineTableau:array[0..100] of string;
  begin
  if OpenDialog1.execute then
           ChargeFichier(Opendialog1.Filename);
end;

procedure TSeqNewHeteroForm.ChargeFichier(Filename:string);
var filepara:string;
    fich2:textfile;
    err,i:integer;nomFichier:string;
    chaine:string;nombre:extended;
    drapeau:boolean;
   chaineTableau:array[0..100] of string;
begin
    if FExis(Filename) then
       begin
         {verifie si bon format}
           nomFichier:=Filename;
           assignfile(fich2,nomfichier);
           reset(fich2);
           drapeau:=false;
           readln(fich2,chaine);

           if (chaine='NewHeteroSpectrometer') or
                 (chaine='OldHeteroSpectrometer') or
                 (chaine='Sequenceur16Channels') then
                 begin
                   if (chaine<>'NewHeteroSpectrometer') then drapeau:=false
                                                       else drapeau:=true;
                 end;

           if drapeau=true then
           begin
           for i:=1 to ntemps do SeqNewHeteroForm.listseqpar.cells[1,i]:='';
           for i:=1 to ntemps do SeqNewHeteroForm.listseqpar.cells[2,i]:='';
           erasetableauSignesREception;
           {lit le fichier}
           nomFichier:=Filename;
           readln(fich2,chaine);
           i:=0;
           {lecture des delais}
                repeat
                 i:=i+1;
                 readln(fich2,chaine);
                 val(chaine,nombre,err);
                 if (err=0) then SeqNewHeteroForm.listseqpar.cells[1,i]:=chaine;
                until (chaine='AMPLITUDES') or (chaine='SEQUENCE') or (i>50);

           i:=0;
           {lecture des amplitudes si elles existent}
           if (chaine='AMPLITUDES') then
                begin
                repeat
                 i:=i+1;
                 readln(fich2,chaine);
                 val(chaine,nombre,err);
                 if (err=0) then SeqNewHeteroForm.listseqpar.cells[2,i]:=chaine;
                until (chaine='SEQUENCE') or (i>50);
                end;

            editseq.Clear;
            editseqnoncompiled.Clear;
           {lecture des instructions}
            while not eof(fich2) and (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') do
                 begin
                 readln(Fich2,chaine);
                 if (chaine<>'NUMBER OF STEPS FOR ACQUISITION :') then editseqnoncompiled.lines.Add(chaine);
                 end;

           {lecture des aiguillages du mode d'acquisition}
           readln(fich2,chaine);{nombre d'aiguillages}
           nombre:=0;
           val(chaine,nombre,err);
           if nombre>0 then
              begin
              NombreStepsPourReception:=round(nombre);
              for i:=1 to round(Nombre) do
                       begin
                       readln(fich2,chaine);
                       readln(fich2,chaine);
                       TableauSignesReception.cells[1,i]:=chaine;
                       readln(fich2,chaine);
                       TableauSignesReception.cells[2,i]:=chaine;
                       end;

              TableauSignesREception.Visible:=true;
              DrapeauSequenceurTimeCheck:=true;

              modeacquisitionstandard.State:=cbunchecked;
              end
              else
              begin

              TableauSignesREception.Visible:=false;
              DrapeauSequenceurTimeCheck:=false;

              modeacquisitionstandard.State:=cbchecked;
              end;
            closefile(fich2);

            SeqNewHeteroForm.NomSequenceRMN.caption:=nomFichier;
            {sauve le nom de la sequence dans Parametres RMN.txt}
            EcritDansParametresRMN('Last Pulse Sequence',filename)
            end;
       end;
end;

procedure TSeqNewHeteroForm.StopClick(Sender: TObject);
var s:string;starttime:integer;timeout:boolean;
begin
      {On s'arrete}
       {SeqNewHeteroForm.openSerialPort;}
       s:='C'+#13;
       CommPortNewHetero.SendData( pchar(s),length(s));
       AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
       {il attendra que la sequence se finisse bien si on lui lance un
       start trop tot}
       MomentOuOnAFermeLaSequence:=Gettickcount;
       {SeqNewHeteroForm.closeSerialPort;}
       Status.caption:='Sequence stopped';
end;




procedure TSeqNewHeteroForm.Close(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caNone;
  SeqNewHeteroForm.WindowState:=wsMinimized;
{On ne ferme pas la fentre sequenceur pour viter de slectionner par erreur deux sequences
mais on la reduit. On peut la reafficher via le menu}
end;

procedure TSeqNewHeteroForm.FormCreate(Sender: TObject);
var nomFichier:string;chaineTableau:array[0..100] of string;fich2:textfile;
i:integer;
begin
   PiSur2Pidialogue.label6.caption:='pulse amplitude (0-200)';
   PiSur2Pidialogue.amplitude.text:='100';
   DrapeauSeq16ChannelsLibre:=true;
   AttentePourFinSequence:=0;
   Initialisation;
          {ouverture du port serie une fois pour toute qui sera utilise pour controle le
       spectro}
      SeqNewHeteroForm.closeSerialPort;
      SeqNewHeteroForm.openSerialPort;

      {TableauSigne : initialisation du tableau des signes de reception}
   TableauSignesReception.cells[1,0]:='0';
   TableauSignesReception.cells[2,0]:='90';
   TableauSignesReception.cells[0,0]:='step';
   for i:=1 to 16 do TableauSignesReception.cells[0,i]:=inttostr(i);
   TableauSignesReception.cells[1,1]:='+X';
   TableauSignesReception.cells[2,1]:='+Y';
   TransfertSignesREceptionDansTableau;

   Sequences.items.clear;
   Sequences.items.add('pi/2');
   Sequences.items.add('pi/2-pi simple');
   Sequences.items.add('pi/2-pi 2 steps smart phase recombination');
   Sequences.items.add('pi/2-pi 2 steps phase recombination');
   Sequences.items.add('pi/2-pi 2 steps soft recombination');
   Sequences.items.add('pi/2-pi 4 steps smart phase recombination');
   Sequences.items.add('pi/2-pi 4 steps phase recombination');
   Sequences.items.add('pi/2-pi 4 steps soft recombination');
   Sequences.items.add('pi/2-pi simple for T1');
   Sequences.items.add('pi/2-pi 4 steps phase recombination for T1');
   Sequences.items.add('pi/2-pi 4 steps smart phase recombination for T1');
   Sequences.items.add('pi/2-pi 4 steps soft recombination for T1');


     {relit la derniere sequence sauve dont le nom est dans Parametres RMN.txt}
   nomfichier:=LitDansParametresRMN('Last Pulse Sequence');
      if fexis(nomfichier) then
               begin
                chargefichier(nomFichier);
               end
               else piSur2PiSimple; {si le fichier n'existe pas on fait pi/2 pi}
end;

procedure TSeqNewHeteroForm.SansRafraichissementClick(Sender: TObject);
begin
   if SansRafraichissement.State=cbChecked then
         begin
         DrapeauSansRafraichissement:=true;
         end
   else DrapeauSansRafraichissement:=false;
end;

procedure TSeqNewHeteroForm.ModeAcquisitionStandardClick(Sender: TObject);
begin
if ModeAcquisitionStandard.State=cbChecked then
         begin
         EraseTableauSignesReception;
         NombreStepsPourReception:=1;
         TableauSignesReception.cells[1,1]:='+X';
         TableauSignesReception.cells[2,1]:='+Y';
         DrapeauSequenceurTimeCheck:=false;


         end
         else
         begin

         TableauSignesREception.Visible:=true;
         DrapeauSequenceurTimeCheck:=true;

         end;
end;

procedure TSeqNewHeteroForm.openSerialPort;
begin
  GetMem( FTempInBuffer2,10);
  CommPortNewHetero.connect;
  CommPortNewHetero.FlushBuffers(true,true);
end;

procedure TSeqNewHeteroForm.closeSerialPort;
begin
  CommPortNewHetero.Disconnect;
  FreeMem( FTempInBuffer2,10);
end;

procedure TSeqNewHeteroForm.StartClick(Sender: TObject);
begin
{ne pas sauver le fichier  chaque fois qu'on relance, c'est
trs problematique car ca fait perdre du temps}
if (DrapeauAcquisitionNMRencours=true)
        then MessageDlg('please, stop first the acquisition on Acquisition window', mtWarning, [mbOk], 0)
        else SeqNewHeteroForm.StartSequenceur;
end;

procedure TSeqNewHeteroForm.RestartSequenceur;
{compilation et execution de la sequence si c'est le spectro sous RS232  16 voies
fait par J-P Cromieres en dec.2002}

var Instructions,chaines:array[1..1000] of string;
    BitA,BitB:array[0..15] of integer;
    numero,NumeroLettre,temps,err,err2,NbSteps,i,j,nb,nb2:integer;
    s,s2,s3,sTemps,chaine,previousinstruction:string;
    DrapeauPhase,drapeau,DrapeauErreur,TimeOut,DrapeauSingleInstruction:boolean;
    Caractere:char;
    nombre,nombre2,StartTime,TempsBis:extended;
    numinstruction,BitsPoidsFaibleVoieA,BitsPoidsFaibleVoieB:integer;
    numero2:integer;chaine1,chaine2:string;
    temps1,temps2:extended;

{1ere colonne : la duree en nanosecondes, puis les 16 colonnes qui suivent:
booleens qui disent si c'est ouvert (true) ou ferm (false)}

begin
  {envoi au RS232}
   {SeqNewHeteroForm.openSerialPort;}
   s:='C'+#13; {ordre de stopper le sequenceur}
   CommPortNewHetero.FlushBuffers(true,true);
   CommPortNewHetero.SendData( pchar(s),length(s));
   {on attend au moins le temps de la sequence qu'elle finisse}
   if AttentepourFinSequence=0 then ATtentePourFinSequence:=1000;
   startTime:= GetTickCount;
       REPEAT
         timeout:= ((GetTickCount - startTime) > AttentePourFinSequence);
{         application.processmessages;  }
       UNTIL timeout;
    {start the sequence}
    s:='B'+#13;
    CommPortNewHetero.SendData( pchar(s),length(s));
    Status.caption:='Sequence running';
    {SeqNewHeteroForm.closeSerialPort;}
end;

procedure TSeqNewHeteroForm.StartSequenceur;
{compilation et execution de la sequence si c'est le spectro sous RS232  16 voies
fait par J-P Cromieres en dec.2002}

var Instructions,chaines:array[1..1000] of string;
    BitA,BitB:array[0..15] of integer;
    Duree:extended;
    numero,NumeroLettre,temps,err,err2,NbSteps,i,j,nb,nb2:integer;
    s,s2,s3,sTemps,chaine,previousinstruction:string;
    DrapeauPhase,drapeau,DrapeauErreur,TimeOut,DrapeauSingleInstruction:boolean;
    Caractere:char;
    nombre,nombre2,StartTime,TempsBis:extended;
    numinstruction,BitsPoidsFaibleVoieA,BitsPoidsFaibleVoieB:integer;
    numero2:integer;chaine1,chaine2:string;
    ProduitTempsParAmplitude,temps1,temps2:extended;
    chainedepart,phaseS,amplitudeS,dureeS:string;
  drapeauCalculerTempsRepetition:boolean;
  {1ere colonne : la duree en nanosecondes, puis les 16 colonnes qui suivent:
booleens qui disent si c'est ouvert (true) ou ferm (false)}

begin

{in editseqnoncompiled window :
each line ends with a ';' and each instruction is separated by ','  like :
T50,TTLC,ARF100; free comment here

INSTRUCTIONS :
* PULSE(duree,amplitude,phase) or PULSE(duree,amplitude)
* PULSE2(duree,amplitude,phase) or PULSE2(duree,amplitude)
    where duree has the form 0.03 (in msec), or A (the line name on 1st column) or TA (idem)
    where amplitude is 100 (0-200), or A (the line name on 2nd column) or AA (idem)
    where phase is 90 (in degree), or A (the line name on 3rd column) or PA (idem)
exples :
PULSE(0.002,200,180); pulse of 0.002 msec amplitude 200 phase 180
PULSE(A,B); pulse of length A (1st line, 1st col), amplitude B (1st line, 2nd col),
phase 0

* WAIT(duree,phase) or WAIT(duree)
* WAIT2(duree,phase) or WAIT2(duree)
* T0.015  : delay of 0.015 msec. Delays are in msec and consist of multiples of
50 nsec
* TC : delay contained in box C of first column of left array (in msec)
* TMIN : minimum delay of 100 nsec
* TTLA,TTLB,TTLC,TTLD,TTLE,TTLF : TTL gates on front pannel
* ABLANK, BBLANK : blanking output on channel 1 or 2
* TRIGACQ : trigger for acquisition (linked to GAGE card)
* AP0, BP0, AP90, BP90 ... : phases on channel A or B (by steps of 11.25 only)
* ARF100 or BRF100 : rf signal of amplitude 100 on channel A or B.
* ARFA or BRFA : rf signal of amplitude contained in box Amplitude line A
When you put a rf instruction with non zero amplitude, it will also
put by defaut the corresponding blanking.
Important : the rf pulse will stay at its amplitude till you put it back to zero
so REMEMBER TO PUT ARF0 AFTER ANY ARF INSTRUCTION !!!
If you put 2 consecutive rf instructions with different non zero amplitudes,
there will be an automatic minimum additional delay between them of 100 nsec
NEVER PUT ON THE SAME LINE A PHASE AND AMPLITUDE INSTRUCTION}

j:=0;
editseq.Lines.Clear;
for i:=0 to (EditSeqNonCompiled.Lines.Count-1) do
   begin
    chainedepart:=EditSeqNonCompiled.Lines[i];
    if chainedepart<>'' then
    begin
    {transfo en majuscules, ajout point virgule}
    if (pos(';',chainedepart)=0) then chainedepart:=chainedepart+';';
    chainedepart:=AnsiUpperCase(chainedepart);
    chainedepart:=copy(chainedepart,1,pos(';',chainedepart));
    {instruction PULSE(duree,amplitude,phase) ou PULSE2(duree,amplitude,phase)
    si phase non specifiee, on met 0
    Fait un pulse avec duree,amplitude,phase sur voie principale ou secondaire}

    if (pos('PULSE',chainedepart)>0) and (pos('PULSE2',chainedepart)=0) then
       begin
       chaine:=chainedepart;
       chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-8);
       dureeS:=copy(chaine,1,pos(',',chaine)-1);
       chaine:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
       if pos(',',chaine)=0 then begin amplitudeS:=chaine;phaseS:='0';end
                            else
                            begin
                            amplitudeS:=copy(chaine,1,pos(',',chaine)-1);
                            phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                            end;
       if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
       if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
       if (length(amplitudeS)=2) and (copy(amplitudeS,1,1)='A') then amplitudeS:=copy(amplitudeS,2,1);

       editseq.Lines.Add('TMIN,ARF0;');
       editseq.lines.Add('TMIN,AP'+phaseS+';');
       editseq.lines.Add('T0.003,ABLANK;');
       editseq.lines.Add('T'+dureeS+',ARF'+amplitudeS+';');
       editseq.lines.Add('TMIN;');
       editseq.lines.Add('TMIN,ARF0;');
       end
       else
       begin
       if (pos('PULSE2',chainedepart)>0) then
         begin
         chaine:=chainedepart;
         chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-9);
         dureeS:=copy(chaine,1,pos(',',chaine)-1);
         chaine:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
         if pos(',',chaine)=0 then begin amplitudeS:=chaine;phaseS:='0';end
                            else
                            begin
                            amplitudeS:=copy(chaine,1,pos(',',chaine)-1);
                            phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                            end;
         if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
         if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
         if (length(amplitudeS)=2) and (copy(amplitudeS,1,1)='A') then amplitudeS:=copy(amplitudeS,2,1);

         editseq.Lines.Add('TMIN,BRF0;');
         editseq.lines.Add('TMIN,BP'+phaseS+';');
         editseq.lines.Add('T0.003,BBLANK;');
         editseq.lines.Add('T'+dureeS+',BRF'+amplitudeS+';');
         editseq.lines.Add('TMIN;');
         editseq.lines.Add('TMIN,BRF0;');
         end
         else
         begin
         if (pos('WAIT',chainedepart)>0) and (pos('WAIT2',chainedepart)=0) then
            {instruction WAIT(duree,phase) or WAIT(duree) and phase=0}
            begin
            chaine:=chainedepart;
            chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-7);
            if pos(',',chaine)=0 then begin dureeS:=chaine;
                                            phaseS:='0';
                                      end
                                      else
                                      begin
                                      dureeS:=copy(chaine,1,pos(',',chaine)-1);
                                      phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                                      end;
            if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
            if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
            editseq.lines.Add('TMIN,AP'+phaseS+';');
            editseq.lines.Add('T'+dureeS+';');
            end
            else
            begin
            if (pos('WAIT2',chainedepart)>0) then
               {idem avec phase sur voie 2}
               begin
               chaine:=chainedepart;
               chaine:=copy(chaine,pos('(',chaine)+1,length(chaine)-8);
               if pos(',',chaine)=0 then begin dureeS:=chaine;
                                            phaseS:='0';
                                      end
                                      else
                                      begin
                                      dureeS:=copy(chaine,1,pos(',',chaine)-1);
                                      phaseS:=copy(chaine,pos(',',chaine)+1,length(chaine)-pos(',',chaine));
                                      end;
               if (length(dureeS)=2) and (copy(dureeS,1,1)='T') then dureeS:=copy(dureeS,2,1);
               if (length(phaseS)=2) and (copy(dureeS,1,1)='P') then phaseS:=copy(phaseS,2,1);
               editseq.lines.Add('TMIN,BP'+phaseS+';');
               editseq.lines.Add('T'+dureeS+';');
               end
               else
               editseq.lines.add(chainedepart);
            end;
         end;
       end;
    end;
   end;


{si deux instructions ARF ou BRF de suite sur meme voie, on introduit une ligne
de TMIN vide ou bien avec ARF et BRF ou bien juste avec blank ouvert ?
verifier avec JEan Paul}
{voie A}
for i:=0 to (EditSeq.Lines.Count-2) do
   begin
   if pos('ARF',EditSeq.Lines[i])>0 then
          begin
          if pos('ARF',EditSeq.Lines[i+1])>0 then
                   begin
                   {on insere une ligne}
                   editSeq.Lines.Insert(i+1,'TMIN; waiting time of 100nsec');
                   end;
          end;
   end;
{voie B}
for i:=0 to (EditSeq.Lines.Count-2) do
   begin
   if pos('BRF',EditSeq.Lines[i])>0 then
          begin
          if pos('BRF',EditSeq.Lines[i+1])>0 then
                   begin
                   {on insere une ligne}
                   editSeq.Lines.Insert(i+1,'TMIN; waiting time of 100nsec');
                   end;
          end;
   end;
{voie A phase}
for i:=0 to (EditSeq.Lines.Count-2) do
   begin
   if pos('AP',EditSeq.Lines[i])>0 then
          begin
          if pos('AP',EditSeq.Lines[i+1])>0 then
                   begin
                   {on insere une ligne}
                   editSeq.Lines.Insert(i+1,'TMIN; waiting time of 100nsec');
                   end;
          end;
   end;
{voie B phase}
for i:=0 to (EditSeq.Lines.Count-2) do
   begin
   if pos('BP',EditSeq.Lines[i])>0 then
          begin
          if pos('BP',EditSeq.Lines[i+1])>0 then
                   begin
                   {on insere une ligne}
                   editSeq.Lines.Insert(i+1,'TMIN; waiting time of 100nsec');
                   end;
          end;
   end;
numinstruction:=EditSeq.Lines.Count;
{si deux instructions RF et Phase sur meme ligne et meme voie, il annonce le probleme}
drapeau:=false;
for i:=0 to (EditSeq.Lines.Count-1) do
   begin
   if (pos('BP',EditSeq.Lines[i])>0) and (pos('BRF',EditSeq.Lines[i])>0) then drapeau:=true;
   if (pos('AP',EditSeq.Lines[i])>0) and (pos('ARF',EditSeq.Lines[i])>0) then drapeau:=true;
   end;
if drapeau=true then
        begin
        MessageDlg('Error : you put a phase instruction and an amplitude instruction on the same line like T50,BP90,BRF100', mtWarning, [mbOk], 0);
        exit;
        end;

NbSteps:=0;
tempstotaluneSequence:=0;

drapeauCalculerTempsRepetition:=false;
TempsRepetition:=0;
{on lit chaque instruction de EditSeq du type
T0.05,A8,B9...
on convertit  chaque fois dans le bon nom d'instruction.}
DrapeauErreur:=false;
previousinstruction:='';
for i:=1 to numInstruction do
   begin
   s:=editseq.lines[i-1];
   {si c'est un trigger, on repere pour evaluer TempsRepetition}
   if pos('TRIGACQ',s)>0 then
          begin
          drapeauCalculerTempsRepetition:=true;
          if (tempsrepetition>0) then drapeauCalculerTempsRepetition:=false;
          end;

    {on vire les commentaires apres le ; mais on laisse le ;}
   if pos(';',s)>0 then s:=copy(s,1,pos(';',s));
   DrapeauSingleInstruction:=false;
   {cas d'une instruction de fermeture de la reception via un switch}
   if (DrapeauSingleInstruction=false) and (s<>'') then
   begin
    Duree:=0;
    BitsPoidsFaibleVoieA:=0;BitsPoidsFaibleVoieB:=0;
    for j:=0 to 15 do begin BitA[j]:=0;BitB[j]:=0;end;
    {1. On identifie duree}
    {cas de TMIN}
    if copy(s,1,4)='TMIN' then
       begin
       Duree:=100; {duree minimum = 100 ou 50 nsec : verifier avec Jean-Paul}
       end
       else
       begin
       if copy(s,1,1)='T' then
         begin
         val(copy(s,2,1),tempsbis,err);
         {cas de T0.05}
         if err=0 then begin
                       if pos(',',s)>0 then  s2:=copy(s,2,pos(',',s)-2)
                                       else s2:=copy(s,2,pos(';',s)-2);
                       val(s2,tempsbis,err2);
                       if err2<>0 then
                                  begin DrapeauErreur:=true;
                                  MessageDlg('Erreur in the command of type T0.05.', mtWarning, [mbOk], 0);
                                  end;
                       if drapeaucalculerTempsRepetition=true then tempsrepetition:=tempsrepetition+tempsbis;
                       {on convertit la valeur de msec en nanosec}
                       if err2=0 then Duree:=tempsbis*1e6;
                       end;

         {cas de TA,TB,TC...}
         if err<>0 then begin
                        s2:=copy(s,2,1);
                        if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                        if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                        if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                        if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                        if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                        if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                        if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                        if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                        val(listseqpar.Cells[1,nb],tempsBis,err2);
                        if err2<>0 then begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Erreur in the command of type TA', mtWarning, [mbOk], 0);
                                        end
                                   else
                                   begin
                                   if drapeaucalculerTempsRepetition=true then tempsrepetition:=tempsrepetition+tempsbis;
                                   Duree:=tempsBis*1e6;{on convertit la valeur des msec en nanosec}
                                   end;
                        end;
         end
         else
             begin DrapeauErreur:=true;
                    MessageDlg('Erreur : you did not start each line by a command of a delay, like T0.05, TA or TMIN', mtWarning, [mbOk], 0);
             end;
       end;

       {Voie A}
       {changement de phase}
       DrapeauPhase:=false;
       if pos('AP',s)>0 then
                        begin
                        DrapeauPhase:=true;
                        BitA[15]:=1;BitA[14]:=1;
                        {on extrait le nombre aprs AP}
                        s2:=copy(s,pos('AP',s)+2,length(s)-pos('AP',s)-1);
                        if pos(',',s2)>0 then s2:=copy(s2,1,pos(',',s2)-1);
                        if pos(';',s2)>0 then s2:=copy(s2,1,pos(';',s2)-1);
                        val(s2,nombre,err);
                        if err<>0 then DrapeauErreur:=true
                                  else begin
                                       nombre2:=nombre/11.25;
                                       if (nombre2<>round(nombre2)) then DrapeauErreur:=true
                                          else
                                          {ruse : on doit coder nombre2 sur les 5 bits de poids fort d'un nb de 8 bits
                                          dont les 3 derniers seront 0, donc on multiplie par 8 ce nombre2 }
                                          BitsPoidsFaibleVoieA:=8*round(nombre2);
                                       end;
                        end;

       {changement d'amplitude : si ce n'est pas 0, on met d'office le blanking sur A aussi}
       if pos('ARF',s)>0 then
                        begin
                        if DrapeauPhase=true then
                                  begin
                                  DrapeauErreur:=true;
                                  MessageDlg('Error : you put a phase instruction and an amplitude instruction on the same line like T50,BP90,BRF100', mtWarning, [mbOk], 0);
                                  end;
                        BitA[13]:=1;
                        {on extrait le nombre aprs ARF ou la variable si c'en est une}
                        s2:=copy(s,pos('ARF',s)+3,length(s)-pos('ARF',s)-2);
                        if pos(',',s2)>0 then s2:=copy(s2,1,pos(',',s2)-1);
                        if copy(s2,length(s2),1)=';' then s2:=copy(s2,1,length(s2)-1);
                        val(s2,nombre,err);
                        if err=0 then BitsPoidsFAibleVoieA:=round(nombre)
                                 else
                            begin  {cas de ARFA ARFB,...}
                            if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                            if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                            if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                            if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                            if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                            if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                            if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                            if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                            val(listseqpar.Cells[2,nb],nombre,err2);

                            {TEST si pulse trop long : on regarde longueur du pulse * amplitude.
                            Pulse en msec et amplitude entre 0 et 200
                            On veut Temps*Amp< 5 (cad max pour pulse=50 microsec et pour Amplitude=100)}
                            ProduitTempsParAmplitude:=nombre*Duree*1e-6;
                            if PRoduitTempsParAmplitude>5 then
                                        begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Attention ! Pulse ARF too long for rf power (limit : Length*Amplitude < 5)', mtWarning, [mbOk], 0);
                                        end;

                            if err2<>0 then begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Erreur in the content of amplitude cells linked to command of type BRFA, BRFB...', mtWarning, [mbOk], 0);
                                        end
                                   else BitsPoidsFAibleVoieA:=round(nombre);{on convertit la valeur des msec en nanosec}
                            end;
                  {regler les limites autorisees de l'amplitude rf ici}
                         if BitsPoidsFAibleVoieA>255 then begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Erreur in the value of the amplitude which should be < 255 ', mtWarning, [mbOk], 0);
                                        end;
                  {si ce n'est pas 0, on met d'office le blanking sur A aussi}
                         if (BitsPoidsFaibleVoieA>0) then BitA[12]:=1;
                        end;

       {autres possibilits voie A}
       if pos('ABLANK',s)>0 then BitA[12]:=1;        {blanking : bit 12}
       if pos('TTLF',s)>0 then BitA[9]:=1; {TTL Panneau Avant}
       if pos('TTLE',s)>0 then BitA[8]:=1; {TTL Panneau Avant}

       {TRIGGER ACQUISITION}
       if pos('TRIGACQ',s)>0 then
          begin
          {spectro 2005 : trigger acquisition sur la voie F}
          if DrapeauSpectroHetero2005=true then BitA[9]:=1; {TTL voie F}
          {spectro 2003 : trigger sur sortie TRIGACQ}
          if DrapeauSpectroHetero2003=true then BitA[10]:=1; {TTL voie TRIGACQ}
          {bit signalant qu'il faut envoyer un signal de reconnaissance :
          ne l'allumer que quand on envoie un signal de trigger a la carte GAGE}
          BitA[11]:=1;
          end
          else
          BitA[11]:=0;


       {Voie B}
       {changement de phase}
       DrapeauPhase:=false;
       if pos('BP',s)>0 then
                        begin
                        DrapeauPhase:=true;
                        BitB[15]:=1;BitB[14]:=1;
                        {on extrait le nombre aprs AP}
                        s2:=copy(s,pos('BP',s)+2,length(s)-pos('BP',s)-1);
                        if pos(',',s2)>0 then s2:=copy(s2,1,pos(',',s2)-1);
                        if pos(';',s2)>0 then s2:=copy(s2,1,pos(';',s2)-1);
                        val(s2,nombre,err);
                        if err<>0 then DrapeauErreur:=true
                                  else begin
                                       nombre2:=nombre/11.25;
                                       if (nombre2<>round(nombre2)) then DrapeauErreur:=true
                                          else
                                          {ruse : on doit coder nombre2 sur les 5 bits de poids fort d'un nb de 8 bits
                                          dont les 3 derniers seront 0, donc on multiplie par 8 ce nombre2 }
                                          BitsPoidsFaibleVoieB:=8*round(nombre2);
                                       end;
                        end;

       {changement d'amplitude}
       if pos('BRF',s)>0 then
                        begin
                        if DrapeauPhase=true then
                                  begin
                                  DrapeauErreur:=true;
                                  MessageDlg('Error : you put a phase instruction and an amplitude instruction on the same line like T50,AP90,ARD100', mtWarning, [mbOk], 0);
                                  end;
                        BitB[13]:=1;
                        {on extrait le nombre aprs ARF ou la variable si c'en est une}
                        s2:=copy(s,pos('BRF',s)+3,length(s)-pos('BRF',s)-2);
                        if pos(',',s2)>0 then s2:=copy(s2,1,pos(',',s2)-1);
                        if copy(s2,length(s2),1)=';' then s2:=copy(s2,1,length(s2)-1);
                        val(s2,nombre,err);
                        if err=0 then BitsPoidsFAibleVoieB:=round(nombre)
                                 else
                            begin  {cas de ARFA ARFB,...}
                            if s2='A' then nb:=1;if s2='B' then nb:=2;if s2='C' then nb:=3;
                            if s2='D' then nb:=4;if s2='E' then nb:=5;if s2='F' then nb:=6;
                            if s2='G' then nb:=7;if s2='H' then nb:=8;if s2='I' then nb:=9;
                            if s2='J' then nb:=10;if s2='K' then nb:=11;if s2='L' then nb:=12;
                            if s2='M' then nb:=13;if s2='N' then nb:=14;if s2='O' then nb:=15;
                            if s2='P' then nb:=16;if s2='Q' then nb:=17;if s2='R' then nb:=18;
                            if s2='S' then nb:=19;if s2='T' then nb:=20;if s2='U' then nb:=21;
                            if s2='V' then nb:=22;if s2='W' then nb:=23;if s2='X' then nb:=24;
                            val(listseqpar.Cells[2,nb],nombre,err2);
                            if err2<>0 then begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Erreur in the content of amplitude cells linked to command of type ARFA, ARFB...', mtWarning, [mbOk], 0);
                                        end
                                   else BitsPoidsFAibleVoieB:=round(nombre);{on convertit la valeur des msec en nanosec}
                            end;
                            {TEST si pulse trop long : on regarde longueur du pulse * amplitude.
                            Pulse en msec et amplitude entre 0 et 200
                            On veut Temps*Amp< 5 (cad max pour pulse=50 microsec et pour Amplitude=100)}
                            ProduitTempsParAmplitude:=nombre*Duree*1e-6;
                            if PRoduitTempsParAmplitude>5 then
                                        begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Attention ! Pulse BRF too long for rf power (limit : Length*Amplitude < 5)', mtWarning, [mbOk], 0);
                                        end;

                  {regler les limites autorisees de l'amplitude rf ici}
                         if BitsPoidsFAibleVoieB>255 then begin
                                        DrapeauErreur:=true;
                                        MessageDlg('Erreur in the value of the amplitude which should be < 255 ', mtWarning, [mbOk], 0);
                                        end;
                  {si ce n'est pas 0, on met d'office le blanking sur B aussi}
                         if (BitsPoidsFaibleVoieB>0) then BitB[12]:=1;
                        end;

       {autres possibilits voie B}
       if pos('BBLANK',s)>0 then BitB[12]:=1;        {blanking : bit 12}
       if pos('TTLB',s)>0 then BitB[11]:=1; {TTL Panneau Avant}
       if pos('TTLA',s)>0 then BitB[10]:=1; {TTL Panneau Avant}
       if pos('TTLD',s)>0 then BitB[9]:=1; {TTL Panneau Avant}
       if pos('TTLC',s)>0 then BitB[8]:=1; {TTL Panneau Avant}

       {Ecriture de la commande du type A6E3R0A2356B34982}
       if DrapeauErreur=false then
          begin
          NbSteps:=NbSteps+1;
          tempstotaluneSequence:=tempstotaluneSequence+duree;
          {on arrondit duree d au fait qu'on n'est pas meilleur en precision que 100nsec}
          duree:=round(duree/100)*100;
          {on convertit le temps dans un format du type : 1 sec = 1e9; 517.3 microsec= 5173e2}
          str(round(duree):15,chaine);
          for j:=1 to 15 do if copy(chaine,1,1)=' ' then chaine:=copy(chaine,2,length(chaine)-1);
          nb:=0;
          for j:=1 to (length(chaine)-1) do
             if copy(chaine,length(chaine),1)='0' then begin nb:=nb+1;chaine:=copy(chaine,1,length(chaine)-1);end;

          Instructions[nbsteps]:='A'+chaine+'E'+inttostr(nb)+'R0A';
          chaine:=inttostr(BitA[15])+inttostr(BitA[14])+inttostr(BitA[13])+inttostr(BitA[12])+
          inttostr(BitA[11])+inttostr(BitA[10])+inttostr(BitA[9])+inttostr(BitA[8])+'00000000';
          nombre:=conversionBinaryWord(chaine);
          nombre:=nombre+BitsPoidsFaibleVoieA;
          s2:=inttostr(round(nombre));
          if length(s2)<8 then repeat  s2:='0'+s2; until (length(s2)=8);
          Instructions[nbsteps]:=Instructions[nbsteps]+s2;

          chaine:=inttostr(BitB[15])+inttostr(BitB[14])+inttostr(BitB[13])+inttostr(BitB[12])+
          inttostr(BitB[11])+inttostr(BitB[10])+inttostr(BitB[9])+inttostr(BitB[8])+'00000000';
          nombre:=conversionBinaryWord(chaine);
          nombre:=nombre+BitsPoidsFaibleVoieB;
          s2:=inttostr(round(nombre));
          if length(s2)<8 then repeat s2:='0'+s2; until (length(s2)=8);
          Instructions[nbsteps]:=Instructions[nbsteps]+'B'+s2+#13;
          end;
     end; {fin cas instruction multiple}
   previousinstruction:=s;
   end; {fin boucle sur cq ligne d'instructions}

  {envoi au RS232}
  if DrapeauErreur=false then
    begin {reset the previous sequence }
   {SeqNewHeteroForm.openSerialPort;}
   s:='C'+#13; {ordre de stopper le sequenceur}
   CommPortNewHetero.FlushBuffers(true,true);
   CommPortNewHetero.SendData( pchar(s),length(s));
   {on attend au moins le temps de la sequence qu'elle finisse
   sauf si elle a ete stoppe il y a longtemps}
   if AttentepourFinSequence=0 then ATtentePourFinSequence:=1000;

   if (MomentOuOnAFermeLaSequence=0) then MomentOuOnAFermeLaSequence:=GetTickCount;
   if  ((GetTickCount - MomentOuOnAFermeLaSequence) < AttentePourFinSequence) then
      begin
       REPEAT
         timeout:= ((GetTickCount - MomentOuOnAFermeLaSequence) > AttentePourFinSequence);
{         application.processmessages; }
       UNTIL timeout;
      end; 
   AttentePourFinSequence:=round(tempstotaluneSequence*1e-6)+50;
   MomentOuOnAFermeLaSequence:=0;
   {lancement des differents ordres}
   for j:=1 to NbSteps do
        begin
        CommPortNewHetero.SendData( pchar(Instructions[j]),length(Instructions[j]));
        label1.caption:=instructions[j];
        end;
    {ordre de bouclage  la fin de la squence}
    s:='A1E1R1B0'+#13; {le temps n'est pas pris en compte, juste le R1}
    CommPortNewHetero.SendData( pchar(s),length(s));
    {start the sequence}
    s:='B'+#13;
    CommPortNewHetero.SendData( pchar(s),length(s));
    Status.caption:='Sequence running';

    {SeqNewHeteroForm.closeSerialPort;}
    {Sauver ici la sequence !}

    end
    else
    MessageDlg('Error in the sequence writing - Not sent to the sequenceur', mtWarning, [mbOk], 0);


TransfertSignesREceptionDansTableau;
end;



procedure TSeqNewHeteroForm.Button1Click(Sender: TObject);
var nomFichier:string;
begin
{single pulse automatic programming}
SeqNewHeteroForm.NomSequenceRMN.caption:='Single pulse';
   EditSeq.Lines.Clear;
EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
end;

procedure TSeqNewHeteroForm.Button2Click(Sender: TObject);
begin
{pi/2-pi}
SeqNewHeteroForm.NomSequenceRMN.caption:='pi/2 - pi';
   EditSeq.Lines.Clear;
   EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse pi/2 on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TC; wait during TC');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1 during TB (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
end;

procedure TSeqNewHeteroForm.ButtonPulseRecep2Click(Sender: TObject);
begin
{pi/2-pi}
SeqNewHeteroForm.NomSequenceRMN.caption:='pi/2 - pi Turning reception';

   EditSeq.Lines.Add('NOT POSSIBLE WITH THIS 16 CHANNELS SETUP');

end;

procedure TSeqNewHeteroForm.Button3Click(Sender: TObject);
begin
{pi/2-pi}
SeqNewHeteroForm.NomSequenceRMN.caption:='pi/2 - pi Recognition With RS232';
   EditSeq.Lines.Clear;
   EditSeq.Lines.Add('T0.005,C4,C16; trigger for GAGE card (chanel 16) and oscilloscope (chanel 4) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C1,C3; pulse pi/2 on channel 1 during TA (blanking still open)');
   EditSeq.Lines.Add('TC; wait during TC');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1 during TB (blanking still open)');
   EditSeq.Lines.Add('TR; wait during TR, no pulse = repetition time');
   EditSeq.Lines.Add('T0.005,C16; trigger for GAGE card (chanel 16) of 5 microsec');
   EditSeq.Lines.Add('T0.003,C3; blanking of 3 microsec on Channel 3');
   EditSeq.Lines.Add('TA,C2,C3; pulse pi/2 on channel 2 (you have to inverse it with a gate)');
   EditSeq.Lines.Add('TC;');
   EditSeq.Lines.Add('T0.003,C3;');
   EditSeq.Lines.Add('TB,C1,C3; pulse pi on channel 1');
   EditSeq.Lines.Add('TR; reception will be substracted from previous one');
end;




procedure TSeqNewHeteroForm.Button4Click(Sender: TObject);
var s:string;  timeout:boolean;start:integer;
begin
    MessageDlg('Attention, CLOSE THE RF POWER BECAUSE THERE WILL BE A VERY LONG PULSE !!!', mtWarning, [mbOk], 0);
    {SeqNewHeteroForm.openSerialPort;}
    s:='ZR'+#13; {ordre de reset du sequenceur}
    CommPortNewHetero.SendData( pchar(s),length(s));
    {SeqNewHeteroForm.closeSerialPort;}
     {attendre 3 secondes}
     start:= GetTickCount;
     REPEAT
      timeout:= ((GetTickCount - start) > 3000);
      application.processmessages;
     UNTIL timeout;
    MomentOuOnAFermeLaSequence:=Gettickcount;
    {on reinitialise les valeurs des amplis de reception}
    MessageDlg('To start again the spectro, start the pulse sequence', mtWarning, [mbOk], 0);
    ReceptionNewHeteroForm.InitialiseParametresReception;
    {Sauver ici la sequence !}

end;

function TSeqNewHeteroForm.conversionBinaryWord(chaine:string):word;
{une chaine de 16 bits du style 1000101011101101 est convertie
en le nombre word equivalent}
var nombre:word;i:integer;
begin
nombre:=0;
for i:=1 to 16 do
    begin
    if (copy(chaine,i,1)='1') then nombre:=nombre+ round(power(2,(16-i)));
    end;
conversionBinaryWord:=nombre;
end;

procedure TSeqNewHeteroForm.Timer1Timer(Sender: TObject);
{timer activ quand on utilise la carte 1012}
begin
if DrapeauStartAgainSequence=true then
                                  begin
                                  timer1.enabled:=false;
                                  seqnewheteroform.RestartSequenceur;
                                  timer1.enabled:=true;
                                  drapeauStartAgainSequence:=false;
                                  end;
end;

procedure TSeqNewHeteroForm.Button5Click(Sender: TObject);
{sauve le fichier}
begin
    SauveSequence(SeqNewHeteroForm.nomsequencermn.caption);
end;

procedure TseqNewHeteroForm.InitialiseSequence;
var i:integer;
begin
editseq.Lines.Clear;
editseqnoncompiled.Lines.Clear;
for i:=1 to listseqpar.rowcount do
    begin
    listseqpar.cells[1,i]:='0';
    listseqpar.cells[2,i]:='0';
    end;
erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
end;

procedure TSeqNewHeteroForm.LitBuffer0123(var Caractere:char);
{va lire au buffer si caractere envoye par le spectro est
0 1 2 3 4 5 6 7 8 9 : ; < = > ?}
var u:integer;s1:char;
    u1:double;s:string[1];
begin
  { lecture du caractere recu }
  u1:=time; { 0.00001 = 1 sec est le timeout }
  s:=' ';
  repeat
     u:=_hread(CommPortNewHetero.comhandle,@Ftempinbuffer2^,1);
     if u>0 then s:=strpas(Ftempinbuffer2);
  until (u1+0.00001>time) or (s='0') or (s='1') or (s='2') or (s='3')
  or (s='4') or (s='5') or (s='6') or (s='7') or (s='8') or (s='9') or (s=':')
  or (s=';') or (s='<') or (s='=') or (s='>') or (s='?');

 Caractere:=s[1];
 CommPortNewHetero.FlushBuffers(true,true);
 {on vire ce qu'il y a dans le buffer
 pour la lecture suivante : essentiel si on laisse le port serie ouvert}

end;


procedure TSeqNewHeteroForm.piSur2Simple;
{sequence pi/2 simple}
var i:integer;
begin
InitialiseSequence;
pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;

pulsedialogue.piSur2PiDialogue.label2.visible:=false;
pulsedialogue.piSur2PiDialogue.label3.visible:=false;
pulsedialogue.piSur2PiDialogue.pi.visible:=false;
pulsedialogue.piSur2PiDialogue.tau.visible:=false;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Repetition...';

pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TC, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2 simple';

end;

procedure TSeqNewHeteroForm.piSur2PiSimple;
{sequence pi/2 pi simple}
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;



pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple';

end;

procedure TSeqNewHeteroForm.piSur2Pi2StepsPhaseREcombination;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;



pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
 pulsedialogue.PiSur2PiDialogue.showmodal;
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse  phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,180); wait for TR, the repetition time, at phase 180');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple 2 steps phase recombination';
MessageDlg('Phase Recombination : plug OUT LO PPALE to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi2StepsSmartPhaseREcombination;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('WAIT2(0.001,0); reception phase set from SEC channel, here 0');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,180); reception phase set at 180');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse of length TA, amplitude AA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');
editseqNoncompiled.Lines.Add('');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple 2 steps smart phase recombination';
MessageDlg('Smart Phase Recombination : plug OUT LO SECOND to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi2StepsSoftREcombination;
var i:integer;
begin
InitialiseSequence;

 pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;


editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse  phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=2;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='-X';
TableauSignesReception.cells[2,2]:='-Y';
ModeAcquisitionStandard.State:=cbUnChecked;
SansRafraichissement.State:=cbChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 2 steps soft recombination';

end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsPhaseREcombination;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,270); phase 270');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,180); phase 180');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,90); phase 90');


erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps phase recombination';
MessageDlg('Phase Recombination : plug OUT LO PPALE to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsSmartPhaseREcombination;
var i:integer;
begin
InitialiseSequence;

 pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('WAIT2(0.001,0); reception phase set from SEC channel, here 0');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,270); reception phase set from SEC channel, here 270');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); rf pulse of length TA, amplitude AA, phase 90');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,180); reception phase set at 180');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); rf pulse of length TA, amplitude AA, phase 180');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,90); reception phase set from SEC channel, here 90');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); rf pulse of length TA, amplitude AA, phase 270');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple 2 steps smart phase recombination';
MessageDlg('Smart Phase Recombination : plug OUT LO SECOND to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsSoftREcombination;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=false;
pulsedialogue.piSur2PiDialogue.label8.visible:=false;
pulsedialogue.piSur2PiDialogue.label9.visible:=false;
pulsedialogue.piSur2PiDialogue.delay.visible:=false;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=false;


pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='PiSur2-Tau-Pi-Repetition...';
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;

editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); phase 0');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='+Y'; {corrig par rapport  premiere version}
TableauSignesReception.cells[2,2]:='-X';
TableauSignesReception.cells[1,3]:='-X';
TableauSignesReception.cells[2,3]:='-Y';
TableauSignesReception.cells[1,4]:='-Y';
TableauSignesReception.cells[2,4]:='+X';
ModeAcquisitionStandard.State:=cbUnChecked;
SansRafraichissement.State:=cbChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps soft recombination';
end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsPhaseREcombinationT1;
var i:integer;
begin
InitialiseSequence;


pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,270); phase 270');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,180); phase 180');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,90); phase 90');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps phase recombination for T1';
MessageDlg('Phase Recombination : plug OUT LO PPALE to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsSmartPhaseREcombinationT1;
var i:integer;
begin
InitialiseSequence;


pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('WAIT2(0.001,0); reception phase set from SEC channel, here 0');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,270); reception phase set from SEC channel, here 270');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); ');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,180); reception phase set from SEC channel, here 180');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); ');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('WAIT2(0.001,90); reception phase set from SEC channel, here 90');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); ');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps smart phase recombination for T1';
MessageDlg('Smart Phase Recombination : plug OUT LO SECOND to IN LO.', mtWarning, [mbOk], 0);
end;

procedure TSeqNewHeteroForm.piSur2Pi4StepsSoftREcombinationT1;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,90); phase 90 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); ');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,180); phase 180 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0); ');
editseqNoncompiled.Lines.Add('');
editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TRIGACQ; TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,270); phase 270 ');
editseqNoncompiled.Lines.Add('WAIT(TC,0); ');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); ');
editseqNoncompiled.Lines.Add('WAIT(TR,0);');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
TableauSignesReception.cells[1,2]:='+Y'; {corrig par rapport  premiere version}
TableauSignesReception.cells[2,2]:='-X';
TableauSignesReception.cells[1,3]:='-X';
TableauSignesReception.cells[2,3]:='-Y';
TableauSignesReception.cells[1,4]:='-Y';
TableauSignesReception.cells[2,4]:='+X';
ModeAcquisitionStandard.State:=cbUnChecked;
SansRafraichissement.State:=cbChecked;
NomSequenceRMN.Caption:='PiSur2-Pi 4 steps soft recombination for T1';
end;


procedure TSeqNewHeteroForm.piSur2PiSimpleT1;
var i:integer;
begin
InitialiseSequence;

pulsedialogue.piSur2PiDialogue.label7.visible:=true;
pulsedialogue.piSur2PiDialogue.label8.visible:=true;
pulsedialogue.piSur2PiDialogue.label9.visible:=true;
pulsedialogue.piSur2PiDialogue.delay.visible:=true;
pulsedialogue.piSur2PiDialogue.saturationpulse.visible:=true;
pulsedialogue.piSur2PiDialogue.label5.caption:='sat-delay-PiSur2-Tau-Pi-Repetition...';

pulsedialogue.piSur2PiDialogue.label2.visible:=true;
pulsedialogue.piSur2PiDialogue.label3.visible:=true;
pulsedialogue.piSur2PiDialogue.pi.visible:=true;
pulsedialogue.piSur2PiDialogue.tau.visible:=true;
pulsedialogue.PiSur2PiDialogue.showmodal;
listseqpar.cells[1,1]:=pulsedialogue.PiSur2PiDialogue.piSur2.text;
listseqpar.cells[1,2]:=pulsedialogue.PiSur2PiDialogue.pi.text;
listseqpar.cells[1,3]:=pulsedialogue.PiSur2PiDialogue.tau.text;
listseqpar.cells[1,18]:=pulsedialogue.PiSur2PiDialogue.repetition.text;
listseqpar.cells[2,1]:=pulsedialogue.PiSur2PiDialogue.amplitude.text;
listseqpar.cells[1,5]:=pulsedialogue.PiSur2PiDialogue.saturationpulse.text;
listseqpar.cells[1,4]:=pulsedialogue.PiSur2PiDialogue.delay.text;


editseqNoncompiled.Lines.Add('PULSE(TE,AA,0); saturation rf pulse of length TE, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TD,0); delay TD for T1 measurement');
editseqNoncompiled.Lines.Add('T0.005,TTLC,TRIGACQ; TTL on C and TRIG ACQ');
editseqNoncompiled.Lines.Add('PULSE(TA,AA,0); rf pulse of length TA, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TC,0); wait for TC, at phase 0');
editseqNoncompiled.Lines.Add('PULSE(TB,AA,0); rf pulse of length TB, amplitude AA, phase 0');
editseqNoncompiled.Lines.Add('WAIT(TR,0); wait for TR, the repetition time, at phase 0');
editseqNoncompiled.Lines.Add('');

erasetableauSignesREception;
NombreStepsPourReception:=1;
TableauSignesReception.cells[1,1]:='+X';
TableauSignesReception.cells[2,1]:='+Y';
ModeAcquisitionStandard.State:=cbChecked;
SansRafraichissement.State:=cbUnChecked;
NomSequenceRMN.Caption:='PiSur2-Pi simple for T1';
end;

procedure TSeqNewHeteroForm.SequencesClick(Sender: TObject);
begin

   if Sequences.Text='pi/2' then piSur2Simple;
   if Sequences.Text='pi/2-pi simple' then piSur2PiSimple;
   if Sequences.Text='pi/2-pi 2 steps phase recombination' then piSur2Pi2StepsPhaseRecombination;
   if Sequences.Text='pi/2-pi 2 steps smart phase recombination' then piSur2Pi2StepssmartPhaseRecombination;
   if Sequences.Text='pi/2-pi 2 steps soft recombination' then piSur2Pi2StepsSoftRecombination;
   if Sequences.Text='pi/2-pi 4 steps phase recombination' then piSur2Pi4StepsPhaseRecombination;
   if Sequences.Text='pi/2-pi 4 steps smart phase recombination' then piSur2Pi4StepssmartPhaseRecombination;
   if Sequences.Text='pi/2-pi 4 steps soft recombination' then piSur2Pi4StepsSoftRecombination;
{   if Sequences.Text='pi/2-pi T1' then piSur2PiSimpleT1; }
   if Sequences.Text='pi/2-pi simple for T1' then piSur2PiSimpleT1;
   if Sequences.Text='pi/2-pi 4 steps phase recombination for T1' then piSur2Pi4StepsPhaseRecombinationT1;
   if Sequences.Text='pi/2-pi 4 steps smart phase recombination for T1' then piSur2Pi4StepsSmartPhaseRecombinationT1;
   if Sequences.Text='pi/2-pi 4 steps soft recombination for T1' then piSur2Pi4StepsSoftRecombinationT1;
 {  if Sequences.Text='pi/2-pi 4 steps soft recombination T1' then piSur2Pi4StepsSoftRecombinationT1;

   if Sequences.Text='cyclop' then cyclop;
 }
end;

end.
