unit receptionNewHetero;
{RECEPTION POUR SPECTROS HETERODYNE DEPUIS 2003 (le old hetero est dans Reception)}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Menus, Buttons,ExtCtrls, xyGraph,  ComCtrls, Spin,  ToolWin,
  math, EditReal,editdata,DrapeauAlloulUnit, Comrs232;

type
  TReceptionNewHeteroForm = class(TForm)
    L_GainHF1: TLabel;
    L_GainLo0: TLabel;
    Label3: TLabel;
    explicationHF: TLabel;
    explicationBF1: TLabel;
    Label2: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label8: TLabel;
    Button4: TButton;
    gainhf: TEdit;
    gainbf0: TEdit;
    gainbf90: TEdit;
    Offset0: TEdit;
    Offset90: TEdit;
    correctionQuadrature: TEdit;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    SpinButton3: TSpinButton;
    Label10: TLabel;
    Label11: TLabel;
    explicationBF2: TLabel;
    Button1: TButton;
    Label5: TLabel;
    LowPassFilterBox: TComboBox;
    amplis: TLabel;
  procedure FormCreate(Sender: TObject);
  procedure SauveParametresReception;
  procedure valideparametresreception;
  procedure ouverture;
  procedure ChangeGainHF(valeur:integer);
  procedure ChangeGainBF0(valeur:integer);
  procedure ChangeGainBF90(valeur:integer);
  procedure ChangeOffset0(valeur:integer);
  procedure ChangeOffset90(valeur:integer);
  procedure ChangePhase(valeur:extended);
  procedure ChangeCorrectionQuadrature(valeur:integer);
  procedure ChangeLowPassFilter;
    procedure Button4Click(Sender: TObject);
    procedure InitialiseParametresReception;
    procedure gainhfClick(Sender: TObject);
    procedure gainhfKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure gainbf0KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gainbf90KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure Offset0KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Offset90KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure correctionQuadratureKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure LowPassFilterBoxChange(Sender: TObject);



  private
      FTempInBuffer2              : pointer;
      DrapeauEnCoursDeModif:boolean;
      DrapeauDebutProgramme:boolean;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  ReceptionNewHeteroForm: TReceptionNewHeteroForm;

implementation

uses SeqNewHetero;

{$R *.DFM}

procedure TReceptionNewHeteroForm.FormCreate(Sender: TObject);
var nomFichier:string;chaineTableau:array[0..100] of string;fich2:textfile;
t0,t:real;
i:integer;  chaine:string;
begin
     if DrapeauSpectroHetero2005=true then
        begin
        label3.caption:='Reception Heterodyne 2005';
        LowPassFilterBox.visible:=true;
        label5.visible:=true;
        label13.caption:='possible between -32768 and 32767';
        label10.caption:=' ';
        amplis.caption:='Amplis : 18 dB -> ampli HF -> 30 db -> demodulation -> ampli BF -> 20dB';
        explicationHF.caption:='increases linearly (MIN=128 ---> MAX=255) (saturations above 220)';
        explicationBF1.caption:='increases linearly (MIN=60 ---> MAX=255)';
        explicationBF2.caption:='CHOOSE BF90 value = BF0 value - 1 for same amplification';        end;
     if DrapeauSpectroHetero2003=true then
        begin
        label3.caption:='Reception Heterodyne 2003';
        LowPassFilterBox.visible:=false;
        label5.visible:=false;
        label13.caption:='possible between 0 and 65535 by step of 256 : drastic change at 32768';
        label10.caption:='default value 50944';
        amplis.caption:='';
        explicationHF.caption:='increases linearly (MIN=128 ---> MAX=255) (saturations above 200)';
        explicationBF1.caption:='decreases exponentially (MIN=255 ---> MAX=60)';
        explicationBF2.caption:='CHOOSE BF90 value = BF0 value + 3 for same amplification';
        end;

      DrapeauEnCoursDeModif:=false;
      DrapeauDebutProgramme:=true;
      {initialisation de la connexion RS232 necessaire ensuite :
      deja fait dans SeqNewHetero}

      LowPassFilterBox.items.clear;
      LowPassFilterBox.items.add('2 MHz');
      LowPassFilterBox.items.add('200 kHz');
      LowPassFilterBox.items.add('20 kHz');
      LowPassFilterBox.items.add('2 kHz');
      LowPassFilterBox.items.add('200 Hz');
      LowPassFilterBox.items.add('20 Hz');
      LowPassFilterBox.itemindex:=0;
      {initialisation des parametres}

      InitialiseParametresReception;
end;

procedure TReceptionNewHeteroForm.InitialiseParametresReception;
var chaine:string;var t0,t:real;
begin
 {relie les parametres dans parametres rmn.txt et les valide}
  chaine:=LitDansParametresRMN('Gain HF new hetero');
  if chaine<>'' then GainHF.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain BF0 new hetero');
  if chaine<>'' then GainBF0.Text:=chaine;
  chaine:=LitDansParametresRMN('Gain BF90 new hetero');
  if chaine<>'' then GainBF90.Text:=chaine;
  chaine:=LitDansParametresRMN('Offset 0 new hetero');
  if chaine<>'' then Offset0.Text:=chaine;
  chaine:=LitDansParametresRMN('Offset 90 new hetero');
  if chaine<>'' then Offset90.Text:=chaine;
  chaine:=LitDansParametresRMN('Quadrature correction new hetero');
  if chaine<>'' then correctionQuadrature.Text:=chaine;

  if (DrapeauSpectroHetero2005=true) then
     begin
     chaine:=LitDansParametresRMN('Low Pass Filter');
     LowPassFilterBox.itemindex:=0; {valeur par defaut}
     if chaine='2 MHz' then LowPassFilterBox.itemindex:=0;
     if chaine='200 kHz' then LowPassFilterBox.itemindex:=1;
     if chaine='20 kHz' then LowPassFilterBox.itemindex:=2;
     if chaine='2 kHz' then LowPassFilterBox.itemindex:=3;
     if chaine='200 Hz' then LowPassFilterBox.itemindex:=4;
     if chaine='20 Hz' then LowPassFilterBox.itemindex:=5;
     end;

  SauveParametresReception;
  if drapeauDebutProgramme=true then drapeauDebutProgramme:=false;
{  else MessageDlg('Attention, you reinitialized the spectrometer so the pulse sequence was stopped.', mtWarning, [mbOk], 0);}
  {attente qui permet que ca marche... Je ne sais pas pourquoi}

  ValideParametresReception;
end;

procedure TReceptionNewHeteroForm.SauveParametresReception;
{sauve dans parametres rmn.txt les parametres de la fenetre}
begin
  EcritDansParametresRMN('Gain HF new hetero',GainHF.text);
  EcritDansParametresRMN('Gain BF0 new hetero',GainBF0.text);
  EcritDansParametresRMN('Gain BF90 new hetero',GainBF90.text);
  EcritDansParametresRMN('Offset 0 new hetero',offset0.text);
  EcritDansParametresRMN('Offset 90 new hetero',offset90.text);
  EcritDansParametresRMN('Additional phase new hetero ','0');
  EcritDansParametresRMN('Quadrature correction new hetero',correctionquadrature.text);
  if (DrapeauSpectroHetero2005=true) then  EcritDansParametresRMN('Low Pass Filter',LowPassFilterBox.text);

end;

procedure TReceptionNewHeteroForm.valideparametresreception;
{sauve dans parametres rmn.txt les parametres de la fenetre}
var nombre:extended;err:integer;
begin
   val(gainhf.text,nombre,err);
   if (err=0) then changegainhf(round(nombre));
   val(gainbf0.text,nombre,err);
   if (err=0) then changegainbf0(round(nombre));
   val(gainbf90.text,nombre,err);
   if (err=0) then changegainbf90(round(nombre));
   val(offset0.text,nombre,err);
   if (err=0) then changeoffset0(round(nombre));
   val(offset90.text,nombre,err);
   if (err=0) then changeoffset90(round(nombre));
   val(correctionQuadrature.text,nombre,err);
   if (err=0) then changecorrectionQuadrature(round(nombre));
end;

procedure TReceptionNewHeteroForm.ouverture;
begin
{on affiche la fenetre qui est juste reduite en la maximisant}
ReceptionNewHeteroForm.WindowState:=WsMinimized;
ReceptionNewHeteroForm.WindowState:=WsNormal;
end;

procedure TReceptionNewHeteroForm.ChangeGainHF(valeur:integer);
{ordre L150\r}
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='L'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));

      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeGainBF0(valeur:integer);
{ordre K0N200\r }
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='K0N'+chaine+#13; {ordre de reset du sequenceur}

      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeGainBF90(valeur:integer);
{ordre K1N200\r }
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='K1N'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeOffset0(valeur:integer);
{ordre J0N200\r }
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='J0N'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeOffset90(valeur:integer);
{ordre J1N200\r }
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='J1N'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangePhase(valeur:extended);
{ordre M2700\r }
var chaine,s:string;
begin
      valeur:=valeur*10;
      chaine:=inttostr(round(valeur));
      s:='M'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeCorrectionQuadrature(valeur:integer);
{ordre N17200\r }
var chaine,s:string;
begin
      chaine:=inttostr(valeur);
      s:='N'+chaine+#13; {ordre de reset du sequenceur}
      
      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
end;

procedure TReceptionNewHeteroForm.ChangeLowPassFilter;
{ordre M0, M1... }
var chaine,s:string;
begin
      if (DrapeauSpectroHetero2005=true) then
      begin
      chaine:='M5'; {par defaut : 2MHz}
      if lowpassfilterbox.text='2 MHz' then chaine:='M5';
      if lowpassfilterbox.text='200 kHz' then chaine:='M4';
      if lowpassfilterbox.text='20 kHz' then chaine:='M3';
      if lowpassfilterbox.text='2 kHz' then chaine:='M2';
      if lowpassfilterbox.text='200 Hz' then chaine:='M1';
      if lowpassfilterbox.text='20 Hz' then chaine:='M0';
      s:=chaine+#13;

      SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
      
      SauveParametresReception;
      end;
end;

procedure TReceptionNewHeteroForm.Button4Click(Sender: TObject);
var s:string;
begin
   { MessageDlg('Attention, CLOSE THE RF POWER BECAUSE THERE WILL BE A VERY LONG PULSE !!!', mtWarning, [mbOk], 0);
    
   { s:='ZR'+#13; {ordre de reset du sequenceur}
    {SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));

    {on reinitialise les parametres ici}
    InitialiseParametresReception;

end;

procedure TReceptionNewHeteroForm.gainhfClick(Sender: TObject);
begin
    MessageDlg('click', mtWarning, [mbOk], 0);

end;

procedure TReceptionNewHeteroForm.gainhfKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var chaine:string;
var nombre:extended;err:integer;
begin
   val(gainhf.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changegainhf(round(nombre));
         gainhf.text:=inttostr(round(nombre));
         end;

end;

procedure TReceptionNewHeteroForm.gainbf0KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var nombre:extended;err:integer;
begin
   val(gainbf0.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changegainbf0(round(nombre));
         gainbf0.text:=inttostr(round(nombre));
         end;
end;

procedure TReceptionNewHeteroForm.gainbf90KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var nombre:extended;err:integer;
begin
   val(gainbf90.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changegainbf90(round(nombre));
         gainbf90.text:=inttostr(round(nombre));
         end;

end;


procedure TReceptionNewHeteroForm.Offset0KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var nombre:extended;err:integer;
begin
   val(offset0.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changeoffset0(round(nombre));
         offset0.text:=inttostr(round(nombre));
         end;

end;

procedure TReceptionNewHeteroForm.Offset90KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var nombre:extended;err:integer;
begin
   val(offset90.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changeoffset90(round(nombre));
         offset90.text:=inttostr(round(nombre));
         end;

end;

procedure TReceptionNewHeteroForm.correctionQuadratureKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
var nombre:extended;err:integer;
begin
   val(correctionquadrature.text,nombre,err);
   if (err=0) and (key=13) then
         begin
         changecorrectionquadrature(round(nombre));
         correctionquadrature.text:=inttostr(round(nombre));
         end;

end;

procedure TReceptionNewHeteroForm.SpinButton1DownClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(correctionquadrature.text,nombre,err);
   if (err=0) then begin nombre:=nombre-256;
                         if nombre<0 then nombre:=0;
                         correctionQuadrature.text:=inttostr(round(nombre));
                         changecorrectionquadrature(round(nombre));
                   end;

end;

procedure TReceptionNewHeteroForm.SpinButton1UpClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(correctionquadrature.text,nombre,err);
   if (err=0) then begin nombre:=nombre+256;
                         if DrapeauSpectroHetero2005=true then
                            begin
                            if nombre>32767 then nombre:=32767;
                            end;
                         if DrapeauSpectroHetero2003=true then
                            begin
                            if nombre>65536 then nombre:=65536;
                            end;
                         correctionQuadrature.text:=inttostr(round(nombre));
                         changecorrectionquadrature(round(nombre));
                   end;


end;

procedure TReceptionNewHeteroForm.SpinButton2DownClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(offset0.text,nombre,err);
   if (err=0) then begin nombre:=nombre-256;
                         if DrapeauSpectroHetero2005=true then
                            begin
                            if nombre<-32768 then nombre:=-32768;
                            end;
                         if DrapeauSpectroHetero2003=true then
                            begin
                            if nombre<0 then nombre:=0;
                            end;
                         offset0.text:=inttostr(round(nombre));
                         changeoffset0(round(nombre));
                   end;

end;

procedure TReceptionNewHeteroForm.SpinButton3DownClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(offset90.text,nombre,err);
   if (err=0) then begin nombre:=nombre-256;
 if DrapeauSpectroHetero2005=true then
                            begin
                            if nombre<-32768 then nombre:=-32768;
                            end;
                         if DrapeauSpectroHetero2003=true then
                            begin
                            if nombre<0 then nombre:=0;
                            end;
                         offset90.text:=inttostr(round(nombre));
                         changeoffset90(round(nombre));
                   end;


end;

procedure TReceptionNewHeteroForm.SpinButton2UpClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(offset0.text,nombre,err);
   if (err=0) then begin nombre:=nombre+256;
                         if nombre>65535 then nombre:=65535;
                         offset0.text:=inttostr(round(nombre));
                         changeoffset0(round(nombre));
                   end;
end;

procedure TReceptionNewHeteroForm.SpinButton3UpClick(Sender: TObject);
var nombre:extended;err:integer;
begin
   val(offset90.text,nombre,err);
   if (err=0) then begin nombre:=nombre+256;
                         if nombre>65535 then nombre:=65535;
                         offset90.text:=inttostr(round(nombre));
                         changeoffset90(round(nombre));
                   end;


end;

procedure TReceptionNewHeteroForm.Button1Click(Sender: TObject);
var s:string;
begin
   { s:='ZR'+#13; {ordre de reset du sequenceur}
    {SeqNewHeteroForm.CommPortNewHetero.SendData( pchar(s),length(s));
     }
     if DrapeauSpectroHetero2005=true then
        begin
            {on met les valeurs suivantes par defaut}
            GainHF.Text:='150';
            GainBF0.Text:='100';
            GainBF90.Text:='100';
            Offset0.Text:='0';
            Offset90.Text:='0';
            correctionQuadrature.Text:='0';
            LowPassFilterBox.itemindex:=0; {filtre  2 MHz}
       end;
     if DrapeauSpectroHetero2003=true then
        begin
            {on met les valeurs suivantes par defaut}
            GainHF.Text:='200';
            GainBF0.Text:='100';
            GainBF90.Text:='103';
            Offset0.Text:='27200';
            Offset90.Text:='27200';
            correctionQuadrature.Text:='50944';
       end;
    ValideParametresReception;


end;

procedure TReceptionNewHeteroForm.LowPassFilterBoxChange(Sender: TObject);
begin
changelowpassfilter;
end;

end.
