unit controlesDivers;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,DBctrls,DB, DBTables,Mask,DBConsts;

 const
    valgain:array[1..31] of array[0..4] of char=('1/32','1/16',' 1/8',' 1/4',' 1/2','   1','   2','   4','   8',
    '  16','  32','  64',' 128',' 256',' 512','  1k','  2k','  4k','  8k',
    ' 16k',' 32k',' 64k','128k','256k','512k','  1M','  2M','  4M','  8M',
    ' 16M',' 32M');
    wm_gain=10400;

  type
  Teditnum = class(TEdit)
        private
        fstatic:boolean;
        logfont:tlogfont;
        thefont:hfont;
        cur:hcursor;
        tir:array[1..5] of integer;
        zero:integer;
        ldown:boolean;
        sgn:integer;
        ff:integer;
        posx,posy:longint;
        nbr:longint;
        FCanvas: TControlCanvas;
        fvalue:longint;
        fdec:integer;
        fvalmax:longint;
        fvalmin:longint;
        fboucle:boolean;
        function GetCanvas: TCanvas;
        protected
        function closequery:boolean;virtual;
        procedure update;override;
        procedure wmlbuttondown(var msg:tmessage);message wm_lbuttondown;
        procedure wmmousemove(var msg:tmessage);message wm_mousemove;
        procedure time(var msg:tmessage);message wm_timer;
        procedure wmrbuttondown(var msg:tmessage);message wm_rbuttondown;
        procedure wmlbuttonup(var msg:tmessage);message wm_lbuttonup;
        procedure wmrbuttonup(var msg:tmessage);message wm_rbuttonup;
        procedure perd(var msg:tmessage);message wm_user+1000;
        destructor free;
        public
        property Canvas: TCanvas read GetCanvas;
        constructor create(Aowner: Tcomponent);override;
        procedure setnum(value:longint);
        function getnum:longint;
        procedure loaded;override;
        published
        property valeur:longint read getnum write setnum ;
        property max:longint read fvalmax write fvalmax ;
        property min:longint read fvalmin write fvalmin ;
        property decimale:integer read fdec write fdec ;
        property boucle:boolean read fboucle write fboucle;
        property static:boolean read fstatic write fstatic;
    { Dclarations publies }
  end;

  type
    Pperbox=^Tperbox;
    Tperbox=class(Tcustomcontrol)
    private
    fcouleur:tcolor;
    fvalue:longint;
    fspectre:integer;
    fvalmax:longint;
    fvalmin:longint;
    FOnChange: TNotifyEvent;
    protected
    procedure Hscrolmsg(var msg:TWMScroll); message WM_HSCROLL;
    procedure CNCommand(var Message: TWMCommand); message WM_COMMAND;
    public
    scrol:Tscrollbar;
    box:Tcheckbox;
    st:Tedit;
    graph:hwnd;
    constructor create(Aowner:Tcomponent);override;
    procedure loaded;override;
    function getval:longint;
    procedure refresh;
    procedure setval(value:longint);
    procedure check;
    procedure uncheck;
    function getcheck:word;
    procedure wmlbuttondown(var msg:tmessage);message wm_lbuttondown;
    procedure wmrbuttondown(var msg:tmessage);message wm_rbuttondown;
    procedure Paint; override;
    published
    property onchange:tnotifyevent read Fonchange write Fonchange;
    property valeur:longint read getval write setval;
    property max:longint read fvalmax write fvalmax ;
    property min:longint read fvalmin write fvalmin ;
    property spectre:integer read fspectre write fspectre ;
    property couleur:tcolor read fcouleur write fcouleur;
    end;

    type
    Pline=^Tline;
    Tline=class(Tcustomcontrol)
    private
    oldline:array[1..256,1..2] of longint;
    fpos:longint;
    fcoul:tcolor;
    protected
    procedure setpos(value:longint);
    public
    graph:hwnd;
    property couleur:tcolor read fcoul write fcoul;
    property pos:longint read fpos write setpos;
    procedure deplace(pos1:longint);
    procedure efface;
    procedure dessine(pos1:longint);
    constructor create(Aowner:Tcomponent);override;
    destructor free;
    end;


  Tgraph1dtyp = set of (grpoint, grligne,grmodulo,grlog,
  grgrillevert,grgrillehorz,grgrilldothorz,grgrilldotvert,grcurseur);
  Tgraph1cent =(grcentre,grbas,grhaut,grquart);
  type
    Tgraph1D=class(Tcustomcontrol)
    private
    fdil:integer; {coefficient de dilatation taillesp div 2^ln width}
    fligne1:longint;
    fligne2:longint;
    fgrilv:integer;{ecart grille verticale}
    fgrilh:integer;{ecart grille horizontale}
    fgrilcoul:tcolor;{couleur de grille}
    ftaillspectre:longint;{taille totale des spectres}
    fnbresp:integer;{nombre de spectres}
    ftypeaff:Tgraph1dtyp;{type d'affichage}
    fdilat:integer; {dilatation}
    ftrans:longint;{translation}
    fcoulsp:array[1..8] of tcolor;
    fdilsp:array[1..8] of real;
    ftrsp:array[1..8] of longint;
    fgasp:array[1..8] of integer;
    fvis:array[1..8] of boolean;
    fdepl:array[1..8] of integer;
    fzero:Tgraph1cent;
    trscrol:Tscrollbar;
    discrol:Tscrollbar;
    tredit:tedit;
    diedit:tedit;
    procedure setcoulsp(index:integer;value:tcolor);
    procedure setdilsp(index:integer;value:real);
    procedure settrsp(index:integer;value:longint);
    procedure setgasp(index:integer;value:integer);
    procedure setvis(index:integer;value:boolean);
    procedure setdepl(index:integer;value:integer);
    procedure param(var msg:tmessage);message wm_user+wm_gain;
    protected
    procedure Hscrolmsg(var msg:TWMScroll); message WM_HSCROLL;
    procedure wmlbuttondown(var msg:tmessage);message wm_lbuttondown;
    procedure wmrbuttondown(var msg:tmessage);message wm_rbuttondown;
    procedure settrans(value:longint);
    procedure setdilat(value:integer);
    public
    spe:variant;{contiendra le tableau des data}
    lin1,lin2:tline;
    constructor create(Aowner:Tcomponent);override;
    procedure loaded;override;
    procedure Paint; override;
    procedure redessiner;
    property coulsp[index:integer]:tcolor write setcoulsp;
    property dilsp[index:integer]:real write setdilsp;
    property trsp[index:integer]:longint write settrsp;
    property gasp[index:integer]:integer write setgasp;
    property vis[index:integer]:boolean write setvis;
    property depl[index:integer]:integer write setdepl;
    published
    property ligne1:longint read fligne1 write fligne1;
    property ligne2:longint read fligne2 write fligne2;
    property grillevert:integer read fgrilv write fgrilv;
    property grillehorz:integer read fgrilh write fgrilh;
    property couleurgrille:tcolor read fgrilcoul write fgrilcoul;
    property taillesp:longint read ftaillspectre write ftaillspectre;
    property nbresp:integer read fnbresp write fnbresp;
    property dilatation:integer read fdilat write setdilat default 32;
    property translation:longint read ftrans write settrans default 0;
    property typeaff:Tgraph1dtyp read ftypeaff write ftypeaff;
    property zero:Tgraph1cent read fzero write fzero;
    end;

type
  TDCComboBox = class(TCustomComboBox)
  private
    FDataLink: TFieldDataLink;
    FPaintControl: TPaintControl;
    procedure DataChange(Sender: TObject);
    procedure EditingChange(Sender: TObject);
    function GetComboText: string;
    function GetDataField: string;
    function GetDataSource: TDataSource;
    function GetField: TField;
    function GetReadOnly: Boolean;
    procedure SetComboText(const Value: string);
    procedure SetDataField(const Value: string);
    procedure SetDataSource(Value: TDataSource);
    procedure SetEditReadOnly;
    procedure SetItems(Value: TStrings);
    procedure SetReadOnly(Value: Boolean);
    procedure UpdateData(Sender: TObject);
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure CMGetDataLink(var Message: TMessage); message CM_GETDATALINK;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    procedure Click; override;
    procedure ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
      ComboProc: Pointer); override;
    procedure CreateWnd; override;
    procedure DropDown; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure SetStyle(Value: TComboboxStyle); override;
    procedure WndProc(var Message: TMessage); override;
    procedure Change; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure refresh;
    property Field: TField read GetField;
    property Text;
  published
    property Style; {Must be published before Items}
    property Color;
    property Ctl3D;
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property DragMode;
    property DragCursor;
    property DropDownCount;
    property Enabled;
    property Font;
    property ItemHeight;
    property Items write SetItems;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDrag;
  end;

type

{ Tdcctrlgrid }

  Tdcctrlgrid = class;

  TdcctrlgridLink = class(TDataLink)
  private
    Fdcctrlgrid: Tdcctrlgrid;
  protected
    procedure ActiveChanged; override;
    procedure DataSetChanged; override;
  public
    constructor Create(dcctrlgrid: Tdcctrlgrid);
  end;

  TDBCtrlPanel = class(TWinControl)
  private
    Fdcctrlgrid: Tdcctrlgrid;
    procedure CMControlListChange(var Message: TCMControlListChange); message CM_CONTROLLISTCHANGE;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
  protected
    procedure PaintWindow(DC: HDC); override;
  public
    constructor Createlinked(dcctrlgrid: Tdcctrlgrid);
  end;

  TdcctrlgridOrientation = (goVertical, goHorizontal);
  TdcctrlgridBorder = (gbNone, gbRaised);
  TdcctrlgridKey = (gkNull, gkEditMode, gkPriorTab, gkNextTab, gkLeft,
    gkRight, gkUp, gkDown, gkScrollUp, gkScrollDown, gkPageUp, gkPageDown,
    gkHome, gkEnd, gkInsert, gkAppend, gkDelete, gkCancel);

  TPaintPanelEvent = procedure(dcctrlgrid: Tdcctrlgrid;
    Index: Integer) of object;

  Tdcctrlgrid = class(TWinControl)
  private
    FDataLink: TdcctrlgridLink;
    FPanel: TDBCtrlPanel;
    FCanvas: TCanvas;
    FColCount: Integer;
    FRowCount: Integer;
    FPanelWidth: Integer;
    FPanelHeight: Integer;
    FPanelIndex: Integer;
    FPanelCount: Integer;
    FBitmapCount: Integer;
    FPanelBitmap: HBitmap;
    FSaveBitmap: HBitmap;
    FPanelDC: HDC;
    FOrientation: TdcctrlgridOrientation;
    FPanelBorder: TdcctrlgridBorder;
    FAllowInsert: Boolean;
    FAllowDelete: Boolean;
    FShowFocus: Boolean;
    FFocused: Boolean;
    FOnPaintPanel: TPaintPanelEvent;
    function AcquireFocus: Boolean;
    procedure AdjustSize;override;
    procedure CreatePanelBitmap;
    procedure DataSetChanged(Reset: Boolean);
    procedure DestroyPanelBitmap;
    procedure DrawPanel(DC: HDC; Index: Integer);
    procedure DrawPanelBackground(DC: HDC; const R: TRect; Erase: Boolean);
    function GetDataSource: TDataSource;
    function GetEditMode: Boolean;
    function GetPanelBounds(Index: Integer): TRect;
    function PointInPanel(const P: TSmallPoint): Boolean;
    procedure Reset;
    procedure Scroll(Inc: Integer; ScrollLock: Boolean);
    procedure ScrollMessage(var Message: TWMScroll);
    procedure SelectNext(GoForward: Boolean);
    procedure SetColCount(Value: Integer);
    procedure SetDataSource(Value: TDataSource);
    procedure SetEditMode(Value: Boolean);
    procedure SetOrientation(Value: TdcctrlgridOrientation);
    procedure SetPanelBorder(Value: TdcctrlgridBorder);
    procedure SetPanelHeight(Value: Integer);
    procedure SetPanelIndex(Value: Integer);
    procedure SetPanelWidth(Value: Integer);
    procedure SetRowCount(Value: Integer);
    procedure UpdateDataLinks(Control: TControl; Inserting: Boolean);
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMChildKey(var Message: TCMChildKey); message CM_CHILDKEY;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    function GetChildParent: TComponent; override;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
    procedure PaintPanel(Index: Integer); virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure ReadState(Reader: TReader); override;
  public
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;  
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DoKey(Key: TdcctrlgridKey);
    procedure GetTabOrderList(List: TList); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    property Canvas: TCanvas read FCanvas;
    property EditMode: Boolean read GetEditMode write SetEditMode;
    property PanelCount: Integer read FPanelCount;
    property PanelIndex: Integer read FPanelIndex write SetPanelIndex;
  published
    property AllowDelete: Boolean read FAllowDelete write FAllowDelete default True;
    property AllowInsert: Boolean read FAllowInsert write FAllowInsert default True;
    property ColCount: Integer read FColCount write SetColCount;
    property Color;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property Orientation: TdcctrlgridOrientation read FOrientation write SetOrientation default goVertical;
    property PanelBorder: TdcctrlgridBorder read FPanelBorder write SetPanelBorder default gbRaised;
    property PanelHeight: Integer read FPanelHeight write SetPanelHeight;
    property PanelWidth: Integer read FPanelWidth write SetPanelWidth;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property TabOrder;
    property TabStop default True;
    property RowCount: Integer read FRowCount write SetRowCount;
    property ShowFocus: Boolean read FShowFocus write FShowFocus default True;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaintPanel: TPaintPanelEvent read FOnPaintPanel write FOnPaintPanel;
    property OnStartDrag;
  end;

procedure Register;

implementation

{$R c:\res\owncon.RES}

procedure Register;
begin
  RegisterComponents('PilotageManip', [Teditnum,Tperbox,Tgraph1D,TDCComboBox,Tdcctrlgrid]);
end;

function power2(i:integer):longint;
var
j,k:longint;
begin
j:=i;k:=1;
if j>=31 then j:=31;
while j>0 do begin
k:=k*2;j:=j-1;end;
power2:=k;
end;


constructor Teditnum.create(Aowner: Tcomponent);
  begin
  inherited create(Aowner);
        ldown:=false;
        height:=14;
        ff:=-1;
        readonly:=true;
        maxlength:=5;
        Fcanvas:=Tcontrolcanvas.create;
        with font do
         begin
          height:=-11;
          size:=10;
          name:='Terminal';
          pitch:=fpfixed;
         end;
         max:=99999;
         min:=0;
         boucle:=false;
         end;

procedure teditnum.loaded;
 begin
 inherited;
 width:=maxlength*8+9 ;
 zero:=width-fdec*8-5;
 setnum(fvalue);
 cur:= loadcursor(hinstance,'palet');
 end;

function Teditnum.GetCanvas: TCanvas;
  begin
  Result := FCanvas;
  end;


function teditnum.closequery;
  begin
  closequery:=true;
  end;

procedure Teditnum.update;
  begin
  setnum(fvalue);
  inherited update;
  end;


destructor teditnum.free;
  begin
  Fcanvas.free;
  inherited free;
  end;

procedure  teditnum.wmlbuttondown(var msg:tmessage);
   var
   nbre:longint;
   t:real;
   begin
   if not fstatic  then begin
   nbre:=getnum;
   posy:=nbre+msg.lparamhi;
   if (msg.lparamlo<1) then posx:=0 else begin
     t:=maxlength-(msg.lparamlo+8) div 8;
     if t>9 then t:=9;
     posx:=round(exp(t*ln(10)));
     end;
     nbre:=nbre+posx;
     setnum(nbre);
     settimer(handle,3,400,nil);
     sgn:=1;
     setcursor(cur);
     setcapture(handle);
    end;
   end;

  procedure  teditnum.wmrbuttondown(var msg:tmessage);
  var
   nbre:longint;
   t:real;
  begin
  if not fstatic then begin
  nbre:=getnum;
  posy:=nbre+msg.lparamhi;
  if (msg.lparamlo<1) then posx:=0 else begin
  t:=maxlength-(msg.lparamlo+5) div 8;
  if t>9 then t:=9;
  posx:=round(exp(t*ln(10)));
  end;
  nbre:=nbre-posx;
  setnum(nbre);
  settimer(handle,3,400,nil);
  sgn:=-1;
  setcursor(cur);
  setcapture(handle);
  end;
  end;


  procedure  teditnum.wmlbuttonup(var msg:tmessage);
  begin
  if not fstatic then begin
  killtimer(handle,3);
  releasecapture;
  ff:=0;sgn:=1;
  setcursor(cur);
  end;
  inherited;
  end;

  procedure  teditnum.wmrbuttonup(var msg:tmessage);
  begin
  if not fstatic then begin
  killtimer(handle,3);
  releasecapture;
  sgn:=-1;ff:=0;
  setcursor(cur);
  end;
  inherited;
  end;

  procedure  teditnum.wmmousemove(var msg:tmessage);
  var
  t:real;
  begin
  if not fstatic then begin
  if (msg.lparamlo<13) then posx:=0 else begin
  t:=maxlength-(integer(msg.lparamlo)+5) div 8;
  if t>9 then t:=9;
  if t<0 then t:=0;
  posx:=round(exp(t*ln(10)));
  end;
  setcursor(cur);
  end;
  end;

  procedure teditnum.time(var msg:tmessage);
  var
  nbre:longint;
  begin
  if msg.wparam=3 then
  begin
  nbre:=getnum;
  nbre:=nbre+posx*sgn;
  setnum(nbre);
  ff:=ff+1;
  settimer(handle,3,150,nil);
  if (ff>=5) then settimer(handle,3,90,nil);
  if (ff>=15) then settimer(handle,3,30,nil);
  if (ff mod 15=0) then posx:=posx*2;
  end;
  end;

  procedure teditnum.perd(var msg:tmessage);
  begin
  if not fstatic then begin
  killtimer(handle,3);
  sgn:=-1;ff:=0;
  end;
  end;


  function teditnum.getnum;
  var
  mt:array[0..30] of char;
  s:string;
  err:integer;
  nbre:longint;
  begin
  gettextbuf(mt,30);
  s:=strpas(mt);val(s,nbre,err);getnum:=nbre;
  end;

  procedure teditnum.setnum(value:longint);
  var
  mt:array[0..30] of char;
  s:string;
  i:integer;
  nbre:longint;
  begin
  nbre:=value;
  if fboucle then
  begin
   nbre:=nbre mod (fvalmax+1);
   if (nbre<fvalmin)  then nbre:=fvalmin+fvalmax;
  end else begin
   if (nbre<fvalmin)  then nbre:=fvalmin;
   if (nbre>fvalmax)  then nbre:=fvalmax;
  end;
  str(nbre,s);
  while length(s)<maxlength do s:=' '+s;
  strpcopy(mt,s);
  settextbuf(mt);
  fcanvas.handle:=getDC(handle);
  fcanvas.pen.width:=5;
  fcanvas.pen.style:=pssolid;
  fcanvas.pen.color:=0;
  selectobject(fcanvas.handle,getstockobject(Black_brush));
  for i:=1 to 5 do begin
  tir[i]:=zero-i*24;
  if tir[i]<5 then tir[i]:=0;
  if FCanvas <> nil then begin
   fcanvas.moveto(tir[i],13);
   fcanvas.lineto(tir[i],16);
  end;
  end;
  if zero>0 then
  if FCanvas <> nil then fcanvas.ellipse(zero-1,13,zero+1,15);
  releaseDC(handle,fcanvas.handle);
  if(nbre<>nbr) then begin
  sendmessage(parent.handle,wm_user+1010,componentindex,nbre);
  nbr:=nbre;
  end;
  end;

{----------perbox---------boite a cocher+editeur+scroll-----}

    constructor Tperbox.create(Aowner:Tcomponent);
    const
    perStyle = [csClickEvents, csSetCaption, csDoubleClicks, csFixedHeight,csFramed];
    begin
    inherited create(Aowner);
    ControlStyle := perStyle;
    scrol:=tscrollbar.create(self);scrol.parent:=self;
    box:=tcheckbox.create(self);box.parent:=self;
    st:=tedit.create(self);st.parent:=self;
    min:=1;
    max:=31;
    valeur:=1;
    spectre:=1;
    {controlstyle:=csFramed;}
    color:=clWindow;
    end;

    procedure Tperbox.loaded;
    begin
    inherited;
    width:=125;height:=15;
    scrol.left:=30;scrol.top:=0;scrol.width:=55;scrol.height:=15;
    box.left:=15;box.top:=0;box.width:=15;box.height:=15;
    st.left:=90;st.top:=0;st.width:=35;st.height:=15;
    st.readonly:=true;
    scrol.setparams(fvalmin,fvalmin,fvalmax);
    box.state:=cbChecked;
    if fvalmax>31 then fvalmax:=31;
    if fvalmin<1 then fvalmin:=1;
    graph:=parent.handle;
    end;

    procedure Tperbox.paint;
    var
    mt:array[0..3] of char;
    begin
    inherited paint;
    strpcopy(mt,chr(64+spectre)+':');
    setbkmode(canvas.handle,transparent);
    settextcolor(canvas.handle,couleur);
    canvas.textout(1,1,chr(64+spectre)+':');
    end;

    procedure tperbox.Hscrolmsg(var msg:TWMScroll);
    begin
    fvalue:=scrol.position;
    if fvalue>fvalmax then fvalue:=fvalmax;
    if fvalue<fvalmin then fvalue:=fvalmin;
    if msg.scrollcode=8 then setval(fvalue) else
    st.settextbuf(valgain[fvalue]);
    inherited;
    end;

    procedure Tperbox.CNCommand(var Message: TWMCommand);
    begin
    if Message.NotifyCode = BN_CLICKED then
    sendmessage(graph,wm_user+wm_gain,spectre,2+getcheck);
    inherited;
    end;

    function Tperbox.getval:longint;
    begin
    getval:=fvalue;
    end;

    procedure Tperbox.setval(value:longint);
    begin
    fvalue:=value;
    if fvalue>fvalmax then fvalue:=fvalmax;
    if fvalue<fvalmin then fvalue:=fvalmin;
    st.settextbuf(valgain[fvalue]);
    scrol.position:=fvalue;
    sendmessage(graph,wm_user+wm_gain,spectre+10,fvalue);
    end;

    procedure Tperbox.check;
    begin
    box.state:=cbchecked;
    sendmessage(graph,wm_user+wm_gain,spectre,3);
    end;

    procedure Tperbox.uncheck;
    begin
    box.state:=cbunchecked;
    sendmessage(graph,wm_user+wm_gain,spectre,2);
    end;

    procedure Tperbox.Refresh;
    begin
    setval(fvalue);
    inherited refresh;
    end;

    function Tperbox.getcheck:word;
    begin
    if box.state=cbchecked then getcheck:=1 else getcheck:=0;
    end;

    procedure Tperbox.wmlbuttondown(var msg:tmessage);
    begin
    if (msg.lparamlo<10) then begin
    sendmessage(graph,wm_user+wm_gain,spectre,1);
    refresh;
    end;
    end;

    procedure Tperbox.wmrbuttondown(var msg:tmessage);
    begin
    if (msg.lparamlo<10) then begin
    sendmessage(graph,wm_user+wm_gain,spectre,-1);
    end;
    end;

{-------------------------graphiques 1D-------------------------------------}

    constructor Tgraph1D.create(Aowner:Tcomponent);
    const
    perStyle = [csClickEvents, csSetCaption, csDoubleClicks, csFixedHeight,csFramed];
    begin
    inherited create(Aowner);
    ControlStyle := perStyle;
    discrol:=tscrollbar.create(self);discrol.parent:=self;
    trscrol:=tscrollbar.create(self);trscrol.parent:=self;
    diedit:=tedit.create(self);diedit.parent:=self;
    tredit:=tedit.create(self);tredit.parent:=self;
    lin1:=tline.create(self);lin1.parent:=self;
    lin2:=tline.create(self);lin2.parent:=self;
    color:=clWhite;
    grillevert:=32;
    grillehorz:=32;
    width:=512;
    height:=272;
    couleurgrille:=clgray;
    taillesp:=16384;
    nbresp:=8;
    dilatation:=32;
    translation:=0;
    setcoulsp(0,clwindow);
    setdilsp(0,1);
    settrsp(0,0);
    setgasp(0,1);
    setvis(0,true);
    zero:=grcentre;
    typeaff:=[grligne,grgrilldotvert,grgrilldothorz,grcurseur];
    end;


    procedure Tgraph1D.loaded;
    var
    i,j:integer;
    u:real;
    begin
    inherited;
    if dilatation=0 then dilatation:=32;
    u:=ln(width)/ln(2);
    u:=taillesp/power2(round(u));
    fdil:=round(u);
    if nbresp>8 then nbresp:=8;
    if nbresp<1 then nbresp:=1;
    spe:=vararraycreate([1,nbresp,1,taillesp],varinteger);
    for j:=1 to nbresp do
    for i:=1 to taillesp do spe[j,i]:=(i div j) mod 256;
    trscrol.left:=0;trscrol.top:=height-15;trscrol.width:=100;trscrol.height:=15;
    trscrol.max:=taillesp-width;trscrol.min:=0;trscrol.position:=0;
    discrol.left:=150;discrol.top:=height-15;discrol.width:=50;discrol.height:=15;
    discrol.max:=13;discrol.min:=0;discrol.position:=round(ln(dilatation)/ln(2));
    tredit.left:=100;tredit.top:=height-15;tredit.width:=50;tredit.height:=15;
    tredit.readonly:=true;
    diedit.left:=200;diedit.top:=height-15;diedit.width:=50;diedit.height:=15;
    diedit.readonly:=true;
    typeaff:=[grligne,grgrilldotvert,grgrilldothorz,grcurseur];
    lin1.graph:=handle;lin2.graph:=handle;
    lin1.pos:=round((fligne1-translation)*dilatation/fdil);
    lin2.pos:=round((fligne2-translation)*dilatation/fdil);
    lin1.couleur:=clred;lin2.couleur:=clblue;
    end;

    procedure Tgraph1D.Paint;
    var
    hauteur,depl,u,i,j:integer;
    gain:longint;
    s:string;
    begin
    hauteur:=height-16;
    canvas.pen.color:=clblack;
    canvas.brush.color:=clwhite;
    canvas.rectangle(0,0,width,hauteur);
    {trac de la grille}
    if (grgrillevert in ftypeaff) then  begin
     i:=grillevert*dilatation div fdil;
     canvas.pen.color:=couleurgrille;
     if i>1 then
     while i<width do begin
      canvas.moveto(i,0);
      canvas.lineto(i,hauteur);
      i:=i+grillevert*dilatation div fdil;
     end;
     end;
     if (grgrillehorz in ftypeaff) then begin
     i:=grillehorz;
     if i>1 then
     while i<hauteur do begin
      canvas.moveto(0,i);
      canvas.lineto(width,i);
      i:=i+grillehorz;
     end;
    end;
    {trac des axes}
    if (grgrilldotvert in ftypeaff) then  begin
     i:=grillevert*dilatation div fdil;
     canvas.pen.color:=couleurgrille;
     canvas.pen.width:=2;
     if i>1 then
     while i<width do begin
      canvas.moveto(i,0);canvas.lineto(i,4);
      canvas.moveto(i,hauteur-4);canvas.lineto(i,hauteur);
      if fzero=grcentre then
      canvas.moveto(i,hauteur div 2-4);canvas.lineto(i,hauteur div 2+4);
      i:=i+grillevert*dilatation div fdil;
     end;
     canvas.pen.width:=1;
      if fzero=grcentre then
      canvas.moveto(0,hauteur div 2);canvas.lineto(width,hauteur div 2);
     end;
    if (grgrilldothorz  in ftypeaff) then begin
     canvas.pen.color:=couleurgrille;
     canvas.pen.width:=2;
     i:=grillehorz;
     if i>1 then
     while i<hauteur do begin
      canvas.moveto(0,i);canvas.lineto(4,i);
      canvas.moveto(width-4,i);canvas.lineto(width,i);
      i:=i+grillehorz;
     end;
    end;
    {trac des spectres}
    if varIsArray(spe) then begin
    for j:=1 to nbresp do
    if fvis[j] then begin
    canvas.pen.width:=1;
    canvas.pen.color:=fcoulsp[j];
    depl:=hauteur;gain:=power2(fgasp[j]);
    if (fzero=grcentre) then depl:=(hauteur) div 2;
    if (fzero=grhaut) then depl:=0;
    if (1+translation+ftrsp[j])<taillesp then
    begin
    if (grmodulo in ftypeaff) then
     u:=(depl+fdepl[j]-(spe[j,1+translation+ftrsp[j]]*16) div gain) mod hauteur
     else begin
     u:=depl+fdepl[j]-(spe[j,1+translation+ftrsp[j]]*16) div gain;
     if u<0 then u:=0;if u>hauteur then u:=hauteur;end;
    canvas.moveto(dilatation div fdil,u);
    end;
    for i:=2 to (width*fdil div dilatation) do
    if (i+translation+ftrsp[j])<taillesp then
    begin
    if (grmodulo in ftypeaff) then
     u:=(depl+fdepl[j]-(spe[j,i+translation+ftrsp[j]]*16) div gain) mod hauteur
     else begin
     u:=depl+fdepl[j]-(spe[j,i+translation+ftrsp[j]]*16) div gain;
     if u<0 then u:=0;if u>hauteur then u:=hauteur;end;
    canvas.lineto(i*dilatation div fdil,u);
    end;
  end;
  end;
  if grcurseur in ftypeaff then begin
  lin1.dessine(round((fligne1-translation)*dilatation/fdil));
  lin2.dessine(round((fligne2-translation)*dilatation/fdil));
  end;
 str(dilatation:0,s);diedit.text:='di:'+s;
 str(translation:0,s);tredit.text:='tr:'+s;
 inherited;
 end;

procedure Tgraph1D.setcoulsp(index:integer;value:tcolor);
begin
case index of
0:begin
  fcoulsp[1]:=$000000FF;fcoulsp[2]:=$0000FF00;fcoulsp[3]:=$00FF0000;
  fcoulsp[4]:=$00000000;fcoulsp[5]:=$0000FFFF;fcoulsp[6]:=$00FF00FF;
  fcoulsp[7]:=$00FFFF00;fcoulsp[8]:=$00009FFF;
  end;
1..8:fcoulsp[index]:=value;
end;
end;


procedure Tgraph1D.setdilsp(index:integer;value:real);
var
i:integer;
begin
case index of
0:for i:=1 to 8 do fdilsp[i]:=value;
1..8:fdilsp[index]:=value;
end;
end;

procedure Tgraph1D.settrsp(index:integer;value:longint);
var
i:integer;
begin
case index of
0:for i:=1 to 8 do ftrsp[i]:=value;
1..8:ftrsp[index]:=value;
end;
end;

procedure Tgraph1D.setgasp(index:integer;value:integer);
var
i:integer;
begin
case index of
0:for i:=1 to 8 do fgasp[i]:=value;
1..8:fgasp[index]:=value;
end;
end;

procedure Tgraph1D.setvis(index:integer;value:boolean);
var
i:integer;
begin
case index of
0:for i:=1 to 8 do fvis[i]:=value;
1..8:fvis[index]:=value;
end;
end;

procedure Tgraph1D.setdepl(index:integer;value:integer);
var
i:integer;
begin
case index of
0:for i:=1 to 8 do fdepl[i]:=value;
1..8:fdepl[index]:=value;
end;
end;

procedure Tgraph1D.settrans(value:longint);
var
s:string[10];
begin
ftrans:=value;
str(ftrans:0,s);tredit.text:='tr:'+s;
trscrol.position:=value;
end;

procedure Tgraph1D.setdilat(value:integer);
var
s:string[5];
begin
fdilat:=value;
str(fdilat:0,s);diedit.text:='di:'+s;
if fdilat<1 then fdilat:=1;
if fdilat>power2(30) then fdilat:=power2(30);
discrol.position:=round(ln(fdilat)/ln(2));
end;

procedure Tgraph1D.Redessiner;
var
rec:trect;
begin
rec.left:=0;
rec.top:=0;
rec.right:=width;
rec.bottom:=height-16;
invalidaterect(handle,@rec,true);
update;
end;


procedure Tgraph1D.param(var msg:tmessage);
begin
case msg.wparam of
1..8 : begin
if msg.lparam=2 then fvis[msg.wparam]:=true;
if msg.lparam=3 then fvis[msg.wparam]:=false;
if msg.lparam=1 then fdepl[msg.wparam]:=(fdepl[msg.wparam]+32) mod (height-15);{decalage haut}
if msg.lparam=-1 then fdepl[msg.wparam]:=(fdepl[msg.wparam]-32) mod (height-15);{decalage bas}
end;
11..18:
if (msg.lparam<=31) and (msg.lparam>=1) then fgasp[msg.wparam-10]:=msg.lparam;
end;
redessiner;
end;

procedure tgraph1D.Hscrolmsg(var msg:TWMScroll);
 var
 s:string;
 begin
 if msg.scrollbar=discrol.handle then begin
 dilatation:=power2(discrol.position);
  if msg.scrollcode=8 then redessiner;
 end;
 if msg.scrollbar=trscrol.handle then begin
 translation:=trscrol.position;
 redessiner;
 end;
 inherited;
 end;

 procedure tgraph1D.wmlbuttondown(var msg:tmessage);
 var
 u:longint;
 begin
 if grcurseur in ftypeaff then begin
 u:=round(msg.lparamlo/dilatation*fdil+translation);
 if u<fligne2 then
 begin
 fligne1:=u;
 lin1.deplace(round((fligne1-translation)*dilatation/fdil));
 end;
 end;
 end;

 procedure tgraph1D.wmrbuttondown(var msg:tmessage);
 var
 u:longint;
 begin
 if grcurseur in ftypeaff then begin
 u:=round(msg.lparamlo/dilatation*fdil+translation);
 if u>fligne1 then
 begin
 fligne2:=u;lin2.deplace(round((fligne2-translation)*dilatation/fdil));
 end;
 end;
 end;


 {--------------line 1d,-----------------------}
    procedure tline.deplace(pos1:longint);
    begin
    efface;
    dessine(pos1);
    end;

    procedure tline.efface;
    var
    DC:hDC;
    i:integer;
    begin
    dc:=getdc(graph);
    if (fpos>=0) and (fpos<=512) then
    for i:=1 to 256 do begin
    setpixel(DC,fpos,i,oldline[i,1]);
    end;
    releasedc(graph,dc);
    end;

    procedure tline.setpos(value:longint);
    begin
    efface;
    dessine(value);
    end;

    procedure tline.dessine(pos1:longint);
    var
    DC:hDC;
    i:integer;
    oldpen,pen:hpen;
    begin
    fpos:=pos1;
    dc:=getdc(graph);
    if (pos1<512) and (pos1>=0) then begin
    for i:=1 to 256 do begin
    oldline[i,1]:=getpixel(dc,pos1,i);
    end;
    pen:=createpen(ps_solid,1,fcoul);
    oldpen:=selectobject(dc,pen);
    movetoex(dc,pos1,2,nil);
    lineto(dc,pos1,256);
    selectobject(dc,oldpen);
    deleteobject(pen);
    end;
    releasedc(graph,dc);
    end;

    constructor tline.create(Aowner:Tcomponent);
    begin
    inherited create(Aowner);
    end;


    destructor tline.free;
    begin
    efface;
    end;

constructor TDCComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnUpdateData := UpdateData;
  FDataLink.OnEditingChange := EditingChange;
  FPaintControl := TPaintControl.Create(Self, 'COMBOBOX');
end;

destructor TDCComboBox.Destroy;
begin
  FPaintControl.Free;
  FDataLink.Free;
  FDataLink := nil;
  inherited Destroy;
end;

procedure TDCComboBox.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end;

procedure TDCComboBox.CreateWnd;
begin
  inherited CreateWnd;
  SetEditReadOnly;
end;

procedure TDCComboBox.DataChange(Sender: TObject);
var
err,i:integer;
begin
  if FDataLink.Field <> nil then begin
    val(FDataLink.Field.Text,i,err);
    if (i>=0) and (err=0) then itemindex:=i else itemindex:=-1
  end  else
    if csDesigning in ComponentState then
      SetComboText(Name)
    else
      SetComboText('');
end;

procedure TDCComboBox.UpdateData(Sender: TObject);
begin
  FDataLink.Field.Text := inttostr(itemindex);
end;

procedure TDCComboBox.SetComboText(const Value: string);
var
  I: Integer;
  Redraw: Boolean;
begin
  if Value <> GetComboText then
  begin
    if Style <> csDropDown then
    begin
      Redraw := (Style <> csSimple) and HandleAllocated;
      if Redraw then SendMessage(Handle, WM_SETREDRAW, 0, 0);
      try
        if Value = '' then I := -1 else I := Items.IndexOf(Value);
        ItemIndex := I;
      finally
        if Redraw then
        begin
          SendMessage(Handle, WM_SETREDRAW, 1, 0);
          Invalidate;
        end;
      end;
      if I >= 0 then Exit;
    end;
    if Style in [csDropDown, csSimple] then Text := Value;
  end;
end;

function TDCComboBox.GetComboText: string;
var
  I: Integer;
begin
  if Style in [csDropDown, csSimple] then Result := Text else
  begin
    I := ItemIndex;
    if I < 0 then Result := '' else Result := Items[I];
  end;
end;

procedure TDCComboBox.Change;
begin
  FDataLink.Edit;
  inherited Change;
  FDataLink.Modified;
end;

procedure TDCComboBox.Click;
begin
  FDataLink.Edit;
  inherited Click;
  FDataLink.Modified;
end;

procedure TDCComboBox.DropDown;
begin
  FDataLink.Edit;
  inherited DropDown;
end;

function TDCComboBox.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TDCComboBox.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TDCComboBox.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure TDCComboBox.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;

function TDCComboBox.GetReadOnly: Boolean;
begin
  Result := FDataLink.ReadOnly;
end;

procedure TDCComboBox.SetReadOnly(Value: Boolean);
begin
  FDataLink.ReadOnly := Value;
end;

function TDCComboBox.GetField: TField;
begin
  Result := FDataLink.Field;
end;

procedure TDCComboBox.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  if Key in [VK_BACK, VK_DELETE, VK_UP, VK_DOWN, 32..255] then
  begin
    if not FDataLink.Edit and (Key in [VK_UP, VK_DOWN]) then
      Key := 0;
  end;
end;

procedure TDCComboBox.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  if (Key in [#32..#255]) and (FDataLink.Field <> nil) and
    not FDataLink.Field.IsValidChar(Key) then
  begin
    MessageBeep(0);
    Key := #0;
  end;
  case Key of
    ^H, ^V, ^X, #32..#255:
      FDataLink.Edit;
    #27:
      begin
        FDataLink.Reset;
        SelectAll;
        Key := #0;
      end;
  end;
end;

procedure TDCComboBox.EditingChange(Sender: TObject);
begin
  SetEditReadOnly;
end;

procedure TDCComboBox.SetEditReadOnly;
begin
  if (Style in [csDropDown, csSimple]) and HandleAllocated then
    SendMessage(EditHandle, EM_SETREADONLY, Ord(not FDataLink.Editing), 0);
end;

procedure TDCComboBox.WndProc(var Message: TMessage);
begin
  if not (csDesigning in ComponentState) then
    case Message.Msg of
      WM_COMMAND:
        if TWMCommand(Message).NotifyCode = CBN_SELCHANGE then
          if not FDataLink.Edit then
          begin
            if Style <> csSimple then
              PostMessage(Handle, CB_SHOWDROPDOWN, 0, 0);
            Exit;
          end;
      CB_SHOWDROPDOWN:
        if Message.WParam <> 0 then FDataLink.Edit else
          if not FDataLink.Editing then DataChange(Self); {Restore text}
      WM_CREATE,
      WM_WINDOWPOSCHANGED,
      CM_FONTCHANGED:
        FPaintControl.DestroyHandle;
    end;
  inherited WndProc(Message);
end;

procedure TDCComboBox.ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
  ComboProc: Pointer);
begin
  if not (csDesigning in ComponentState) then
    case Message.Msg of
      WM_LBUTTONDOWN:
        if (Style = csSimple) and (ComboWnd <> EditHandle) then
          if not FDataLink.Edit then Exit;
    end;
  inherited ComboWndProc(Message, ComboWnd, ComboProc);
end;

procedure TDCComboBox.CMExit(var Message: TCMExit);
begin
  try
    FDataLink.UpdateRecord;
  except
    SelectAll;
    SetFocus;
    raise;
  end;
  inherited;
end;

procedure TDCComboBox.WMPaint(var Message: TWMPaint);
var
  S: string;
  i,err:integer;
  R: TRect;
  P: TPoint;
  Child: HWND;
begin
  if csPaintCopy in ControlState then
  begin
    if FDataLink.Field <> nil then
    begin
    val(FDataLink.Field.Text,i,err);
    if (err=0) and (i>=0) then S :=items[i] else S := '';
    end else S:='';
    if Style = csDropDown then
    begin
      SendMessage(FPaintControl.Handle, WM_SETTEXT, 0, Longint(PChar(S)));
      SendMessage(FPaintControl.Handle, WM_PAINT, Message.DC, 0);
      Child := GetWindow(FPaintControl.Handle, GW_CHILD);
      if Child <> 0 then
      begin
        Windows.GetClientRect(Child, R);
        Windows.MapWindowPoints(Child, FPaintControl.Handle, R.TopLeft, 2);
        GetWindowOrgEx(Message.DC, P);
        SetWindowOrgEx(Message.DC, P.X - R.Left, P.Y - R.Top, nil);
        IntersectClipRect(Message.DC, 0, 0, R.Right - R.Left, R.Bottom - R.Top);
        SendMessage(Child, WM_PAINT, Message.DC, 0);
      end;
    end else
    begin
      SendMessage(FPaintControl.Handle, CB_RESETCONTENT, 0, 0);
      if Items.IndexOf(S) <> -1 then
      begin
        SendMessage(FPaintControl.Handle, CB_ADDSTRING, 0, Longint(PChar(S)));
        SendMessage(FPaintControl.Handle, CB_SETCURSEL, 0, 0);
      end;
      SendMessage(FPaintControl.Handle, WM_PAINT, Message.DC, 0);
    end;
  end else
    inherited;
end;

procedure TDCComboBox.SetItems(Value: TStrings);
begin
  Items.Assign(Value);
  DataChange(Self);
end;

procedure TDCCombobox.SetStyle(Value: TComboboxStyle);
begin
  if (Value = csSimple) and Assigned(FDatalink) and FDatalink.DatasourceFixed then
    DatabaseError(SNotReplicatable);
  inherited SetStyle(Value);
end;

procedure TDCCombobox.CMGetDatalink(var Message: TMessage);
begin
  Message.Result := Integer(FDataLink);
end;

procedure TDCCombobox.refresh;
begin
FDataLink.Field.Text := inttostr(itemindex);
inherited;
end;

constructor TdcctrlgridLink.Create(dcctrlgrid: Tdcctrlgrid);
begin
  inherited Create;
  Fdcctrlgrid := dcctrlgrid;
end;

procedure TdcctrlgridLink.ActiveChanged;
begin
  Fdcctrlgrid.DataSetChanged(False);
end;

procedure TdcctrlgridLink.DataSetChanged;
begin
  Fdcctrlgrid.DataSetChanged(False);
end;

{ TDBCtrlPanel }

constructor TDBCtrlPanel.Createlinked(dcctrlgrid: Tdcctrlgrid);
begin
  inherited Create(dcctrlgrid);
  ControlStyle := [csAcceptsControls, csCaptureMouse, csClickEvents,
    csDoubleClicks, csOpaque, csReplicatable];
  Fdcctrlgrid := dcctrlgrid;
  Parent := dcctrlgrid;
end;

procedure TDBCtrlPanel.PaintWindow(DC: HDC);
var
  R: TRect;
begin
  with Fdcctrlgrid do
  begin
    DrawPanelBackground(DC, Self.ClientRect, True);
    if FDataLink.Active then
    begin
      FCanvas.Handle := DC;
      try
        FCanvas.Font := Font;
        FCanvas.Brush.Style := bsSolid;
        FCanvas.Brush.Color := Color;
        PaintPanel(FDataLink.ActiveRecord);
        if FShowFocus and FFocused and
          (FDataLink.ActiveRecord = FPanelIndex) then
        begin
          R := Self.ClientRect;
          if FPanelBorder = gbRaised then InflateRect(R, -2, -2);
          FCanvas.Brush.Color := Color;
          FCanvas.DrawFocusRect(R);
        end;
      finally
        FCanvas.Handle := 0;
      end;
    end;
  end;
end;

procedure TDBCtrlPanel.CMControlListChange(var Message: TCMControlListChange);
begin
  Fdcctrlgrid.UpdateDataLinks(Message.Control, Message.Inserting);
end;

procedure TDBCtrlPanel.WMPaint(var Message: TWMPaint);
var
  DC: HDC;
  PS: TPaintStruct;
begin
  if Message.DC = 0 then
  begin
    Fdcctrlgrid.CreatePanelBitmap;
    try
      Message.DC := Fdcctrlgrid.FPanelDC;
      PaintHandler(Message);
      Message.DC := 0;
      DC := BeginPaint(Handle, PS);
      BitBlt(DC, 0, 0, Width, Height, Fdcctrlgrid.FPanelDC, 0, 0, SRCCOPY);
      EndPaint(Handle, PS);
    finally
      Fdcctrlgrid.DestroyPanelBitmap;
    end;
  end else
    PaintHandler(Message);
end;

procedure TDBCtrlPanel.WMNCHitTest(var Message: TWMNCHitTest);
begin
  if csDesigning in ComponentState then
    Message.Result := HTCLIENT else
    Message.Result := HTTRANSPARENT;
end;

{ Tdcctrlgrid }

constructor Tdcctrlgrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csOpaque, csDoubleClicks];
  TabStop := True;
  FDataLink := TdcctrlgridLink.Create(Self);
  FCanvas := TCanvas.Create;
  FPanel := TDBCtrlPanel.Create(Self);
  FColCount := 1;
  FRowCount := 3;
  FPanelWidth := 200;
  FPanelHeight := 72;
  FPanelBorder := gbRaised;
  FAllowInsert := True;
  FAllowDelete := True;
  FShowFocus := True;
  AdjustSize;
end;

destructor Tdcctrlgrid.Destroy;
begin
  FCanvas.Free;
  FDataLink.Free;
  FDataLink := nil;
  inherited Destroy;
end;

function Tdcctrlgrid.AcquireFocus: Boolean;
begin
  Result := True;
  if not (Focused or EditMode) then
  begin
    SetFocus;
    Result := Focused;
  end;
end;

procedure Tdcctrlgrid.AdjustSize;
var
  W, H: Integer;
begin
  W := FPanelWidth * FColCount;
  H := FPanelHeight * FRowCount;
  if FOrientation = goVertical then
    Inc(W, GetSystemMetrics(SM_CXVSCROLL)) else
    Inc(H, GetSystemMetrics(SM_CYHSCROLL));
  SetBounds(Left, Top, W, H);
  Reset;
end;

procedure Tdcctrlgrid.CreatePanelBitmap;
var
  DC: HDC;
begin
  if FBitmapCount = 0 then
  begin
    DC := GetDC(0);
    FPanelBitmap := CreateCompatibleBitmap(DC, FPanel.Width, FPanel.Height);
    ReleaseDC(0, DC);
    FPanelDC := CreateCompatibleDC(0);
    FSaveBitmap := SelectObject(FPanelDC, FPanelBitmap);
  end;
  Inc(FBitmapCount);
end;

procedure Tdcctrlgrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN;
end;

procedure Tdcctrlgrid.CreateWnd;
var
  ScrollBar: Integer;
begin
  inherited CreateWnd;
  if FOrientation = goVertical then
    ScrollBar := SB_VERT else
    ScrollBar := SB_HORZ;
  SetScrollRange(Handle, ScrollBar, 0, 4, False);
end;

procedure Tdcctrlgrid.DataSetChanged(Reset: Boolean);
var
  NewPanelIndex, NewPanelCount, ScrollBar, Pos: Integer;
  FocusedControl: TWinControl;
  R: TRect;
begin
  if csDesigning in ComponentState then
  begin
    NewPanelIndex := 0;
    NewPanelCount := 1;
  end else
    if FDataLink.Active then
    begin
      NewPanelIndex := FDataLink.ActiveRecord;
      NewPanelCount := FDataLink.RecordCount;
      if NewPanelCount = 0 then NewPanelCount := 1;
    end else
    begin
      NewPanelIndex := 0;
      NewPanelCount := 0;
    end;
  R := GetPanelBounds(NewPanelIndex);
  if Reset or not HandleAllocated then FPanel.BoundsRect := R else
    if NewPanelIndex <> FPanelIndex then
    begin
      SetWindowPos(FPanel.Handle, 0, R.Left, R.Top, R.Right - R.Left,
        R.Bottom - R.Top, SWP_NOZORDER or SWP_NOREDRAW);
      if NewPanelIndex >= FPanelCount then
        RedrawWindow(FPanel.Handle, nil, 0, RDW_INVALIDATE or RDW_ALLCHILDREN)
      else
      begin
        FocusedControl := FindControl(GetFocus);
        if (FocusedControl <> FPanel) and
          FPanel.ContainsControl(FocusedControl) then
          FocusedControl.Invalidate;
      end;
    end;
  FPanelIndex := NewPanelIndex;
  FPanelCount := NewPanelCount;
  FPanel.Visible := FPanelCount > 0;
  Invalidate;
  FPanel.Invalidate;
  if not Reset then Repaint;
  if HandleAllocated then
  begin
    if FOrientation = goVertical then
      ScrollBar := SB_VERT else
      ScrollBar := SB_HORZ;
    Pos := 0;
    if FDataLink.Active and not FDataLink.DataSet.BOF then
      if not FDataLink.DataSet.EOF then Pos := 2 else Pos := 4;
    if GetScrollPos(Handle, ScrollBar) <> Pos then
      SetScrollPos(Handle, ScrollBar, Pos, True);
  end;
end;

procedure Tdcctrlgrid.DestroyPanelBitmap;
begin
  Dec(FBitmapCount);
  if FBitmapCount = 0 then
  begin
    SelectObject(FPanelDC, FSaveBitmap);
    DeleteDC(FPanelDC);
    DeleteObject(FPanelBitmap);
  end;
end;

procedure Tdcctrlgrid.DoKey(Key: TdcctrlgridKey);
var
  HInc, VInc: Integer;
begin
  if FDataLink.Active then
  begin
    if FOrientation = goVertical then
    begin
      HInc := 1;
      VInc := FColCount;
    end else
    begin
      HInc := FRowCount;
      VInc := 1;
    end;
    with FDataLink.DataSet do
      case Key of
        gkEditMode: EditMode := not EditMode;
        gkPriorTab: SelectNext(False);
        gkNextTab: SelectNext(True);
        gkLeft: Scroll(-HInc, False);
        gkRight: Scroll(HInc, False);
        gkUp: Scroll(-VInc, False);
        gkDown: Scroll(VInc, False);
        gkScrollUp: Scroll(-VInc, True);
        gkScrollDown: Scroll(VInc, True);
        gkPageUp: Scroll(-FDataLink.BufferCount, True);
        gkPageDown: Scroll(FDataLink.BufferCount, True);
        gkHome: First;
        gkEnd: Last;
        gkInsert:
          if FAllowInsert and CanModify then
          begin
            Insert;
            EditMode := True;
          end;
        gkAppend:
          if FAllowInsert and CanModify then
          begin
            Append;
            EditMode := True;
          end;
        gkDelete:
          if FAllowDelete and CanModify then
          begin
            Delete;
            EditMode := False;
          end;
        gkCancel:
          begin
            Cancel;
            EditMode := False;
          end;
      end;
  end;
end;

procedure Tdcctrlgrid.DrawPanel(DC: HDC; Index: Integer);
var
  SaveActive: Integer;
  R: TRect;
begin
  R := GetPanelBounds(Index);
  if Index < FPanelCount then
  begin
    SaveActive := FDataLink.ActiveRecord;
    FDataLink.ActiveRecord := Index;
    FPanel.PaintTo(FPanelDC, 0, 0);
    FDataLink.ActiveRecord := SaveActive;
  end else
    DrawPanelBackground(FPanelDC, FPanel.ClientRect, True);
  BitBlt(DC, R.Left, R.Top, R.Right - R.Left, R.Bottom - R.Top,
    FPanelDC, 0, 0, SRCCOPY);
end;

procedure Tdcctrlgrid.DrawPanelBackground(DC: HDC; const R: TRect;
  Erase: Boolean);
var
  Brush: HBrush;
begin
  if Erase then
  begin
    Brush := CreateSolidBrush(ColorToRGB(Color));
    FillRect(DC, R, Brush);
    DeleteObject(Brush);
  end;
  if FPanelBorder = gbRaised then
    DrawEdge(DC, PRect(@R)^, BDR_RAISEDINNER, BF_RECT);
end;

function Tdcctrlgrid.GetChildParent: TComponent;
begin
  Result := FPanel;
end;

procedure Tdcctrlgrid.GetChildren(Proc: TGetChildProc;root:Tcomponent);
begin
   FPanel.GetChildren(Proc, Root);
end;

function Tdcctrlgrid.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

function Tdcctrlgrid.GetEditMode: Boolean;
begin
  Result := not Focused and ContainsControl(FindControl(GetFocus));
end;

function Tdcctrlgrid.GetPanelBounds(Index: Integer): TRect;
var
  Col, Row: Integer;
begin
  if FOrientation = goVertical then
  begin
    Col := Index mod FColCount;
    Row := Index div FColCount;
  end else
  begin
    Col := Index div FRowCount;
    Row := Index mod FRowCount;
  end;
  Result.Left := FPanelWidth * Col;
  Result.Top := FPanelHeight * Row;
  Result.Right := Result.Left + FPanelWidth;
  Result.Bottom := Result.Top + FPanelHeight;
end;

procedure Tdcctrlgrid.GetTabOrderList(List: TList);
begin
end;

procedure Tdcctrlgrid.KeyDown(var Key: Word; Shift: TShiftState);
var
  GridKey: TdcctrlgridKey;
begin
  inherited KeyDown(Key, Shift);
  GridKey := gkNull;
  case Key of
    VK_LEFT: GridKey := gkLeft;
    VK_RIGHT: GridKey := gkRight;
    VK_UP: GridKey := gkUp;
    VK_DOWN: GridKey := gkDown;
    VK_PRIOR: GridKey := gkPageUp;
    VK_NEXT: GridKey := gkPageDown;
    VK_HOME: GridKey := gkHome;
    VK_END: GridKey := gkEnd;
    VK_RETURN, VK_F2: GridKey := gkEditMode;
    VK_INSERT:
      if GetKeyState(VK_CONTROL) >= 0 then
        GridKey := gkInsert else
        GridKey := gkAppend;
    VK_DELETE: if GetKeyState(VK_CONTROL) < 0 then GridKey := gkDelete;
    VK_ESCAPE: GridKey := gkCancel;
  end;
  DoKey(GridKey);
end;

procedure Tdcctrlgrid.PaintWindow(DC: HDC);
var
  I: Integer;
  Brush: HBrush;
begin
  if csDesigning in ComponentState then
  begin
    FPanel.Update;
    Brush := CreateHatchBrush(HS_BDIAGONAL, ColorToRGB(clBtnShadow));
    SetBkColor(DC, ColorToRGB(Color));
    FillRect(DC, ClientRect, Brush);
    DeleteObject(Brush);
    for I := 1 to FColCount * FRowCount - 1 do
      DrawPanelBackground(DC, GetPanelBounds(I), False);
  end else
  begin
    CreatePanelBitmap;
    try
      for I := 0 to FColCount * FRowCount - 1 do
        if (FPanelCount <> 0) and (I = FPanelIndex) then
          FPanel.Update else
          DrawPanel(DC, I);
    finally
      DestroyPanelBitmap;
    end;
  end;
end;

procedure Tdcctrlgrid.PaintPanel(Index: Integer);
begin
  if Assigned(FOnPaintPanel) then FOnPaintPanel(Self, Index);
end;

function Tdcctrlgrid.PointInPanel(const P: TSmallPoint): Boolean;
begin
  Result := (FPanelCount > 0) and PtInRect(GetPanelBounds(FPanelIndex),
    SmallPointToPoint(P));
end;

procedure Tdcctrlgrid.ReadState(Reader: TReader);
begin
  inherited ReadState(Reader);
  FPanel.FixupTabList;
end;

procedure Tdcctrlgrid.Reset;
begin
  if csDesigning in ComponentState then
    FDataLink.BufferCount := 1 else
    FDataLink.BufferCount := FColCount * FRowCount;
  DataSetChanged(True);
end;

procedure Tdcctrlgrid.Scroll(Inc: Integer; ScrollLock: Boolean);
var
  NewIndex, ScrollInc, Adjust: Integer;
begin
  if FDataLink.Active and (Inc <> 0) then
    with FDataLink.DataSet do
      if State = dsInsert then
      begin
        UpdateRecord;
        if Modified then Post else
          if (Inc < 0) or not EOF then Cancel;
      end else
      begin
        CheckBrowseMode;
        DisableControls;
        try
          if ScrollLock then
            if Inc > 0 then
              MoveBy(Inc - MoveBy(Inc + FDataLink.BufferCount - FPanelIndex - 1))
            else
              MoveBy(Inc - MoveBy(Inc - FPanelIndex))
          else
          begin
            NewIndex := FPanelIndex + Inc;
            if (NewIndex >= 0) and (NewIndex < FDataLink.BufferCount) then
              MoveBy(Inc)
            else
              if MoveBy(Inc) = Inc then
              begin
                if FOrientation = goVertical then
                  ScrollInc := FColCount else
                  ScrollInc := FRowCount;
                if Inc > 0 then
                  Adjust := ScrollInc - 1 - NewIndex mod ScrollInc
                else
                  Adjust := 1 - ScrollInc - (NewIndex + 1) mod ScrollInc;
                MoveBy(-MoveBy(Adjust));
              end;
          end;
          if (Inc = 1) and EOF and CanModify and fallowinsert then Append;
        finally
          EnableControls;
        end;
      end;
end;

procedure Tdcctrlgrid.ScrollMessage(var Message: TWMScroll);
var
  Key: TdcctrlgridKey;
begin
  if AcquireFocus then
  begin
    Key := gkNull;
    case Message.ScrollCode of
      SB_LINEUP: Key := gkScrollUp;
      SB_LINEDOWN: Key := gkScrollDown;
      SB_PAGEUP: Key := gkPageUp;
      SB_PAGEDOWN: Key := gkPageDown;
      SB_TOP: Key := gkHome;
      SB_BOTTOM: Key := gkEnd;
      SB_THUMBPOSITION:
        begin
          case Message.Pos of
            0: Key := gkHome;
            1: Key := gkPageUp;
            3: Key := gkPageDown;
            4: Key := gkEnd;
          end;
        end;
    end;
    DoKey(Key);
  end;
end;

procedure Tdcctrlgrid.SelectNext(GoForward: Boolean);
var
  I, StartIndex: Integer;
  List: TList;
  ParentForm: TcustomForm;
  ActiveControl, Control: TWinControl;
begin
  ParentForm := GetParentForm(Self);
  if ParentForm <> nil then
  begin
    ActiveControl := ParentForm.ActiveControl;
    if ContainsControl(ActiveControl) then
    begin
      List := TList.Create;
      try
        StartIndex := 0;
        I := 0;
        Control := ActiveControl;
        FPanel.GetTabOrderList(List);
        if List.Count > 0 then
        begin
          StartIndex := List.IndexOf(ActiveControl);
          if StartIndex = -1 then
            if GoForward then
              StartIndex := List.Count - 1 else
              StartIndex := 0;
          I := StartIndex;
          repeat
            if GoForward then
            begin
              Inc(I);
              if I = List.Count then I := 0;
            end else
            begin
              if I = 0 then I := List.Count;
              Dec(I);
            end;
            Control := List[I];
          until (Control.CanFocus and Control.TabStop) or (I = StartIndex);
        end;
        FPanel.SetFocus;
        try
          if GoForward then
          begin
            if I <= StartIndex then Scroll(1, False);
          end else
          begin
            if I >= StartIndex then Scroll(-1, False);
          end;
        except
          ActiveControl.SetFocus;
          raise;
        end;
        Control.SetFocus;
      finally
        List.Free;
      end;
    end;
  end;
end;

procedure Tdcctrlgrid.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
var
  ScrollWidth, ScrollHeight, NewPanelWidth, NewPanelHeight: Integer;
begin
  ScrollWidth := 0;
  ScrollHeight := 0;
  if FOrientation = goVertical then
    ScrollWidth := GetSystemMetrics(SM_CXVSCROLL) else
    ScrollHeight := GetSystemMetrics(SM_CYHSCROLL);
  NewPanelWidth := (AWidth - ScrollWidth) div FColCount;
  NewPanelHeight := (AHeight - ScrollHeight) div FRowCount;
  if NewPanelWidth < 1 then NewPanelWidth := 1;
  if NewPanelHeight < 1 then NewPanelHeight := 1;
  if (FPanelWidth <> NewPanelWidth) or (FPanelHeight <> NewPanelHeight) then
  begin
    FPanelWidth := NewPanelWidth;
    FPanelHeight := NewPanelHeight;
    Reset;
  end;
  inherited SetBounds(ALeft, ATop, FPanelWidth * FColCount + ScrollWidth,
    FPanelHeight * FRowCount + ScrollHeight);
end;

procedure Tdcctrlgrid.SetColCount(Value: Integer);
begin
  if Value < 1 then Value := 1;
  if Value > 100 then Value := 100;
  if FColCount <> Value then
  begin
    FColCount := Value;
    AdjustSize;
  end;
end;

procedure Tdcctrlgrid.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  UpdateDataLinks(FPanel, True);
end;

procedure Tdcctrlgrid.SetEditMode(Value: Boolean);
var
  Control: TWinControl;
begin
  if GetEditMode <> Value then
    if Value then
    begin
      Control := FPanel.FindNextControl(nil, True, True, False);
      if Control <> nil then Control.SetFocus;
    end else
      SetFocus;
end;

procedure Tdcctrlgrid.SetOrientation(Value: TdcctrlgridOrientation);
begin
  if FOrientation <> Value then
  begin
    FOrientation := Value;
    RecreateWnd;
    AdjustSize;
  end;
end;

procedure Tdcctrlgrid.SetPanelBorder(Value: TdcctrlgridBorder);
begin
  if FPanelBorder <> Value then
  begin
    FPanelBorder := Value;
    Invalidate;
    FPanel.Invalidate;
  end;
end;

procedure Tdcctrlgrid.SetPanelHeight(Value: Integer);
begin
  if Value < 1 then Value := 1;
  if Value > 65535 then Value := 65535;
  if FPanelHeight <> Value then
  begin
    FPanelHeight := Value;
    AdjustSize;
  end;
end;

procedure Tdcctrlgrid.SetPanelIndex(Value: Integer);
begin
  if FDataLink.Active and (Value < PanelCount) then
    FDataLink.DataSet.MoveBy(Value - FPanelIndex);
end;

procedure Tdcctrlgrid.SetPanelWidth(Value: Integer);
begin
  if Value < 1 then Value := 1;
  if Value > 65535 then Value := 65535;
  if FPanelWidth <> Value then
  begin
    FPanelWidth := Value;
    AdjustSize;
  end;
end;

procedure Tdcctrlgrid.SetRowCount(Value: Integer);
begin
  if Value < 1 then Value := 1;
  if Value > 100 then Value := 100;
  if FRowCount <> Value then
  begin
    FRowCount := Value;
    AdjustSize;
  end;
end;

procedure Tdcctrlgrid.UpdateDataLinks(Control: TControl; Inserting: Boolean);
var
  I: Integer;
  DataLink: TDataLink;
begin
  if Inserting and not (csReplicatable in Control.ControlStyle) then
    DatabaseError(SNotReplicatable);
  DataLink := TDataLink(Control.Perform(CM_GETDATALINK, 0, 0));
  if DataLink <> nil then
  begin
    DataLink.DataSourceFixed := False;
    if Inserting then
    begin
      DataLink.DataSource := DataSource;
      DataLink.DataSourceFixed := True;
    end;
  end;
  if Control is TWinControl then
    with TWinControl(Control) do
      for I := 0 to ControlCount - 1 do
        UpdateDataLinks(Controls[I], Inserting);
end;

procedure Tdcctrlgrid.WMLButtonDown(var Message: TWMLButtonDown);
var
  I: Integer;
  P: TPoint;
  Window: HWnd;
begin
  if FDataLink.Active then
  begin
    P := SmallPointToPoint(Message.Pos);
    for I := 0 to FPanelCount - 1 do
      if (I <> FPanelIndex) and PtInRect(GetPanelBounds(I), P) then
      begin
        SetPanelIndex(I);
        P := ClientToScreen(P);
        Window := WindowFromPoint(P);
        if IsChild(FPanel.Handle, Window) then
        begin
          Windows.ScreenToClient(Window, P);
          Message.Pos := PointToSmallPoint(P);
          with TMessage(Message) do SendMessage(Window, Msg, WParam, LParam);
          Exit;
        end;
        Break;
      end;
  end;
  if AcquireFocus then
  begin
    if PointInPanel(Message.Pos) then
    begin
      EditMode := False;
      Click;
    end;
    inherited;
  end;
end;

procedure Tdcctrlgrid.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  if PointInPanel(Message.Pos) then DblClick;
  inherited;
end;

procedure Tdcctrlgrid.WMHScroll(var Message: TWMHScroll);
begin
  ScrollMessage(Message);
end;

procedure Tdcctrlgrid.WMVScroll(var Message: TWMVScroll);
begin
  ScrollMessage(Message);
end;

procedure Tdcctrlgrid.WMPaint(var Message: TWMPaint);
begin
  PaintHandler(Message);
end;

procedure Tdcctrlgrid.WMSetFocus(var Message: TWMSetFocus);
begin
  FFocused := True;
  FPanel.Repaint;
end;

procedure Tdcctrlgrid.WMKillFocus(var Message: TWMKillFocus);
begin
  FFocused := False;
  FPanel.Repaint;
end;

procedure Tdcctrlgrid.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS or DLGC_WANTCHARS;
end;

procedure Tdcctrlgrid.CMChildKey(var Message: TCMChildKey);
var
  GridKey: TdcctrlgridKey;
begin
  with Message do
    if Sender <> Self then
    begin
      GridKey := gkNull;
      case CharCode of
        VK_TAB:
          if (GetKeyState(VK_CONTROL) >= 0) and
            (Sender.Perform(WM_GETDLGCODE, 0, 0) and DLGC_WANTTAB = 0) then
            if GetKeyState(VK_SHIFT) >= 0 then
              GridKey := gkNextTab else
              GridKey := gkPriorTab;
        VK_RETURN, VK_F2: GridKey := gkEditMode;
        VK_ESCAPE: GridKey := gkCancel;
      end;
      if GridKey <> gkNull then
      begin
        DoKey(GridKey);
        Result := 1;
        Exit;
      end;
    end;
  inherited;
end;


end.
