unit interpret;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, multimemo, Parser10, StdCtrls, Menus, Db, DBTables,editdata;
const
repseq='c:\seq\';
seqext='.seq';
wm_redessine=$403+wm_user;
type
EvarError = class(Exception);

type
tvaripar = class(tobject)
       public
       value:extended;
       p1:integer;
       p2:double;
       p3:double;
       p4: string;
end;
type
  Tinterpretform = class(TForm)
    Panel1: TPanel;
    Parser1: TParser;
    ScriptExecuteButton: TButton;
    Timer1: TTimer;
    ScriptExecuteSelectionButton: TButton;
    ScriptStopButton: TButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    mem1: tmultimemo;
    MainMenu1: TMainMenu;
    suividevariable1: TMenuItem;
    variables1: TMenuItem;
    fonctions1: TMenuItem;
    Button4: TButton;
    Tablemot: TTable;
    DataSourcemot: TDataSource;
    TablemotIndex: TIntegerField;
    TablemotZero: TIntegerField;
    TablemotDepart: TIntegerField;
    TablemotFin: TIntegerField;
    TablemotInc: TIntegerField;
    TablemotNomcourt: TStringField;
    TablemotAutorisation: TIntegerField;
    fonctionsmathmatiques1: TMenuItem;
    fonctionsduprogramme1: TMenuItem;
    ScriptStatus: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ScriptExecuteButtonClick(Sender: TObject);
    procedure ScriptExecuteSelectionButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure suividevariable1Click(Sender: TObject);
    procedure ScriptStopButtonClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure variables1Click(Sender: TObject);
    procedure fonctions1Click(Sender: TObject);
    procedure Parser1ParserError(Sender: TObject; E: Exception);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives}
    filename:string;
    actlig,actligf:tstringlist;{tableau des ordres  ffectuer}
    procedure addmotorlist;
    procedure pretraitement;
    procedure execution;
    function traitstring(s:string;ind:integer):integer;
   public
    { Dclarations publiques}
    seqencours:integer;{sequence en cours}
    procedure addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
    procedure setvaleur(name:string;value:integer);
    procedure executeseq(name:string);
 end;

var
  interpretform: Tinterpretform;
implementation

uses suividevarfi1, variablelistfi, functionlistfi,moteurfi1, pacompt,
  deuxdtestfi1, boiten;

var
  ordre,variable,varpar,labels:tstringlist;
  par:array[1..10] of extended;
  pars:array[1..10] of  string;
  param:array[0..200] of tvaripar;
  labelstab:array[0..26] of integer;
  seqon,seqlig:integer;
  flagwaitchamp,flagwaittemp:boolean;
  flagwaitacquis,flagwaitmotor:boolean;

{ A cet endroit se crent toutes les fonctions
destines  appeler les diffrentes routines}



{fonctions internes}
    function rien(s:string):integer; far;
    begin
    result:=0;
    end;

    function fixtimer(s:string):integer; far;
    var
    i:extended;
    begin
    i:=param[variable.indexof(s)].value;
    if i=0 then
    interpretform.timer1.enabled:=false else
    interpretform.timer1.interval:=round(i);
    result:=0;
    end;
{fonction associes aux variables moteurs}
    function movabs(s:string):integer; far;
    begin
    result:=0;
    end;

    function settable(s:string):integer; far;
    var
    i:integer;
    begin
    i:=variable.indexof(s);
    if tabmot<>nil then tabmot.setval((param[i].p1),round(param[i].p2),round(param[i].value));
    result:=0;
    end;


{fonctions d'attente}
    function waitchamp:integer;far;
    begin
    flagwaitchamp:=true;
    result:=0;
    end;

    function waittemp:integer;far;
    begin
    flagwaittemp:=true;
    result:=0;
    end;

    function pause:integer;far;
    begin
    interpretform.timer1.enabled:=false;
    result:=0;
    end;

    function waitmotors:integer;far;
    begin
    if tabmot<>nil then flagwaitmotor:=true;
    result:=0;
    end;

{fonction affichage}

    function acqsimple:integer; far;
    begin
    if compt<>nil then compt.acqsimple(par[1],par[2],par[3],par[4]);
    result:=1;
    flagwaitacquis:=true;
    end;

    function clearspectre:integer;far;
    begin
    if par[1]=1 then und.clear(pars[2]);
    if par[1]=2 then deuxd.clear(pars[2]);
    result:=1;
    end;

    function addspectre:integer;far;
    begin
    if par[1]=1 then und.addspectre(pars[2],round(par[3]),round(par[4]));
    if par[1]=2 then deuxd.addspectre(pars[2],round(par[3]),round(par[4]));
    result:=1;
    end;

    function savespectre:integer;far;
    begin
    dataeditform.sauve(round(par[1]),pars[2]);
    result:=1;
    end;


    function addpt:integer;far;
    begin
    if par[1]=1 then und.addpt(pars[2],par[3],par[4],par[5],par[6]);
    if par[1]=2 then deuxd.addpt(pars[2],par[3],par[4],par[5],par[6]);
    result:=1;
    sendmessage(principalform.handle,wm_redessine,0,0);
    end;

{fonctions boite noire}

    function addcond:integer;far;
    var
    s:string;
    begin
    if compt<>nil then begin
    s:=pars[1]+' polar :'+compt.getpolar;
    boitnoir.receivetext(s);
    end;
    result:=1;
    end;

    function addcomment:integer;far;
    var
    s:string;
    begin
    s:=pars[1];
    boitnoir.receivetext(s);
    result:=1;
    end;

    function addangle:integer;far;
    begin
    if tabmot<>nil then tabmot.ecritangles;
    result:=1;
    end;
{fonction comptage}
    function fixtemps(s:string):integer; far;
    begin
    if compt<>nil then compt.fixtemps(round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function comptcond(s:string):integer; far;
    begin
    if compt<>nil then compt.comptcond(param[variable.indexof(s)].p1,round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function fixflip(s:string):integer; far;
    begin
    if compt<>nil then compt.fixflip(pars[1]);
    result:=0;
    end;

    function polarisation:integer;far;
    begin
    if compt<>nil then compt.fixpolar(pars[1]);
    result:=1;
    end;

    function fixcompt:integer;far;
    begin
    if compt<>nil then compt.fixcompt(pars[1]);
    result:=1;
    end;

{$R *.DFM}

procedure Tinterpretform.FormCreate(Sender: TObject);
var
i:integer;
begin
tablemot.open;
seqon:=0;
actlig:=tstringlist.create;
actligf:=tstringlist.create;
variable:=tstringlist.create;
varpar:=tstringlist.create;
ordre:=tstringlist.create;
labels:=tstringlist.create;
for i:=0 to 200 do param[i]:=tvaripar.create;
mem1.filter:='Squences (*.seq)|*.seq|textes (*.txt)|*.txt';
mem1.defaultext:='.seq';
mem1.directory:=repseq;
{variables de comptage}
if compt<>nil then begin
addvariable('Nupup',0,0,0,0,'',tobject(@rien));
addvariable('Nupdo',1,0,0,0,'',tobject(@rien));
addvariable('Ndoup',2,0,0,0,'',tobject(@rien));
addvariable('Ndodo',3,0,0,0,'',tobject(@rien));
addvariable('Mupup',0,0,0,0,'',tobject(@rien));
addvariable('Mupdo',1,0,0,0,'',tobject(@rien));
addvariable('Mdoup',2,0,0,0,'',tobject(@rien));
addvariable('Mdodo',3,0,0,0,'',tobject(@rien));
addvariable('Tupup',0,0,0,0,'',tobject(@rien));
addvariable('Tupdo',1,0,0,0,'',tobject(@rien));
addvariable('Tdoup',2,0,0,0,'',tobject(@rien));
addvariable('Tdodo',3,0,0,0,'',tobject(@rien));
addvariable('up',4,0,0,0,'',tobject(@rien));
addvariable('do',5,0,0,0,'',tobject(@rien));
addvariable('temps',4,0,0,0,'',tobject(@fixtemps));
addvariable('Tu1',1,0,0,0,'',tobject(@comptcond));
addvariable('Tu2',2,0,0,0,'',tobject(@comptcond));
addvariable('Tu3',3,0,0,0,'',tobject(@comptcond));
addvariable('Tu4',4,0,0,0,'',tobject(@comptcond));
addvariable('Cl1',5,0,0,0,'',tobject(@comptcond));
addvariable('Cl2',6,0,0,0,'',tobject(@comptcond));
addvariable('Cl3',7,0,0,0,'',tobject(@comptcond));
addvariable('Cl4',8,0,0,0,'',tobject(@comptcond));
end;
{variables internes}
addvariable('timer',100,1,0,0,'',tobject(@fixtimer));
{ajout des moteurs}
if tabmot<>nil then addmotorlist;
{l'ensemble des fonctions se rajoutent dans les fonctions possibles ici}
ordre.addobject('addpt',tobject(@addpt));
ordre.addobject('acqsimple',tobject(@acqsimple));
ordre.addobject('waitchamp',tobject(@waitchamp));
ordre.addobject('waittemp',tobject(@waittemp));
ordre.addobject('waitmotors',tobject(@waitmotors));
ordre.addobject('pause',tobject(@pause));
ordre.addobject('clearspectre',tobject(@clearspectre));
ordre.addobject('addspectre',tobject(@addspectre));
ordre.addobject('addconditions',tobject(@addcond));
ordre.addobject('addcomment',tobject(@addcomment));
ordre.addobject('addangles',tobject(@addangle));
ordre.addobject('savespectre',tobject(@savespectre));
ordre.addobject('polarisation',tobject(@polarisation));
ordre.addobject('typecompt',tobject(@typcompt));
ordre.addobject('flippers',tobject(@fixflip));
for i:=1 to 26 do
begin labels.add('L'+chr(i+64));labelstab[i]:=0;end;
flagwaitchamp:=false;
flagwaittemp:=false;
flagwaitacquis:=false;
flagwaitmotor:=false;
top:=350;
left:=600;
width:=380;
height:=350;
end;

procedure Tinterpretform.addmotorlist;
begin
tablemot.first;
while not tablemot.eof do begin
addvariable(tablemotnomcourt.value,0,tablemotindex.value,3,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'dep',tablemotdepart.value,tablemotindex.value,4,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'fin',tablemotfin.value,tablemotindex.value,5,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'inc',tablemotinc.value,tablemotindex.value,6,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'zero',tablemotzero.value,tablemotindex.value,7,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'val',0,tablemotindex.value,8,0,'',tobject(@settable));
tablemot.next;
end;
end;

procedure Tinterpretform.addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
var
i:integer;
begin
parser1.setvariable(name,value);
i:=variable.AddObject(name,tpro);
param[i].p1:=p1;param[i].p2:=p2;param[i].p3:=p3;param[i].p4:=p4;
varpar.AddObject(name,@param[i]);
end;

procedure Tinterpretform.setvaleur(name:string;value:integer);
begin

parser1.setvariable(name,value);
end;

{ lancement d'une squence de script
{ INPUT: utilise le text du memo en cours }
procedure Tinterpretform.ScriptExecuteButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;

procedure Tinterpretform.ScriptExecuteSelectionButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.seltext;
pretraitement;
execution;
end;

{prtraitement traite les inclusions}
procedure Tinterpretform.pretraitement;
var
i,tf:integer;
fich:tstringlist;
s:string;
begin
for i:=1 to 26 do labelstab[i]:=0;
actlig.clear;
fich:=tstringlist.create;
tf:=1;
{ajout des inclusions}
while tf<>0 do begin
tf:=0;
for i:=0 to actligf.count-1 do begin
{ajout du ; oubli}
if pos(';',actligf.strings[i])<=0 then actligf.strings[i]:=actligf.strings[i]+';';
actligf.strings[i]:=copy(actligf.strings[i],1,pos(';',actligf.strings[i]));
if copy(actligf.strings[i],1,4)<>'inc=' then begin
actlig.add(actligf.strings[i]);
end else begin
filename:=copy(actligf.strings[i],5,pos(';',actligf.strings[i])-5);
fich.loadfromfile(repseq+filename+seqext);
actlig.addstrings(fich);
tf:=1;
end;
end;
if tf<>0 then begin
actligf.text:=actlig.text;
actlig.clear;
end;
end;
{fin d'ajout des inclusions}
{assignation des labels}
for i:=0 to actlig.count-1 do begin
s:=actlig.Strings[i];
if (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
labelstab[labels.indexof(copy(s,1,2))]:=i;
end;
fich.free;
end;

procedure tinterpretform.execution {test d'une squence pour criture};
begin
{dbut de la realisation}
seqlig:=0;
seqon:=1;
flagwaitacquis:=false;
timer1.enabled:=true;
ScriptStatus.caption:='Running...';
end;



function Tinterpretform.traitstring(s:string;ind:integer):integer;
label
debut;
var
j:integer;
s2,sn,sval:string;
retour:integer;
f:function(name:string):integer;
g:function:integer;
pari:string;
test,tu:boolean;
x,mon,tem:integer;
begin
{lecture de paramtres externes avant l'excution de l'instruction suivante}
{transfert des chelles de comptage}
compt.getcomptage(1,x,mon,tem);
parser1.setvariable('Nupup',x);parser1.setvariable('Mupup',mon);
parser1.setvariable('Tupup',tem);
compt.getcomptage(2,x,mon,tem);
parser1.setvariable('Ndodo',x);parser1.setvariable('Mdodo',mon);
parser1.setvariable('Tdodo',tem);
compt.getcomptage(3,x,mon,tem);
parser1.setvariable('Nupdo',x);parser1.setvariable('Mupdo',mon);
parser1.setvariable('Tupdo',tem);
compt.getcomptage(4,x,mon,tem);
parser1.setvariable('Ndoup',x);parser1.setvariable('Mdoup',mon);
parser1.setvariable('Tdoup',tem);
retour:=ind+1;
debut:test:=false;
{chaine commentaire ou vide}
if (copy(s,1,1)=';') or (copy(s,2,1)=';') then test:=true;
{labels}
if (not test) and (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
s:=copy(s,4,length(s));
if (not test) and (copy(s,1,2)='if') then begin
{traitement du if}
 test:=true;
 if pos('then',s)<0 then
 begin
 timer1.enabled:=false;
 raise EvarError.Create('if sans then'+
 inttostr(ind)+':'+s);
 end;
 s2:=copy(s,4,pos('then',s)-5);
 tu:=false;
 if pos('>=',s2)>0 then begin
 sn:=copy(s2,1,pos('>=',s2)-1)+'-'+copy(s2,pos('>=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value>=0 then tu:=true;
 end else
 if pos('<>',s2)>0 then begin
 sn:=copy(s2,1,pos('<>',s2)-1)+'-'+copy(s2,pos('<>',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<>0 then tu:=true;
 end else
 if pos('<=',s2)>0 then begin
 sn:=copy(s2,1,pos('<=',s2)-1)+'-'+copy(s2,pos('<=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<=0 then tu:=true;
 end else
 if pos('=',s2)>0 then begin
 sn:=copy(s2,1,pos('=',s2)-1)+'-'+copy(s2,pos('=',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value=0 then tu:=true;
 end else
 if pos('<',s2)>0 then begin
 sn:=copy(s2,1,pos('<',s2)-1)+'-'+copy(s2,pos('<',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value<0 then tu:=true;
 end else
 if pos('>',s2)>0 then begin
 sn:=copy(s2,1,pos('>',s2)-1)+'-'+copy(s2,pos('>',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value>0 then tu:=true;
 end;
 if tu=true then begin
  s2:=copy(s,pos('then',s)+5,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)] else
  begin
  s:=copy(s,pos('then',s)+5,length(s));goto debut;
  end;
 end;
end;
{fin du traitement if then}
if (not test) and (copy(s,1,4)='goto') then begin
s2:=copy(s,6,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)];
test:=true;end;
{debut du traitement assignation de variables toto=10}
if (pos('=',s)>0) and not test then begin
test:=true;
sn:= copy(s,1,pos('=',s)-1);
if sn='' then raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
sval:=copy(s,pos('=',s)+1,pos(';',s)-pos('=',s)-1);
parser1.expression:=sval;
if not isvalidident(sn) then begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end else begin
try
if variable.indexof(sn)>=0 then begin
param[variable.indexof(sn)].value:=parser1.value;
@f:=variable.Objects[variable.indexof(sn)];
f(sn);
end;
parser1.setvariable(sn,parser1.value);
except begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end;
end;
end;
end;
{fin du traitement des variables}
{test des fonctions appeles}
if not test then begin
 if (pos('[',s)<=0) then
 begin
  pari:='';s2:=copy(s,1,pos(';',s)-1);
 end else begin
  s2:=copy(s,1,pos('[',s)-1);
  pari:=copy(s,pos('[',s)+1,pos(']',s)-pos('[',s)-1);
 end;
if ordre.indexof(s2)=-1 then
begin
timer1.enabled:=false;
raise EvarError.Create('fonction non valide  la ligne '+
inttostr(ind)+':'+s)
end else begin
 j:=1;
 if pari<>'' then begin
  while (pos(',',pari)>0) and (j<=10) do begin
  pars[j]:=copy(pari,1,pos(',',pari)-1);
  if pos('"',pars[j])<=0 then begin
  parser1.expression:=copy(pari,1,pos(',',pari)-1);
  par[j]:=parser1.value;end else
  pars[j]:=copy(pars[j],2,length(pars[j])-2);
  pari:=copy(pari,pos(',',pari)+1,length(pari));
  j:=j+1;
  end;
  pars[j]:=pari;
  if pos('"',pars[j])<=0 then begin
  parser1.expression:=pari;
  par[j]:=parser1.value;
  end else pars[j]:=copy(pars[j],2,length(pars[j])-2);
 end;
 @g:=ordre.Objects[ordre.indexof(s2)];
 g;
end;
end;
result:=retour;
end;





procedure Tinterpretform.FormClose(Sender: TObject; var Action: TCloseAction);
var
i:integer;
begin
actlig.free;
actligf.free;
variable.free;
varpar.free;
ordre.free;
for i:=1 to 200 do param[i].free;
end;

procedure Tinterpretform.Timer1Timer(Sender: TObject);
begin
if (flagwaitmotor) and (tabmot<>nil) then flagwaitmotor:=tabmot.onmov;
if (flagwaitacquis) and (compt<>nil) then flagwaitacquis:=compt.testacquis;
if (seqon>0) and (not flagwaitchamp) and (not flagwaitchamp)
and (not flagwaitmotor) and (not flagwaitacquis) then begin
 if (seqlig<actlig.count) and (seqlig>=0) then begin
 while ((copy(actlig.strings[seqlig],1,1)=';') or
 (copy(actlig.strings[seqlig],2,1)=';'))
  and (seqlig<actlig.count-1) do seqlig:=seqlig+1;
  interpretform.caption:='sq : '+actlig.strings[seqlig];
  seqlig:=traitstring(actlig.strings[seqlig],seqlig);
  suividevar.affiche;
  end else begin
  seqon:=0;timer1.enabled:=false;
  interpretform.caption:='pas de squence en cours';
  scriptStatus.caption:='Paused';
 end;
end;
end;

procedure Tinterpretform.suividevariable1Click(Sender: TObject);
begin
if not suividevar.visible then suividevar.show
else suividevar.visible:=false;
end;

procedure Tinterpretform.ScriptStopButtonClick(Sender: TObject);
begin
compt.stop;
seqon:=0;timer1.enabled:=false;
interpretform.caption:='pas de squence en cours';
scriptStatus.caption:='Paused';
end;

procedure Tinterpretform.Button4Click(Sender: TObject);
begin
timer1.enabled:=true;
end;

procedure Tinterpretform.variables1Click(Sender: TObject);
begin
if not variablelistform.visible then
begin
variablelistform.affiche;variablelistform.show;
end else variablelistform.visible:=false;
end;

procedure Tinterpretform.fonctions1Click(Sender: TObject);
begin
if not functionlistform.visible then
begin
functionlistform.affiche;functionlistform.show;
end else functionlistform.visible:=false;
end;

procedure Tinterpretform.Parser1ParserError(Sender: TObject; E: Exception);
var
mt:array[0..30] of char;
begin
timer1.enabled:=false;strpcopy(mt,E.message);
messagebox(interpretform.handle,'erreur',mt,mb_ok);
end;


procedure Tinterpretform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
toto:integer;
begin
if key=13 then begin
toto:=1;
if pos(';',edit1.text)<=0 then edit1.text:=edit1.text+';';
traitstring(edit1.text,toto);
suividevar.affiche;
end;
end;

procedure Tinterpretform.executeseq(name:string);
begin
mem1.activepage:=10;
mem1.Memo.Lines.LoadfromFile(name);
if compt<>nil then compt.stop;
timer1.enabled:=false;
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;

end.
