unit EditReal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, math;

type
  TEditReal = class(TEdit)
    private
       FNbrCarac:integer;
       FNbrDecimales:integer;
       function GetValue:double;
       procedure SetValue(Value:double);
    public
       constructor Create(AOwner:TComponent);override;
       procedure Click;override;
       procedure KeyDown(var Key: Word; Shift: TShiftState);override;
    published
       property NbrCarac:integer read FNbrCarac write FNbrCarac default 8;
       Property NbrDecimales:integer read FNbrDecimales write FNbrDecimales default 2;
       property Value:double read GetValue write SetValue;
    end;

procedure Register;

implementation

constructor TEditReal.Create(AOwner:TComponent);
begin
     inherited Create(AOwner);
     FNbrCarac:=8;
     FNbrDecimales:=2;
end;

procedure TEditReal.Click;
var errorpos:integer;
    valeur:double;
    s:string;
begin
     inherited Click;
     val(text,valeur,errorPos);
     Value:=Valeur;
     if value<>0 then
     while abs(Value)<power(10,-FnbrDecimales) do
     begin
          FNbrDecimales:=FNbrdecimales+1;
     end;
     NbrDecimales:=FNbrDecimales;
     str(Valeur:FNbrCarac:FnbrDecimales,s);
     text:=S;
end;

procedure TEditReal.KeyDown(var Key: Word; Shift: TShiftState);
var errorpos:integer;
    valeur:double;
    s:string;
begin
     inherited KeyDown(Key, Shift);
     if key=13
     then
         begin
             val(text,valeur,errorPos);
             Value:=Valeur;
             if value<>0 then
             while abs(Value)<power(10,-FnbrDecimales) do
             begin
                  FNbrDecimales:=FNbrdecimales+1;
             end;
             NbrDecimales:=FNbrDecimales;
             str(Valeur:FNbrCarac:FnbrDecimales,s);
             text:=S;
         end;
end;

function TEditReal.GetValue:double;
var errorpos:integer;
    valeur:double;
    s:string;
begin
   val(text,valeur,errorPos);
   getvalue:=Valeur;
   if abs(Valeur)<>0 then
   while abs(Valeur)<power(10,-FnbrDecimales) do
     begin
          FNbrDecimales:=FNbrdecimales+1;
     end;
   NbrDecimales:=FNbrDecimales;
   str(Valeur:FNbrCarac:FnbrDecimales,s);
   text:=S;
end;

procedure TEditReal.SetValue(Value:double);
var S:string;
begin
     if abs(Value)<>0 then
     while abs(Value)<power(10,-FnbrDecimales) do
     begin
          FNbrDecimales:=FNbrdecimales+1;
     end;
     NbrDecimales:=FNbrDecimales;
     str(Value:FNbrCarac:FnbrDecimales,s);
     text:=S;
 end;

procedure Register;
begin
  RegisterComponents('PilotageManip', [TEditReal]);
end;

end.
