unit dirdlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Grids, Outline, DirOutln, DirOutln1,registry;

const
sreg='\HKEY_CURRENT_USER\manips';

type
  TdirDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    DirectoryOutline1: TDirectoryOutline;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure DirectoryOutline1Change(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DirectoryOutline1Click(Sender: TObject);
    procedure DirectoryOutline1MouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
  regis:tregistry;
    { Public declarations }
  end;

var
  dirDialog: TdirDialog;
  defaultdir:tfilename;
implementation

{$R *.DFM}

procedure TdirDialog.FormCreate(Sender: TObject);
var
  Drive: Char;
  s:string;
  tf:boolean;
begin
  for Drive := 'a' to 'z' do
  begin
    s:=drive+':\';
    case GetDriveType(PChar(Drive + ':\')) of
      DRIVE_REMOVABLE:
        combobox1.Items.add(s);
      DRIVE_FIXED:
        combobox1.Items.add(s);
      DRIVE_CDROM:
        combobox1.Items.add(s);
      DRIVE_RAMDISK:
        combobox1.Items.add(s);
      DRIVE_REMOTE:
        combobox1.Items.add(s);
    else
    end;
  end;
regis:=tregistry.create;
tf:=regis.openkey(sreg,true);
if tf then begin
s:=regis.readstring('dir');
end else s:='c:\spe\';
ComboBox1.itemindex:=1;
directoryoutline1.drive:='c';
directoryoutline1.directory:=s;
directoryoutline1.walktree(directoryoutline1.directory);
defaultdir:=s;
edit1.text:=defaultdir;
end;

procedure TdirDialog.ComboBox1Change(Sender: TObject);
var
drive:char;
mt:array[0..20] of char;
begin
strpcopy(mt,combobox1.items[combobox1.itemindex]);
directoryoutline1.drive:=mt[0];
end;

procedure TdirDialog.DirectoryOutline1Change(Sender: TObject);
begin
edit1.text:= DirectoryOutline1.Directory;
end;

procedure TdirDialog.OKBtnClick(Sender: TObject);
begin
defaultdir:=edit1.text;
regis.writestring('dir',defaultdir);
end;

procedure TdirDialog.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then begin
createdir(edit1.text);
DirectoryOutline1.buildtree;
directoryoutline1.walktree(edit1.text);
end;
end;

procedure TdirDialog.DirectoryOutline1Click(Sender: TObject);
begin
edit1.text:= DirectoryOutline1.Directory;
end;

procedure TdirDialog.DirectoryOutline1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
edit1.text:= DirectoryOutline1.Directory;
end;

end.
