unit editdata;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  filectrl,StdCtrls, ExtCtrls, AxCtrls, OleCtrls, vcf1, Parser10, Buttons;

type
    points=record
    mon:real;
    x:real;
    y:real;
    z:real;
end;
type
    pspectsav=^spectsav;
    spectsav=record
    X:integer;
    Y:integer;
    nom:string[20];
    com:string[100];
    typX:string[6];
    typY:string[6];
    indexX:integer;
    indexY:integer;
    {data:array of array of points;}
end;
type
    spectre=class(tobject)
    private
    fX:integer;
    fY:integer;
    fnom:string;
    fcom:string;
    ftypX:string;
    ftypY:string;
    { Dclarations prives }
    protected
    public
    data:array of array of points;
    indexX,indexY:integer;
    property X:integer read fx write fx;
    property Y:integer read fy write fy;
    property Nom:string read fnom write fnom;
    property Comment:string read fcom write fcom;
    property typeX:string read ftypX write ftypX;
    property typeY:string read ftypY write ftypY;
    procedure clear;
    function total:real;
    procedure minmax(var min:real;var max:real);
    procedure savetofile(filename:string);
    procedure readfromfile(filename:string);

end;
const
totalspectre=30;
type
    spectlist=class(tobject)
    protected
    procedure free;
    public
    spect:array[1..totalspectre] of spectre;
    function addspectre(nom:string;X:integer;Y:integer):integer;
    procedure deletespectre(ind:integer);
    function indexof(nom:string):integer;
    function addition(nom1,nom2,nom3:string):boolean;{nom3=nom2+nom1}
    function soustraction(nom1,nom2,nom3:string):boolean;{nom3=nom2-nom1}
    function parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
    procedure saveall;
    procedure add(spec:spectre);
    procedure clear(nom:string);
    procedure addpt(nom:string;x,y,z,mon:extended);
end;

type
  Tdataeditform = class(TForm)
    F1Book1: TF1Book;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Parser1: TParser;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    X: TLabel;
    EditX: TEdit;
    Label1: TLabel;
    EditY: TEdit;
    Label2: TLabel;
    EdittypX: TEdit;
    Label3: TLabel;
    EdittypY: TEdit;
    Label4: TLabel;
    Editnom: TEdit;
    Label5: TLabel;
    Editcom: TEdit;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure F1Book1EndEdit(Sender: TObject; var EditString: WideString;
      var Cancel: Smallint);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroup1Click(Sender: TObject);
    procedure F1Book1DblClick(Sender: TObject; nRow, nCol: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure EdittypXChange(Sender: TObject);
    procedure EdittypYChange(Sender: TObject);
    procedure EditnomChange(Sender: TObject);
    procedure EditcomChange(Sender: TObject);
  private
    { Dclarations prives}
    unddeud:boolean;
  public
  procedure traitchaine(s:string);
  procedure sauve(i:integer;nom:string);
    { Dclarations publiques}
  end;

function fexis(nomf:string):boolean;

var
  dataeditform: Tdataeditform;
  deuxd:spectlist;
  und:spectlist;

implementation

uses boiten;


function fexis(nomf:string):boolean;
        var
        fich:file;
        begin
        {$I-}
        assignfile(fich,nomf);
        reset(fich);
        closefile(fich);
        {$I+}
        fexis:=(IOresult=0) and (nomf<>'');
        end;

{$R *.DFM}
{---------------spectre---------------------------}
procedure spectre.clear;
var
i,j:integer;
begin
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
data[i,j].x:=0;
data[i,j].y:=0;
data[i,j].z:=0;
data[i,j].mon:=1;
end;
indexX:=0;indexY:=0;
end;

function spectre.total:real;
var
i,j:integer;
tota:real;
begin
tota:=0;
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
tota:=data[i,j].z+tota;
end;
result:=tota;
end;

procedure spectre.minmax(var min:real;var max:real);
var
i,j:integer;
begin
min:=data[1,1].z;max:=data[1,1].z;
for i:=0 to X-1 do
for j:=0 to Y-1 do begin
if min>data[i,j].z then min:=data[i,j].z;
if max<data[i,j].z then max:=data[i,j].z;
end;
end;

procedure spectre.SaveToFile(FileName: string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
filetot:string;
u:real;
begin
fa:=new(pspectsav);
fa.X:=X;fa.Y:=Y;
fa.indexX:=indexX;fa.indexY:=indexY;
fa.com:=comment;fa.nom:=nom;
fa.typX:=typeX;fa.typY:=typeY;
p.mon:=1;p.x:=0;p.y:=0;p.z:=0;u:=0;
if typex<>'raw' then begin
filetot:=defaultdir+'\'+filename+'.spe';
if fexis(filetot) then begin
i:=1;
filetot:=defaultdir+'\'+filename+inttostr(i)+'.spe';
while fexis(filetot)do begin
i:=i+1;
filetot:=defaultdir+'\'+filename+inttostr(i)+'.spe';
end;
end;
assignfile(fich,filetot);
assignfile(fich1,filetot);
rewrite(fich1);
for i:=1 to 200 do write(fich1,p);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do write(fich1,data[i,j]);
closefile(fich1);
reset(fich);
write(fich,fa^);
closefile(fich);
end else begin
filetot:=defaultdir+'\'+filename+'.raw';
if fexis(filetot) then begin
i:=1;
filetot:=defaultdir+'\'+filename+inttostr(i)+'.raw';
while fexis(filetot)do begin
i:=i+1;
filetot:=defaultdir+'\'+filename+inttostr(i)+'.raw';
end;
end;
assignfile(fich,filetot);
assignfile(fich2,filetot);
rewrite(fich2);
for i:=1  to 200 do write(fich2,u);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do write(fich2,data[i,j].z);
closefile(fich2);
reset(fich);
write(fich,fa^);
closefile(fich);
end;
dispose(fa);
end;

procedure spectre.readfromfile(filename:string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
u:real;
begin
fa:=new(pspectsav);
assignfile(fich,filename);
assignfile(fich1,filename);
assignfile(fich2,filename);
reset(fich);
read(fich,fa^);
X:=fa.X;Y:=fa.Y;
comment:=fa.com;nom:=fa.nom;
typeX:=fa.typX;typeY:=fa.typY;
indexX:=fa.indexX;indexY:=fa.indexY;
setlength(data,X,Y);
closefile(fich);
if typeX<>'raw' then begin
reset(fich1);
for i:=1 to 200 do read(fich1,p);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich1,data[i,j]);
closefile(fich1);
end else begin
reset(fich2);
for i:=1 to 200 do read(fich2,u);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich2,data[i,j].z);
closefile(fich2);
end;
dispose(fa);
end;

{----------------spectrelist------------------------}
function spectlist.addspectre(nom:string;X:integer;Y:integer):integer;
var
i:integer;
i1:integer;
tf:boolean;
begin
i:=1;i1:=-1;tf:=false;
deletespectre(indexof(nom));
while (i<=totalspectre) and (not tf) do begin
if spect[i]=nil then begin
spect[i]:=spectre.create;
spect[i].nom:=nom;
spect[i].X:=X;
spect[i].Y:=Y;
setlength(spect[i].data,X,Y);
i1:=i;tf:=true;
spect[i].clear;
end;
i:=i+1;
end;
result:=i1;
end;

procedure spectlist.add(spec:spectre);
var
i,k,l:integer;
begin
i:=addspectre(spec.nom,spec.X,spec.Y);
if i>=1 then begin
spect[i].comment:=spec.comment;
spect[i].typeX:=spec.typeX;
spect[i].typeY:=spec.typeY;
spect[i].indexX:=spec.indexX;
spect[i].indexY:=spec.indexY;
for k:=0 to spec.X-1 do
for l:=0 to spec.Y-1 do
spect[i].data[k,l]:=spec.data[k,l];
end;
end;

procedure spectlist.deletespectre(ind:integer);
begin
if (ind>=1) and (ind<=totalspectre) then
if spect[ind]<>nil then begin
spect[ind].free;
spect[ind]:=nil;
end;
end;

procedure spectlist.free;
var
i:integer;
begin
for i:=1 to totalspectre do spect[i].free;
end;

procedure spectlist.clear(nom:string);
var
ind:integer;
begin
ind:=indexof(nom);
if ind>=0 then spect[ind].clear;
end;

procedure spectlist.addpt(nom:string;x,y,z,mon:extended);
var
i:integer;
tf:boolean;
begin
i:=indexof(nom);tf:=false;
if i>=0 then begin
if spect[i].indexX>=spect[i].X-1 then begin
  spect[i].indexY:=spect[i].indexY+1;
  if spect[i].indexY<spect[i].Y-1 then begin
  spect[i].indexX:=0;tf:=true;end;
end else begin
  tf:=true;
  spect[i].indexX:=spect[i].indexX+1;
end;
if tf then begin
spect[i].data[spect[i].indexX,spect[i].indexY].x:=x;
spect[i].data[spect[i].indexX,spect[i].indexY].y:=y;
spect[i].data[spect[i].indexX,spect[i].indexY].z:=z;
spect[i].data[spect[i].indexX,spect[i].indexY].mon:=mon;
end;
end;
end;


function spectlist.indexof(nom:string):integer;
var
i:integer;
i1:integer;
begin
i:=1;i1:=-1;
while (i<=totalspectre) and (i1=-1) do begin
if spect[i]<>nil then
if spect[i].nom=nom then i1:=i;
i:=i+1;
end;
result:=i1;
end;

function spectlist.addition(nom1,nom2,nom3:string):boolean;{nom3=nom2+nom1}
var
i,j,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i1>=2) then
if (spect[i1].x=spect[i2].x) and
(spect[i1].y=spect[i2].y) then begin
if i3<1 then begin
i3:=addspectre(nom3,spect[i1].x,spect[i1].y);
end;
spect[i3].x:=spect[i1].x;
spect[i3].y:=spect[i1].y;
spect[i3].typex:=spect[i1].typex;
spect[i3].typey:=spect[i1].typey;
for i:=0 to spect[i1].x-1 do
for j:=0 to spect[i1].y-1 do begin
spect[i3].data[i,j].x:=spect[i1].data[i,j].x;
spect[i3].data[i,j].y:=spect[i1].data[i,j].y;
spect[i3].data[i,j].z:=spect[i1].data[i,j].z+spect[i2].data[i,j].z;
spect[i3].data[i,j].mon:=spect[i1].data[i,j].mon+spect[i2].data[i,j].mon;
end;
tf:=true;
end;
result:=tf;
end;

function spectlist.soustraction(nom1,nom2,nom3:string):boolean;{nom3=nom2-nom1}
var
i,j,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i1>=2) then
if (spect[i1].x=spect[i2].x) and
(spect[i1].y=spect[i2].y) then begin
if i3<1 then begin
i3:=addspectre(nom3,spect[i1].x,spect[i1].y);
end;
spect[i3].x:=spect[i1].x;
spect[i3].y:=spect[i1].y;
spect[i3].typex:=spect[i1].typex;
spect[i3].typey:=spect[i1].typey;
for i:=0 to spect[i1].x-1 do
for j:=0 to spect[i1].y-1 do begin
spect[i3].data[i,j].x:=spect[i1].data[i,j].x;
spect[i3].data[i,j].y:=spect[i1].data[i,j].y;
spect[i3].data[i,j].z:=spect[i1].data[i,j].z-spect[i2].data[i,j].z;
spect[i3].data[i,j].mon:=spect[i1].data[i,j].mon-spect[i2].data[i,j].mon;
end;
tf:=true;
end;
result:=tf;
end;
{on se sert du parser en remplacant les variables par la
valeur dans la chane
pour chaque chane on rentre le nom (remplac par [i,j])
on peut rentrer le nommon (remplac par le moniteur) ou le
nomtemps remplac par le temps}
function spectlist.parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
var
s2,s1:string;
s3:array[1..10] of string;
uu3:array[1..10] of integer;
m,i,j,x,y,k,l:integer;
i1:integer;
typx,typy:string;
begin
for i:=1 to 10 do s3[i]:='';
j:=1;x:=0;y:=0;
for i:=1 to totalspectre do if spect[i]<>nil then
 if pos(spect[i].nom,s)>0 then begin
 s3[j]:=spect[i].nom;uu3[j]:=i;j:=j+1;
  x:=spect[i].x;y:=spect[i].y;
  typx:=spect[i].typex;typy:=spect[i].typey;
 end;
if (pos('=',s)>0) and (x>0) and (y>0) then begin
s2:=copy(s,pos('=',s)+1,length(s));
s1:=copy(s,1,pos('=',s)-1);
i1:=indexof(s1);
if i1<0 then begin
i1:=addspectre(s1,x,y);
spect[i1].typex:=typx;
spect[i1].typey:=typy;
end;
for k:=0 to x-1 do
for l:=0 to y-1 do begin
dataeditform.parser1.setvariable('i',k);
dataeditform.parser1.setvariable('j',l);
for m:=0 to 9 do begin
i:=m+1;
if s3[i]<>'' then begin
dataeditform.parser1.setvariable(s3[i],spect[uu3[i]].data[k,l].z);
dataeditform.parser1.setvariable(s3[i]+'mon',spect[uu3[i]].data[k,l].mon);
end;
end;
dataeditform.parser1.expression:=s2;
spect[i1].data[k,l].z:=dataeditform.parser1.value;
end;
end;
result:=true;
end;

procedure spectlist.saveall;
var
i:integer;
begin
i:=1;
while (i<=totalspectre)do begin
if spect[i]<>nil then spect[i].savetofile(spect[i].nom);
i:=i+1;
end;
end;

{----------------------tdataeditform--------------------}
procedure Tdataeditform.ComboBox1Change(Sender: TObject);
var
ind,i,j:integer;
begin
if unddeud=false then begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(deuxd.spect[ind].X);
editY.text:=inttostr(deuxd.spect[ind].Y);
edittypx.text:=deuxd.spect[ind].typeX;
edittypy.text:=deuxd.spect[ind].typeY;
editnom.text:=deuxd.spect[ind].nom;
editcom.text:=deuxd.spect[ind].comment;
f1book1.inittable;
f1book1.maxcol:=deuxd.spect[ind].X;
f1book1.maxrow:=deuxd.spect[ind].Y;
for i:=1 to deuxd.spect[ind].x do
for j:=1 to deuxd.spect[ind].y do begin
f1book1.TextRC[j,i]:=floattostr(deuxd.spect[ind].data[i-1,j-1].z);
end;
for i:=1 to deuxd.spect[ind].x do f1book1.ColText[i]:=inttostr(i);
end;
end else begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(und.spect[ind].X);
editY.text:=inttostr(und.spect[ind].Y);
edittypx.text:=und.spect[ind].typeX;
edittypy.text:=und.spect[ind].typeY;
editnom.text:=und.spect[ind].nom;
editcom.text:=und.spect[ind].comment;
f1book1.inittable;
f1book1.maxcol:=12;
f1book1.maxrow:=und.spect[ind].X;
for i:=1 to und.spect[ind].x do begin
f1book1.TextRC[i,1]:=floattostr(und.spect[ind].data[i-1,0].mon);
f1book1.TextRC[i,2]:=floattostr(und.spect[ind].data[i-1,0].x);
f1book1.TextRC[i,3]:=floattostr(und.spect[ind].data[i-1,0].z);
end;
f1book1.ColText[1]:='mon'; 
f1book1.ColText[2]:='x';
f1book1.ColText[3]:='z';
end;
end;
end;

procedure Tdataeditform.FormCreate(Sender: TObject);
var
i:integer;
begin
unddeud:=true;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
begin
combobox1.items.add(und.spect[i].nom);
end;
top:=0;
left:=0;
end;

procedure Tdataeditform.F1Book1EndEdit(Sender: TObject;
  var EditString: WideString; var Cancel: Smallint);
var
ind,i,j:integer;
u:real;
begin
if unddeud=true then begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
f1book1.GetActiveCell(i,j);
u:=strtofloat(editstring);
if j=1 then und.spect[ind].data[i-1,0].mon:=u;
if j=2 then und.spect[ind].data[i-1,0].x:=u;
if j=3 then und.spect[ind].data[i-1,0].z:=u;
end;
end else begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
f1book1.GetActiveCell(j,i);
u:=strtofloat(editstring);
deuxd.spect[ind].data[i-1,j-1].z:=u;
end;
end;
end;

procedure Tdataeditform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then traitchaine(edit1.text);
end;

procedure Tdataeditform.traitchaine(s:string);
var
i:integer;
begin
if unddeud=true then begin
und.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
deuxd.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
end;

procedure Tdataeditform.RadioGroup1Click(Sender: TObject);
var
i:integer;
begin
if radiogroup1.itemindex=0 then unddeud:=true else unddeud:=false;
if unddeud=true then begin
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
combobox1.itemindex:=0;
end;

procedure Tdataeditform.F1Book1DblClick(Sender: TObject; nRow,
  nCol: Integer);
begin
f1book1.launchdesigner;
end;

procedure Tdataeditform.sauve(i:integer;nom:string);
begin
if (nom<>'tout') then begin
if i=1 then
if und.indexof(nom)>=0 then
und.spect[und.indexof(nom)].savetofile(nom);
if i=2 then
if deuxd.indexof(nom)>=0 then
deuxd.spect[deuxd.indexof(nom)].savetofile(nom);
end else begin
if i=1 then und.saveall;
if i=2 then deuxd.saveall;
end;
end;

procedure Tdataeditform.SpeedButton2Click(Sender: TObject);
begin
if unddeud then sauve(1,combobox1.text)
else sauve(2,combobox1.text);
end;

procedure Tdataeditform.SpeedButton3Click(Sender: TObject);
begin
if unddeud then sauve(1,'tout')
else sauve(2,'tout');
end;

procedure Tdataeditform.SpeedButton5Click(Sender: TObject);
begin
if unddeud then und.deletespectre(und.indexof(combobox1.text))
else deuxd.deletespectre(deuxd.indexof(combobox1.text));
radiogroup1click(Sender);
end;

procedure Tdataeditform.SpeedButton4Click(Sender: TObject);
var
spec:spectre;
begin
spec:=spectre.create;
opendialog1.initialdir:=defaultdir;
if opendialog1.execute then
begin
spec.readfromfile(opendialog1.filename);
if spec.typey='single' then und.add(spec) else deuxd.add(spec);
end;
spec.Destroy;
end;

procedure Tdataeditform.EdittypXChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeX:=edittypX.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeX:=edittypX.text;
end;

procedure Tdataeditform.EdittypYChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeY:=edittypY.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeY:=edittypY.text;
end;



procedure Tdataeditform.EditnomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].nom:=editnom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].nom:=editnom.text;
ComboBox1Change(Sender);
end;



procedure Tdataeditform.EditcomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].comment:=editcom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].comment:=editcom.text;
end;

end.
