unit graph2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, xyGraph, StdCtrls, ComCtrls, Spin, Buttons, ToolWin,
  clacon,math,xydesign,xyDatWiz, Menus,editdata, Parser10;
const
wm_fermeture=$400+wm_user;
wm_redessiner=$401+wm_user;
type
  Tgraph1d = class(TForm)
    xyGraph1: TxyGraph;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    courbes1: TMenuItem;
    Nouvelle1: TMenuItem;
    Nouvelle2: TMenuItem;
    Oprations1: TMenuItem;
    Panel10: TPanel;
    Edit1: TEdit;
    Edit3: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    Panel11: TPanel;
    cocourbe1: TComboBox;
    perbox1: Tperbox;
    Panel12: TPanel;
    cocourbe2: TComboBox;
    perbox2: Tperbox;
    Panel13: TPanel;
    cocourbe3: TComboBox;
    perbox3: Tperbox;
    Panel14: TPanel;
    cocourbe4: TComboBox;
    perbox4: Tperbox;
    Panel2: TPanel;
    Edit5: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Parser1: TParser;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    sauver1: TMenuItem;
    charger1: TMenuItem;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    SpeedButton7: TSpeedButton;
    ToggleLinLog: TButton;
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure xyGraph1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cocourbe1Change(Sender: TObject);
    procedure perbox1change(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Edit5KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure ToggleLinLogClick(Sender: TObject);
  private
    index1,index2:integer;
    arrayzoom:array[0..15,1..4] of double;
    indexzoom:integer;
    procedure fermeture(var msg:tmessage); message wm_fermeture;
    procedure wmredessiner(var msg:tmessage); message wm_redessiner;
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure redessiner;
    procedure changegain(var msg:tmessage);message wm_user+wm_gain;
    procedure tfrspectre(i:integer;courbe:integer);
    procedure traitchaine(s:string);
end;

var
  graph1d: Tgraph1d;
  coul:array[1..16] of tcolor;
  ga:array[1..16] of integer;
implementation

{$R *.DFM}

procedure Tgraph1d.redessiner;
begin
cocourbe1change(cocourbe1);
cocourbe1change(cocourbe2);
cocourbe1change(cocourbe3);
cocourbe1change(cocourbe4);
end;

procedure Tgraph1d.wmredessiner(var msg:tmessage);
begin
redessiner;
end;

procedure Tgraph1d.fermeture(var msg:tmessage);
begin
release;
end;

procedure Tgraph1d.Button1Click(Sender: TObject);
begin
redessiner;
end;

procedure Tgraph1d.SpeedButton2Click(Sender: TObject);
begin
xygraph1.print;
end;

procedure Tgraph1d.SpeedButton3Click(Sender: TObject);
begin
editxyGraph(self, xyGraph1);
end;

procedure Tgraph1d.SpeedButton5Click(Sender: TObject);
begin
if indexzoom>=1 then begin
indexzoom:=indexzoom-1;
xygraph1.xaxis.min:=arrayzoom[indexzoom,1];
xygraph1.xaxis.max:=arrayzoom[indexzoom,2];
(xygraph1.annotations[1] as tmark).x1:=arrayzoom[indexzoom,3];
(xygraph1.annotations[2] as tmark).x1:=arrayzoom[indexzoom,4];
end;
end;

procedure Tgraph1d.SpeedButton6Click(Sender: TObject);
var
i:integer;
v1,v2:double;
begin
if indexzoom=0 then begin
arrayzoom[indexzoom,1]:=xygraph1.xaxis.min;
arrayzoom[indexzoom,2]:=xygraph1.xaxis.max;
arrayzoom[indexzoom,3]:=(xygraph1.annotations[1] as tmark).x1;
arrayzoom[indexzoom,4]:=(xygraph1.annotations[2] as tmark).x1;
end;
v1:=(xygraph1.annotations[1] as tmark).x1;
v2:=(xygraph1.annotations[2] as tmark).x1;
if v2>v1 then begin
indexzoom:=indexzoom+1;
if indexzoom>15 then begin
indexzoom:=15;
for i:=1 to 14 do begin
arrayzoom[i,1]:=arrayzoom[i+1,1];
arrayzoom[i,2]:=arrayzoom[i+1,2];
arrayzoom[i,3]:=arrayzoom[i+1,3];
arrayzoom[i,4]:=arrayzoom[i+1,4];
end;
end;
arrayzoom[indexzoom,1]:=v1;arrayzoom[indexzoom,2]:=v2;
arrayzoom[indexzoom,3]:=v1;arrayzoom[indexzoom,4]:=v2;
xygraph1.xaxis.min:=v1;
xygraph1.xaxis.max:=v2;
end;
end;

procedure Tgraph1d.FormCreate(Sender: TObject);
var
i:integer;
tf:boolean;
begin
for i:=1 to 4 do ga[i]:=1;
tf:=false;
xygraph1.Addmark(1,xygraph1.xAxis.Min,xygraph1.YAxis.Min,xygraph1.xAxis.Min,xygraph1.YAxis.Max,clred,'1',mtxmark ,mpUpLeft, dtAfter);
xygraph1.Addmark(2,xygraph1.xAxis.Max,xygraph1.YAxis.Min,xygraph1.xAxis.Max,xygraph1.YAxis.Max,clblue,'2',mtxmark ,mpUpLeft, dtAfter);
coul[1]:=$000000;coul[2]:=$0000FF;coul[3]:=$FF0000;
coul[4]:=$007F00;coul[5]:=$FFFF00;coul[6]:=$FF00FF;
coul[7]:=$00FFFF;coul[8]:=$7F0000;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
begin
cocourbe1.items.add(und.spect[i].nom);
cocourbe2.items.add(und.spect[i].nom);
cocourbe3.items.add(und.spect[i].nom);
cocourbe4.items.add(und.spect[i].nom);
if not tf then begin
cocourbe1.text:=und.spect[i].nom;
cocourbe2.text:=und.spect[i].nom;
cocourbe3.text:=und.spect[i].nom;
cocourbe4.text:=und.spect[i].nom;
tfrspectre(i,1);tfrspectre(i,2);
tfrspectre(i,3);tfrspectre(i,4);
tf:=true;
end;
end;
perbox1.graph:=handle;perbox2.graph:=handle;perbox3.graph:=handle;
perbox4.graph:=handle;
indexzoom:=0;
top:=0;
left:=0;
width:=580;
height:=350;
end;

procedure Tgraph1d.tfrspectre(i:integer;courbe:integer);
var
j:integer;
tf:boolean;
begin
tf:=false;
if (courbe>=1) and (courbe<=4) then begin
xygraph1.series[courbe].holdupdates:=true;
xygraph1.Series[courbe].clear;
xygraph1.Series[courbe].seriesname:=und.spect[i].nom;
xygraph1[courbe].drawpoints:=false;
xygraph1[courbe].linecolor:=coul[courbe];
xygraph1[courbe].LineStyle:=pssolid;
if und.spect[i].typex='raw' then begin
for j:=0 to und.spect[i].x-1 do
xygraph1.Series[courbe].add(j,und.spect[i].data[j,0].z*intpower(2,ga[courbe]-6));
tf:=true;end;
if und.spect[i].typex='reflec' then begin
for j:=0 to und.spect[i].indexX-1 do
xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].z*intpower(2,ga[courbe]-6));
tf:=true;end;
if not tf then
for j:=0 to und.spect[i].indexX-1 do
xygraph1.Series[courbe].add(und.spect[i].data[j,0].x,und.spect[i].data[j,0].z*intpower(2,ga[courbe]-6));
xygraph1.series[courbe].holdupdates:=false;
end;
end;

procedure Tgraph1d.changegain(var msg:tmessage);
begin
  if (msg.wparam<=4)and (msg.wparam>=1) then begin
  if msg.lparam=3 then
  xygraph1.series[msg.wparam].active:=false;
  if msg.lparam=2 then
  xygraph1.series[msg.wparam].active:=true;
  if msg.lparam=1 then begin
  {left button}end;
  if msg.lparam=-1 then begin
  {right button}end;
  end else begin
  ga[msg.wparam-10]:=msg.lparamlo;
  case msg.wparam-10 of
  1:cocourbe1change(cocourbe1);
  2:cocourbe1change(cocourbe2);
  3:cocourbe1change(cocourbe3);
  4:cocourbe1change(cocourbe4);
  end;
  end;
  end;

procedure Tgraph1d.xyGraph1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
  x2,y2:double;
  x3,y3:double;
  index:integer;
  begin
  inherited;
xygraph1.GetMouseXY(1, x, y, index, x2, y2, x3, y3);
if button=mbleft then begin
edit1.text:=floattostrf(x3,fffixed,5,7);
edit2.text:=floattostrf(y3,fffixed,4,8);
(xygraph1.Annotations[1] as TMark).x1 := x3;
(xygraph1.Annotations[1] as TMark).x2 := x3;
index1:=index;
end;
if button=mbright then begin
edit3.text:=floattostrf(x3,fffixed,5,7);
edit4.text:=floattostrf(y3,fffixed,4,8);
(xygraph1.Annotations[2] as TMark).x1 := x3;
(xygraph1.Annotations[2] as TMark).x2 := x3;
index2:=index;
end;
end;

procedure Tgraph1d.cocourbe1Change(Sender: TObject);
begin
if sender=cocourbe1 then
tfrspectre(und.indexof(cocourbe1.text),1);
if sender=cocourbe2 then
tfrspectre(und.indexof(cocourbe2.text),2);
if sender=cocourbe3 then
tfrspectre(und.indexof(cocourbe3.text),3);
if sender=cocourbe4 then
tfrspectre(und.indexof(cocourbe4.text),4);
end;

procedure Tgraph1d.perbox1change(Sender: TObject);
begin
if perbox1.getcheck=1 then xygraph1.series[1].active:=true
else xygraph1.series[1].active:=false;
end;

procedure Tgraph1d.SpeedButton4Click(Sender: TObject);
begin
ShowxyDataWizard(self, xyGraph1);
end;

procedure Tgraph1d.Edit5KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then traitchaine(edit5.text);
end;

procedure Tgraph1d.traitchaine(s:string);
var
i:integer;
begin
und.parsechaine(s);
cocourbe1.clear;cocourbe2.clear;
cocourbe4.clear;cocourbe3.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then begin
cocourbe1.items.add(und.spect[i].nom);
cocourbe2.items.add(und.spect[i].nom);
cocourbe3.items.add(und.spect[i].nom);
cocourbe4.items.add(und.spect[i].nom);
end;
end;


procedure Tgraph1d.SpinButton1UpClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index1:=index1+1;
index4:=index1;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[1] as TMark).x1 := x;
(xygraph1.Annotations[1] as TMark).x2 := x;
edit1.text:=floattostrf(x,fffixed,5,7);
edit2.text:=floattostrf(y,fffixed,4,8);
end else begin
index1:=index1-1;
end;
end;

procedure Tgraph1d.SpinButton1DownClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index1:=index1-1;
index4:=index1;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[1] as TMark).x1 := x;
(xygraph1.Annotations[1] as TMark).x2 := x;
edit1.text:=floattostrf(x,fffixed,5,7);
edit2.text:=floattostrf(y,fffixed,4,8);
end else begin
index1:=index1+1;
end;
end;

procedure Tgraph1d.SpinButton2DownClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index2:=index2-1;
index4:=index2;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[2] as TMark).x1 := x;
(xygraph1.Annotations[2] as TMark).x2 := x;
edit3.text:=floattostrf(x,fffixed,5,7);
edit4.text:=floattostrf(y,fffixed,4,8);
end else begin
index2:=index2+1;
end;
end;

procedure Tgraph1d.SpinButton2UpClick(Sender: TObject);
var
x,y,r:double;
index4:integer;
begin
index2:=index2+1;
index4:=index2;
if xygraph1.series[1].GetPoint(index4,x, y,r) then begin
(xygraph1.Annotations[2] as TMark).x1 := x;
(xygraph1.Annotations[2] as TMark).x2 := x;
edit3.text:=floattostrf(x,fffixed,5,7);
edit4.text:=floattostrf(y,fffixed,4,8);
end else begin
index2:=index2-1;
end;
end;

procedure Tgraph1d.SpeedButton7Click(Sender: TObject);
begin
if xygraph1.yaxis.autosizing then begin
xygraph1.yaxis.autosizing:=false;
speedbutton7.caption:='Man';
end else begin
xygraph1.yaxis.autosizing:=true;
speedbutton7.caption:='Auto';
end;
end;

procedure Tgraph1d.ToggleLinLogClick(Sender: TObject);
begin
     If ToggleLinLog.caption='Lin'
     then begin
          xygraph1.Yaxis.Logscale:=True;
          ToggleLinLog.caption:='Log'
          end
     else begin
          xyGraph1.Yaxis.Logscale:=False;
          ToggleLinLog.caption:='Lin'
          end;
     redessiner
end;

end.
